/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var de=["require","exports","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/path","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/types","vs/base/common/errors","vs/base/common/strings","vs/base/common/async","fs","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/objects","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/process","os","vs/base/common/map","vs/platform/environment/common/environment","vs/base/common/cancellation","vs/base/common/extpath","vs/platform/product/common/product","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/parts/ipc/common/ipc","vs/base/common/json","child_process","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetry","vs/server/remoteUriTransformer","vs/base/common/stream","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/performance","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/iterator","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/server/serverEnvironmentService","vs/workbench/services/editor/common/editorService","vs/base/node/zip","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","path","vs/base/node/id","util","net","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/node/localizations","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/remoteLanguagePacks","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/decorators","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/node/ptyHostService","vs/platform/workspaces/common/workspaces","vs/server/remoteExtensionManagement","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostTypeConverters","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],me=function(Y){for(var e=[],E=0,b=Y.length;E<b;E++)e[E]=de[Y[E]];return e};define(de[107],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class E{static get(){const C=new Map,S=new Map,k=new Map,R=new Map;function f(D,o){D.has(o.detail)||D.set(o.detail,-o.timestamp)}function m(D,o){let a=D.get(o.detail);!a||a>=0||D.set(o.detail,a+o.timestamp)}const i=Y.getStats().slice(0).sort((D,o)=>D.timestamp-o.timestamp);for(const D of i)switch(D.type){case 10:f(C,D);break;case 11:case 12:m(C,D);break;case 21:f(S,D);break;case 22:m(S,D);break;case 33:f(k,D);break;case 34:m(k,D);break;case 31:f(R,D);break;case 32:m(R,D);break}let I=0;k.forEach(D=>I+=D);function p(D){let o=[];return D.forEach((a,w)=>o.push([w,a])),o}return{amdLoad:p(C),amdInvoke:p(S),nodeRequire:p(k),nodeEval:p(R),nodeRequireTotal:I}}static toMarkdownTable(C,S){let k="",R=[];return C.forEach((f,m)=>{R[m]=f.length}),S.forEach(f=>{f.forEach((m,i)=>{typeof m=="undefined"&&(m=f[i]="-");const I=m.toString().length;R[i]=Math.max(I,R[i])})}),C.forEach((f,m)=>{k+=`| ${f+" ".repeat(R[m]-f.toString().length)} `}),k+=`|
`,C.forEach((f,m)=>{k+=`| ${"-".repeat(R[m])} `}),k+=`|
`,S.forEach(f=>{f.forEach((m,i)=>{typeof m!="undefined"&&(k+=`| ${m+" ".repeat(R[i]-m.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=E}),define(de[108],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(b,C){if(!b)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=E}),define(de[109],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(f){return(m,i,I)=>{let p=null,D=null;if(typeof I.value=="function"?(p="value",D=I.value):typeof I.get=="function"&&(p="get",D=I.get),!D)throw new Error("not supported");I[p]=f(D,i)}}e.createDecorator=E;let b=0;function C(){const f=`$memoize${b++}`;let m;const i=function(p,D,o){let a=null,w=null;if(typeof o.value=="function"?(a="value",w=o.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(a="get",w=o.get),!w)throw new Error("not supported");const _=`${f}:${D}`;o[a]=function(...A){return m=this,this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!0,enumerable:!1,writable:!0,value:w.apply(this,A)}),this[_]}};return i.clear=()=>{typeof m!="undefined"&&Object.getOwnPropertyNames(m).forEach(I=>{I.indexOf(f)===0&&delete m[I]})},i}e.createMemoizer=C;function S(f,m,i){return C()(f,m,i)}e.memoize=S;function k(f,m,i){return E((I,p)=>{const D=`$debounce$${p}`,o=`$debounce$result$${p}`;return function(...a){this[o]||(this[o]=i?i():void 0),clearTimeout(this[D]),m&&(this[o]=m(this[o],...a),a=[this[o]]),this[D]=setTimeout(()=>{I.apply(this,a),this[o]=i?i():void 0},f)}})}e.debounce=k;function R(f,m,i){return E((I,p)=>{const D=`$throttle$timer$${p}`,o=`$throttle$result$${p}`,a=`$throttle$lastRun$${p}`,w=`$throttle$pending$${p}`;return function(..._){if(this[o]||(this[o]=i?i():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),m&&(this[o]=m(this[o],..._)),!this[w]){const A=this[a]+f;A<=Date.now()?(this[a]=Date.now(),I.apply(this,[this[o]]),this[o]=i?i():void 0):(this[w]=!0,this[D]=setTimeout(()=>{this[w]=!1,this[a]=Date.now(),I.apply(this,[this[o]]),this[o]=i?i():void 0},A-Date.now()))}}})}e.throttle=R}),define(de[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function b(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=b;function C(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=C;function S(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=S;function k(c){if(c instanceof Error){let{name:t,message:n}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:n,stack:r}}return c}e.transformErrorForSerialization=k;const R="Canceled";function f(c){return c instanceof Error&&c.name===R&&c.message===R}e.isPromiseCanceledError=f;class m extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=m;function i(){const c=new Error(R);return c.name=c.message,c}e.canceled=i;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=p;function D(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function o(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function a(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=a;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class _ extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=_;class A extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=A;function d(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function l(c,t=Object.create(null)){const n=new Error(c);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(de[19],me([0,1,12]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function b(q,ee=0){return q[q.length-(1+ee)]}e.tail=b;function C(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=C;function S(q,ee,H=(T,L)=>T===L){if(q===ee)return!0;if(!q||!ee||q.length!==ee.length)return!1;for(let T=0,L=q.length;T<L;T++)if(!H(q[T],ee[T]))return!1;return!0}e.equals=S;function k(q,ee,H){let T=0,L=q.length-1;for(;T<=L;){const B=(T+L)/2|0,U=H(q[B],ee);if(U<0)T=B+1;else if(U>0)L=B-1;else return B}return-(T+1)}e.binarySearch=k;function R(q,ee){let H=0,T=q.length;if(T===0)return 0;for(;H<T;){const L=Math.floor((H+T)/2);ee(q[L])?T=L:H=L+1}return H}e.findFirstInSorted=R;function f(q,ee,H){if(q=q|0,q>=ee.length)throw new TypeError("invalid index");let T=ee[Math.floor(ee.length*Math.random())],L=[],B=[],U=[];for(let V of ee){const ie=H(V,T);ie<0?L.push(V):ie>0?B.push(V):U.push(V)}return q<L.length?f(q,L,H):q<L.length+U.length?U[0]:f(q-(L.length+U.length),B,H)}e.quickSelect=f;function m(q,ee){const H=[];let T;for(const L of q.slice(0).sort(ee))!T||ee(T[0],L)!==0?(T=[L],H.push(T)):T.push(L);return H}e.groupBy=m;function i(q,ee,H){const T=[];function L(V,ie,le){if(!(ie===0&&le.length===0)){const ue=T[T.length-1];ue&&ue.start+ue.deleteCount===V?(ue.deleteCount+=ie,ue.toInsert.push(...le)):T.push({start:V,deleteCount:ie,toInsert:le})}}let B=0,U=0;for(;;){if(B===q.length){L(B,0,ee.slice(U));break}if(U===ee.length){L(B,q.length-B,[]);break}const V=q[B],ie=ee[U],le=H(V,ie);le===0?(B+=1,U+=1):le<0?(L(B,1,[]),B+=1):le>0&&(L(B,0,[ie]),U+=1)}return T}e.sortedDiff=i;function I(q,ee,H){const T=i(q,ee,H),L=[],B=[];for(const U of T)L.push(...q.slice(U.start,U.start+U.deleteCount)),B.push(...U.toInsert);return{removed:L,added:B}}e.delta=I;function p(q,ee,H){if(H===0)return[];const T=q.slice(0,H).sort(ee);return o(q,ee,T,H,q.length),T}e.top=p;function D(q,ee,H,T,L){return H===0?Promise.resolve([]):new Promise((B,U)=>{(async()=>{const V=q.length,ie=q.slice(0,H).sort(ee);for(let le=H,ue=Math.min(H+T,V);le<V;le=ue,ue=Math.min(ue+T,V)){if(le>H&&await new Promise(we=>setTimeout(we)),L&&L.isCancellationRequested)throw(0,E.canceled)();o(q,ee,ie,le,ue)}return ie})().then(B,U)})}e.topAsync=D;function o(q,ee,H,T,L){for(const B=H.length;T<L;T++){const U=q[T];if(ee(U,H[B-1])<0){H.pop();const V=R(H,ie=>ee(U,ie)<0);H.splice(V,0,U)}}}function a(q){return q.filter(ee=>!!ee)}e.coalesce=a;function w(q){let ee=0;for(let H=0;H<q.length;H++)q[H]&&(q[ee]=q[H],ee+=1);q.length=ee}e.coalesceInPlace=w;function _(q,ee,H){q.splice(H,0,q.splice(ee,1)[0])}e.move=_;function A(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=A;function d(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=d;function l(q,ee){if(!ee)return q.filter((T,L)=>q.indexOf(T)===L);const H=Object.create(null);return q.filter(T=>{const L=ee(T);return H[L]?!1:(H[L]=!0,!0)})}e.distinct=l;function c(q){const ee=new Set;return q.filter(H=>ee.has(H)?!1:(ee.add(H),!0))}e.distinctES6=c;function t(q){const ee=Object.create(null);return H=>{const T=q(H);return ee[T]?!1:(ee[T]=!0,!0)}}e.uniqueFilter=t;function n(q,ee){for(let H=q.length-1;H>=0;H--){const T=q[H];if(ee(T))return H}return-1}e.lastIndex=n;function r(q,ee){return q.length>0?q[0]:ee}e.firstOrDefault=r;function s(q,ee,H=(T,L)=>T===L){let T=0;for(let L=0,B=Math.min(q.length,ee.length);L<B&&H(q[L],ee[L]);L++)T++;return T}e.commonPrefixLength=s;function u(q){return[].concat(...q)}e.flatten=u;function h(q,ee){let H=typeof ee=="number"?q:0;typeof ee=="number"?H=q:(H=0,ee=q);const T=[];if(H<=ee)for(let L=H;L<ee;L++)T.push(L);else for(let L=H;L>ee;L--)T.push(L);return T}e.range=h;function y(q,ee,H){return q.reduce((T,L)=>(T[ee(L)]=H?H(L):L,T),Object.create(null))}e.index=y;function P(q,ee){return q.push(ee),()=>v(q,ee)}e.insert=P;function v(q,ee){const H=q.indexOf(ee);if(H>-1)return q.splice(H,1),ee}e.remove=v;function g(q,ee,H){const T=q.slice(0,ee),L=q.slice(ee);return T.concat(H,L)}e.arrayInsert=g;function F(q,ee){let H;if(typeof ee=="number"){let T=ee;H=()=>{const L=Math.sin(T++)*179426549;return L-Math.floor(L)}}else H=Math.random;for(let T=q.length-1;T>0;T-=1){const L=Math.floor(H()*(T+1)),B=q[T];q[T]=q[L],q[L]=B}}e.shuffle=F;function O(q,ee){const H=q.indexOf(ee);H>-1&&(q.splice(H,1),q.unshift(ee))}e.pushToStart=O;function x(q,ee){const H=q.indexOf(ee);H>-1&&(q.splice(H,1),q.push(ee))}e.pushToEnd=x;function oe(q,ee){return Array.isArray(q)?q.map(ee):ee(q)}e.mapArrayOrNot=oe;function W(q){return Array.isArray(q)?q:[q]}e.asArray=W;function te(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=te;function Q(q,ee){for(const H of q){const T=ee(H);if(T!==void 0)return T}}e.mapFind=Q}),define(de[69],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(b){const C=this;let S=!1,k;return function(){return S||(S=!0,k=b.apply(C,arguments)),k}}e.once=E}),define(de[50],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(b){function C(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}b.is=C;const S=Object.freeze([]);function k(){return S}b.empty=k;function*R(c){yield c}b.single=R;function f(c){return c||S}b.from=f;function m(c){return!c||c[Symbol.iterator]().next().done===!0}b.isEmpty=m;function i(c){return c[Symbol.iterator]().next().value}b.first=i;function I(c,t){for(const n of c)if(t(n))return!0;return!1}b.some=I;function p(c,t){for(const n of c)if(t(n))return n}b.find=p;function*D(c,t){for(const n of c)t(n)&&(yield n)}b.filter=D;function*o(c,t){for(const n of c)yield t(n)}b.map=o;function*a(...c){for(const t of c)for(const n of t)yield n}b.concat=a;function*w(c){for(const t of c)for(const n of t)yield n}b.concatNested=w;function _(c,t,n){let r=n;for(const s of c)r=t(r,s);return r}b.reduce=_;function*A(c,t,n=c.length){for(t<0&&(t+=c.length),n<0?n+=c.length:n>c.length&&(n=c.length);t<n;t++)yield c[t]}b.slice=A;function d(c,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,c];const r=c[Symbol.iterator]();for(let s=0;s<t;s++){const u=r.next();if(u.done)return[n,b.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return r}}]}b.consume=d;function l(c,t,n=(r,s)=>r===s){const r=c[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=r.next(),h=s.next();if(u.done!==h.done)return!1;if(u.done)return!0;if(!n(u.value,h.value))return!1}}b.equals=l})(E=e.Iterable||(e.Iterable={}))}),define(de[36],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var b;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(b=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function k(t,n=!1){let r=0,s=t.length,u="",h=0,y=16,P=0;function v(te){let Q=0,q=0;for(;Q<te;){const ee=t.charCodeAt(r);if(ee>=48&&ee<=57)q=q*16+ee-48;else if(ee>=65&&ee<=70)q=q*16+ee-65+10;else if(ee>=97&&ee<=102)q=q*16+ee-97+10;else break;r++,Q++}return Q<te&&(q=-1),q}function g(te){r=te,u="",h=0,y=16,P=0}function F(){const te=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&m(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&m(t.charCodeAt(r)))for(r++;r<t.length&&m(t.charCodeAt(r));)r++;else return P=3,t.substring(te,r);let Q=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&m(t.charCodeAt(r))){for(r++;r<t.length&&m(t.charCodeAt(r));)r++;Q=r}else P=3;return t.substring(te,Q)}function O(){let te="",Q=r;for(;;){if(r>=s){te+=t.substring(Q,r),P=2;break}const q=t.charCodeAt(r);if(q===34){te+=t.substring(Q,r),r++;break}if(q===92){if(te+=t.substring(Q,r),r++,r>=s){P=2;break}switch(t.charCodeAt(r++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const H=v(4);H>=0?te+=String.fromCharCode(H):P=4;break;default:P=5}Q=r;continue}if(q>=0&&q<=31)if(f(q)){te+=t.substring(Q,r),P=2;break}else P=6;r++}return te}function x(){if(u="",P=0,h=r,r>=s)return h=s,y=17;let te=t.charCodeAt(r);if(R(te)){do r++,u+=String.fromCharCode(te),te=t.charCodeAt(r);while(R(te));return y=15}if(f(te))return r++,u+=String.fromCharCode(te),te===13&&t.charCodeAt(r)===10&&(r++,u+=`
`),y=14;switch(te){case 123:return r++,y=1;case 125:return r++,y=2;case 91:return r++,y=3;case 93:return r++,y=4;case 58:return r++,y=6;case 44:return r++,y=5;case 34:return r++,u=O(),y=10;case 47:const Q=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(t.charCodeAt(r));)r++;return u=t.substring(Q,r),y=12}if(t.charCodeAt(r+1)===42){r+=2;const q=s-1;let ee=!1;for(;r<q;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ee=!0;break}r++}return ee||(r++,P=1),u=t.substring(Q,r),y=13}return u+=String.fromCharCode(te),r++,y=16;case 45:if(u+=String.fromCharCode(te),r++,r===s||!m(t.charCodeAt(r)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=F(),y=11;default:for(;r<s&&oe(te);)r++,te=t.charCodeAt(r);if(h!==r){switch(u=t.substring(h,r),u){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return u+=String.fromCharCode(te),r++,y=16}}function oe(te){if(R(te)||f(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:g,getPosition:()=>r,scan:n?W:x,getToken:()=>y,getTokenValue:()=>u,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>P}}e.createScanner=k;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const r=[],s=new Object;let u;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function P(v,g,F,O){h.value=v,h.offset=g,h.length=F,h.type=O,h.colonOffset=void 0,u=h}try{d(t,{onObjectBegin:(v,g)=>{if(n<=v)throw s;u=void 0,y=n>v,r.push("")},onObjectProperty:(v,g,F)=>{if(n<g||(P(v,g,F,"property"),r[r.length-1]=v,n<=g+F))throw s},onObjectEnd:(v,g)=>{if(n<=v)throw s;u=void 0,r.pop()},onArrayBegin:(v,g)=>{if(n<=v)throw s;u=void 0,r.push(0)},onArrayEnd:(v,g)=>{if(n<=v)throw s;u=void 0,r.pop()},onLiteralValue:(v,g,F)=>{if(n<g||(P(v,g,F,c(v)),n<=g+F))throw s},onSeparator:(v,g,F)=>{if(n<=g)throw s;if(v===":"&&u&&u.type==="property")u.colonOffset=g,y=!1,u=void 0;else if(v===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(y=!0,r[r.length-1]=""),u=void 0}}})}catch(v){if(v!==s)throw v}return{path:r,previousNode:u,isAtPropertyKey:y,matches:v=>{let g=0;for(let F=0;g<v.length&&F<r.length;F++)if(v[g]===r[F]||v[g]==="*")g++;else if(v[g]!=="**")return!1;return g===v.length}}}e.getLocation=I;function p(t,n=[],r=S.DEFAULT){let s=null,u=[];const h=[];function y(v){Array.isArray(u)?u.push(v):s!==null&&(u[s]=v)}return d(t,{onObjectBegin:()=>{const v={};y(v),h.push(u),u=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{const v=[];y(v),h.push(u),u=v,s=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:y,onError:(v,g,F)=>{n.push({error:v,offset:g,length:F})}},r),u[0]}e.parse=p;function D(t,n=[],r=S.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function h(v){return s.children.push(v),v}d(t,{onObjectBegin:v=>{s=h({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,g,F)=>{s=h({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:g,length:F,parent:s})},onObjectEnd:(v,g)=>{s.length=v+g-s.offset,s=s.parent,u(v+g)},onArrayBegin:(v,g)=>{s=h({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,g)=>{s.length=v+g-s.offset,s=s.parent,u(v+g)},onLiteralValue:(v,g,F)=>{h({type:c(v),offset:g,length:F,parent:s,value:v}),u(g+F)},onSeparator:(v,g,F)=>{s.type==="property"&&(v===":"?s.colonOffset=g:v===","&&u(g))},onError:(v,g,F)=>{n.push({error:v,offset:g,length:F})}},r);const P=s.children[0];return P&&delete P.parent,P}e.parseTree=D;function o(t,n){if(!!t){let r=t;for(let s of n)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===s){r=h.children[1],u=!0;break}if(!u)return}else{const u=s;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}}e.findNodeAtLocation=o;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=a;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const n=Object.create(null);for(let r of t.children){const s=r.children[1];s&&(n[r.children[0].value]=w(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function _(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=_;function A(t,n,r=!1){if(_(t,n,r)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=n;u++){const h=A(s[u],n,r);if(h)return h}return t}}e.findNodeAtOffset=A;function d(t,n,r=S.DEFAULT){const s=k(t,!1);function u(ie){return ie?()=>ie(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(ie){return ie?le=>ie(le,s.getTokenOffset(),s.getTokenLength()):()=>!0}const y=u(n.onObjectBegin),P=h(n.onObjectProperty),v=u(n.onObjectEnd),g=u(n.onArrayBegin),F=u(n.onArrayEnd),O=h(n.onLiteralValue),x=h(n.onSeparator),oe=u(n.onComment),W=h(n.onError),te=r&&r.disallowComments,Q=r&&r.allowTrailingComma;function q(){for(;;){const ie=s.scan();switch(s.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:te||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(ie){case 12:case 13:te?ee(10):oe();break;case 16:ee(1);break;case 15:case 14:break;default:return ie}}}function ee(ie,le=[],ue=[]){if(W(ie),le.length+ue.length>0){let we=s.getToken();for(;we!==17;){if(le.indexOf(we)!==-1){q();break}else if(ue.indexOf(we)!==-1)break;we=q()}}}function H(ie){const le=s.getTokenValue();return ie?O(le):P(le),q(),!0}function T(){switch(s.getToken()){case 11:let ie=0;try{ie=JSON.parse(s.getTokenValue()),typeof ie!="number"&&(ee(2),ie=0)}catch(le){ee(2)}O(ie);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return q(),!0}function L(){return s.getToken()!==10?(ee(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(x(":"),q(),V()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function B(){y(),q();let ie=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ie||ee(4,[],[]),x(","),q(),s.getToken()===2&&Q)break}else ie&&ee(6,[],[]);L()||ee(4,[],[2,5]),ie=!0}return v(),s.getToken()!==2?ee(7,[2],[]):q(),!0}function U(){g(),q();let ie=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ie||ee(4,[],[]),x(","),q(),s.getToken()===4&&Q)break}else ie&&ee(6,[],[]);V()||ee(4,[],[4,5]),ie=!0}return F(),s.getToken()!==4?ee(8,[4],[]):q(),!0}function V(){switch(s.getToken()){case 3:return U();case 1:return B();case 10:return H(!0);default:return T()}}return q(),s.getToken()===17?r.allowEmptyContent?!0:(ee(4,[],[]),!1):V()?(s.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.visit=d;function l(t,n){let r=k(t),s=[],u,h=0,y;do switch(y=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:h!==y&&s.push(t.substring(h,y)),n!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,n)),h=r.getPosition();break}while(u!==17);return s.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(de[110],me([0,1,36]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function b(f,m,i){let I,p,D,o,a;if(m){for(o=m.offset,a=o+m.length,D=o;D>0&&!R(f,D-1);)D--;let h=a;for(;h<f.length&&!R(f,h);)h++;p=f.substring(D,h),I=S(p,i)}else p=f,I=0,D=0,o=0,a=f.length;const w=k(i,f);let _=!1,A=0,d;i.insertSpaces?d=C(" ",i.tabSize||4):d="	";const l=(0,E.createScanner)(p,!1);let c=!1;function t(){return w+C(d,I+A)}function n(){let h=l.scan();for(_=!1;h===15||h===14;)_=_||h===14,h=l.scan();return c=h===16||l.getTokenError()!==0,h}const r=[];function s(h,y,P){!c&&y<a&&P>o&&f.substring(y,P)!==h&&r.push({offset:y,length:P-y,content:h})}let u=n();if(u!==17){const h=l.getTokenOffset()+D,y=C(d,I);s(y,D,h)}for(;u!==17;){let h=l.getTokenOffset()+l.getTokenLength()+D,y=n(),P="";for(;!_&&(y===12||y===13);){const g=l.getTokenOffset()+D;s(" ",h,g),h=l.getTokenOffset()+l.getTokenLength()+D,P=y===12?t():"",y=n()}if(y===2)u!==1&&(A--,P=t());else if(y===4)u!==3&&(A--,P=t());else{switch(u){case 3:case 1:A++,P=t();break;case 5:case 12:P=t();break;case 13:_?P=t():P=" ";break;case 6:P=" ";break;case 10:if(y===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?P=" ":y!==5&&y!==17&&(c=!0);break;case 16:c=!0;break}_&&(y===12||y===13)&&(P=t())}const v=l.getTokenOffset()+D;s(P,h,v),u=y}return r}e.format=b;function C(f,m){let i="";for(let I=0;I<m;I++)i+=f;return i}function S(f,m){let i=0,I=0;const p=m.tabSize||4;for(;i<f.length;){const D=f.charAt(i);if(D===" ")I++;else if(D==="	")I+=p;else break;i++}return Math.floor(I/p)}function k(f,m){for(let i=0;i<m.length;i++){const I=m.charAt(i);if(I==="\r")return i+1<m.length&&m.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=k;function R(f,m){return`\r
`.indexOf(f.charAt(m))!==-1}e.isEOL=R}),define(de[111],me([0,1,36,110]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(m,i,I){return S(m,i,void 0,I)}e.removeProperty=C;function S(m,i,I,p,D){const o=i.slice(),a=[],w=(0,E.parseTree)(m,a);let _,A;for(;o.length>0&&(A=o.pop(),_=(0,E.findNodeAtLocation)(w,o),_===void 0&&I!==void 0);)typeof A=="string"?I={[A]:I}:I=[I];if(_)if(_.type==="object"&&typeof A=="string"&&Array.isArray(_.children)){const d=(0,E.findNodeAtLocation)(_,[A]);if(d!==void 0)if(I===void 0){if(!d.parent)throw new Error("Malformed AST");const l=_.children.indexOf(d.parent);let c,t=d.parent.offset+d.parent.length;if(l>0){const n=_.children[l-1];c=n.offset+n.length}else c=_.offset+1,_.children.length>1&&(t=_.children[1].offset);return k(m,{offset:c,length:t-c,content:""},p)}else return k(m,{offset:d.offset,length:d.length,content:JSON.stringify(I)},p);else{if(I===void 0)return[];const l=`${JSON.stringify(A)}: ${JSON.stringify(I)}`,c=D?D(_.children.map(n=>n.children[0].value)):_.children.length;let t;if(c>0){const n=_.children[c-1];t={offset:n.offset+n.length,length:0,content:","+l}}else _.children.length===0?t={offset:_.offset+1,length:0,content:l}:t={offset:_.offset+1,length:0,content:l+","};return k(m,t,p)}}else if(_.type==="array"&&typeof A=="number"&&Array.isArray(_.children))if(I!==void 0){const d=`${JSON.stringify(I)}`;let l;if(_.children.length===0||A===0)l={offset:_.offset+1,length:0,content:_.children.length===0?d:d+","};else{const c=A===-1||A>_.children.length?_.children.length:A,t=_.children[c-1];l={offset:t.offset+t.length,length:0,content:","+d}}return k(m,l,p)}else{const d=A,l=_.children[d];let c;if(_.children.length===1)c={offset:_.offset+1,length:_.length-2,content:""};else if(_.children.length-1===d){const t=_.children[d-1],n=t.offset+t.length,r=_.offset+_.length;c={offset:n,length:r-2-n,content:""}}else c={offset:l.offset,length:_.children[d+1].offset-l.offset,content:""};return k(m,c,p)}else throw new Error(`Can not add ${typeof A!="number"?"index":"property"} to parent of type ${_.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(m,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(I)},p)}}e.setProperty=S;function k(m,i,I){let p=R(m,i),D=i.offset,o=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;D>0&&!(0,b.isEOL)(p,D-1);)D--;for(;o<p.length&&!(0,b.isEOL)(p,o);)o++}const a=(0,b.format)(p,{offset:D,length:o-D},I);for(let _=a.length-1;_>=0;_--){const A=a[_];p=R(p,A),D=Math.min(D,A.offset),o=Math.max(o,A.offset+A.length),o+=A.content.length-A.length}const w=m.length-(p.length-o)-D;return[{offset:D,length:w,content:p.substring(D,o)}]}e.withFormatting=k;function R(m,i){return m.substring(0,i.offset)+i.content+m.substring(i.offset+i.length)}e.applyEdit=R;function f(m,i){let I=i.slice(0).sort((D,o)=>{const a=D.offset-o.offset;return a===0?D.length-o.length:a}),p=m.length;for(let D=I.length-1;D>=0;D--){let o=I[D];if(o.offset+o.length<=p)m=R(m,o);else throw new Error("Overlapping edit");p=o.offset}return m}e.applyEdits=f}),define(de[2],me([0,1,69,50]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let S=null;function k(d){S=d}if(e.setDisposableTracker=k,C){const d="__is_disposable_tracked__";S=new class{trackDisposable(l){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[d]||console.log(c)},3e3)}markTracked(l){if(l&&l!==a.None)try{l[d]=!0}catch(c){}}}}function R(d){!S||S.markTracked(d)}function f(d){return S&&S.trackDisposable(d),d}e.trackDisposable=f;class m extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=m;function i(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=i;function I(d){if(b.Iterable.is(d)){let l=[];for(const c of d)if(c){R(c);try{c.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new m(l);return Array.isArray(d)?[]:d}else if(d)return R(d),d.dispose(),d}e.dispose=I;function p(...d){return d.forEach(R),D(()=>I(d))}e.combinedDisposable=p;function D(d){const l=f({dispose:()=>{R(l),d()}});return l}e.toDisposable=D;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(R(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return R(l),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new o,f(this)}dispose(){R(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var c;this._isDisposed||l===this._value||((c=this._value)===null||c===void 0||c.dispose(),l&&R(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,R(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=w;class _{constructor(){this.references=new Map}acquire(l,...c){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...c)},this.references.set(l,t));const{object:n}=t,r=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=_;class A{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=A}),define(de[70],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(S){this.element=S,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class b{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,k){const R=new E(S);if(this._first===E.Undefined)this._first=R,this._last=R;else if(k){const m=this._last;this._last=R,R.prev=m,m.next=R}else{const m=this._first;this._first=R,R.next=m,m.prev=R}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(R))}}shift(){if(this._first!==E.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==E.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==E.Undefined&&S.next!==E.Undefined){const k=S.prev;k.next=S.next,S.next.prev=k}else S.prev===E.Undefined&&S.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):S.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):S.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==E.Undefined;)yield S.element,S=S.next}}e.LinkedList=b}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(j,K){for(var ne=0;ne<K.length;ne++){var z=K[ne];z.enumerable=z.enumerable||!1,z.configurable=!0,"value"in z&&(z.writable=!0),Object.defineProperty(j,z.key,z)}}function e(j,K,ne){return K&&Y(j.prototype,K),ne&&Y(j,ne),j}function E(j,K){if(!!j){if(typeof j=="string")return b(j,K);var ne=Object.prototype.toString.call(j).slice(8,-1);if(ne==="Object"&&j.constructor&&(ne=j.constructor.name),ne==="Map"||ne==="Set")return Array.from(j);if(ne==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ne))return b(j,K)}}function b(j,K){(K==null||K>j.length)&&(K=j.length);for(var ne=0,z=new Array(K);ne<K;ne++)z[ne]=j[ne];return z}function C(j,K){var ne;if(typeof Symbol=="undefined"||j[Symbol.iterator]==null){if(Array.isArray(j)||(ne=E(j))||K&&j&&typeof j.length=="number"){ne&&(j=ne);var z=0;return function(){return z>=j.length?{done:!0}:{done:!1,value:j[z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ne=j[Symbol.iterator](),ne.next.bind(ne)}function S(j){var K={exports:{}};return j(K,K.exports),K.exports}var k=S(function(j){function K(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ne(z){j.exports.defaults=z}j.exports={defaults:K(),getDefaults:K,changeDefaults:ne}}),R=/[&<>"']/,f=/[&<>"']/g,m=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(K){return I[K]};function D(j,K){if(K){if(R.test(j))return j.replace(f,p)}else if(m.test(j))return j.replace(i,p);return j}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(j){return j.replace(o,function(K,ne){return ne=ne.toLowerCase(),ne==="colon"?":":ne.charAt(0)==="#"?ne.charAt(1)==="x"?String.fromCharCode(parseInt(ne.substring(2),16)):String.fromCharCode(+ne.substring(1)):""})}var w=/(^|[^\[])\^/g;function _(j,K){j=j.source||j,K=K||"";var ne={replace:function(G,Z){return Z=Z.source||Z,Z=Z.replace(w,"$1"),j=j.replace(G,Z),ne},getRegex:function(){return new RegExp(j,K)}};return ne}var A=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(j,K,ne){if(j){var z;try{z=decodeURIComponent(a(ne)).replace(A,"").toLowerCase()}catch(G){return null}if(z.indexOf("javascript:")===0||z.indexOf("vbscript:")===0||z.indexOf("data:")===0)return null}K&&!d.test(ne)&&(ne=s(K,ne));try{ne=encodeURI(ne).replace(/%25/g,"%")}catch(G){return null}return ne}var c={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(j,K){c[" "+j]||(t.test(j)?c[" "+j]=j+"/":c[" "+j]=P(j,"/",!0)),j=c[" "+j];var ne=j.indexOf(":")===-1;return K.substring(0,2)==="//"?ne?K:j.replace(n,"$1")+K:K.charAt(0)==="/"?ne?K:j.replace(r,"$1")+K:j+K}var u={exec:function(){}};function h(j){for(var K=1,ne,z;K<arguments.length;K++){ne=arguments[K];for(z in ne)Object.prototype.hasOwnProperty.call(ne,z)&&(j[z]=ne[z])}return j}function y(j,K){var ne=j.replace(/\|/g,function(Z,re,ce){for(var Re=!1,Ce=re;--Ce>=0&&ce[Ce]==="\\";)Re=!Re;return Re?"|":" |"}),z=ne.split(/ \|/),G=0;if(z.length>K)z.splice(K);else for(;z.length<K;)z.push("");for(;G<z.length;G++)z[G]=z[G].trim().replace(/\\\|/g,"|");return z}function P(j,K,ne){var z=j.length;if(z===0)return"";for(var G=0;G<z;){var Z=j.charAt(z-G-1);if(Z===K&&!ne)G++;else if(Z!==K&&ne)G++;else break}return j.substr(0,z-G)}function v(j,K){if(j.indexOf(K[1])===-1)return-1;for(var ne=j.length,z=0,G=0;G<ne;G++)if(j[G]==="\\")G++;else if(j[G]===K[0])z++;else if(j[G]===K[1]&&(z--,z<0))return G;return-1}function g(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(j,K){if(K<1)return"";for(var ne="";K>1;)K&1&&(ne+=j),K>>=1,j+=j;return ne+j}var O={escape:D,unescape:a,edit:_,cleanUrl:l,resolveUrl:s,noopTest:u,merge:h,splitCells:y,rtrim:P,findClosingBracket:v,checkSanitizeDeprecation:g,repeatString:F},x=k.defaults,oe=O.rtrim,W=O.splitCells,te=O.escape,Q=O.findClosingBracket;function q(j,K,ne){var z=K.href,G=K.title?te(K.title):null,Z=j[1].replace(/\\([\[\]])/g,"$1");return j[0].charAt(0)!=="!"?{type:"link",raw:ne,href:z,title:G,text:Z}:{type:"image",raw:ne,href:z,title:G,text:te(Z)}}function ee(j,K){var ne=j.match(/^(\s+)(?:```)/);if(ne===null)return K;var z=ne[1];return K.split(`
`).map(function(G){var Z=G.match(/^\s+/);if(Z===null)return G;var re=Z[0];return re.length>=z.length?G.slice(z.length):G}).join(`
`)}var H=function(){function j(ne){this.options=ne||x}var K=j.prototype;return K.space=function(z){var G=this.rules.block.newline.exec(z);if(G)return G[0].length>1?{type:"space",raw:G[0]}:{raw:`
`}},K.code=function(z){var G=this.rules.block.code.exec(z);if(G){var Z=G[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:G[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:oe(Z,`
`)}}},K.fences=function(z){var G=this.rules.block.fences.exec(z);if(G){var Z=G[0],re=ee(Z,G[3]||"");return{type:"code",raw:Z,lang:G[2]?G[2].trim():G[2],text:re}}},K.heading=function(z){var G=this.rules.block.heading.exec(z);if(G){var Z=G[2].trim();if(/#$/.test(Z)){var re=oe(Z,"#");(this.options.pedantic||!re||/ $/.test(re))&&(Z=re.trim())}return{type:"heading",raw:G[0],depth:G[1].length,text:Z}}},K.nptable=function(z){var G=this.rules.block.nptable.exec(z);if(G){var Z={type:"table",header:W(G[1].replace(/^ *| *\| *$/g,"")),align:G[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:G[3]?G[3].replace(/\n$/,"").split(`
`):[],raw:G[0]};if(Z.header.length===Z.align.length){var re=Z.align.length,ce;for(ce=0;ce<re;ce++)/^ *-+: *$/.test(Z.align[ce])?Z.align[ce]="right":/^ *:-+: *$/.test(Z.align[ce])?Z.align[ce]="center":/^ *:-+ *$/.test(Z.align[ce])?Z.align[ce]="left":Z.align[ce]=null;for(re=Z.cells.length,ce=0;ce<re;ce++)Z.cells[ce]=W(Z.cells[ce],Z.header.length);return Z}}},K.hr=function(z){var G=this.rules.block.hr.exec(z);if(G)return{type:"hr",raw:G[0]}},K.blockquote=function(z){var G=this.rules.block.blockquote.exec(z);if(G){var Z=G[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:G[0],text:Z}}},K.list=function(z){var G=this.rules.block.list.exec(z);if(G){var Z=G[0],re=G[2],ce=re.length>1,Re={type:"list",raw:Z,ordered:ce,start:ce?+re.slice(0,-1):"",loose:!1,items:[]},Ce=G[0].match(this.rules.block.item),Pe=!1,fe,Se,Te,Me,Ue,Xe,Ye,ae,he=Ce.length;Te=this.rules.block.listItemStart.exec(Ce[0]);for(var J=0;J<he;J++){if(fe=Ce[J],Z=fe,J!==he-1){if(Me=this.rules.block.listItemStart.exec(Ce[J+1]),this.options.pedantic?Me[1].length>Te[1].length:Me[1].length>Te[0].length||Me[1].length>3){Ce.splice(J,2,Ce[J]+`
`+Ce[J+1]),J--,he--;continue}else(!this.options.pedantic||this.options.smartLists?Me[2][Me[2].length-1]!==re[re.length-1]:ce===(Me[2].length===1))&&(Ue=Ce.slice(J+1).join(`
`),Re.raw=Re.raw.substring(0,Re.raw.length-Ue.length),J=he-1);Te=Me}Se=fe.length,fe=fe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~fe.indexOf(`
 `)&&(Se-=fe.length,fe=this.options.pedantic?fe.replace(/^ {1,4}/gm,""):fe.replace(new RegExp("^ {1,"+Se+"}","gm"),"")),Xe=Pe||/\n\n(?!\s*$)/.test(fe),J!==he-1&&(Pe=fe.charAt(fe.length-1)===`
`,Xe||(Xe=Pe)),Xe&&(Re.loose=!0),this.options.gfm&&(Ye=/^\[[ xX]\] /.test(fe),ae=void 0,Ye&&(ae=fe[1]!==" ",fe=fe.replace(/^\[[ xX]\] +/,""))),Re.items.push({type:"list_item",raw:Z,task:Ye,checked:ae,loose:Xe,text:fe})}return Re}},K.html=function(z){var G=this.rules.block.html.exec(z);if(G)return{type:this.options.sanitize?"paragraph":"html",raw:G[0],pre:!this.options.sanitizer&&(G[1]==="pre"||G[1]==="script"||G[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):te(G[0]):G[0]}},K.def=function(z){var G=this.rules.block.def.exec(z);if(G){G[3]&&(G[3]=G[3].substring(1,G[3].length-1));var Z=G[1].toLowerCase().replace(/\s+/g," ");return{tag:Z,raw:G[0],href:G[2],title:G[3]}}},K.table=function(z){var G=this.rules.block.table.exec(z);if(G){var Z={type:"table",header:W(G[1].replace(/^ *| *\| *$/g,"")),align:G[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:G[3]?G[3].replace(/\n$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=G[0];var re=Z.align.length,ce;for(ce=0;ce<re;ce++)/^ *-+: *$/.test(Z.align[ce])?Z.align[ce]="right":/^ *:-+: *$/.test(Z.align[ce])?Z.align[ce]="center":/^ *:-+ *$/.test(Z.align[ce])?Z.align[ce]="left":Z.align[ce]=null;for(re=Z.cells.length,ce=0;ce<re;ce++)Z.cells[ce]=W(Z.cells[ce].replace(/^ *\| *| *\| *$/g,""),Z.header.length);return Z}}},K.lheading=function(z){var G=this.rules.block.lheading.exec(z);if(G)return{type:"heading",raw:G[0],depth:G[2].charAt(0)==="="?1:2,text:G[1]}},K.paragraph=function(z){var G=this.rules.block.paragraph.exec(z);if(G)return{type:"paragraph",raw:G[0],text:G[1].charAt(G[1].length-1)===`
`?G[1].slice(0,-1):G[1]}},K.text=function(z){var G=this.rules.block.text.exec(z);if(G)return{type:"text",raw:G[0],text:G[0]}},K.escape=function(z){var G=this.rules.inline.escape.exec(z);if(G)return{type:"escape",raw:G[0],text:te(G[1])}},K.tag=function(z,G,Z){var re=this.rules.inline.tag.exec(z);if(re)return!G&&/^<a /i.test(re[0])?G=!0:G&&/^<\/a>/i.test(re[0])&&(G=!1),!Z&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?Z=!0:Z&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(Z=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:G,inRawBlock:Z,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):te(re[0]):re[0]}},K.link=function(z){var G=this.rules.inline.link.exec(z);if(G){var Z=G[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var re=oe(Z.slice(0,-1),"\\");if((Z.length-re.length)%2==0)return}else{var ce=Q(G[2],"()");if(ce>-1){var Re=G[0].indexOf("!")===0?5:4,Ce=Re+G[1].length+ce;G[2]=G[2].substring(0,ce),G[0]=G[0].substring(0,Ce).trim(),G[3]=""}}var Pe=G[2],fe="";if(this.options.pedantic){var Se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);Se&&(Pe=Se[1],fe=Se[3])}else fe=G[3]?G[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(Z)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),q(G,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},G[0])}},K.reflink=function(z,G){var Z;if((Z=this.rules.inline.reflink.exec(z))||(Z=this.rules.inline.nolink.exec(z))){var re=(Z[2]||Z[1]).replace(/\s+/g," ");if(re=G[re.toLowerCase()],!re||!re.href){var ce=Z[0].charAt(0);return{type:"text",raw:ce,text:ce}}return q(Z,re,Z[0])}},K.emStrong=function(z,G,Z){Z===void 0&&(Z="");var re=this.rules.inline.emStrong.lDelim.exec(z);if(!!re&&!(re[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=re[1]||re[2]||"";if(!ce||ce&&(Z===""||this.rules.inline.punctuation.exec(Z))){var Re=re[0].length-1,Ce,Pe,fe=Re,Se=0,Te=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Te.lastIndex=0,G=G.slice(-1*z.length+Re);(re=Te.exec(G))!=null;)if(Ce=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!Ce){if(Pe=Ce.length,re[3]||re[4]){fe+=Pe;continue}else if((re[5]||re[6])&&Re%3&&!((Re+Pe)%3)){Se+=Pe;continue}if(fe-=Pe,!(fe>0)){if(fe+Se-Pe<=0&&!G.slice(Te.lastIndex).match(Te)&&(Pe=Math.min(Pe,Pe+fe+Se)),Math.min(Re,Pe)%2)return{type:"em",raw:z.slice(0,Re+re.index+Pe+1),text:z.slice(1,Re+re.index+Pe)};if(Math.min(Re,Pe)%2==0)return{type:"strong",raw:z.slice(0,Re+re.index+Pe+1),text:z.slice(2,Re+re.index+Pe-1)}}}}}},K.codespan=function(z){var G=this.rules.inline.code.exec(z);if(G){var Z=G[2].replace(/\n/g," "),re=/[^ ]/.test(Z),ce=/^ /.test(Z)&&/ $/.test(Z);return re&&ce&&(Z=Z.substring(1,Z.length-1)),Z=te(Z,!0),{type:"codespan",raw:G[0],text:Z}}},K.br=function(z){var G=this.rules.inline.br.exec(z);if(G)return{type:"br",raw:G[0]}},K.del=function(z){var G=this.rules.inline.del.exec(z);if(G)return{type:"del",raw:G[0],text:G[2]}},K.autolink=function(z,G){var Z=this.rules.inline.autolink.exec(z);if(Z){var re,ce;return Z[2]==="@"?(re=te(this.options.mangle?G(Z[1]):Z[1]),ce="mailto:"+re):(re=te(Z[1]),ce=re),{type:"link",raw:Z[0],text:re,href:ce,tokens:[{type:"text",raw:re,text:re}]}}},K.url=function(z,G){var Z;if(Z=this.rules.inline.url.exec(z)){var re,ce;if(Z[2]==="@")re=te(this.options.mangle?G(Z[0]):Z[0]),ce="mailto:"+re;else{var Re;do Re=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(Re!==Z[0]);re=te(Z[0]),Z[1]==="www."?ce="http://"+re:ce=re}return{type:"link",raw:Z[0],text:re,href:ce,tokens:[{type:"text",raw:re,text:re}]}}},K.inlineText=function(z,G,Z){var re=this.rules.inline.text.exec(z);if(re){var ce;return G?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):te(re[0]):re[0]:ce=te(this.options.smartypants?Z(re[0]):re[0]),{type:"text",raw:re[0],text:ce}}},j}(),T=O.noopTest,L=O.edit,B=O.merge,U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:T,table:T,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=L(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,U.item=L(U.item,"gm").replace(/bull/g,U.bullet).getRegex(),U.listItemStart=L(/^( *)(bull)/).replace("bull",U.bullet).getRegex(),U.list=L(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=L(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=L(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.blockquote=L(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=B({},U),U.gfm=B({},U.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.nptable=L(U.gfm.nptable).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.gfm.table=L(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.pedantic=B({},U.normal,{html:L(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:T,paragraph:L(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:T,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:T,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=L(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=L(U._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=L(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=L(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=L(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=L(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=L(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=L(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=L(V.reflink).replace("label",V._label).getRegex(),V.reflinkSearch=L(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=B({},V),V.pedantic=B({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:L(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:L(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=B({},V.normal,{escape:L(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),V.gfm.url=L(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=B({},V.gfm,{br:L(V.br).replace("{2,}","*").getRegex(),text:L(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:U,inline:V},le=k.defaults,ue=ie.block,we=ie.inline,ke=O.repeatString;function Ae(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Fe(j){var K="",ne,z,G=j.length;for(ne=0;ne<G;ne++)z=j.charCodeAt(ne),Math.random()>.5&&(z="x"+z.toString(16)),K+="&#"+z+";";return K}var je=function(){function j(ne){this.tokens=[],this.tokens.links=Object.create(null),this.options=ne||le,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var z={block:ue.normal,inline:we.normal};this.options.pedantic?(z.block=ue.pedantic,z.inline=we.pedantic):this.options.gfm&&(z.block=ue.gfm,this.options.breaks?z.inline=we.breaks:z.inline=we.gfm),this.tokenizer.rules=z}j.lex=function(z,G){var Z=new j(G);return Z.lex(z)},j.lexInline=function(z,G){var Z=new j(G);return Z.inlineTokens(z)};var K=j.prototype;return K.lex=function(z){return z=z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(z,this.tokens,!0),this.inline(this.tokens),this.tokens},K.blockTokens=function(z,G,Z){G===void 0&&(G=[]),Z===void 0&&(Z=!0),this.options.pedantic&&(z=z.replace(/^ +$/gm,""));for(var re,ce,Re,Ce;z;){if(re=this.tokenizer.space(z)){z=z.substring(re.raw.length),re.type&&G.push(re);continue}if(re=this.tokenizer.code(z)){z=z.substring(re.raw.length),Ce=G[G.length-1],Ce&&Ce.type==="paragraph"?(Ce.raw+=`
`+re.raw,Ce.text+=`
`+re.text):G.push(re);continue}if(re=this.tokenizer.fences(z)){z=z.substring(re.raw.length),G.push(re);continue}if(re=this.tokenizer.heading(z)){z=z.substring(re.raw.length),G.push(re);continue}if(re=this.tokenizer.nptable(z)){z=z.substring(re.raw.length),G.push(re);continue}if(re=this.tokenizer.hr(z)){z=z.substring(re.raw.length),G.push(re);continue}if(re=this.tokenizer.blockquote(z)){z=z.substring(re.raw.length),re.tokens=this.blockTokens(re.text,[],Z),G.push(re);continue}if(re=this.tokenizer.list(z)){for(z=z.substring(re.raw.length),Re=re.items.length,ce=0;ce<Re;ce++)re.items[ce].tokens=this.blockTokens(re.items[ce].text,[],!1);G.push(re);continue}if(re=this.tokenizer.html(z)){z=z.substring(re.raw.length),G.push(re);continue}if(Z&&(re=this.tokenizer.def(z))){z=z.substring(re.raw.length),this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(z)){z=z.substring(re.raw.length),G.push(re);continue}if(re=this.tokenizer.lheading(z)){z=z.substring(re.raw.length),G.push(re);continue}if(Z&&(re=this.tokenizer.paragraph(z))){z=z.substring(re.raw.length),G.push(re);continue}if(re=this.tokenizer.text(z)){z=z.substring(re.raw.length),Ce=G[G.length-1],Ce&&Ce.type==="text"?(Ce.raw+=`
`+re.raw,Ce.text+=`
`+re.text):G.push(re);continue}if(z){var Pe="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return G},K.inline=function(z){var G,Z,re,ce,Re,Ce,Pe=z.length;for(G=0;G<Pe;G++)switch(Ce=z[G],Ce.type){case"paragraph":case"text":case"heading":{Ce.tokens=[],this.inlineTokens(Ce.text,Ce.tokens);break}case"table":{for(Ce.tokens={header:[],cells:[]},ce=Ce.header.length,Z=0;Z<ce;Z++)Ce.tokens.header[Z]=[],this.inlineTokens(Ce.header[Z],Ce.tokens.header[Z]);for(ce=Ce.cells.length,Z=0;Z<ce;Z++)for(Re=Ce.cells[Z],Ce.tokens.cells[Z]=[],re=0;re<Re.length;re++)Ce.tokens.cells[Z][re]=[],this.inlineTokens(Re[re],Ce.tokens.cells[Z][re]);break}case"blockquote":{this.inline(Ce.tokens);break}case"list":{for(ce=Ce.items.length,Z=0;Z<ce;Z++)this.inline(Ce.items[Z].tokens);break}}return z},K.inlineTokens=function(z,G,Z,re){G===void 0&&(G=[]),Z===void 0&&(Z=!1),re===void 0&&(re=!1);var ce,Re,Ce=z,Pe,fe,Se;if(this.tokens.links){var Te=Object.keys(this.tokens.links);if(Te.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)Te.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Pe.index)+"["+ke("a",Pe[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Pe.index)+"["+ke("a",Pe[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Pe.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;z;){if(fe||(Se=""),fe=!1,ce=this.tokenizer.escape(z)){z=z.substring(ce.raw.length),G.push(ce);continue}if(ce=this.tokenizer.tag(z,Z,re)){z=z.substring(ce.raw.length),Z=ce.inLink,re=ce.inRawBlock;var Me=G[G.length-1];Me&&ce.type==="text"&&Me.type==="text"?(Me.raw+=ce.raw,Me.text+=ce.text):G.push(ce);continue}if(ce=this.tokenizer.link(z)){z=z.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,re)),G.push(ce);continue}if(ce=this.tokenizer.reflink(z,this.tokens.links)){z=z.substring(ce.raw.length);var Ue=G[G.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,re),G.push(ce)):Ue&&ce.type==="text"&&Ue.type==="text"?(Ue.raw+=ce.raw,Ue.text+=ce.text):G.push(ce);continue}if(ce=this.tokenizer.emStrong(z,Ce,Se)){z=z.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],Z,re),G.push(ce);continue}if(ce=this.tokenizer.codespan(z)){z=z.substring(ce.raw.length),G.push(ce);continue}if(ce=this.tokenizer.br(z)){z=z.substring(ce.raw.length),G.push(ce);continue}if(ce=this.tokenizer.del(z)){z=z.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],Z,re),G.push(ce);continue}if(ce=this.tokenizer.autolink(z,Fe)){z=z.substring(ce.raw.length),G.push(ce);continue}if(!Z&&(ce=this.tokenizer.url(z,Fe))){z=z.substring(ce.raw.length),G.push(ce);continue}if(ce=this.tokenizer.inlineText(z,re,Ae)){z=z.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Se=ce.raw.slice(-1)),fe=!0,Re=G[G.length-1],Re&&Re.type==="text"?(Re.raw+=ce.raw,Re.text+=ce.text):G.push(ce);continue}if(z){var Xe="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return G},e(j,null,[{key:"rules",get:function(){return{block:ue,inline:we}}}]),j}(),Qe=k.defaults,qe=O.cleanUrl,it=O.escape,tt=function(){function j(ne){this.options=ne||Qe}var K=j.prototype;return K.code=function(z,G,Z){var re=(G||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(z,re);ce!=null&&ce!==z&&(Z=!0,z=ce)}return z=z.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+it(re,!0)+'">'+(Z?z:it(z,!0))+`</code></pre>
`:"<pre><code>"+(Z?z:it(z,!0))+`</code></pre>
`},K.blockquote=function(z){return`<blockquote>
`+z+`</blockquote>
`},K.html=function(z){return z},K.heading=function(z,G,Z,re){return this.options.headerIds?"<h"+G+' id="'+this.options.headerPrefix+re.slug(Z)+'">'+z+"</h"+G+`>
`:"<h"+G+">"+z+"</h"+G+`>
`},K.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},K.list=function(z,G,Z){var re=G?"ol":"ul",ce=G&&Z!==1?' start="'+Z+'"':"";return"<"+re+ce+`>
`+z+"</"+re+`>
`},K.listitem=function(z){return"<li>"+z+`</li>
`},K.checkbox=function(z){return"<input "+(z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},K.paragraph=function(z){return"<p>"+z+`</p>
`},K.table=function(z,G){return G&&(G="<tbody>"+G+"</tbody>"),`<table>
<thead>
`+z+`</thead>
`+G+`</table>
`},K.tablerow=function(z){return`<tr>
`+z+`</tr>
`},K.tablecell=function(z,G){var Z=G.header?"th":"td",re=G.align?"<"+Z+' align="'+G.align+'">':"<"+Z+">";return re+z+"</"+Z+`>
`},K.strong=function(z){return"<strong>"+z+"</strong>"},K.em=function(z){return"<em>"+z+"</em>"},K.codespan=function(z){return"<code>"+z+"</code>"},K.br=function(){return this.options.xhtml?"<br/>":"<br>"},K.del=function(z){return"<del>"+z+"</del>"},K.link=function(z,G,Z){if(z=qe(this.options.sanitize,this.options.baseUrl,z),z===null)return Z;var re='<a href="'+it(z)+'"';return G&&(re+=' title="'+G+'"'),re+=">"+Z+"</a>",re},K.image=function(z,G,Z){if(z=qe(this.options.sanitize,this.options.baseUrl,z),z===null)return Z;var re='<img src="'+z+'" alt="'+Z+'"';return G&&(re+=' title="'+G+'"'),re+=this.options.xhtml?"/>":">",re},K.text=function(z){return z},j}(),ye=function(){function j(){}var K=j.prototype;return K.strong=function(z){return z},K.em=function(z){return z},K.codespan=function(z){return z},K.del=function(z){return z},K.html=function(z){return z},K.text=function(z){return z},K.link=function(z,G,Z){return""+Z},K.image=function(z,G,Z){return""+Z},K.br=function(){return""},j}(),be=function(){function j(){this.seen={}}var K=j.prototype;return K.serialize=function(z){return z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},K.getNextSafeSlug=function(z,G){var Z=z,re=0;if(this.seen.hasOwnProperty(Z)){re=this.seen[z];do re++,Z=z+"-"+re;while(this.seen.hasOwnProperty(Z))}return G||(this.seen[z]=re,this.seen[Z]=0),Z},K.slug=function(z,G){G===void 0&&(G={});var Z=this.serialize(z);return this.getNextSafeSlug(Z,G.dryrun)},j}(),_e=k.defaults,Ie=O.unescape,Le=function(){function j(ne){this.options=ne||_e,this.options.renderer=this.options.renderer||new tt,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new be}j.parse=function(z,G){var Z=new j(G);return Z.parse(z)},j.parseInline=function(z,G){var Z=new j(G);return Z.parseInline(z)};var K=j.prototype;return K.parse=function(z,G){G===void 0&&(G=!0);var Z="",re,ce,Re,Ce,Pe,fe,Se,Te,Me,Ue,Xe,Ye,ae,he,J,$,De,Ee,$e=z.length;for(re=0;re<$e;re++)switch(Ue=z[re],Ue.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,Ie(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(Te="",Se="",Ce=Ue.header.length,ce=0;ce<Ce;ce++)Se+=this.renderer.tablecell(this.parseInline(Ue.tokens.header[ce]),{header:!0,align:Ue.align[ce]});for(Te+=this.renderer.tablerow(Se),Me="",Ce=Ue.cells.length,ce=0;ce<Ce;ce++){for(fe=Ue.tokens.cells[ce],Se="",Pe=fe.length,Re=0;Re<Pe;Re++)Se+=this.renderer.tablecell(this.parseInline(fe[Re]),{header:!1,align:Ue.align[Re]});Me+=this.renderer.tablerow(Se)}Z+=this.renderer.table(Te,Me);continue}case"blockquote":{Me=this.parse(Ue.tokens),Z+=this.renderer.blockquote(Me);continue}case"list":{for(Xe=Ue.ordered,Ye=Ue.start,ae=Ue.loose,Ce=Ue.items.length,Me="",ce=0;ce<Ce;ce++)J=Ue.items[ce],$=J.checked,De=J.task,he="",J.task&&(Ee=this.renderer.checkbox($),ae?J.tokens.length>0&&J.tokens[0].type==="text"?(J.tokens[0].text=Ee+" "+J.tokens[0].text,J.tokens[0].tokens&&J.tokens[0].tokens.length>0&&J.tokens[0].tokens[0].type==="text"&&(J.tokens[0].tokens[0].text=Ee+" "+J.tokens[0].tokens[0].text)):J.tokens.unshift({type:"text",text:Ee}):he+=Ee),he+=this.parse(J.tokens,ae),Me+=this.renderer.listitem(he,De,$);Z+=this.renderer.list(Me,Xe,Ye);continue}case"html":{Z+=this.renderer.html(Ue.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(Me=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;re+1<$e&&z[re+1].type==="text";)Ue=z[++re],Me+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);Z+=G?this.renderer.paragraph(Me):Me;continue}default:{var He='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}return Z},K.parseInline=function(z,G){G=G||this.renderer;var Z="",re,ce,Re=z.length;for(re=0;re<Re;re++)switch(ce=z[re],ce.type){case"escape":{Z+=G.text(ce.text);break}case"html":{Z+=G.html(ce.text);break}case"link":{Z+=G.link(ce.href,ce.title,this.parseInline(ce.tokens,G));break}case"image":{Z+=G.image(ce.href,ce.title,ce.text);break}case"strong":{Z+=G.strong(this.parseInline(ce.tokens,G));break}case"em":{Z+=G.em(this.parseInline(ce.tokens,G));break}case"codespan":{Z+=G.codespan(ce.text);break}case"br":{Z+=G.br();break}case"del":{Z+=G.del(this.parseInline(ce.tokens,G));break}case"text":{Z+=G.text(ce.text);break}default:{var Ce='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}return Z},j}(),ze=O.merge,We=O.checkSanitizeDeprecation,Ke=O.escape,et=k.getDefaults,se=k.changeDefaults,ve=k.defaults;function ge(j,K,ne){if(typeof j=="undefined"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof K=="function"&&(ne=K,K=null),K=ze({},ge.defaults,K||{}),We(K),ne){var z=K.highlight,G;try{G=je.lex(j,K)}catch(Re){return ne(Re)}var Z=function(Ce){var Pe;if(!Ce)try{Pe=Le.parse(G,K)}catch(fe){Ce=fe}return K.highlight=z,Ce?ne(Ce):ne(null,Pe)};if(!z||z.length<3||(delete K.highlight,!G.length))return Z();var re=0;ge.walkTokens(G,function(Re){Re.type==="code"&&(re++,setTimeout(function(){z(Re.text,Re.lang,function(Ce,Pe){if(Ce)return Z(Ce);Pe!=null&&Pe!==Re.text&&(Re.text=Pe,Re.escaped=!0),re--,re===0&&Z()})},0))}),re===0&&Z();return}try{var ce=je.lex(j,K);return K.walkTokens&&ge.walkTokens(ce,K.walkTokens),Le.parse(ce,K)}catch(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+Ke(Re.message+"",!0)+"</pre>";throw Re}}ge.options=ge.setOptions=function(j){return ze(ge.defaults,j),se(ge.defaults),ge},ge.getDefaults=et,ge.defaults=ve,ge.use=function(j){var K=ze({},j);if(j.renderer&&function(){var z=ge.defaults.renderer||new tt,G=function(ce){var Re=z[ce];z[ce]=function(){for(var Ce=arguments.length,Pe=new Array(Ce),fe=0;fe<Ce;fe++)Pe[fe]=arguments[fe];var Se=j.renderer[ce].apply(z,Pe);return Se===!1&&(Se=Re.apply(z,Pe)),Se}};for(var Z in j.renderer)G(Z);K.renderer=z}(),j.tokenizer&&function(){var z=ge.defaults.tokenizer||new H,G=function(ce){var Re=z[ce];z[ce]=function(){for(var Ce=arguments.length,Pe=new Array(Ce),fe=0;fe<Ce;fe++)Pe[fe]=arguments[fe];var Se=j.tokenizer[ce].apply(z,Pe);return Se===!1&&(Se=Re.apply(z,Pe)),Se}};for(var Z in j.tokenizer)G(Z);K.tokenizer=z}(),j.walkTokens){var ne=ge.defaults.walkTokens;K.walkTokens=function(z){j.walkTokens(z),ne&&ne(z)}}ge.setOptions(K)},ge.walkTokens=function(j,K){for(var ne=C(j),z;!(z=ne()).done;){var G=z.value;switch(K(G),G.type){case"table":{for(var Z=C(G.tokens.header),re;!(re=Z()).done;){var ce=re.value;ge.walkTokens(ce,K)}for(var Re=C(G.tokens.cells),Ce;!(Ce=Re()).done;)for(var Pe=Ce.value,fe=C(Pe),Se;!(Se=fe()).done;){var Te=Se.value;ge.walkTokens(Te,K)}break}case"list":{ge.walkTokens(G.items,K);break}default:G.tokens&&ge.walkTokens(G.tokens,K)}}},ge.parseInline=function(j,K){if(typeof j=="undefined"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");K=ze({},ge.defaults,K||{}),We(K);try{var ne=je.lexInline(j,K);return K.walkTokens&&ge.walkTokens(ne,K.walkTokens),Le.parseInline(ne,K)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+Ke(z.message+"",!0)+"</pre>";throw z}},ge.Parser=Le,ge.parser=Le.parse,ge.Renderer=tt,ge.TextRenderer=ye,ge.Lexer=je,ge.lexer=je.lex,ge.Tokenizer=H,ge.Slugger=be,ge.parse=ge;var Ne=ge;return Ne}),define(de[112],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(k,R,f){return Math.min(Math.max(k,R),f)}e.clamp=E;function b(k,R){return(R+k%R)%R}e.rot=b;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class S{constructor(){this._n=1,this._val=0}update(R){return this._val=this._val+(R-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S});"use strict";(function(){function Y(C){const S=[];typeof C=="number"&&S.push("code/timeOrigin",C);function k(f){S.push(f,Date.now())}function R(){const f=[];for(let m=0;m<S.length;m+=2)f.push({name:S[m],startTime:S[m+1]});return f}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const k of performance.getEntriesByType("mark"))S.push({name:k.name,startTime:Math.round(C+k.startTime)});return S}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=E(b))})(),define(de[5],me([0,1]),function(Y,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const b="en";let C=!1,S=!1,k=!1,R=!1,f=!1,m=!1,i=!1,I,p=b,D,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const w=typeof((E=a==null?void 0:a.versions)===null||E===void 0?void 0:E.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=w&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)o=navigator.userAgent,C=o.indexOf("Windows")>=0,S=o.indexOf("Macintosh")>=0,i=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=o.indexOf("Linux")>=0,m=!0,I=navigator.language,p=I;else if(typeof a=="object"){C=a.platform==="win32",S=a.platform==="darwin",k=a.platform==="linux",R=k&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,I=b,p=b;const s=a.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),h=u.availableLanguages["*"];I=u.locale,p=h||b,D=u._translationsConfigFile}catch(u){}f=!0}else console.error("Unable to resolve platform.");var _;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function A(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let d=0;S?d=1:C?d=3:k&&(d=2),e.isWindows=C,e.isMacintosh=S,e.isLinux=k,e.isLinuxSnap=R,e.isNative=f,e.isWeb=m,e.isIOS=i,e.platform=d,e.userAgent=o,e.language=p;var l;(function(s){function u(){return e.language}s.value=u;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function y(){return e.language==="en"}s.isDefault=y})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=D,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let v=0,g=h.length;v<g;v++){const F=h[v];if(F.id===P.data.vscodeSetImmediateId){h.splice(v,1),F.callback();return}}});let y=0;return P=>{const v=++y;h.push({id:v,callback:P}),e.globals.postMessage({vscodeSetImmediateId:v},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const u=Promise.resolve();return h=>u.then(h)}();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||i?2:C?1:3;let t=!0,n=!1;function r(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(de[24],me([0,1,5]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let b;if(typeof E.globals.vscode!="undefined"){const C=E.globals.vscode.process;b={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(S){return(0,E.setImmediate)(S)}}}else typeof process!="undefined"?b={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:b={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(C){return(0,E.setImmediate)(C)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=b.cwd,e.env=b.env,e.platform=b.platform,e.nextTick=b.nextTick}),define(de[4],me([0,1,24]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const b=65,C=97,S=90,k=122,R=46,f=47,m=92,i=58,I=63;class p extends Error{constructor(l,c,t){let n;typeof c=="string"&&c.indexOf("not ")===0?(n="must not be",c=c.replace(/^not /,"")):n="must be";const r=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${r} ${n} of type ${c}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function D(d,l){if(typeof d!="string")throw new p(l,"string",d)}function o(d){return d===f||d===m}function a(d){return d===f}function w(d){return d>=b&&d<=S||d>=C&&d<=k}function _(d,l,c,t){let n="",r=0,s=-1,u=0,h=0;for(let y=0;y<=d.length;++y){if(y<d.length)h=d.charCodeAt(y);else{if(t(h))break;h=f}if(t(h)){if(!(s===y-1||u===1))if(u===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==R||n.charCodeAt(n.length-2)!==R){if(n.length>2){const P=n.lastIndexOf(c);P===-1?(n="",r=0):(n=n.slice(0,P),r=n.length-1-n.lastIndexOf(c)),s=y,u=0;continue}else if(n.length!==0){n="",r=0,s=y,u=0;continue}}l&&(n+=n.length>0?`${c}..`:"..",r=2)}else n.length>0?n+=`${c}${d.slice(s+1,y)}`:n=d.slice(s+1,y),r=y-s-1;s=y,u=0}else h===R&&u!==-1?++u:u=-1}return n}function A(d,l){if(l===null||typeof l!="object")throw new p("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${d}${t}`:t}e.win32={resolve(...d){let l="",c="",t=!1;for(let n=d.length-1;n>=-1;n--){let r;if(n>=0){if(r=d[n],D(r,"path"),r.length===0)continue}else l.length===0?r=E.cwd():(r=E.env[`=${l}`]||E.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${l}\\`));const s=r.length;let u=0,h="",y=!1;const P=r.charCodeAt(0);if(s===1)o(P)&&(u=1,y=!0);else if(o(P))if(y=!0,o(r.charCodeAt(1))){let v=2,g=v;for(;v<s&&!o(r.charCodeAt(v));)v++;if(v<s&&v!==g){const F=r.slice(g,v);for(g=v;v<s&&o(r.charCodeAt(v));)v++;if(v<s&&v!==g){for(g=v;v<s&&!o(r.charCodeAt(v));)v++;(v===s||v!==g)&&(h=`\\\\${F}\\${r.slice(g,v)}`,u=v)}}}else u=1;else w(P)&&r.charCodeAt(1)===i&&(h=r.slice(0,2),u=2,s>2&&o(r.charCodeAt(2))&&(y=!0,u=3));if(h.length>0)if(l.length>0){if(h.toLowerCase()!==l.toLowerCase())continue}else l=h;if(t){if(l.length>0)break}else if(c=`${r.slice(u)}\\${c}`,t=y,y&&l.length>0)break}return c=_(c,!t,"\\",o),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(d){D(d,"path");const l=d.length;if(l===0)return".";let c=0,t,n=!1;const r=d.charCodeAt(0);if(l===1)return a(r)?"\\":d;if(o(r))if(n=!0,o(d.charCodeAt(1))){let u=2,h=u;for(;u<l&&!o(d.charCodeAt(u));)u++;if(u<l&&u!==h){const y=d.slice(h,u);for(h=u;u<l&&o(d.charCodeAt(u));)u++;if(u<l&&u!==h){for(h=u;u<l&&!o(d.charCodeAt(u));)u++;if(u===l)return`\\\\${y}\\${d.slice(h)}\\`;u!==h&&(t=`\\\\${y}\\${d.slice(h,u)}`,c=u)}}}else c=1;else w(r)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),c=2,l>2&&o(d.charCodeAt(2))&&(n=!0,c=3));let s=c<l?_(d.slice(c),!n,"\\",o):"";return s.length===0&&!n&&(s="."),s.length>0&&o(d.charCodeAt(l-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(d){D(d,"path");const l=d.length;if(l===0)return!1;const c=d.charCodeAt(0);return o(c)||l>2&&w(c)&&d.charCodeAt(1)===i&&o(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,c;for(let r=0;r<d.length;++r){const s=d[r];D(s,"path"),s.length>0&&(l===void 0?l=c=s:l+=`\\${s}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof c=="string"&&o(c.charCodeAt(0))){++n;const r=c.length;r>1&&o(c.charCodeAt(1))&&(++n,r>2&&(o(c.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&o(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(d,l){if(D(d,"from"),D(l,"to"),d===l)return"";const c=e.win32.resolve(d),t=e.win32.resolve(l);if(c===t||(d=c.toLowerCase(),l=t.toLowerCase(),d===l))return"";let n=0;for(;n<d.length&&d.charCodeAt(n)===m;)n++;let r=d.length;for(;r-1>n&&d.charCodeAt(r-1)===m;)r--;const s=r-n;let u=0;for(;u<l.length&&l.charCodeAt(u)===m;)u++;let h=l.length;for(;h-1>u&&l.charCodeAt(h-1)===m;)h--;const y=h-u,P=s<y?s:y;let v=-1,g=0;for(;g<P;g++){const O=d.charCodeAt(n+g);if(O!==l.charCodeAt(u+g))break;O===m&&(v=g)}if(g!==P){if(v===-1)return t}else{if(y>P){if(l.charCodeAt(u+g)===m)return t.slice(u+g+1);if(g===2)return t.slice(u+g)}s>P&&(d.charCodeAt(n+g)===m?v=g:g===2&&(v=3)),v===-1&&(v=0)}let F="";for(g=n+v+1;g<=r;++g)(g===r||d.charCodeAt(g)===m)&&(F+=F.length===0?"..":"\\..");return u+=v,F.length>0?`${F}${t.slice(u,h)}`:(t.charCodeAt(u)===m&&++u,t.slice(u,h))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===m){if(l.charCodeAt(1)===m){const c=l.charCodeAt(2);if(c!==I&&c!==R)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(w(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===m)return`\\\\?\\${l}`;return d},dirname(d){D(d,"path");const l=d.length;if(l===0)return".";let c=-1,t=0;const n=d.charCodeAt(0);if(l===1)return o(n)?d:".";if(o(n)){if(c=t=1,o(d.charCodeAt(1))){let u=2,h=u;for(;u<l&&!o(d.charCodeAt(u));)u++;if(u<l&&u!==h){for(h=u;u<l&&o(d.charCodeAt(u));)u++;if(u<l&&u!==h){for(h=u;u<l&&!o(d.charCodeAt(u));)u++;if(u===l)return d;u!==h&&(c=t=u+1)}}}}else w(n)&&d.charCodeAt(1)===i&&(c=l>2&&o(d.charCodeAt(2))?3:2,t=c);let r=-1,s=!0;for(let u=l-1;u>=t;--u)if(o(d.charCodeAt(u))){if(!s){r=u;break}}else s=!1;if(r===-1){if(c===-1)return".";r=c}return d.slice(0,r)},basename(d,l){l!==void 0&&D(l,"ext"),D(d,"path");let c=0,t=-1,n=!0,r;if(d.length>=2&&w(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(c=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let s=l.length-1,u=-1;for(r=d.length-1;r>=c;--r){const h=d.charCodeAt(r);if(o(h)){if(!n){c=r+1;break}}else u===-1&&(n=!1,u=r+1),s>=0&&(h===l.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=u))}return c===t?t=u:t===-1&&(t=d.length),d.slice(c,t)}for(r=d.length-1;r>=c;--r)if(o(d.charCodeAt(r))){if(!n){c=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":d.slice(c,t)},extname(d){D(d,"path");let l=0,c=-1,t=0,n=-1,r=!0,s=0;d.length>=2&&d.charCodeAt(1)===i&&w(d.charCodeAt(0))&&(l=t=2);for(let u=d.length-1;u>=l;--u){const h=d.charCodeAt(u);if(o(h)){if(!r){t=u+1;break}continue}n===-1&&(r=!1,n=u+1),h===R?c===-1?c=u:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||n===-1||s===0||s===1&&c===n-1&&c===t+1?"":d.slice(c,n)},format:A.bind(null,"\\"),parse(d){D(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.length;let t=0,n=d.charCodeAt(0);if(c===1)return o(n)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(o(n)){if(t=1,o(d.charCodeAt(1))){let v=2,g=v;for(;v<c&&!o(d.charCodeAt(v));)v++;if(v<c&&v!==g){for(g=v;v<c&&o(d.charCodeAt(v));)v++;if(v<c&&v!==g){for(g=v;v<c&&!o(d.charCodeAt(v));)v++;v===c?t=v:v!==g&&(t=v+1)}}}}else if(w(n)&&d.charCodeAt(1)===i){if(c<=2)return l.root=l.dir=d,l;if(t=2,o(d.charCodeAt(2))){if(c===3)return l.root=l.dir=d,l;t=3}}t>0&&(l.root=d.slice(0,t));let r=-1,s=t,u=-1,h=!0,y=d.length-1,P=0;for(;y>=t;--y){if(n=d.charCodeAt(y),o(n)){if(!h){s=y+1;break}continue}u===-1&&(h=!1,u=y+1),n===R?r===-1?r=y:P!==1&&(P=1):r!==-1&&(P=-1)}return u!==-1&&(r===-1||P===0||P===1&&r===u-1&&r===s+1?l.base=l.name=d.slice(s,u):(l.name=d.slice(s,r),l.base=d.slice(s,u),l.ext=d.slice(r,u))),s>0&&s!==t?l.dir=d.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",c=!1;for(let t=d.length-1;t>=-1&&!c;t--){const n=t>=0?d[t]:E.cwd();D(n,"path"),n.length!==0&&(l=`${n}/${l}`,c=n.charCodeAt(0)===f)}return l=_(l,!c,"/",a),c?`/${l}`:l.length>0?l:"."},normalize(d){if(D(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===f,c=d.charCodeAt(d.length-1)===f;return d=_(d,!l,"/",a),d.length===0?l?"/":c?"./":".":(c&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return D(d,"path"),d.length>0&&d.charCodeAt(0)===f},join(...d){if(d.length===0)return".";let l;for(let c=0;c<d.length;++c){const t=d[c];D(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(D(d,"from"),D(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const c=1,t=d.length,n=t-c,r=1,s=l.length-r,u=n<s?n:s;let h=-1,y=0;for(;y<u;y++){const v=d.charCodeAt(c+y);if(v!==l.charCodeAt(r+y))break;v===f&&(h=y)}if(y===u)if(s>u){if(l.charCodeAt(r+y)===f)return l.slice(r+y+1);if(y===0)return l.slice(r+y)}else n>u&&(d.charCodeAt(c+y)===f?h=y:y===0&&(h=0));let P="";for(y=c+h+1;y<=t;++y)(y===t||d.charCodeAt(y)===f)&&(P+=P.length===0?"..":"/..");return`${P}${l.slice(r+h)}`},toNamespacedPath(d){return d},dirname(d){if(D(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===f;let c=-1,t=!0;for(let n=d.length-1;n>=1;--n)if(d.charCodeAt(n)===f){if(!t){c=n;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":d.slice(0,c)},basename(d,l){l!==void 0&&D(l,"ext"),D(d,"path");let c=0,t=-1,n=!0,r;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let s=l.length-1,u=-1;for(r=d.length-1;r>=0;--r){const h=d.charCodeAt(r);if(h===f){if(!n){c=r+1;break}}else u===-1&&(n=!1,u=r+1),s>=0&&(h===l.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=u))}return c===t?t=u:t===-1&&(t=d.length),d.slice(c,t)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===f){if(!n){c=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":d.slice(c,t)},extname(d){D(d,"path");let l=-1,c=0,t=-1,n=!0,r=0;for(let s=d.length-1;s>=0;--s){const u=d.charCodeAt(s);if(u===f){if(!n){c=s+1;break}continue}t===-1&&(n=!1,t=s+1),u===R?l===-1?l=s:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||t===-1||r===0||r===1&&l===t-1&&l===c+1?"":d.slice(l,t)},format:A.bind(null,"/"),parse(d){D(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.charCodeAt(0)===f;let t;c?(l.root="/",t=1):t=0;let n=-1,r=0,s=-1,u=!0,h=d.length-1,y=0;for(;h>=t;--h){const P=d.charCodeAt(h);if(P===f){if(!u){r=h+1;break}continue}s===-1&&(u=!1,s=h+1),P===R?n===-1?n=h:y!==1&&(y=1):n!==-1&&(y=-1)}if(s!==-1){const P=r===0&&c?1:r;n===-1||y===0||y===1&&n===s-1&&n===r+1?l.base=l.name=d.slice(P,s):(l.name=d.slice(P,n),l.base=d.slice(P,s),l.ext=d.slice(n,s))}return r>0?l.dir=d.slice(0,r-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(de[113],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var E;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(E=e.Source||(e.Source={}));var b;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(b=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(S,...k){const R=k.reduce((i,I)=>(i[I]=!0,i),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!R[i]).forEach(i=>{for(let I=0;I<f.length;I++)if(i.search(f[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=C}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var b in E)(typeof exports=="object"?exports:Y)[b]=E[b]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function E(b){if(e[b])return e[b].exports;var C=e[b]={i:b,l:!1,exports:{}};return Y[b].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=Y,E.c=e,E.d=function(b,C,S){E.o(b,C)||Object.defineProperty(b,C,{enumerable:!0,get:S})},E.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},E.t=function(b,C){if(1&C&&(b=E(b)),8&C||4&C&&typeof b=="object"&&b&&b.__esModule)return b;var S=Object.create(null);if(E.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:b}),2&C&&typeof b!="string")for(var k in b)E.d(S,k,function(R){return b[R]}.bind(null,k));return S},E.n=function(b){var C=b&&b.__esModule?function(){return b.default}:function(){return b};return E.d(C,"a",C),C},E.o=function(b,C){return Object.prototype.hasOwnProperty.call(b,C)},E.p="",E(E.s=0)}([function(Y,e,E){(function(b){var C;e=Y.exports=ue,C=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var S=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],f=e.src=[],m=0,i=m++;f[i]="0|[1-9]\\d*";var I=m++;f[I]="[0-9]+";var p=m++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=m++;f[D]="("+f[i]+")\\.("+f[i]+")\\.("+f[i]+")";var o=m++;f[o]="("+f[I]+")\\.("+f[I]+")\\.("+f[I]+")";var a=m++;f[a]="(?:"+f[i]+"|"+f[p]+")";var w=m++;f[w]="(?:"+f[I]+"|"+f[p]+")";var _=m++;f[_]="(?:-("+f[a]+"(?:\\."+f[a]+")*))";var A=m++;f[A]="(?:-?("+f[w]+"(?:\\."+f[w]+")*))";var d=m++;f[d]="[0-9A-Za-z-]+";var l=m++;f[l]="(?:\\+("+f[d]+"(?:\\."+f[d]+")*))";var c=m++,t="v?"+f[D]+f[_]+"?"+f[l]+"?";f[c]="^"+t+"$";var n="[v=\\s]*"+f[o]+f[A]+"?"+f[l]+"?",r=m++;f[r]="^"+n+"$";var s=m++;f[s]="((?:<|>)?=?)";var u=m++;f[u]=f[I]+"|x|X|\\*";var h=m++;f[h]=f[i]+"|x|X|\\*";var y=m++;f[y]="[v=\\s]*("+f[h]+")(?:\\.("+f[h]+")(?:\\.("+f[h]+")(?:"+f[_]+")?"+f[l]+"?)?)?";var P=m++;f[P]="[v=\\s]*("+f[u]+")(?:\\.("+f[u]+")(?:\\.("+f[u]+")(?:"+f[A]+")?"+f[l]+"?)?)?";var v=m++;f[v]="^"+f[s]+"\\s*"+f[y]+"$";var g=m++;f[g]="^"+f[s]+"\\s*"+f[P]+"$";var F=m++;f[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=m++;f[O]="(?:~>?)";var x=m++;f[x]="(\\s*)"+f[O]+"\\s+",R[x]=new RegExp(f[x],"g");var oe=m++;f[oe]="^"+f[O]+f[y]+"$";var W=m++;f[W]="^"+f[O]+f[P]+"$";var te=m++;f[te]="(?:\\^)";var Q=m++;f[Q]="(\\s*)"+f[te]+"\\s+",R[Q]=new RegExp(f[Q],"g");var q=m++;f[q]="^"+f[te]+f[y]+"$";var ee=m++;f[ee]="^"+f[te]+f[P]+"$";var H=m++;f[H]="^"+f[s]+"\\s*("+n+")$|^$";var T=m++;f[T]="^"+f[s]+"\\s*("+t+")$|^$";var L=m++;f[L]="(\\s*)"+f[s]+"\\s*("+n+"|"+f[y]+")",R[L]=new RegExp(f[L],"g");var B=m++;f[B]="^\\s*("+f[y]+")\\s+-\\s+("+f[y]+")\\s*$";var U=m++;f[U]="^\\s*("+f[P]+")\\s+-\\s+("+f[P]+")\\s*$";var V=m++;f[V]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)C(ie,f[ie]),R[ie]||(R[ie]=new RegExp(f[ie]));function le(se,ve){if(se instanceof ue)return se;if(typeof se!="string"||se.length>S||!(ve?R[r]:R[c]).test(se))return null;try{return new ue(se,ve)}catch(ge){return null}}function ue(se,ve){if(se instanceof ue){if(se.loose===ve)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof ue))return new ue(se,ve);C("SemVer",se,ve),this.loose=ve;var ge=se.trim().match(ve?R[r]:R[c]);if(!ge)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var j=+Ne;if(j>=0&&j<k)return j}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=le,e.valid=function(se,ve){var ge=le(se,ve);return ge?ge.version:null},e.clean=function(se,ve){var ge=le(se.trim().replace(/^[=v]+/,""),ve);return ge?ge.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(se){return C("SemVer.compare",this.version,this.loose,se),se instanceof ue||(se=new ue(se,this.loose)),this.compareMain(se)||this.comparePre(se)},ue.prototype.compareMain=function(se){return se instanceof ue||(se=new ue(se,this.loose)),ke(this.major,se.major)||ke(this.minor,se.minor)||ke(this.patch,se.patch)},ue.prototype.comparePre=function(se){if(se instanceof ue||(se=new ue(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var ve=0;do{var ge=this.prerelease[ve],Ne=se.prerelease[ve];if(C("prerelease compare",ve,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return ke(ge,Ne)}while(++ve)},ue.prototype.inc=function(se,ve){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,ve,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ue(se,ge).inc(ve,Ne).version}catch(j){return null}},e.diff=function(se,ve){if(Qe(se,ve))return null;var ge=le(se),Ne=le(ve);if(ge.prerelease.length||Ne.prerelease.length){for(var j in ge)if((j==="major"||j==="minor"||j==="patch")&&ge[j]!==Ne[j])return"pre"+j;return"prerelease"}for(var j in ge)if((j==="major"||j==="minor"||j==="patch")&&ge[j]!==Ne[j])return j},e.compareIdentifiers=ke;var we=/^[0-9]+$/;function ke(se,ve){var ge=we.test(se),Ne=we.test(ve);return ge&&Ne&&(se=+se,ve=+ve),ge&&!Ne?-1:Ne&&!ge?1:se<ve?-1:se>ve?1:0}function Ae(se,ve,ge){return new ue(se,ge).compare(new ue(ve,ge))}function Fe(se,ve,ge){return Ae(se,ve,ge)>0}function je(se,ve,ge){return Ae(se,ve,ge)<0}function Qe(se,ve,ge){return Ae(se,ve,ge)===0}function qe(se,ve,ge){return Ae(se,ve,ge)!==0}function it(se,ve,ge){return Ae(se,ve,ge)>=0}function tt(se,ve,ge){return Ae(se,ve,ge)<=0}function ye(se,ve,ge,Ne){var j;switch(ve){case"===":typeof se=="object"&&(se=se.version),typeof ge=="object"&&(ge=ge.version),j=se===ge;break;case"!==":typeof se=="object"&&(se=se.version),typeof ge=="object"&&(ge=ge.version),j=se!==ge;break;case"":case"=":case"==":j=Qe(se,ge,Ne);break;case"!=":j=qe(se,ge,Ne);break;case">":j=Fe(se,ge,Ne);break;case">=":j=it(se,ge,Ne);break;case"<":j=je(se,ge,Ne);break;case"<=":j=tt(se,ge,Ne);break;default:throw new TypeError("Invalid operator: "+ve)}return j}function be(se,ve){if(se instanceof be){if(se.loose===ve)return se;se=se.value}if(!(this instanceof be))return new be(se,ve);C("comparator",se,ve),this.loose=ve,this.parse(se),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(se,ve){return ke(ve,se)},e.major=function(se,ve){return new ue(se,ve).major},e.minor=function(se,ve){return new ue(se,ve).minor},e.patch=function(se,ve){return new ue(se,ve).patch},e.compare=Ae,e.compareLoose=function(se,ve){return Ae(se,ve,!0)},e.rcompare=function(se,ve,ge){return Ae(ve,se,ge)},e.sort=function(se,ve){return se.sort(function(ge,Ne){return e.compare(ge,Ne,ve)})},e.rsort=function(se,ve){return se.sort(function(ge,Ne){return e.rcompare(ge,Ne,ve)})},e.gt=Fe,e.lt=je,e.eq=Qe,e.neq=qe,e.gte=it,e.lte=tt,e.cmp=ye,e.Comparator=be;var _e={};function Ie(se,ve){if(se instanceof Ie)return se.loose===ve?se:new Ie(se.raw,ve);if(se instanceof be)return new Ie(se.value,ve);if(!(this instanceof Ie))return new Ie(se,ve);if(this.loose=ve,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function Le(se){return!se||se.toLowerCase()==="x"||se==="*"}function ze(se,ve,ge,Ne,j,K,ne,z,G,Z,re,ce,Re){return((ve=Le(ge)?"":Le(Ne)?">="+ge+".0.0":Le(j)?">="+ge+"."+Ne+".0":">="+ve)+" "+(z=Le(G)?"":Le(Z)?"<"+(+G+1)+".0.0":Le(re)?"<"+G+"."+(+Z+1)+".0":ce?"<="+G+"."+Z+"."+re+"-"+ce:"<="+z)).trim()}function We(se,ve){for(var ge=0;ge<se.length;ge++)if(!se[ge].test(ve))return!1;if(ve.prerelease.length){for(ge=0;ge<se.length;ge++)if(C(se[ge].semver),se[ge].semver!==_e&&se[ge].semver.prerelease.length>0){var Ne=se[ge].semver;if(Ne.major===ve.major&&Ne.minor===ve.minor&&Ne.patch===ve.patch)return!0}return!1}return!0}function Ke(se,ve,ge){try{ve=new Ie(ve,ge)}catch(Ne){return!1}return ve.test(se)}function et(se,ve,ge,Ne){var j,K,ne,z,G;switch(se=new ue(se,Ne),ve=new Ie(ve,Ne),ge){case">":j=Fe,K=tt,ne=je,z=">",G=">=";break;case"<":j=je,K=it,ne=Fe,z="<",G="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ke(se,ve,Ne))return!1;for(var Z=0;Z<ve.set.length;++Z){var re=ve.set[Z],ce=null,Re=null;if(re.forEach(function(Ce){Ce.semver===_e&&(Ce=new be(">=0.0.0")),ce=ce||Ce,Re=Re||Ce,j(Ce.semver,ce.semver,Ne)?ce=Ce:ne(Ce.semver,Re.semver,Ne)&&(Re=Ce)}),ce.operator===z||ce.operator===G||(!Re.operator||Re.operator===z)&&K(se,Re.semver)||Re.operator===G&&ne(se,Re.semver))return!1}return!0}be.prototype.parse=function(se){var ve=this.loose?R[H]:R[T],ge=se.match(ve);if(!ge)throw new TypeError("Invalid comparator: "+se);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ue(ge[2],this.loose):this.semver=_e},be.prototype.toString=function(){return this.value},be.prototype.test=function(se){return C("Comparator.test",se,this.loose),this.semver===_e||(typeof se=="string"&&(se=new ue(se,this.loose)),ye(se,this.operator,this.semver,this.loose))},be.prototype.intersects=function(se,ve){if(!(se instanceof be))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ie(se.value,ve),Ke(this.value,ge,ve);if(se.operator==="")return ge=new Ie(this.value,ve),Ke(se.semver,ge,ve);var Ne=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),j=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),K=this.semver.version===se.semver.version,ne=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),z=ye(this.semver,"<",se.semver,ve)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),G=ye(this.semver,">",se.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ne||j||K&&ne||z||G},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(se){var ve=this.loose;se=se.trim(),C("range",se,ve);var ge=ve?R[U]:R[B];se=se.replace(ge,ze),C("hyphen replace",se),se=se.replace(R[L],"$1$2$3"),C("comparator trim",se,R[L]),se=(se=(se=se.replace(R[x],"$1~")).replace(R[Q],"$1^")).split(/\s+/).join(" ");var Ne=ve?R[H]:R[T],j=se.split(" ").map(function(K){return function(ne,z){return C("comp",ne),ne=function(G,Z){return G.trim().split(/\s+/).map(function(re){return function(ce,Re){C("caret",ce,Re);var Ce=Re?R[ee]:R[q];return ce.replace(Ce,function(Pe,fe,Se,Te,Me){var Ue;return C("caret",ce,Pe,fe,Se,Te,Me),Le(fe)?Ue="":Le(Se)?Ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Le(Te)?Ue=fe==="0"?">="+fe+"."+Se+".0 <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+".0 <"+(+fe+1)+".0.0":Me?(C("replaceCaret pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Ue=fe==="0"?Se==="0"?">="+fe+"."+Se+"."+Te+Me+" <"+fe+"."+Se+"."+(+Te+1):">="+fe+"."+Se+"."+Te+Me+" <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+"."+Te+Me+" <"+(+fe+1)+".0.0"):(C("no pr"),Ue=fe==="0"?Se==="0"?">="+fe+"."+Se+"."+Te+" <"+fe+"."+Se+"."+(+Te+1):">="+fe+"."+Se+"."+Te+" <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+"."+Te+" <"+(+fe+1)+".0.0"),C("caret return",Ue),Ue})}(re,Z)}).join(" ")}(ne,z),C("caret",ne),ne=function(G,Z){return G.trim().split(/\s+/).map(function(re){return function(ce,Re){var Ce=Re?R[W]:R[oe];return ce.replace(Ce,function(Pe,fe,Se,Te,Me){var Ue;return C("tilde",ce,Pe,fe,Se,Te,Me),Le(fe)?Ue="":Le(Se)?Ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Le(Te)?Ue=">="+fe+"."+Se+".0 <"+fe+"."+(+Se+1)+".0":Me?(C("replaceTilde pr",Me),Me.charAt(0)!=="-"&&(Me="-"+Me),Ue=">="+fe+"."+Se+"."+Te+Me+" <"+fe+"."+(+Se+1)+".0"):Ue=">="+fe+"."+Se+"."+Te+" <"+fe+"."+(+Se+1)+".0",C("tilde return",Ue),Ue})}(re,Z)}).join(" ")}(ne,z),C("tildes",ne),ne=function(G,Z){return C("replaceXRanges",G,Z),G.split(/\s+/).map(function(re){return function(ce,Re){ce=ce.trim();var Ce=Re?R[g]:R[v];return ce.replace(Ce,function(Pe,fe,Se,Te,Me,Ue){C("xRange",ce,Pe,fe,Se,Te,Me,Ue);var Xe=Le(Se),Ye=Xe||Le(Te),ae=Ye||Le(Me);return fe==="="&&ae&&(fe=""),Xe?Pe=fe===">"||fe==="<"?"<0.0.0":"*":fe&&ae?(Ye&&(Te=0),ae&&(Me=0),fe===">"?(fe=">=",Ye?(Se=+Se+1,Te=0,Me=0):ae&&(Te=+Te+1,Me=0)):fe==="<="&&(fe="<",Ye?Se=+Se+1:Te=+Te+1),Pe=fe+Se+"."+Te+"."+Me):Ye?Pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":ae&&(Pe=">="+Se+"."+Te+".0 <"+Se+"."+(+Te+1)+".0"),C("xRange return",Pe),Pe})}(re,Z)}).join(" ")}(ne,z),C("xrange",ne),ne=function(G,Z){return C("replaceStars",G,Z),G.trim().replace(R[V],"")}(ne,z),C("stars",ne),ne}(K,ve)}).join(" ").split(/\s+/);return this.loose&&(j=j.filter(function(K){return!!K.match(Ne)})),j=j.map(function(K){return new be(K,ve)})},Ie.prototype.intersects=function(se,ve){if(!(se instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return se.set.some(function(j){return j.every(function(K){return Ne.intersects(K,ve)})})})})},e.toComparators=function(se,ve){return new Ie(se,ve).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new ue(se,this.loose));for(var ve=0;ve<this.set.length;ve++)if(We(this.set[ve],se))return!0;return!1},e.satisfies=Ke,e.maxSatisfying=function(se,ve,ge){var Ne=null,j=null;try{var K=new Ie(ve,ge)}catch(ne){return null}return se.forEach(function(ne){K.test(ne)&&(Ne&&j.compare(ne)!==-1||(j=new ue(Ne=ne,ge)))}),Ne},e.minSatisfying=function(se,ve,ge){var Ne=null,j=null;try{var K=new Ie(ve,ge)}catch(ne){return null}return se.forEach(function(ne){K.test(ne)&&(Ne&&j.compare(ne)!==1||(j=new ue(Ne=ne,ge)))}),Ne},e.validRange=function(se,ve){try{return new Ie(se,ve).range||"*"}catch(ge){return null}},e.ltr=function(se,ve,ge){return et(se,ve,"<",ge)},e.gtr=function(se,ve,ge){return et(se,ve,">",ge)},e.outside=et,e.prerelease=function(se,ve){var ge=le(se,ve);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(se,ve,ge){return se=new Ie(se,ge),ve=new Ie(ve,ge),se.intersects(ve)},e.coerce=function(se){if(se instanceof ue)return se;if(typeof se!="string")return null;var ve=se.match(R[F]);return ve==null?null:le((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,E(1))},function(Y,e){var E,b,C=Y.exports={};function S(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(w){if(E===setTimeout)return setTimeout(w,0);if((E===S||!E)&&setTimeout)return E=setTimeout,setTimeout(w,0);try{return E(w,0)}catch(_){try{return E.call(null,w,0)}catch(A){return E.call(this,w,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:S}catch(w){E=S}try{b=typeof clearTimeout=="function"?clearTimeout:k}catch(w){b=k}})();var f,m=[],i=!1,I=-1;function p(){i&&f&&(i=!1,f.length?m=f.concat(m):I=-1,m.length&&D())}function D(){if(!i){var w=R(p);i=!0;for(var _=m.length;_;){for(f=m,m=[];++I<_;)f&&f[I].run();I=-1,_=m.length}f=null,i=!1,function(A){if(b===clearTimeout)return clearTimeout(A);if((b===k||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(A);try{b(A)}catch(d){try{return b.call(null,A)}catch(l){return b.call(this,A)}}}(w)}}function o(w,_){this.fun=w,this.array=_}function a(){}C.nextTick=function(w){var _=new Array(arguments.length-1);if(arguments.length>1)for(var A=1;A<arguments.length;A++)_[A-1]=arguments[A];m.push(new o(w,_)),m.length!==1||i||R(D)},o.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(w){return[]},C.binding=function(w){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(w){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(de[114],me([0,1,5]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const b=E.globals.performance&&typeof E.globals.performance.now=="function";class C{constructor(k){this._highResolution=b&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new C(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=C}),define(de[6],me([0,1,12,69,2,70,114]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(_){_.None=()=>C.Disposable.None;function A(W){return(te,Q=null,q)=>{let ee=!1,H;return H=W(T=>{if(!ee)return H?H.dispose():ee=!0,te.call(Q,T)},null,q),ee&&H.dispose(),H}}_.once=A;function d(W,te){return s((Q,q=null,ee)=>W(H=>Q.call(q,te(H)),null,ee))}_.map=d;function l(W,te){return s((Q,q=null,ee)=>W(H=>{te(H),Q.call(q,H)},null,ee))}_.forEach=l;function c(W,te){return s((Q,q=null,ee)=>W(H=>te(H)&&Q.call(q,H),null,ee))}_.filter=c;function t(W){return W}_.signal=t;function n(...W){return(te,Q=null,q)=>(0,C.combinedDisposable)(...W.map(ee=>ee(H=>te.call(Q,H),null,q)))}_.any=n;function r(W,te,Q){let q=Q;return d(W,ee=>(q=te(q,ee),q))}_.reduce=r;function s(W){let te;const Q=new p({onFirstListenerAdd(){te=W(Q.fire,Q)},onLastListenerRemove(){te.dispose()}});return Q.event}_.snapshot=s;function u(W,te,Q=100,q=!1,ee){let H,T,L,B=0;const U=new p({leakWarningThreshold:ee,onFirstListenerAdd(){H=W(V=>{B++,T=te(T,V),q&&!L&&(U.fire(T),T=void 0),clearTimeout(L),L=setTimeout(()=>{const ie=T;T=void 0,L=void 0,(!q||B>1)&&U.fire(ie),B=0},Q)})},onLastListenerRemove(){H.dispose()}});return U.event}_.debounce=u;function h(W){const te=new Date().getTime();return d(A(W),Q=>new Date().getTime()-te)}_.stopwatch=h;function y(W){let te=!0,Q;return c(W,q=>{const ee=te||q!==Q;return te=!1,Q=q,ee})}_.latch=y;function P(W,te=!1,Q=[]){let q=Q.slice(),ee=W(L=>{q?q.push(L):T.fire(L)});const H=()=>{q&&q.forEach(L=>T.fire(L)),q=null},T=new p({onFirstListenerAdd(){ee||(ee=W(L=>T.fire(L)))},onFirstListenerDidAdd(){q&&(te?setTimeout(H):H())},onLastListenerRemove(){ee&&ee.dispose(),ee=null}});return T.event}_.buffer=P;class v{constructor(te){this.event=te}map(te){return new v(d(this.event,te))}forEach(te){return new v(l(this.event,te))}filter(te){return new v(c(this.event,te))}reduce(te,Q){return new v(r(this.event,te,Q))}latch(){return new v(y(this.event))}debounce(te,Q=100,q=!1,ee){return new v(u(this.event,te,Q,q,ee))}on(te,Q,q){return this.event(te,Q,q)}once(te,Q,q){return A(this.event)(te,Q,q)}}function g(W){return new v(W)}_.chain=g;function F(W,te,Q=q=>q){const q=(...L)=>T.fire(Q(...L)),ee=()=>W.on(te,q),H=()=>W.removeListener(te,q),T=new p({onFirstListenerAdd:ee,onLastListenerRemove:H});return T.event}_.fromNodeEventEmitter=F;function O(W,te,Q=q=>q){const q=(...L)=>T.fire(Q(...L)),ee=()=>W.addEventListener(te,q),H=()=>W.removeEventListener(te,q),T=new p({onFirstListenerAdd:ee,onLastListenerRemove:H});return T.event}_.fromDOMEventEmitter=O;function x(W){const te=new p;let Q=!1;return W.then(void 0,()=>null).then(()=>{Q?te.fire(void 0):setTimeout(()=>te.fire(void 0),0)}),Q=!0,te.event}_.fromPromise=x;function oe(W){return new Promise(te=>A(W)(te))}_.toPromise=oe})(R=e.Event||(e.Event={}));class f{constructor(A){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${A}_${f._idPool++}`}start(A){this._stopWatch=new k.StopWatch(!0),this._listenerCount=A}stop(){if(this._stopWatch){const A=this._stopWatch.elapsed();this._elapsedOverall+=A,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${A.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let m=-1;function i(_){const A=m;return m=_,{dispose(){m=A}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(A,d=Math.random().toString(18).slice(2,5)){this.customThreshold=A,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(A){let d=m;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||A<d)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(l)||0;if(this._stacks.set(l,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,n=0;for(const[r,s]of this._stacks)(!t||n<s)&&(t=r,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class p{constructor(A){var d;this._disposed=!1,this._options=A,this._leakageMon=m>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(A,d,l)=>{var c;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(d?[A,d]:A);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,A,d);const r=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let s;return s={dispose:()=>{r&&r(),s.dispose=p._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof C.DisposableStore?l.add(s):Array.isArray(l)&&l.push(s),s}),this._event}fire(A){var d,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,A]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(n){(0,E.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var A,d,l;(A=this._listeners)===null||A===void 0||A.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=p,p._noop=function(){};class D extends p{constructor(A){super(A);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=A==null?void 0:A.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const A=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(A))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(A){this._listeners&&(this._isPaused!==0?this._eventQueue.push(A):super.fire(A))}}e.PauseableEmitter=D;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(A){const d={event:A,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const l=()=>{this.hasListeners&&this.unhook(d);const c=this.events.indexOf(d);this.events.splice(c,1)};return(0,C.toDisposable)((0,b.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(A=>this.hook(A))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(A=>this.unhook(A))}hook(A){A.listener=A.event(d=>this.emitter.fire(d))}unhook(A){A.listener&&A.listener.dispose(),A.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class a{constructor(){this.buffers=[]}wrapEvent(A){return(d,l,c)=>A(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>d.call(l,t)):d.call(l,t)},void 0,c)}bufferEvents(A){const d=[];this.buffers.push(d);const l=A();return this.buffers.pop(),d.forEach(c=>c()),l}}e.EventBufferer=a;class w{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=C.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(A){this.inputEvent=A,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=A(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(de[28],me([0,1,6]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const b=Object.freeze(function(R,f){const m=setTimeout(R.bind(f),0);return{dispose(){clearTimeout(m)}}});var C;(function(R){function f(m){return m===R.None||m===R.Cancelled||m instanceof S?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=f,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:b})})(C=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?b:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=C.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=k}),define(de[71],me([0,1,6]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class b{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(I){const p=this._icons.get(I.id);p?I.description?p.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new b;e.iconRegistry=C;function S(i,I){return new R(i,I)}e.registerCodicon=S;function k(i){return i?i.replace(/\$\((.*?)\)/g,(I,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=k;class R{constructor(I,p,D){this.id=I,this.definition=p,this.description=D,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function f(i,I){const p=["codicon","codicon-"+i];return I&&p.push("codicon-modifier-"+I),p}e.getClassNamesArray=f;var m;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function p(a){if(a instanceof R)return["codicon","codicon-"+a.id];const w=I.exec(a.id);if(!w)return p(R.error);let[,_,A]=w;const d=["codicon","codicon-"+_];return A&&d.push("codicon-modifier-"+A.substr(1)),d}i.asClassNameArray=p;function D(a){return p(a).join(" ")}i.asClassName=D;function o(a){return"."+p(a).join(".")}i.asCSSSelector=o})(m=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(de[41],me([0,1,12,2]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=C;function S(d){const l=d;return l?C(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=S;function k(d,l){return new R(d,l)}e.newWriteableStream=k;class R{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,E.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(c);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(d,l){const c=[];let t;for(;(t=d.read())!==null;)c.push(t);return l(c)}e.consumeReadable=f;function m(d,l,c){const t=[];let n;for(;(n=d.read())!==null&&t.length<c;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const r=n;return n=void 0,r}return d.read()}}}e.peekReadable=m;function i(d,l){return new Promise((c,t)=>{const n=[];I(d,{onData:r=>{l&&n.push(r)},onError:r=>{l?t(r):c(void 0)},onEnd:()=>{c(l?l(n):void 0)}})})}e.consumeStream=i;function I(d,l){d.on("error",c=>l.onError(c)),d.on("end",()=>l.onEnd()),d.on("data",c=>l.onData(c))}e.listenStream=I;function p(d,l){return new Promise((c,t)=>{const n=new b.DisposableStore,r=[],s=y=>{if(r.push(y),r.length>l)return n.dispose(),d.pause(),c({stream:d,buffer:r,ended:!1})},u=y=>t(y),h=()=>c({stream:d,buffer:r,ended:!0});n.add((0,b.toDisposable)(()=>d.removeListener("error",u))),d.on("error",u),n.add((0,b.toDisposable)(()=>d.removeListener("end",h))),d.on("end",h),n.add((0,b.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=p;function D(d,l){const c=k(l);return c.end(d),c}e.toStream=D;function o(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=o;function a(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=a;function w(d,l,c){const t=k(c);return I(d,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=w;function _(d,l,c){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?c([d,n]):d)}}}e.prefixedReadable=_;function A(d,l,c){let t=!1;const n=k(c);return I(l,{onData:r=>t?n.write(r):(t=!0,n.write(c([d,r]))),onError:r=>n.error(r),onEnd:()=>{t||(t=!0,n.write(d)),n.end()}}),n}e.prefixedStream=A}),define(de[13],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=E;const b=/{(\d+)}/g;function C(j,...K){return K.length===0?j:j.replace(b,function(ne,z){const G=parseInt(z,10);return isNaN(G)||G<0||G>=K.length?ne:K[G]})}e.format=C;function S(j){return j.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=S;function k(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function R(j,K){let ne=0;const z=K.charCodeAt(0);for(let G=j.length-1;G>=0;G--)j.charCodeAt(G)===z&&ne++;return ne}e.count=R;function f(j,K,ne="\u2026"){return j.length<=K?j:`${j.substr(0,K)}${ne}`}e.truncate=f;function m(j,K=" "){const ne=i(j,K);return I(ne,K)}e.trim=m;function i(j,K){if(!j||!K)return j;const ne=K.length;if(ne===0||j.length===0)return j;let z=0;for(;j.indexOf(K,z)===z;)z=z+ne;return j.substring(z)}e.ltrim=i;function I(j,K){if(!j||!K)return j;const ne=K.length,z=j.length;if(ne===0||z===0)return j;let G=z,Z=-1;for(;Z=j.lastIndexOf(K,G-1),!(Z===-1||Z+ne!==G);){if(Z===0)return"";G=Z}return j.substring(0,G)}e.rtrim=I;function p(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function D(j){return j.replace(/\*/g,"")}e.stripWildcards=D;function o(j,K,ne={}){if(!j)throw new Error("Cannot create regex from empty string");K||(j=k(j)),ne.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let z="";return ne.global&&(z+="g"),ne.matchCase||(z+="i"),ne.multiline&&(z+="m"),ne.unicode&&(z+="u"),new RegExp(j,z)}e.createRegExp=o;function a(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function w(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function _(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=_;function A(j){return j.split(/\r\n|\r|\n/)}e.splitLines=A;function d(j){for(let K=0,ne=j.length;K<ne;K++){const z=j.charCodeAt(K);if(z!==32&&z!==9)return K}return-1}e.firstNonWhitespaceIndex=d;function l(j,K=0,ne=j.length){for(let z=K;z<ne;z++){const G=j.charCodeAt(z);if(G!==32&&G!==9)return j.substring(K,z)}return j.substring(K,ne)}e.getLeadingWhitespace=l;function c(j,K=j.length-1){for(let ne=K;ne>=0;ne--){const z=j.charCodeAt(ne);if(z!==32&&z!==9)return ne}return-1}e.lastNonWhitespaceIndex=c;function t(j,K){return j<K?-1:j>K?1:0}e.compare=t;function n(j,K,ne=0,z=j.length,G=0,Z=K.length){for(;ne<z&&G<Z;ne++,G++){let Re=j.charCodeAt(ne),Ce=K.charCodeAt(G);if(Re<Ce)return-1;if(Re>Ce)return 1}const re=z-ne,ce=Z-G;return re<ce?-1:re>ce?1:0}e.compareSubstring=n;function r(j,K){return s(j,K,0,j.length,0,K.length)}e.compareIgnoreCase=r;function s(j,K,ne=0,z=j.length,G=0,Z=K.length){for(;ne<z&&G<Z;ne++,G++){let Re=j.charCodeAt(ne),Ce=K.charCodeAt(G);if(Re!==Ce){const Pe=Re-Ce;if(!(Pe===32&&h(Ce))&&!(Pe===-32&&h(Re)))return u(Re)&&u(Ce)?Pe:n(j.toLowerCase(),K.toLowerCase(),ne,z,G,Z)}}const re=z-ne,ce=Z-G;return re<ce?-1:re>ce?1:0}e.compareSubstringIgnoreCase=s;function u(j){return j>=97&&j<=122}e.isLowerAsciiLetter=u;function h(j){return j>=65&&j<=90}e.isUpperAsciiLetter=h;function y(j){return u(j)||h(j)}function P(j,K){return j.length===K.length&&v(j,K)}e.equalsIgnoreCase=P;function v(j,K,ne=j.length){for(let z=0;z<ne;z++){const G=j.charCodeAt(z),Z=K.charCodeAt(z);if(G!==Z){if(y(G)&&y(Z)){const re=Math.abs(G-Z);if(re!==0&&re!==32)return!1}else if(String.fromCharCode(G).toLowerCase()!==String.fromCharCode(Z).toLowerCase())return!1}}return!0}function g(j,K){const ne=K.length;return K.length>j.length?!1:v(j,K,ne)}e.startsWithIgnoreCase=g;function F(j,K){let ne,z=Math.min(j.length,K.length);for(ne=0;ne<z;ne++)if(j.charCodeAt(ne)!==K.charCodeAt(ne))return ne;return z}e.commonPrefixLength=F;function O(j,K){let ne,z=Math.min(j.length,K.length);const G=j.length-1,Z=K.length-1;for(ne=0;ne<z;ne++)if(j.charCodeAt(G-ne)!==K.charCodeAt(Z-ne))return ne;return z}e.commonSuffixLength=O;function x(j){return 55296<=j&&j<=56319}e.isHighSurrogate=x;function oe(j){return 56320<=j&&j<=57343}e.isLowSurrogate=oe;function W(j,K){return(j-55296<<10)+(K-56320)+65536}e.computeCodePoint=W;function te(j,K,ne){const z=j.charCodeAt(ne);if(x(z)&&ne+1<K){const G=j.charCodeAt(ne+1);if(oe(G))return W(z,G)}return z}e.getNextCodePoint=te;function Q(j,K){const ne=j.charCodeAt(K-1);if(oe(ne)&&K>1){const z=j.charCodeAt(K-2);if(x(z))return W(z,ne)}return ne}function q(j,K){const ne=ge.getInstance(),z=K,G=j.length,Z=te(j,G,K);K+=Z>=65536?2:1;let re=ne.getGraphemeBreakType(Z);for(;K<G;){const ce=te(j,G,K),Re=ne.getGraphemeBreakType(ce);if(se(re,Re))break;K+=ce>=65536?2:1,re=Re}return K-z}e.nextCharLength=q;function ee(j,K){const ne=ge.getInstance(),z=K,G=Q(j,K);K-=G>=65536?2:1;let Z=ne.getGraphemeBreakType(G);for(;K>0;){const re=Q(j,K),ce=ne.getGraphemeBreakType(re);if(se(ce,Z))break;K-=re>=65536?2:1,Z=ce}return z-K}e.prevCharLength=ee;function H(j,K){const ne=ge.getInstance(),z=j.length,G=K,Z=te(j,z,K),re=ne.getGraphemeBreakType(Z);K+=Z>=65536?2:1;let ce=re;for(;K<z;){const Ce=te(j,z,K),Pe=ne.getGraphemeBreakType(Ce);if(se(ce,Pe))break;K+=Ce>=65536?2:1,ce=Pe}const Re=K;for(K=G,ce=re;K>0;){const Ce=Q(j,K),Pe=ne.getGraphemeBreakType(Ce);if(se(Pe,ce))break;K-=Ce>=65536?2:1,ce=Pe}return[K,Re]}function T(j,K){return K>0&&oe(j.charCodeAt(K))?H(j,K-1):H(j,K)}e.getCharContainingOffset=T;function L(j){const K=j.length;let ne=0,z=0;for(;z<K;){const re=te(j,K,z);z+=re>=65536?2:1,re<128?ne+=1:re<2048?ne+=2:re<65536?ne+=3:ne+=4}const G=new Uint8Array(ne);z=0;let Z=0;for(;z<K;){const re=te(j,K,z);z+=re>=65536?2:1,re<128?G[Z++]=re:re<2048?(G[Z++]=192|(re&1984)>>>6,G[Z++]=128|(re&63)>>>0):re<65536?(G[Z++]=224|(re&61440)>>>12,G[Z++]=128|(re&4032)>>>6,G[Z++]=128|(re&63)>>>0):(G[Z++]=240|(re&1835008)>>>18,G[Z++]=128|(re&258048)>>>12,G[Z++]=128|(re&4032)>>>6,G[Z++]=128|(re&63)>>>0)}return G}e.encodeUTF8=L;function B(j){const K=j.byteLength,ne=[];let z=0;for(;z<K;){const G=j[z];let Z;if(G>=240&&z+3<K?Z=(j[z++]&7)<<18>>>0|(j[z++]&63)<<12>>>0|(j[z++]&63)<<6>>>0|(j[z++]&63)<<0>>>0:G>=224&&z+2<K?Z=(j[z++]&15)<<12>>>0|(j[z++]&63)<<6>>>0|(j[z++]&63)<<0>>>0:G>=192&&z+1<K?Z=(j[z++]&31)<<6>>>0|(j[z++]&63)<<0>>>0:Z=j[z++],Z>=0&&Z<=55295||Z>=57344&&Z<=65535)ne.push(String.fromCharCode(Z));else if(Z>=65536&&Z<=1114111){const re=Z-65536,ce=55296+((re&1047552)>>>10),Re=56320+((re&1023)>>>0);ne.push(String.fromCharCode(ce)),ne.push(String.fromCharCode(Re))}else ne.push(String.fromCharCode(65533))}return ne.join("")}e.decodeUTF8=B;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(j){return U.test(j)}e.containsRTL=V;const ie=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function le(j){return ie.test(j)}e.containsEmoji=le;const ue=/^[\t\n\r\x20-\x7E]*$/;function we(j){return ue.test(j)}e.isBasicASCII=we,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ke(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=ke;function Ae(j){for(let K=0,ne=j.length;K<ne;K++)if(Fe(j.charCodeAt(K)))return!0;return!1}e.containsFullWidthCharacter=Ae;function Fe(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=Fe;function je(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=je;function Qe(j,K){if(j.length<K)return j;const ne=/\b/g;let z=0;for(;ne.test(j)&&!(j.length-ne.lastIndex<K);)z=ne.lastIndex,ne.lastIndex+=1;return j.substring(z).replace(/^\s/,"")}e.lcut=Qe;const qe=/\x1B\x5B[12]?K/g,it=/\x1b\[\d+m/g,tt=/\x1b\[0?m/g;function ye(j){return j&&(j=j.replace(qe,""),j=j.replace(it,""),j=j.replace(tt,"")),j}e.removeAnsiEscapeCodes=ye,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function _e(j){return be(j)?j.substr(1):j}e.stripUTF8BOM=_e;function Ie(j,K){if(!j||!K||j.length<K.length)return!1;const ne=K.length,z=j.toLowerCase();let G=0,Z=-1;for(;G<ne;){const re=z.indexOf(K[G],Z+1);if(re<0)return!1;Z=re,G++}return!0}e.fuzzyContains=Ie;function Le(j,K=!1){return j?(K&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Le;function ze(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=ze;function We(j,K=1){if(K===0)return"";let ne=-1;do ne=j.indexOf(`
`,ne+1),K--;while(K>0&&ne>=0);return ne===-1?j:(j[ne-1]==="\r"&&ne--,j.substr(0,ne))}e.getNLines=We;function Ke(j){const K=90-65+1;return j=j%(2*K),j<K?String.fromCharCode(97+j):String.fromCharCode(65+j-K)}e.singleLetterHash=Ke;function et(j){return ge.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=et;function se(j,K){return j===0?K!==5&&K!==7:j===2&&K===3?!1:j===4||j===2||j===3||K===4||K===2||K===3?!0:!(j===8&&(K===8||K===9||K===11||K===12)||(j===11||j===9)&&(K===9||K===10)||(j===12||j===10)&&K===10||K===5||K===13||K===7||j===1||j===13&&K===14||j===6&&K===6)}e.breakBetweenGraphemeBreakType=se;var ve;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ge{constructor(){this._data=Ne()}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const ne=this._data,z=ne.length/3;let G=1;for(;G<=z;)if(K<ne[3*G])G=2*G;else if(K>ne[3*G+1])G=2*G+1;else return ne[3*G+2];return 0}}ge._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(de[18],me([0,1,13,41]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let R,f;class m{constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}static alloc(y){return C?new m(Buffer.allocUnsafe(y)):new m(new Uint8Array(y))}static wrap(y){return C&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new m(y)}static fromString(y,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&C?new m(Buffer.from(y)):S?(R||(R=new TextEncoder),new m(R.encode(y))):new m(E.encodeUTF8(y))}static concat(y,P){if(typeof P=="undefined"){P=0;for(let F=0,O=y.length;F<O;F++)P+=y[F].byteLength}const v=m.alloc(P);let g=0;for(let F=0,O=y.length;F<O;F++){const x=y[F];v.set(x,g),g+=x.byteLength}return v}toString(){return C?this.buffer.toString():k?(f||(f=new TextDecoder),f.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(y,P){return new m(this.buffer.subarray(y,P))}set(y,P){y instanceof m?this.buffer.set(y.buffer,P):this.buffer.set(y,P)}readUInt32BE(y){return p(this.buffer,y)}writeUInt32BE(y,P){D(this.buffer,y,P)}readUInt32LE(y){return o(this.buffer,y)}writeUInt32LE(y,P){a(this.buffer,y,P)}readUInt8(y){return w(this.buffer,y)}writeUInt8(y,P){_(this.buffer,y,P)}}e.VSBuffer=m;function i(h,y){return h[y+0]<<0>>>0|h[y+1]<<8>>>0}e.readUInt16LE=i;function I(h,y,P){h[P+0]=y&255,y=y>>>8,h[P+1]=y&255}e.writeUInt16LE=I;function p(h,y){return h[y]*2**24+h[y+1]*2**16+h[y+2]*2**8+h[y+3]}e.readUInt32BE=p;function D(h,y,P){h[P+3]=y,y=y>>>8,h[P+2]=y,y=y>>>8,h[P+1]=y,y=y>>>8,h[P]=y}e.writeUInt32BE=D;function o(h,y){return h[y+0]<<0>>>0|h[y+1]<<8>>>0|h[y+2]<<16>>>0|h[y+3]<<24>>>0}e.readUInt32LE=o;function a(h,y,P){h[P+0]=y&255,y=y>>>8,h[P+1]=y&255,y=y>>>8,h[P+2]=y&255,y=y>>>8,h[P+3]=y&255}e.writeUInt32LE=a;function w(h,y){return h[y]}e.readUInt8=w;function _(h,y,P){h[P]=y}e.writeUInt8=_;function A(h){return b.consumeReadable(h,y=>m.concat(y))}e.readableToBuffer=A;function d(h){return b.toReadable(h)}e.bufferToReadable=d;function l(h){return b.consumeStream(h,y=>m.concat(y))}e.streamToBuffer=l;async function c(h){return h.ended?m.concat(h.buffer):m.concat([...h.buffer,await l(h.stream)])}e.bufferedStreamToBuffer=c;function t(h){return b.toStream(h,y=>m.concat(y))}e.bufferToStream=t;function n(h){return b.transform(h,{data:y=>typeof y=="string"?m.fromString(y):m.wrap(y)},y=>m.concat(y))}e.streamToBufferReadableStream=n;function r(h){return b.newWriteableStream(y=>m.concat(y),h)}e.newWriteableBufferStream=r;function s(h,y){return b.prefixedReadable(h,y,P=>m.concat(P))}e.prefixedBufferReadable=s;function u(h,y){return b.prefixedStream(h,y,P=>m.concat(P))}e.prefixedBufferStream=u}),define(de[115],me([0,1,13]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function b(_){return C(_,0)}e.hash=b;function C(_,A){switch(typeof _){case"object":return _===null?S(349,A):Array.isArray(_)?f(_,A):m(_,A);case"string":return R(_,A);case"boolean":return k(_,A);case"number":return S(_,A);case"undefined":return S(937,A);default:return S(617,A)}}e.doHash=C;function S(_,A){return(A<<5)-A+_|0}function k(_,A){return S(_?433:863,A)}function R(_,A){A=S(149417,A);for(let d=0,l=_.length;d<l;d++)A=S(_.charCodeAt(d),A);return A}e.stringHash=R;function f(_,A){return A=S(104579,A),_.reduce((d,l)=>C(l,d),A)}function m(_,A){return A=S(181387,A),Object.keys(_).sort().reduce((d,l)=>(d=R(l,d),C(_[l],d)),A)}class i{constructor(){this._value=0}get value(){return this._value}hash(A){return this._value=C(A,this._value),this._value}}e.Hasher=i;var I;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(_,A,d=32){const l=d-A,c=~((1<<l)-1);return(_<<A|(c&_)>>>l)>>>0}function D(_,A=0,d=_.byteLength,l=0){for(let c=0;c<d;c++)_[A+c]=l}function o(_,A,d="0"){for(;_.length<A;)_=d+_;return _}function a(_,A=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(d=>d.toString(16).padStart(2,"0")).join(""):o((_>>>0).toString(16),A/4)}e.toHexString=a;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(A){const d=A.length;if(d!==0){const l=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,n,r;for(t!==0?(n=t,r=-1,t=0):(n=A.charCodeAt(0),r=0);;){let s=n;if(E.isHighSurrogate(n))if(r+1<d){const u=A.charCodeAt(r+1);E.isLowSurrogate(u)?(r++,s=E.computeCodePoint(n,u)):s=65533}else{t=n;break}else E.isLowSurrogate(n)&&(s=65533);if(c=this._push(l,c,s),r++,r<d)n=A.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(A,d,l){return l<128?A[d++]=l:l<2048?(A[d++]=192|(l&1984)>>>6,A[d++]=128|(l&63)>>>0):l<65536?(A[d++]=224|(l&61440)>>>12,A[d++]=128|(l&4032)>>>6,A[d++]=128|(l&63)>>>0):(A[d++]=240|(l&1835008)>>>18,A[d++]=128|(l&258048)>>>12,A[d++]=128|(l&4032)>>>6,A[d++]=128|(l&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,A[0]=A[64+0],A[1]=A[64+1],A[2]=A[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,D(this._buff,this._buffLen),this._buffLen>56&&(this._step(),D(this._buff));const A=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(A/4294967296),!1),this._buffDV.setUint32(60,A%4294967296,!1),this._step()}_step(){const A=w._bigBlock32,d=this._buffDV;for(let y=0;y<64;y+=4)A.setUint32(y,d.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)A.setUint32(y,p(A.getUint32(y-12,!1)^A.getUint32(y-32,!1)^A.getUint32(y-56,!1)^A.getUint32(y-64,!1),1),!1);let l=this._h0,c=this._h1,t=this._h2,n=this._h3,r=this._h4,s,u,h;for(let y=0;y<80;y++)y<20?(s=c&t|~c&n,u=1518500249):y<40?(s=c^t^n,u=1859775393):y<60?(s=c&t|c&n|t&n,u=2400959708):(s=c^t^n,u=3395469782),h=p(l,5)+s+r+u+A.getUint32(y*4,!1)&4294967295,r=n,n=t,t=p(c,30),c=l,l=h;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(de[72],me([0,1,13]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var b;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(b||(b={})),function(C){const S="error",k="warning",R="warn",f="info",m="ignore";function i(p){return p?E.equalsIgnoreCase(S,p)?C.Error:E.equalsIgnoreCase(k,p)||E.equalsIgnoreCase(R,p)?C.Warning:E.equalsIgnoreCase(f,p)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function I(p){switch(p){case C.Error:return S;case C.Warning:return k;case C.Info:return f;default:return m}}C.toString=I}(b||(b={})),e.default=b}),define(de[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(y){return Array.isArray(y)}e.isArray=E;function b(y){return typeof y=="string"}e.isString=b;function C(y){return Array.isArray(y)&&y.every(P=>b(P))}e.isStringArray=C;function S(y){return typeof y=="object"&&y!==null&&!Array.isArray(y)&&!(y instanceof RegExp)&&!(y instanceof Date)}e.isObject=S;function k(y){return typeof y=="number"&&!isNaN(y)}e.isNumber=k;function R(y){return!!y&&typeof y[Symbol.iterator]=="function"}e.isIterable=R;function f(y){return y===!0||y===!1}e.isBoolean=f;function m(y){return typeof y=="undefined"}e.isUndefined=m;function i(y){return!I(y)}e.isDefined=i;function I(y){return m(y)||y===null}e.isUndefinedOrNull=I;function p(y,P){if(!y)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=p;function D(y){if(I(y))throw new Error("Assertion Failed: argument is undefined or null");return y}e.assertIsDefined=D;function o(...y){const P=[];for(let v=0;v<y.length;v++){const g=y[v];if(I(g))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);P.push(g)}return P}e.assertAllDefined=o;const a=Object.prototype.hasOwnProperty;function w(y){if(!S(y))return!1;for(let P in y)if(a.call(y,P))return!1;return!0}e.isEmptyObject=w;function _(y){return typeof y=="function"}e.isFunction=_;function A(...y){return y.length>0&&y.every(_)}e.areFunctions=A;function d(y,P){const v=Math.min(y.length,P.length);for(let g=0;g<v;g++)l(y[g],P[g])}e.validateConstraints=d;function l(y,P){if(b(P)){if(typeof y!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(_(P)){try{if(y instanceof P)return}catch(v){}if(!I(y)&&y.constructor===P||P.length===1&&P.call(void 0,y)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(y){let P=[],v=Object.getPrototypeOf(y);for(;Object.prototype!==v;)P=P.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return P}e.getAllPropertyNames=c;function t(y){const P=[];for(const v of c(y))typeof y[v]=="function"&&P.push(v);return P}e.getAllMethodNames=t;function n(y,P){const v=F=>function(){const O=Array.prototype.slice.call(arguments,0);return P(F,O)};let g={};for(const F of y)g[F]=v(F);return g}e.createProxyObject=n;function r(y){return y===null?void 0:y}e.withNullAsUndefined=r;function s(y){return typeof y=="undefined"?null:y}e.withUndefinedAsNull=s;function u(y){return class{constructor(){return new Proxy({},{get(P,v){if(P[v])return P[v];throw new Error(`Not Implemented: ${y}->${String(v)}`)}})}}}e.NotImplementedProxy=u;function h(y){throw new Error("Unreachable")}e.assertNever=h}),define(de[29],me([0,1,5,13,4,11]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function R(n){return n.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=R;function f(n,r=C.posix.sep){if(!n)return"";const s=n.length,u=n.charCodeAt(0);if(k(u)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let y=3;const P=y;for(;y<s&&!k(n.charCodeAt(y));y++);if(P!==y&&!k(n.charCodeAt(y+1))){for(y+=1;y<s;y++)if(k(n.charCodeAt(y)))return n.slice(0,y+1).replace(/[\\/]/g,r)}}return r}else if(w(u)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(k(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=f;function m(n){if(!E.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let s=2;const u=s;for(;s<n.length&&(r=n.charCodeAt(s),r!==92);s++);return!(u===s||(r=n.charCodeAt(s+1),isNaN(r)||r===92))}e.isUNC=m;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(n,r=E.isWindows){const s=r?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||r&&p.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=D;function o(n,r,s){const u=n===r;return!s||u?u:!n||!r?!1:(0,b.equalsIgnoreCase)(n,r)}e.isEqual=o;function a(n,r,s,u=C.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(s){if(!(0,b.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let y=r.length;return r.charAt(r.length-1)===u&&y--,n.charAt(y)===u}return r.charAt(r.length-1)!==u&&(r+=u),n.indexOf(r)===0}e.isEqualOrParent=a;function w(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=w;function _(n,r){return E.isWindows&&n.endsWith(":")&&(n+=C.sep),(0,C.isAbsolute)(n)||(n=(0,C.join)(r,n)),n=(0,C.normalize)(n),E.isWindows?(n=(0,b.rtrim)(n,C.sep),n.endsWith(":")&&(n+=C.sep)):(n=(0,b.rtrim)(n,C.sep),n||(n=C.sep)),n}e.sanitizeFilePath=_;function A(n){const r=(0,C.normalize)(n);return E.isWindows?n.length>3?!1:d(r)&&(n.length===2||r.charCodeAt(2)===92):r===C.posix.sep}e.isRootOrDriveLetter=A;function d(n){return E.isWindows?w(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(n){return d(n)?n[0]:void 0}e.getDriveLetter=l;function c(n,r,s){return r.length>n.length?-1:n===r?0:(s&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=c;function t(n){const r=n.split(":");let s,u,h;if(r.forEach(y=>{const P=Number(y);(0,S.isNumber)(P)?u===void 0?u=P:h===void 0&&(h=P):s=s?[s,y].join(":"):y}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:h!==void 0?h:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(de[20],me([0,1,11]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function b(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const a=Array.isArray(o)?[]:{};return Object.keys(o).forEach(w=>{o[w]&&typeof o[w]=="object"?a[w]=b(o[w]):a[w]=o[w]}),a}e.deepClone=b;function C(o){if(!o||typeof o!="object")return o;const a=[o];for(;a.length>0;){const w=a.shift();Object.freeze(w);for(const _ in w)if(S.call(w,_)){const A=w[_];typeof A=="object"&&!Object.isFrozen(A)&&a.push(A)}}return o}e.deepFreeze=C;const S=Object.prototype.hasOwnProperty;function k(o,a){return R(o,a,new Set)}e.cloneAndChange=k;function R(o,a,w){if((0,E.isUndefinedOrNull)(o))return o;const _=a(o);if(typeof _!="undefined")return _;if((0,E.isArray)(o)){const A=[];for(const d of o)A.push(R(d,a,w));return A}if((0,E.isObject)(o)){if(w.has(o))throw new Error("Cannot clone recursive data-structure");w.add(o);const A={};for(let d in o)S.call(o,d)&&(A[d]=R(o[d],a,w));return w.delete(o),A}return o}function f(o,a,w=!0){return(0,E.isObject)(o)?((0,E.isObject)(a)&&Object.keys(a).forEach(_=>{_ in o?w&&((0,E.isObject)(o[_])&&(0,E.isObject)(a[_])?f(o[_],a[_],w):o[_]=a[_]):o[_]=a[_]}),o):a}e.mixin=f;function m(o,a){if(o===a)return!0;if(o==null||a===null||a===void 0||typeof o!=typeof a||typeof o!="object"||Array.isArray(o)!==Array.isArray(a))return!1;let w,_;if(Array.isArray(o)){if(o.length!==a.length)return!1;for(w=0;w<o.length;w++)if(!m(o[w],a[w]))return!1}else{const A=[];for(_ in o)A.push(_);A.sort();const d=[];for(_ in a)d.push(_);if(d.sort(),!m(A,d))return!1;for(w=0;w<A.length;w++)if(!m(o[A[w]],a[A[w]]))return!1}return!0}e.equals=m;function i(o){const a=new Set;return JSON.stringify(o,(w,_)=>{if((0,E.isObject)(_)||Array.isArray(_)){if(a.has(_))return"[Circular]";a.add(_)}return _})}e.safeStringify=i;function I(o,a,w){const _=a(o);return typeof _=="undefined"?w:_}e.getOrDefault=I;function p(o,a){const w=Object.create(null);return!o||!a||Object.keys(a).forEach(A=>{const d=o[A],l=a[A];m(d,l)||(w[A]=l)}),w}e.distinct=p;function D(o,a){const w=a.toLowerCase(),_=Object.keys(o).find(A=>A.toLowerCase()===w);return _?o[_]:o[a]}e.getCaseInsensitive=D}),define(de[3],me([0,1,5,4]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,S=/^\//,k=/^\/\//;function R(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function m(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const i="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{constructor(s,u,h,y,P,v=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=f(s,v),this.authority=u||i,this.path=m(this.scheme,h||i),this.query=y||i,this.fragment=P||i,R(this,v))}static isUri(s){return s instanceof D?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:h,path:y,query:P,fragment:v}=s;return u===void 0?u=this.scheme:u===null&&(u=i),h===void 0?h=this.authority:h===null&&(h=i),y===void 0?y=this.path:y===null&&(y=i),P===void 0?P=this.query:P===null&&(P=i),v===void 0?v=this.fragment:v===null&&(v=i),u===this.scheme&&h===this.authority&&y===this.path&&P===this.query&&v===this.fragment?this:new a(u,h,y,P,v)}static parse(s,u=!1){const h=p.exec(s);return h?new a(h[2]||i,n(h[4]||i),n(h[5]||i),n(h[7]||i),n(h[9]||i),u):new a(i,i,i,i,i)}static file(s){let u=i;if(E.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const h=s.indexOf(I,2);h===-1?(u=s.substring(2),s=I):(u=s.substring(2,h),s=s.substring(h)||I)}return new a("file",u,s,i,i)}static from(s){return new a(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return E.isWindows&&s.scheme==="file"?h=D.file(b.win32.join(d(s,!0),...u)).path:h=b.posix.join(s.path,...u),s.with({path:h})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof D)return s;{const u=new a(s);return u._formatted=s.external,u._fsPath=s._sep===o?s.fsPath:null,u}}else return s}}e.URI=D;const o=E.isWindows?1:void 0;class a extends D{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=o),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(r,s){let u,h=-1;for(let y=0;y<r.length;y++){const P=r.charCodeAt(y);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||s&&P===47)h!==-1&&(u+=encodeURIComponent(r.substring(h,y)),h=-1),u!==void 0&&(u+=r.charAt(y));else{u===void 0&&(u=r.substr(0,y));const v=w[P];v!==void 0?(h!==-1&&(u+=encodeURIComponent(r.substring(h,y)),h=-1),u+=v):h===-1&&(h=y)}}return h!==-1&&(u+=encodeURIComponent(r.substring(h))),u!==void 0?u:r}function A(r){let s;for(let u=0;u<r.length;u++){const h=r.charCodeAt(u);h===35||h===63?(s===void 0&&(s=r.substr(0,u)),s+=w[h]):s!==void 0&&(s+=r[u])}return s!==void 0?s:r}function d(r,s){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,E.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=d;function l(r,s){const u=s?A:_;let h="",{scheme:y,authority:P,path:v,query:g,fragment:F}=r;if(y&&(h+=y,h+=":"),(P||y==="file")&&(h+=I,h+=I),P){let O=P.indexOf("@");if(O!==-1){const x=P.substr(0,O);P=P.substr(O+1),O=x.indexOf(":"),O===-1?h+=u(x,!1):(h+=u(x.substr(0,O),!1),h+=":",h+=u(x.substr(O+1),!1)),h+="@"}P=P.toLowerCase(),O=P.indexOf(":"),O===-1?h+=u(P,!1):(h+=u(P.substr(0,O),!1),h+=P.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}h+=u(v,!0)}return g&&(h+="?",h+=u(g,!1)),F&&(h+="#",h+=s?F:_(F,!1)),h}function c(r){try{return decodeURIComponent(r)}catch(s){return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,s=>c(s)):r}}),define(de[116],me([0,1,3]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function b(m){const i=m;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=b;function C(m){const i=[];let I;try{const p=JSON.parse(m.arguments),D=p[p.length-1];D&&D.__$stack&&(p.pop(),I=D.__$stack),i.push(...p)}catch(p){i.push("Unable to log remote console arguments",m.arguments)}return{args:i,stack:I}}e.parse=C;function S(m){if(typeof m!="string")return S(C(m).stack);const i=m;if(i){const I=k(i),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:E.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=S;function k(m){if(!m)return m;const i=m.indexOf(`
`);return i===-1?m:m.substring(0,i)}function R(m,i){const{args:I,stack:p}=C(m),D=typeof I[0]=="string"&&I.length===1;let o=k(p);o&&(o=`(${o.trim()})`);let a=[];if(typeof I[0]=="string"?o&&D?a=[`%c[${i}] %c${I[0]} %c${o}`,f("blue"),f(""),f("grey")]:a=[`%c[${i}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:a=[`%c[${i}]%`,f("blue"),...I],o&&!D&&a.push(o),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,a)}e.log=R;function f(m){return`color: ${m}`}});var yt=this&&this.__classPrivateFieldSet||function(Y,e,E,b,C){if(b==="m")throw new TypeError("Private method is not writable");if(b==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return b==="a"?C.call(Y,E):C?C.value=E:e.set(Y,E),E},ot=this&&this.__classPrivateFieldGet||function(Y,e,E,b){if(E==="a"&&!b)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?b:E==="a"?b.call(Y):b?b.value:e.get(Y)};define(de[26],me([0,1,3,13]),function(Y,e,E,b){"use strict";var C,S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,n,r){let s=t.get(n);return s===void 0&&(s=r,t.set(n,s)),s}e.getOrSet=R;function f(t){const n=[];return t.forEach((r,s)=>{n.push(`${s} => ${r}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=f;function m(t){const n=[];return t.forEach(r=>{n.push(r)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=m;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,b.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,b.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class p{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,b.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,b.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var D;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(D||(D={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,b.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,b.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,b.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,b.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(n){this._iter=n}static forUris(n=()=>!1){return new w(new o(n))}static forPaths(){return new w(new p)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new I)}clear(){this._root=void 0}set(n,r){const s=this._iter.reset(n);let u;for(this._root||(this._root=new a,this._root.segment=s.value()),u=this._root;;){const y=s.cmp(u.segment);if(y>0)u.left||(u.left=new a,u.left.segment=s.value()),u=u.left;else if(y<0)u.right||(u.right=new a,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new a,u.mid.segment=s.value()),u=u.mid;else break}const h=u.value;return u.value=r,u.key=n,h}get(n){var r;return(r=this._getNode(n))===null||r===void 0?void 0:r.value}_getNode(n){const r=this._iter.reset(n);let s=this._root;for(;s;){const u=r.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(n){const r=this._getNode(n);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const s=this._iter.reset(n),u=[];let h=this._root;for(;h;){const y=s.cmp(h.segment);if(y>0)u.push([1,h]),h=h.left;else if(y<0)u.push([-1,h]),h=h.right;else if(s.hasNext())s.next(),u.push([0,h]),h=h.mid;else{for(r?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;u.length>0&&h.isEmpty();){let[P,v]=u.pop();switch(P){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}h=v}break}}}findSubstr(n){const r=this._iter.reset(n);let s=this._root,u;for(;s;){const h=r.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(r.hasNext())r.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(n){const r=this._iter.reset(n);let s=this._root;for(;s;){const u=r.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[r,s]of this)n(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=w;class _{constructor(n,r){this[C]="ResourceMap",n instanceof _?(this.map=new Map(n.map),this.toKey=r!=null?r:_.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:_.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[s,u]of this.map)n(u,E.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield E.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[E.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[E.URI.parse(n[0]),n[1]]}}e.ResourceMap=_,_.defaultToKey=t=>t.toString();var A;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(A=e.Touch||(e.Touch={}));class d{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,r=0){const s=this._map.get(n);if(!!s)return r!==0&&this.touch(s,r),s.value}set(n,r,s=0){let u=this._map.get(n);if(u)u.value=r,s!==0&&this.touch(u,s);else{switch(u={key:n,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,r){const s=this._state;let u=this._head;for(;u;){if(r?n.bind(r)(u.value,u.key,this):n(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,r=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return u}values(){const n=this,r=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return u}entries(){const n=this,r=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return u}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>n;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,s=n.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const s=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const s=n.next,u=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,s)=>{n.push([s,r])}),n}fromJSON(n){this.clear();for(const[r,s]of n)this.set(r,s)}}e.LinkedMap=d;class l extends d{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class c{constructor(n){k.set(this,void 0),yt(this,k,n,"f")}get size(){return ot(this,k,"f").size}forEach(n,r){ot(this,k,"f").forEach(n,r)}get(n){return ot(this,k,"f").get(n)}has(n){return ot(this,k,"f").has(n)}entries(){return ot(this,k,"f").entries()}keys(){return ot(this,k,"f").keys()}values(){return ot(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return ot(this,k,"f").entries()}}e.ReadonlyMapView=c}),define(de[117],me([0,1,26,13]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ye){return function(be,_e){for(let Ie=0,Le=ye.length;Ie<Le;Ie++){const ze=ye[Ie](be,_e);if(ze)return ze}return null}}e.or=C,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(ye,be,_e){if(!_e||_e.length<be.length)return null;let Ie;return ye?Ie=b.startsWithIgnoreCase(_e,be):Ie=_e.indexOf(be)===0,Ie?be.length>0?[{start:0,end:be.length}]:[]:null}function k(ye,be){const _e=be.toLowerCase().indexOf(ye.toLowerCase());return _e===-1?null:[{start:_e,end:_e+ye.length}]}e.matchesContiguousSubString=k;function R(ye,be){return f(ye.toLowerCase(),be.toLowerCase(),0,0)}e.matchesSubString=R;function f(ye,be,_e,Ie){if(_e===ye.length)return[];if(Ie===be.length)return null;if(ye[_e]===be[Ie]){let Le=null;return(Le=f(ye,be,_e+1,Ie+1))?_({start:Ie,end:Ie+1},Le):null}return f(ye,be,_e,Ie+1)}function m(ye){return 97<=ye&&ye<=122}function i(ye){return 65<=ye&&ye<=90}e.isUpper=i;function I(ye){return 48<=ye&&ye<=57}function p(ye){return ye===32||ye===9||ye===10||ye===13}const D=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ye=>D.add(ye.charCodeAt(0)));function o(ye){return p(ye)||D.has(ye)}function a(ye,be){return ye===be||o(ye)&&o(be)}function w(ye){return m(ye)||i(ye)||I(ye)}function _(ye,be){return be.length===0?be=[ye]:ye.end===be[0].start?be[0].start=ye.start:be.unshift(ye),be}function A(ye,be){for(let _e=be;_e<ye.length;_e++){const Ie=ye.charCodeAt(_e);if(i(Ie)||I(Ie)||_e>0&&!w(ye.charCodeAt(_e-1)))return _e}return ye.length}function d(ye,be,_e,Ie){if(_e===ye.length)return[];if(Ie===be.length)return null;if(ye[_e]!==be[Ie].toLowerCase())return null;{let Le=null,ze=Ie+1;for(Le=d(ye,be,_e+1,Ie+1);!Le&&(ze=A(be,ze))<be.length;)Le=d(ye,be,_e+1,ze),ze++;return Le===null?null:_({start:Ie,end:Ie+1},Le)}}function l(ye){let be=0,_e=0,Ie=0,Le=0,ze=0;for(let ve=0;ve<ye.length;ve++)ze=ye.charCodeAt(ve),i(ze)&&be++,m(ze)&&_e++,w(ze)&&Ie++,I(ze)&&Le++;const We=be/ye.length,Ke=_e/ye.length,et=Ie/ye.length,se=Le/ye.length;return{upperPercent:We,lowerPercent:Ke,alphaPercent:et,numericPercent:se}}function c(ye){const{upperPercent:be,lowerPercent:_e}=ye;return _e===0&&be>.6}function t(ye){const{upperPercent:be,lowerPercent:_e,alphaPercent:Ie,numericPercent:Le}=ye;return _e>.2&&be<.8&&Ie>.6&&Le<.2}function n(ye){let be=0,_e=0,Ie=0,Le=0;for(let ze=0;ze<ye.length;ze++)Ie=ye.charCodeAt(ze),i(Ie)&&be++,m(Ie)&&_e++,p(Ie)&&Le++;return(be===0||_e===0)&&Le===0?ye.length<=30:be<=5}function r(ye,be){if(!be||(be=be.trim(),be.length===0)||!n(ye)||be.length>60)return null;const _e=l(be);if(!t(_e)){if(!c(_e))return null;be=be.toLowerCase()}let Ie=null,Le=0;for(ye=ye.toLowerCase();Le<be.length&&(Ie=d(ye,be,0,Le))===null;)Le=A(be,Le+1);return Ie}e.matchesCamelCase=r;function s(ye,be,_e=!1){if(!be||be.length===0)return null;let Ie=null,Le=0;for(ye=ye.toLowerCase(),be=be.toLowerCase();Le<be.length&&(Ie=u(ye,be,0,Le,_e))===null;)Le=h(be,Le+1);return Ie}e.matchesWords=s;function u(ye,be,_e,Ie,Le){if(_e===ye.length)return[];if(Ie===be.length)return null;if(a(ye.charCodeAt(_e),be.charCodeAt(Ie))){let ze=null,We=Ie+1;if(ze=u(ye,be,_e+1,Ie+1,Le),!Le)for(;!ze&&(We=h(be,We))<be.length;)ze=u(ye,be,_e+1,We,Le),We++;return ze===null?null:_({start:Ie,end:Ie+1},ze)}else return null}function h(ye,be){for(let _e=be;_e<ye.length;_e++)if(o(ye.charCodeAt(_e))||_e>0&&o(ye.charCodeAt(_e-1)))return _e;return ye.length}const y=C(e.matchesPrefix,r,k),P=C(e.matchesPrefix,r,R),v=new E.LRUCache(1e4);function g(ye,be,_e=!1){if(typeof ye!="string"||typeof be!="string")return null;let Ie=v.get(ye);Ie||(Ie=new RegExp(b.convertSimple2RegExpPattern(ye),"i"),v.set(ye,Ie));const Le=Ie.exec(be);return Le?[{start:Le.index,end:Le.index+Le[0].length}]:_e?P(ye,be):y(ye,be)}e.matchesFuzzy=g;function F(ye,be){const _e=Ae(ye,ye.toLowerCase(),0,be,be.toLowerCase(),0,!0);return _e?x(_e):null}e.matchesFuzzy2=F;function O(ye,be,_e,Ie,Le,ze){const We=Math.min(13,ye.length);for(;_e<We;_e++){const Ke=Ae(ye,be,_e,Ie,Le,ze,!1);if(Ke)return Ke}return[0,ze]}e.anyScore=O;function x(ye){if(typeof ye=="undefined")return[];const be=[],_e=ye[1];for(let Ie=ye.length-1;Ie>1;Ie--){const Le=ye[Ie]+_e,ze=be[be.length-1];ze&&ze.end===Le?ze.end=Le+1:be.push({start:Le,end:Le+1})}return be}e.createMatches=x;const oe=128;function W(){const ye=[],be=[];for(let _e=0;_e<=oe;_e++)be[_e]=0;for(let _e=0;_e<=oe;_e++)ye.push(be.slice(0));return ye}function te(ye){const be=[];for(let _e=0;_e<=ye;_e++)be[_e]=0;return be}const Q=te(2*oe),q=te(2*oe),ee=W(),H=W(),T=W(),L=!1;function B(ye,be,_e,Ie,Le){function ze(Ke,et,se=" "){for(;Ke.length<et;)Ke=se+Ke;return Ke}let We=` |   |${Ie.split("").map(Ke=>ze(Ke,3)).join("|")}
`;for(let Ke=0;Ke<=_e;Ke++)Ke===0?We+=" |":We+=`${be[Ke-1]}|`,We+=ye[Ke].slice(0,Le+1).map(et=>ze(et.toString(),3)).join("|")+`
`;return We}function U(ye,be,_e,Ie){ye=ye.substr(be),_e=_e.substr(Ie),console.log(B(H,ye,ye.length,_e,_e.length)),console.log(B(T,ye,ye.length,_e,_e.length)),console.log(B(ee,ye,ye.length,_e,_e.length))}function V(ye,be){if(be<0||be>=ye.length)return!1;const _e=ye.codePointAt(be);switch(_e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!b.isEmojiImprecise(_e)}}function ie(ye,be){if(be<0||be>=ye.length)return!1;switch(ye.charCodeAt(be)){case 32:case 9:return!0;default:return!1}}function le(ye,be,_e){return be[ye]!==_e[ye]}function ue(ye,be,_e,Ie,Le,ze,We=!1){for(;be<_e&&Le<ze;)ye[be]===Ie[Le]&&(We&&(Q[be]=Le),be+=1),Le+=1;return be===_e}e.isPatternInWord=ue;var we;(function(ye){ye[ye.Diag=1]="Diag",ye[ye.Left=2]="Left",ye[ye.LeftLeft=3]="LeftLeft"})(we||(we={}));var ke;(function(ye){ye.Default=[-100,0];function be(_e){return!_e||_e.length===2&&_e[0]===-100&&_e[1]===0}ye.isDefault=be})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Ae(ye,be,_e,Ie,Le,ze,We){const Ke=ye.length>oe?oe:ye.length,et=Ie.length>oe?oe:Ie.length;if(!(_e>=Ke||ze>=et||Ke-_e>et-ze)&&!!ue(be,_e,Ke,Le,ze,et,!0)){Fe(Ke,et,_e,ze,be,Le);let se=1,ve=1,ge=_e,Ne=ze;const j=[!1];for(se=1,ge=_e;ge<Ke;se++,ge++){const Z=Q[ge],re=q[ge],ce=ge+1<Ke?q[ge+1]:et;for(ve=Z-ze+1,Ne=Z;Ne<ce;ve++,Ne++){let Re=Number.MIN_SAFE_INTEGER,Ce=!1;Ne<=re&&(Re=je(ye,be,ge,_e,Ie,Le,Ne,et,ze,ee[se-1][ve-1]===0,j));let Pe=0;Re!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Pe=Re+H[se-1][ve-1]);const fe=Ne>Z,Se=fe?H[se][ve-1]+(ee[se][ve-1]>0?-5:0):0,Te=Ne>Z+1&&ee[se][ve-1]>0,Me=Te?H[se][ve-2]+(ee[se][ve-2]>0?-5:0):0;if(Te&&(!fe||Me>=Se)&&(!Ce||Me>=Pe))H[se][ve]=Me,T[se][ve]=3,ee[se][ve]=0;else if(fe&&(!Ce||Se>=Pe))H[se][ve]=Se,T[se][ve]=2,ee[se][ve]=0;else if(Ce)H[se][ve]=Pe,T[se][ve]=1,ee[se][ve]=ee[se-1][ve-1]+1;else throw new Error("not possible")}}if(L&&U(ye,_e,Ie,ze),!(!j[0]&&!We)){se--,ve--;const K=[H[se][ve],ze];let ne=0,z=0;for(;se>=1;){let Z=ve;do{const re=T[se][Z];if(re===3)Z=Z-2;else if(re===2)Z=Z-1;else break}while(Z>=1);ne>1&&be[_e+se-1]===Le[ze+ve-1]&&!le(Z+ze-1,Ie,Le)&&ne+1>ee[se][Z]&&(Z=ve),Z===ve?ne++:ne=1,z||(z=Z),se--,ve=Z-1,K.push(ve)}et===Ke&&(K[0]+=2);const G=z-Ke;return K[0]-=G,K}}}e.fuzzyScore=Ae;function Fe(ye,be,_e,Ie,Le,ze){let We=ye-1,Ke=be-1;for(;We>=_e&&Ke>=Ie;)Le[We]===ze[Ke]&&(q[We]=Ke,We--),Ke--}function je(ye,be,_e,Ie,Le,ze,We,Ke,et,se,ve){if(be[_e]!==ze[We])return Number.MIN_SAFE_INTEGER;let ge=1,Ne=!1;return We===_e-Ie?ge=ye[_e]===Le[We]?7:5:le(We,Le,ze)&&(We===0||!le(We-1,Le,ze))?(ge=ye[_e]===Le[We]?7:5,Ne=!0):V(ze,We)&&(We===0||!V(ze,We-1))?ge=5:(V(ze,We-1)||ie(ze,We-1))&&(ge=5,Ne=!0),ge>1&&_e===Ie&&(ve[0]=!0),Ne||(Ne=le(We,Le,ze)||V(ze,We-1)||ie(ze,We-1)),_e===Ie?We>et&&(ge-=Ne?3:5):se?ge+=Ne?2:0:ge+=Ne?0:1,We+1===Ke&&(ge-=Ne?3:5),ge}function Qe(ye,be,_e,Ie,Le,ze,We){return it(ye,be,_e,Ie,Le,ze,!0,We)}e.fuzzyScoreGracefulAggressive=Qe;function qe(ye,be,_e,Ie,Le,ze,We){return it(ye,be,_e,Ie,Le,ze,!1,We)}e.fuzzyScoreGraceful=qe;function it(ye,be,_e,Ie,Le,ze,We,Ke){let et=Ae(ye,be,_e,Ie,Le,ze,Ke);if(et&&!We)return et;if(ye.length>=3){const se=Math.min(7,ye.length-1);for(let ve=_e+1;ve<se;ve++){const ge=tt(ye,ve);if(ge){const Ne=Ae(ge,ge.toLowerCase(),_e,Ie,Le,ze,Ke);Ne&&(Ne[0]-=3,(!et||Ne[0]>et[0])&&(et=Ne))}}}return et}function tt(ye,be){if(!(be+1>=ye.length)){const _e=ye[be],Ie=ye[be+1];if(_e!==Ie)return ye.slice(0,be)+Ie+_e+ye.slice(be+2)}}}),define(de[118],me([0,1,71,117,13]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${S.source}`,"g");function R(a){return a.replace(k,(w,_)=>_?w:`\\${w}`)}e.escapeIcons=R;const f=new RegExp(`\\\\${S.source}`,"g");function m(a){return a.replace(f,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=m;const i=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function I(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(w,_,A,d)=>A?w:_||d||"")}e.stripIcons=I;function p(a){const w=a.indexOf(e.iconStartMarker);return w===-1?{text:a}:D(a,w)}e.parseLabelWithIcons=p;function D(a,w){const _=[];let A="";function d(h){if(h){A+=h;for(const y of h)_.push(t)}}let l=-1,c="",t=0,n,r,s=w;const u=a.length;for(d(a.substr(0,w));s<u;)n=a[s],r=a[s+1],n===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(l=s,d(c),c=e.iconStartMarker,s++):n===")"&&l!==-1?(t+=s-l+1,l=-1,c=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?c+=n:(d(c),l=-1,c=""):d(n),s++;return d(c),{text:A,iconOffsets:_}}function o(a,w,_=!1){const{text:A,iconOffsets:d}=w;if(!d||d.length===0)return(0,b.matchesFuzzy)(a,A,_);const l=(0,C.ltrim)(A," "),c=A.length-l.length,t=(0,b.matchesFuzzy)(a,l,_);if(t)for(const n of t){const r=d[n.start+c]+c;n.start+=r,n.end+=r}return t}e.matchesFuzzyIconAware=o}),define(de[73],me([0,1,19,118,12]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(a="",w=!1){var _,A;if(this.value=a,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1):(this.isTrusted=(_=w.isTrusted)!==null&&_!==void 0?_:void 0,this.supportThemeIcons=(A=w.supportThemeIcons)!==null&&A!==void 0?A:!1)}appendText(a,w=0){return this.value+=I(this.supportThemeIcons?(0,b.escapeIcons)(a):a).replace(/([ \t]+)/g,(_,A)=>"&nbsp;".repeat(A.length)).replace(/^>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,w){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}}e.MarkdownString=k;function R(o){return f(o)?!o.value:Array.isArray(o)?o.every(R):!0}e.isEmptyMarkdownString=R;function f(o){return o instanceof k?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=f;function m(o,a){return!o&&!a?!0:!o||!a?!1:Array.isArray(o)&&Array.isArray(a)?(0,E.equals)(o,a,i):f(o)&&f(a)?i(o,a):!1}e.markedStringsEquals=m;function i(o,a){return o===a?!0:!o||!a?!1:o.value===a.value&&o.isTrusted===a.isTrusted&&o.supportThemeIcons===a.supportThemeIcons}function I(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function p(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function D(o){const a=[],w=o.split("|").map(A=>A.trim());o=w[0];const _=w[1];if(_){const A=/height=(\d+)/.exec(_),d=/width=(\d+)/.exec(_),l=A?A[1]:"",c=d?d[1]:"",t=isFinite(parseInt(c)),n=isFinite(parseInt(l));t&&a.push(`width="${c}"`),n&&a.push(`height="${l}"`)}return{href:o,dimensions:a}}e.parseHrefAndDimensions=D}),define(de[45],me([0,1,18,13,3]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(m){return JSON.stringify(m,R)}e.stringify=S;function k(m){let i=JSON.parse(m);return i=f(i),i}e.parse=k;function R(m,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,b.regExpFlags)(i)}:i}function f(m,i=0){if(!m||i>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof E.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=f(m[I],i+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=f(m[I],i+1))}return m}e.revive=f}),define(de[8],me([0,1,3,5]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,m,i){this._hosts[f]=m,this._ports[f]=i}setConnectionToken(f,m){this._connectionTokens[f]=m}rewrite(f){if(this._delegate)return this._delegate(f);const m=f.authority;let i=this._hosts[m];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[m],p=this._connectionTokens[m];let D=`path=${encodeURIComponent(f.path)}`;return typeof p=="string"&&(D+=`&tkn=${encodeURIComponent(p)}`),E.URI.from({scheme:b.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:D})}}e.RemoteAuthorities=new S;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(f,m,i){const I=this.toUri(f,m);return I.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(I):b.isNative&&(i||b.isPreferringBrowserCodeLoad)&&I.scheme===C.file?I.with({scheme:C.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(f,m){const i=this.toUri(f,m);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(f,m){return E.URI.isUri(f)?f:E.URI.parse(m.toUrl(f))}}e.FileAccess=new k}),define(de[74],me([0,1,26]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const b=new E.LRUCache(1e4);function C(m){return f(m,"NFC",b)}e.normalizeNFC=C;const S=new E.LRUCache(1e4);function k(m){return f(m,"NFD",S)}e.normalizeNFD=k;const R=/[^\u0000-\u0080]/;function f(m,i,I){if(!e.canNormalize||!m)return m;const p=I.get(m);if(p)return p;let D;return R.test(m)?D=m.normalize(i):D=m,I.set(m,D),D}e.removeAccents=function(){if(e.canNormalize){const m=/[\u0300-\u036f]/g;return function(i){return k(i).replace(m,"")}}else return function(m){return m}}()}),define(de[17],me([0,1,29,4,3,13,8,5]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(D){return(0,C.uriToFsPath)(D,!0)}e.originalFSPath=f;class m{constructor(o){this._ignorePathCasing=o}compare(o,a,w=!1){return o===a?0:(0,S.compare)(this.getComparisonKey(o,w),this.getComparisonKey(a,w))}isEqual(o,a,w=!1){return o===a?!0:!o||!a?!1:this.getComparisonKey(o,w)===this.getComparisonKey(a,w)}getComparisonKey(o,a=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,a,w=!1){if(o.scheme===a.scheme){if(o.scheme===k.Schemas.file)return E.isEqualOrParent(f(o),f(a),this._ignorePathCasing(o))&&o.query===a.query&&(w||o.fragment===a.fragment);if((0,e.isEqualAuthority)(o.authority,a.authority))return E.isEqualOrParent(o.path,a.path,this._ignorePathCasing(o),"/")&&o.query===a.query&&(w||o.fragment===a.fragment)}return!1}joinPath(o,...a){return C.URI.joinPath(o,...a)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return b.posix.basename(o.path)}extname(o){return b.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let a;return o.scheme===k.Schemas.file?a=C.URI.file(b.dirname(f(o))).path:(a=b.posix.dirname(o.path),o.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),a="/")),o.with({path:a})}normalizePath(o){if(!o.path.length)return o;let a;return o.scheme===k.Schemas.file?a=C.URI.file(b.normalize(f(o))).path:a=b.posix.normalize(o.path),o.with({path:a})}relativePath(o,a){if(!(o.scheme!==a.scheme||!(0,e.isEqualAuthority)(o.authority,a.authority))){if(o.scheme===k.Schemas.file){const A=b.relative(f(o),f(a));return R.isWindows?E.toSlashes(A):A}let w=o.path||"/",_=a.path||"/";if(this._ignorePathCasing(o)){let A=0;for(const d=Math.min(w.length,_.length);A<d&&!(w.charCodeAt(A)!==_.charCodeAt(A)&&w.charAt(A).toLowerCase()!==_.charAt(A).toLowerCase());A++);w=_.substr(0,A)+w.substr(A)}return b.posix.relative(w,_)}}resolvePath(o,a){if(o.scheme===k.Schemas.file){const w=C.URI.file(b.resolve(f(o),a));return o.with({authority:w.authority,path:w.path})}return a.indexOf("/")===-1&&(a=E.toSlashes(a),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a)),o.with({path:b.posix.resolve(o.path,a)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,a){return o===a||(0,S.equalsIgnoreCase)(o,a)}hasTrailingPathSeparator(o,a=b.sep){if(o.scheme===k.Schemas.file){const w=f(o);return w.length>E.getRoot(w).length&&w[w.length-1]===a}else{const w=o.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,a=b.sep){return(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,a=b.sep){let w=!1;if(o.scheme===k.Schemas.file){const _=f(o);w=_!==void 0&&_.length===E.getRoot(_).length&&_[_.length-1]===a}else{a="/";const _=o.path;w=_.length===1&&_.charCodeAt(_.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path+"/"}):o}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(D=>D.scheme===k.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(D,o){const a=[];for(let w=0;w<D.length;w++){const _=o(D[w]);D.some((A,d)=>d===w?!1:(0,e.isEqualOrParent)(_,o(A)))||a.push(D[w])}return a}e.distinctParents=i;var I;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function o(a){const w=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,c]=d.split(":");l&&c&&w.set(l,c)});const A=a.path.substring(0,a.path.indexOf(";"));return A&&w.set(D.META_DATA_MIME,A),w}D.parseMetaData=o})(I=e.DataUri||(e.DataUri={}));function p(D,o,a){if(o){let w=D.path;return w&&w[0]!==b.posix.sep&&(w=b.posix.sep+w),D.with({scheme:a,authority:o,path:w})}return D.with({scheme:a})}e.toLocalResource=p}),define(de[14],me([0,1,28,12,6,2,70,17]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(H){return!!H&&typeof H.then=="function"}e.isThenable=f;function m(H){const T=new E.CancellationTokenSource,L=H(T.token),B=new Promise((U,V)=>{T.token.onCancellationRequested(()=>{V((0,b.canceled)())}),Promise.resolve(L).then(ie=>{T.dispose(),U(ie)},ie=>{T.dispose(),V(ie)})});return new class{cancel(){T.cancel()}then(U,V){return B.then(U,V)}catch(U){return this.then(void 0,U)}finally(U){return B.finally(U)}}}e.createCancelablePromise=m;function i(H,T,L){return Promise.race([H,new Promise(B=>T.onCancellationRequested(()=>B(L)))])}e.raceCancellation=i;async function I(H){let T=-1;const L=H.map((U,V)=>U.then(ie=>(T=V,ie))),B=await Promise.race(L);return H.forEach((U,V)=>{V!==T&&U.cancel()}),B}e.raceCancellablePromises=I;function p(H,T,L){let B;const U=setTimeout(()=>{B==null||B(void 0),L==null||L()},T);return Promise.race([H.finally(()=>clearTimeout(U)),new Promise(V=>B=V)])}e.raceTimeout=p;function D(H){return new Promise((T,L)=>{const B=H();f(B)?B.then(T,L):T(B)})}e.asPromise=D;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const L=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(L,L).then(B)})}return new Promise((L,B)=>{this.queuedPromise.then(L,B)})}return this.activePromise=T(),new Promise((L,B)=>{this.activePromise.then(U=>{this.activePromise=null,L(U)},U=>{this.activePromise=null,B(U)})})}}e.Throttler=o;class a{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=a;class w{constructor(){this.promiseMap=new Map}queue(T,L){var B;const V=((B=this.promiseMap.get(T))!==null&&B!==void 0?B:Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.promiseMap.get(T)===V&&this.promiseMap.delete(T)});return this.promiseMap.set(T,V),V}}e.SequencerByKey=w;class _{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,L=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,U)=>{this.doResolve=B,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},L),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,b.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=_;class A{constructor(T){this.delayer=new _(T),this.throttler=new o}trigger(T,L){return this.delayer.trigger(()=>this.throttler.queue(T),L)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=A;class d{constructor(){this._isOpen=!1,this._promise=new Promise((T,L)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class l extends d{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function c(H,T){return T?new Promise((L,B)=>{const U=setTimeout(L,H);T.onCancellationRequested(()=>{clearTimeout(U),B((0,b.canceled)())})}):m(L=>c(H,L))}e.timeout=c;function t(H,T=0){const L=setTimeout(H,T);return(0,S.toDisposable)(()=>clearTimeout(L))}e.disposableTimeout=t;function n(H){return H.then(void 0,T=>{})}e.ignoreErrors=n;function r(H){const T=[];let L=0;const B=H.length;function U(){return L<B?H[L++]():null}function V(ie){ie!=null&&T.push(ie);const le=U();return le?le.then(V):Promise.resolve(T)}return Promise.resolve(null).then(V)}e.sequence=r;function s(H,T=B=>!!B,L=null){let B=0;const U=H.length,V=()=>{if(B>=U)return Promise.resolve(L);const ie=H[B++];return Promise.resolve(ie()).then(ue=>T(ue)?Promise.resolve(ue):V())};return V()}e.first=s;function u(H,T=B=>!!B,L=null){if(H.length===0)return Promise.resolve(L);let B=H.length;const U=()=>{var V,ie;B=-1;for(const le of H)(ie=(V=le).cancel)===null||ie===void 0||ie.call(V)};return new Promise((V,ie)=>{for(const le of H)le.then(ue=>{--B>=0&&T(ue)?(U(),V(ue)):B===0&&V(L)}).catch(ue=>{--B>=0&&(U(),ie(ue))})})}e.firstParallel=u;class h{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((L,B)=>{this.outstandingPromises.push({factory:T,c:L,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const L=T.factory();L.then(T.c,T.e),L.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class y extends h{constructor(){super(1)}}e.Queue=y;class P{constructor(){this.queues=new Map}queueFor(T,L=R.extUri){const B=L.getComparisonKey(T);let U=this.queues.get(B);return U||(U=new y,C.Event.once(U.onFinished)(()=>{U==null||U.dispose(),this.queues.delete(B)}),this.queues.set(B,U)),U}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=P;class v{constructor(T,L){this._token=-1,typeof T=="function"&&typeof L=="number"&&this.setIfNotSet(T,L)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,L){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},L)}setIfNotSet(T,L){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},L))}}e.TimeoutTimer=v;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,L){this.cancel(),this._token=setInterval(()=>{T()},L)}}e.IntervalTimer=g;class F{constructor(T,L){this.timeoutToken=-1,this.runner=T,this.timeout=L,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class O extends F{constructor(T,L){super(T,L);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const L=setTimeout(()=>T(H));let B=!1;return{dispose(){B||(B=!0,clearTimeout(L))}}}}else e.runWhenIdle=(H,T)=>{const L=requestIdleCallback(H,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(L))}}}}();class x{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(L){this._error=L}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function oe(H,T,L){let B;for(let U=0;U<L;U++)try{return await H()}catch(V){B=V,await c(T)}throw B}e.retry=oe;class W{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,L,B){return this._pending={taskId:T,cancel:()=>B==null?void 0:B(),promise:L},L.then(()=>this.donePending(T),()=>this.donePending(T)),L}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let L,B;const U=new Promise((V,ie)=>{L=V,B=ie});this._next={run:T,promise:U,promiseResolve:L,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=W;class te{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,L)=>{this.completeCallback=T,this.errorCallback=L})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(L=>{this.completeCallback(T),this.resolved=!0,L()})}error(T){return new Promise(L=>{this.errorCallback(T),this.rejected=!0,L()})}cancel(){new Promise(T=>{this.errorCallback((0,b.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=Q;class q extends C.Emitter{async fireAsync(T,L,B){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const U of this._listeners)this._asyncDeliveryQueue.push([U,T]);for(;this._asyncDeliveryQueue.size>0&&!L.isCancellationRequested;){const[U,V]=this._asyncDeliveryQueue.shift(),ie=[],le=Object.assign(Object.assign({},V),{waitUntil:ue=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");B&&(ue=B(ue,typeof U=="function"?U:U[0])),ie.push(ue)}});try{typeof U=="function"?U.call(void 0,le):U[0].call(U[1],le)}catch(ue){(0,b.onUnexpectedError)(ue);continue}Object.freeze(ie),await ee.settled(ie).catch(ue=>(0,b.onUnexpectedError)(ue))}}}}e.AsyncEmitter=q;var ee;(function(H){async function T(V){return typeof Promise.allSettled=="function"?L(V):B(V)}H.allSettled=T;async function L(V){return Promise.allSettled(V)}async function B(V){return Promise.all(V.map(ie=>ie.then(le=>({status:"fulfilled",value:le}),le=>({status:"rejected",reason:le}))))}async function U(V){let ie;const le=await Promise.all(V.map(ue=>ue.then(we=>we,we=>{ie||(ie=we)})));if(typeof ie!="undefined")throw ie;return le}H.settled=U})(ee=e.Promises||(e.Promises={}))}),define(de[46],me([0,1,13,29,4,26,14]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const f="**",m="/",i="[/\\\\]",I="[^/\\\\]",p=/\//g;function D(L){switch(L){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function o(L,B){if(!L)return[];const U=[];let V=!1,ie=!1,le="";for(const ue of L){switch(ue){case B:if(!V&&!ie){U.push(le),le="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}le+=ue}return le&&U.push(le),U}e.splitGlobAware=o;function a(L){if(!L)return"";let B="";const U=o(L,m);if(U.every(V=>V===f))B=".*";else{let V=!1;U.forEach((ie,le)=>{if(ie===f){V||(B+=D(2),V=!0);return}let ue=!1,we="",ke=!1,Ae="";for(const Fe of ie){if(Fe!=="}"&&ue){we+=Fe;continue}if(ke&&(Fe!=="]"||!Ae)){let je;Fe==="-"?je=Fe:(Fe==="^"||Fe==="!")&&!Ae?je="^":Fe===m?je="":je=E.escapeRegExpCharacters(Fe),Ae+=je;continue}switch(Fe){case"{":ue=!0;continue;case"[":ke=!0;continue;case"}":B+=`(?:${o(we,",").map(qe=>a(qe)).join("|")})`,ue=!1,we="";break;case"]":B+="["+Ae+"]",ke=!1,Ae="";break;case"?":B+=I;continue;case"*":B+=D(1);continue;default:B+=E.escapeRegExpCharacters(Fe)}}le<U.length-1&&(U[le+1]!==f||le+2<U.length)&&(B+=i),V=!1})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,_=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),n=function(){return!1},r=function(){return null};function s(L,B){if(!L)return r;let U;typeof L!="string"?U=L.pattern:U=L,U=U.trim();const V=`${U}_${!!B.trimForExclusions}`;let ie=t.get(V);if(ie)return u(ie,L);let le;if(w.test(U)){const ue=U.substr(4);ie=function(we,ke){return typeof we=="string"&&we.endsWith(ue)?U:null}}else(le=_.exec(h(U,B)))?ie=y(le[1],U):(B.trimForExclusions?d:A).test(U)?ie=P(U,B):(le=l.exec(h(U,B)))?ie=v(le[1].substr(1),U,!0):(le=c.exec(h(U,B)))?ie=v(le[1],U,!1):ie=g(U);return t.set(V,ie),u(ie,L)}function u(L,B){return typeof B=="string"?L:function(U,V){return b.isEqualOrParent(U,B.base)?L(C.relative(B.base,U),V):null}}function h(L,B){return B.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function y(L,B){const U=`/${L}`,V=`\\${L}`,ie=function(ue,we){return typeof ue!="string"?null:we?we===L?B:null:ue===L||ue.endsWith(U)||ue.endsWith(V)?B:null},le=[L];return ie.basenames=le,ie.patterns=[B],ie.allBasenames=le,ie}function P(L,B){const U=T(L.slice(1,-1).split(",").map(we=>s(we,B)).filter(we=>we!==r),L),V=U.length;if(!V)return r;if(V===1)return U[0];const ie=function(we,ke){for(let Ae=0,Fe=U.length;Ae<Fe;Ae++)if(U[Ae](we,ke))return L;return null},le=U.find(we=>!!we.allBasenames);le&&(ie.allBasenames=le.allBasenames);const ue=U.reduce((we,ke)=>ke.allPaths?we.concat(ke.allPaths):we,[]);return ue.length&&(ie.allPaths=ue),ie}function v(L,B,U){const V=C.sep===C.posix.sep,ie=V?L:L.replace(p,C.sep),le=C.sep+ie,ue=C.posix.sep+L,we=U?function(ke,Ae){return typeof ke=="string"&&(ke===ie||ke.endsWith(le)||!V&&(ke===L||ke.endsWith(ue)))?B:null}:function(ke,Ae){return typeof ke=="string"&&(ke===ie||!V&&ke===L)?B:null};return we.allPaths=[(U?"*/":"./")+L],we}function g(L){try{const B=new RegExp(`^${a(L)}$`);return function(U){return B.lastIndex=0,typeof U=="string"&&B.test(U)?L:null}}catch(B){return r}}function F(L,B,U){return!L||typeof B!="string"?!1:O(L)(B,void 0,U)}e.match=F;function O(L,B={}){if(!L)return n;if(typeof L=="string"||te(L)){const U=s(L,B);if(U===r)return n;const V=function(ie,le){return!!U(ie,le)};return U.allBasenames&&(V.allBasenames=U.allBasenames),U.allPaths&&(V.allPaths=U.allPaths),V}return ee(L,B)}e.parse=O;function x(L){if(!!L){let B;return U=>(B||(B=(L()||Promise.resolve([])).then(V=>V?W(V):{})),B.then(V=>!!V[U]))}}e.hasSiblingPromiseFn=x;function oe(L){if(!!L){let B;return U=>{if(!B){const V=L();B=V?W(V):{}}return!!B[U]}}}e.hasSiblingFn=oe;function W(L){const B={};for(const U of L)B[U]=!0;return B}function te(L){const B=L;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=te;function Q(L){return L.allBasenames||[]}e.getBasenameTerms=Q;function q(L){return L.allPaths||[]}e.getPathTerms=q;function ee(L,B){const U=T(Object.getOwnPropertyNames(L).map(we=>H(we,L[we],B)).filter(we=>we!==r)),V=U.length;if(!V)return r;if(!U.some(we=>!!we.requiresSiblings)){if(V===1)return U[0];const we=function(Fe,je){for(let Qe=0,qe=U.length;Qe<qe;Qe++){const it=U[Qe](Fe,je);if(it)return it}return null},ke=U.find(Fe=>!!Fe.allBasenames);ke&&(we.allBasenames=ke.allBasenames);const Ae=U.reduce((Fe,je)=>je.allPaths?Fe.concat(je.allPaths):Fe,[]);return Ae.length&&(we.allPaths=Ae),we}const ie=function(we,ke,Ae){let Fe;for(let je=0,Qe=U.length;je<Qe;je++){const qe=U[je];qe.requiresSiblings&&Ae&&(ke||(ke=C.basename(we)),Fe||(Fe=ke.substr(0,ke.length-C.extname(we).length)));const it=qe(we,ke,Fe,Ae);if(it)return it}return null},le=U.find(we=>!!we.allBasenames);le&&(ie.allBasenames=le.allBasenames);const ue=U.reduce((we,ke)=>ke.allPaths?we.concat(ke.allPaths):we,[]);return ue.length&&(ie.allPaths=ue),ie}function H(L,B,U){if(B===!1)return r;const V=s(L,U);if(V===r)return r;if(typeof B=="boolean")return V;if(B){const ie=B.when;if(typeof ie=="string"){const le=(ue,we,ke,Ae)=>{if(!Ae||!V(ue,we))return null;const Fe=ie.replace("$(basename)",ke),je=Ae(Fe);return(0,k.isThenable)(je)?je.then(Qe=>Qe?L:null):je?L:null};return le.requiresSiblings=!0,le}}return V}function T(L,B){const U=L.filter(we=>!!we.basenames);if(U.length<2)return L;const V=U.reduce((we,ke)=>{const Ae=ke.basenames;return Ae?we.concat(Ae):we},[]);let ie;if(B){ie=[];for(let we=0,ke=V.length;we<ke;we++)ie.push(B)}else ie=U.reduce((we,ke)=>{const Ae=ke.patterns;return Ae?we.concat(Ae):we},[]);const le=function(we,ke){if(typeof we!="string")return null;if(!ke){let Fe;for(Fe=we.length;Fe>0;Fe--){const je=we.charCodeAt(Fe-1);if(je===47||je===92)break}ke=we.substr(Fe)}const Ae=V.indexOf(ke);return Ae!==-1?ie[Ae]:null};le.basenames=V,le.patterns=ie,le.allBasenames=V;const ue=L.filter(we=>!we.basenames);return ue.push(le),ue}}),define(de[51],me([0,1,3,4,13,8,5,17,29]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(s,u,h){if(typeof s=="string"&&(s=E.URI.file(s)),h){const P=h.getWorkspaceFolder(s);if(P){const v=h.getWorkspace().folders.length>1;let g;if((0,R.isEqual)(P.uri,s)?g="":g=(0,R.relativePath)(P.uri,s),v){const F=P.name?P.name:(0,R.basename)(P.uri);g=g?F+" \u2022 "+g:F}return g}}if(s.scheme!==S.Schemas.file&&s.scheme!==S.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(s.fsPath))return(0,b.normalize)(I(s.fsPath));let y=(0,b.normalize)(s.fsPath);return!k.isWindows&&(u==null?void 0:u.userHome)&&(y=D(y,u.userHome.fsPath)),y}e.getPathLabel=m;function i(s){if(!!s){typeof s=="string"&&(s=E.URI.file(s));const u=(0,R.basename)(s)||(s.scheme===S.Schemas.file?s.fsPath:s.path);return k.isWindows&&(0,f.isRootOrDriveLetter)(u)?I(u):u}}e.getBaseLabel=i;function I(s){return(0,f.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let p=Object.create(null);function D(s,u){if(k.isWindows||!s||!u)return s;let h=p.original===u?p.normalized:void 0;return h||(h=`${(0,C.rtrim)(u,b.posix.sep)}${b.posix.sep}`,p={original:u,normalized:h}),(k.isLinux?s.startsWith(h):(0,C.startsWithIgnoreCase)(s,h))&&(s=`~/${s.substr(h.length)}`),s}e.tildify=D;function o(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=o;const a="\u2026",w="\\\\",_="~";function A(s,u=b.sep){const h=new Array(s.length);let y=!1;for(let P=0;P<s.length;P++){let v=s[P];if(v===""){h[P]=`.${u}`;continue}if(!v){h[P]=v;continue}y=!0;let g="";v.indexOf(w)===0?(g=v.substr(0,v.indexOf(w)+w.length),v=v.substr(v.indexOf(w)+w.length)):v.indexOf(u)===0?(g=v.substr(0,v.indexOf(u)+u.length),v=v.substr(v.indexOf(u)+u.length)):v.indexOf(_)===0&&(g=v.substr(0,v.indexOf(_)+_.length),v=v.substr(v.indexOf(_)+_.length));const F=v.split(u);for(let O=1;y&&O<=F.length;O++)for(let x=F.length-O;y&&x>=0;x--){y=!1;let oe=F.slice(x,x+O).join(u);for(let W=0;!y&&W<s.length;W++)if(W!==P&&s[W]&&s[W].indexOf(oe)>-1){const te=x+O===F.length,Q=x>0&&s[W].indexOf(u)>-1?u+oe:oe,q=s[W].endsWith(Q);y=!te||q}if(!y){let W="";(F[0].endsWith(":")||g!=="")&&(x===1&&(x=0,O++,oe=F[0]+u+oe),x>0&&(W=F[0]+u),W=g+W),x>0&&(W=W+a+u),W=W+oe,x+O<F.length&&(W=W+u+a),h[P]=W}}y&&(h[P]=v)}return h}e.shorten=A;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(s,u=Object.create(null)){const h=[];let y=!1,P="";for(const v of s)if(v==="$"||y&&v==="{")P&&h.push({value:P,type:d.TEXT}),P="",y=!0;else if(v==="}"&&y){const g=u[P];if(typeof g=="string")g.length&&h.push({value:g,type:d.VARIABLE});else if(g){const F=h[h.length-1];(!F||F.type!==d.SEPARATOR)&&h.push({value:g.label,type:d.SEPARATOR})}P="",y=!1}else P+=v;return P&&!y&&h.push({value:P,type:d.TEXT}),h.filter((v,g)=>{if(v.type===d.SEPARATOR){const F=h[g-1],O=h[g+1];return[F,O].every(x=>x&&(x.type===d.VARIABLE||x.type===d.TEXT)&&x.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=l;function c(s,u){return k.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(s,u){return k.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):k.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(s){const u=s.indexOf("/")!==-1?b.posix:b.win32,h=u.basename(s),y=u.dirname(s);return h.length?{name:h,parentPath:y}:{name:y,parentPath:""}}e.splitName=r}),define(de[119],me([0,1,4,13,46,8,17]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let R=[],f=[],m=[];function i(l,c=!1){const t=I(l);R.push(t),t.userConfigured?m.push(t):f.push(t),c&&!t.userConfigured&&R.forEach(n=>{n.mime===t.mime||n.userConfigured||(t.extension&&n.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&n.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&n.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&n.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=i;function I(l){return{id:l.id,mime:l.mime,filename:l.filename,extension:l.extension,filepattern:l.filepattern,firstline:l.firstline,userConfigured:l.userConfigured,filenameLowercase:l.filename?l.filename.toLowerCase():void 0,extensionLowercase:l.extension?l.extension.toLowerCase():void 0,filepatternLowercase:l.filepattern?l.filepattern.toLowerCase():void 0,filepatternOnPath:l.filepattern?l.filepattern.indexOf(E.posix.sep)>=0:!1}}function p(l){l?(R=R.filter(c=>!c.userConfigured),m=[]):(R=[],f=[],m=[])}e.clearTextMimes=p;function D(l,c){let t;if(l)switch(l.scheme){case S.Schemas.file:t=l.fsPath;break;case S.Schemas.data:t=k.DataUri.parseMetaData(l).get(k.DataUri.META_DATA_LABEL);break;default:t=l.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const n=(0,E.basename)(t),r=o(t,n,m);if(r)return[r,e.MIME_TEXT];const s=o(t,n,f);if(s)return[s,e.MIME_TEXT];if(c){const u=a(c);if(u)return[u,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=D;function o(l,c,t){let n=null,r=null,s=null;for(let u=t.length-1;u>=0;u--){const h=t[u];if(c===h.filenameLowercase){n=h;break}if(h.filepattern&&(!r||h.filepattern.length>r.filepattern.length)){const y=h.filepatternOnPath?l:c;(0,C.match)(h.filepatternLowercase,y)&&(r=h)}h.extension&&(!s||h.extension.length>s.extension.length)&&c.endsWith(h.extensionLowercase)&&(s=h)}return n?n.mime:r?r.mime:s?s.mime:null}function a(l){if((0,b.startsWithUTF8BOM)(l)&&(l=l.substr(1)),l.length>0)for(let c=R.length-1;c>=0;c--){const t=R[c];if(!!t.firstline){const n=l.match(t.firstline);if(n&&n.length>0)return t.mime}}return null}function w(l){return l?typeof l=="string"?l===e.MIME_BINARY||l===e.MIME_TEXT||l===e.MIME_UNKNOWN:l.length===1&&w(l[0]):!0}e.isUnspecific=w;const _={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(l){const c=(0,E.extname)(l);return _[c.toLowerCase()]}e.getMediaMime=A;function d(l){for(const c in _)if(_[c]===l)return c}e.getExtensionForMimeType=d}),define(de[52],me([0,1,3]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function b(i){return i.toJSON()}class C{constructor(I){this._uriTransformer=I}transformIncoming(I){const p=this._uriTransformer.transformIncoming(I);return p===I?I:b(E.URI.from(p))}transformOutgoing(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:b(E.URI.from(p))}transformOutgoingURI(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:E.URI.from(p)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,I,p){if(!i||p>200)return null;if(typeof i=="object"){if(i instanceof E.URI)return I.transformOutgoing(i);for(let D in i)if(Object.hasOwnProperty.call(i,D)){const o=S(i[D],I,p+1);o!==null&&(i[D]=o)}}return null}function k(i,I){const p=S(i,I,0);return p===null?i:p}e.transformOutgoingURIs=k;function R(i,I,p,D){if(!i||D>200)return null;if(typeof i=="object"){if(i.$mid===1)return p?E.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let o in i)if(Object.hasOwnProperty.call(i,o)){const a=R(i[o],I,p,D+1);a!==null&&(i[o]=a)}}return null}function f(i,I){const p=R(i,I,!1,0);return p===null?i:p}e.transformIncomingURIs=f;function m(i,I){const p=R(i,I,!0,0);return p===null?i:p}e.transformAndReviveIncomingURIs=m}),define(de[23],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function b(f){return E.test(f)}e.isUUID=b;const C=new Uint8Array(16),S=[];for(let f=0;f<256;f++)S.push(f.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(f){for(let m=0;m<f.length;m++)f[m]=Math.floor(Math.random()*256);return f};function R(){k(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let f=0,m="";return m+=S[C[f++]],m+=S[C[f++]],m+=S[C[f++]],m+=S[C[f++]],m+="-",m+=S[C[f++]],m+=S[C[f++]],m+="-",m+=S[C[f++]],m+=S[C[f++]],m+="-",m+=S[C[f++]],m+=S[C[f++]],m+="-",m+=S[C[f++]],m+=S[C[f++]],m+=S[C[f++]],m+=S[C[f++]],m+=S[C[f++]],m+=S[C[f++]],m}e.generateUuid=R}),define(de[75],me([0,1,233]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class b{constructor(S="utf8"){this.stringDecoder=new E.StringDecoder(S),this.remaining=null}write(S){const k=[],R=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(R.length<1)return k;let f=0,m,i=f;for(;i<R.length;)if(m=R.charCodeAt(i),m===13||m===10){if(k.push(R.substring(f,i)),i++,i<R.length){const I=m;m=R.charCodeAt(i),(I===13&&m===10||I===10&&m===13)&&i++}f=i}else i++;return this.remaining=f<R.length?R.substr(f):null,k}end(){return this.remaining}}e.LineDecoder=b}),function(){"use strict";function Y(e,E,b,C){function S(o){return new Promise(a=>b.exists(o,a))}function k(o){return new Promise((a,w)=>{const _=new Date;b.utimes(o,_,_,A=>A?w(A):a())})}function R(o){return new Promise((a,w)=>b.mkdir(o,{recursive:!0},_=>_&&_.code!=="EEXIST"?w(_):a(o)))}function f(o){return new Promise((a,w)=>b.rmdir(o,{recursive:!0},_=>_&&_.code!=="ENOENT"?w(_):a()))}function m(o){return new Promise((a,w)=>b.readFile(o,"utf8",(_,A)=>_?w(_):a(A)))}function i(o,a){return new Promise((w,_)=>b.writeFile(o,a,"utf8",A=>A?_(A):w()))}function I(o){const a=E.join(o,"languagepacks.json");try{return e(a)}catch(w){}}function p(o,a){try{for(;a;){if(o[a])return a;{const w=a.lastIndexOf("-");if(w>0)a=a.substring(0,w);else return}}}catch(w){console.error("Resolving language pack configuration failed.",w)}}function D(o,a,w,_){if(_==="pseudo")return Promise.resolve({locale:_,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:_,availableLanguages:{}});if(_&&(_==="en"||_==="en-us"))return Promise.resolve({locale:_,availableLanguages:{}});const A=_;C.mark("code/willGenerateNls");const d=function(l){return C.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!o)return d(A);const l=I(a);if(!l||(_=p(l,_),!_))return d(A);const c=l[_];let t;return!c||typeof c.hash!="string"||!c.translations||typeof(t=c.translations.vscode)!="string"?d(A):S(t).then(n=>{if(!n)return d(A);const r=c.hash+"."+_,s=E.join(a,"clp",r),u=E.join(s,o),h=E.join(s,"tcf.json"),y=E.join(s,"corrupted.info"),P={locale:A,availableLanguages:{"*":_},_languagePackId:r,_translationsConfigFile:h,_cacheRoot:s,_resolvedLanguagePackCoreLocation:u,_corruptedFile:y};return S(y).then(v=>{let g;return v?g=f(s):g=Promise.resolve(void 0),g.then(()=>S(u).then(F=>F?(k(u).catch(()=>{}),C.mark("code/didGenerateNls"),P):R(u).then(()=>Promise.all([m(w),m(t)])).then(O=>{const x=JSON.parse(O[0]),oe=JSON.parse(O[1]).contents,W=Object.keys(x.bundles),te=[];for(const Q of W){const q=x.bundles[Q],ee=Object.create(null);for(const H of q){const T=x.keys[H],L=x.messages[H],B=oe[H];let U;if(B){U=[];for(let V=0;V<T.length;V++){const ie=T[V],le=typeof ie=="string"?ie:ie.key;let ue=B[le];ue===void 0&&(ue=L[V]),U.push(ue)}}else U=L;ee[H]=U}te.push(i(E.join(u,Q.replace(/\//g,"!")+".nls.json"),JSON.stringify(ee)))}return te.push(i(h,JSON.stringify(c.translations))),Promise.all(te)}).then(()=>(C.mark("code/didGenerateNls"),P)).catch(O=>(console.error("Generating translation files failed.",O),d(_)))))})})}catch(l){return console.error("Generating translation files failed.",l),d(_)}}return{getNLSConfiguration:D}}if(typeof define=="function")define(de[120],me([0,76,15,47]),function(e,E,b,C){return Y(e.__$__nodeRequire,E,b,C)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),b=require("../common/performance");module.exports=Y(require,e,E,b)}else throw new Error("Unknown context")}(),define(de[121],me([0,1,25]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const b=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(R){const f=R.replace(/\-/g,":").toLowerCase();return!b.has(f)}function S(){return new Promise(async(R,f)=>{const m=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await k())}catch(i){f(i)}finally{clearTimeout(m)}})}e.getMac=S;function k(){return new Promise((R,f)=>{try{const m=(0,E.networkInterfaces)();for(let i in m){const I=m[i];if(I){for(const{mac:p}of I)if(C(p))return R(p)}}f("Unable to retrieve mac address (unexpected format)")}catch(m){f(m)}})}}),define(de[77],me([0,1,12,23,25,26,121]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const p=(0,C.networkInterfaces)();for(let D in p){const o=p[D];if(o)for(const{mac:a,internal:w}of o)w||(I+=1,this._isVirtualMachineMacAdress(a.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let R;async function f(){return R||(R=(async()=>await m()||b.generateUuid())()),R}e.getMachineId=f;async function m(){try{const i=await new Promise((p,D)=>{Y(["crypto"],p,D)}),I=await(0,k.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){E.onUnexpectedError(i);return}}}),define(de[21],me([0,1,15,25,4,14,5,29,23,74,17,3]),function(Y,e,E,b,C,S,k,R,f,m,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function D(Q,q=p.UNLINK){if((0,R.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");return q===p.UNLINK?a(Q):o(Q)}e.rimraf=D;async function o(Q){try{const q=(0,C.join)((0,b.tmpdir)(),(0,f.generateUuid)());try{await E.promises.rename(Q,q)}catch(ee){return a(Q)}a(q).catch(ee=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function a(Q){return E.promises.rmdir(Q,{recursive:!0,maxRetries:3})}function w(Q){if((0,R.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync(Q,{recursive:!0})}e.rimrafSync=w;async function _(Q,q){return l(await(q?A(Q):E.promises.readdir(Q)))}e.readdir=_;async function A(Q){try{return await E.promises.readdir(Q,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const q=[],ee=await _(Q);for(const H of ee){let T=!1,L=!1,B=!1;try{const U=await E.promises.lstat((0,C.join)(Q,H));T=U.isFile(),L=U.isDirectory(),B=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}q.push({name:H,isFile:()=>T,isDirectory:()=>L,isSymbolicLink:()=>B})}return q}function d(Q){return l(E.readdirSync(Q))}e.readdirSync=d;function l(Q){return Q.map(q=>typeof q=="string"?k.isMacintosh?(0,m.normalizeNFC)(q):q:(q.name=k.isMacintosh?(0,m.normalizeNFC)(q.name):q.name,q))}async function c(Q){const q=await _(Q),ee=[];for(const H of q)await n.existsDirectory((0,C.join)(Q,H))&&ee.push(H);return ee}e.readDirsInDir=c;function t(Q,q=1e3){return new Promise(ee=>{let H=!1;const T=setInterval(()=>{H||(H=!0,E.access(Q,L=>{H=!1,L&&(clearInterval(T),ee(void 0))}))},q)})}e.whenDeleted=t;var n;(function(Q){async function q(T){let L;try{if(L=await E.promises.lstat(T),!L.isSymbolicLink())return{stat:L}}catch(B){}try{return{stat:await E.promises.stat(T),symbolicLink:(L==null?void 0:L.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(k.isWindows&&B.code==="EACCES")try{return{stat:await E.promises.stat(await E.promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw U}throw B}}Q.stat=q;async function ee(T){try{const{stat:L,symbolicLink:B}=await Q.stat(T);return L.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(L){}return!1}Q.existsFile=ee;async function H(T){try{const{stat:L,symbolicLink:B}=await Q.stat(T);return L.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(L){}return!1}Q.existsDirectory=H})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new S.ResourceQueue;function s(Q,q,ee){return r.queueFor(I.URI.file(Q),i.extUriBiasedIgnorePathCase).queue(()=>{const H=P(ee);return new Promise((T,L)=>h(Q,q,H,B=>B?L(B):T()))})}e.writeFile=s;let u=!0;function h(Q,q,ee,H){if(!u)return E.writeFile(Q,q,{mode:ee.mode,flag:ee.flag},H);E.open(Q,ee.flag,ee.mode,(T,L)=>{if(T)return H(T);E.writeFile(L,q,B=>{if(B)return E.close(L,()=>H(B));E.fdatasync(L,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),u=!1),E.close(L,V=>H(V))))})})}function y(Q,q,ee){const H=P(ee);if(!u)return E.writeFileSync(Q,q,{mode:H.mode,flag:H.flag});const T=E.openSync(Q,H.flag,H.mode);try{E.writeFileSync(T,q);try{E.fdatasyncSync(T)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),u=!1}}finally{E.closeSync(T)}}e.writeFileSync=y;function P(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function v(Q,q){if(Q!==q){async function ee(H){try{const T=await E.promises.lstat(H);if(T.isDirectory()||T.isSymbolicLink())return;const L=await E.promises.open(H,"a");try{await L.utimes(T.atime,new Date)}finally{await L.close()}}catch(T){}}try{await E.promises.rename(Q,q),await ee(q)}catch(H){if(Q.toLowerCase()!==q.toLowerCase()&&H.code==="EXDEV"||Q.endsWith("."))await g(Q,q,{preserveSymlinks:!1}),await D(Q,p.MOVE),await ee(q);else throw H}}}e.move=v;async function g(Q,q,ee){return O(Q,q,{root:{source:Q,target:q},options:ee,handledSourcePaths:new Set})}e.copy=g;const F=511;async function O(Q,q,ee){if(!ee.handledSourcePaths.has(Q)){ee.handledSourcePaths.add(Q);const{stat:H,symbolicLink:T}=await n.stat(Q);if(T){if(ee.options.preserveSymlinks)try{return await W(Q,q,ee)}catch(L){console.warn("[node.js fs] copy of symlink failed: ",L)}if(T.dangling)return}return H.isDirectory()?x(Q,q,H.mode&F,ee):oe(Q,q,H.mode&F)}}async function x(Q,q,ee,H){await E.promises.mkdir(q,{recursive:!0,mode:ee});const T=await _(Q);for(const L of T)await O((0,C.join)(Q,L),(0,C.join)(q,L),H)}async function oe(Q,q,ee){await E.promises.copyFile(Q,q),await E.promises.chmod(q,ee)}async function W(Q,q,ee){let H=await E.promises.readlink(Q);(0,R.isEqualOrParent)(H,ee.root.source,!k.isLinux)&&(H=(0,C.join)(ee.root.target,H.substr(ee.root.source.length+1))),await E.promises.symlink(H,q)}async function te(Q){try{return await E.promises.access(Q),!0}catch(q){return!1}}e.exists=te}),define(de[122],me([0,1,15,78,13,4,21]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(I){const p=(0,S.dirname)(I);if(I===p)return I;const D=((0,S.basename)(I)||I).toLowerCase();try{const a=(0,k.readdirSync)(p).filter(w=>w.toLowerCase()===D);if(a.length===1){const w=R(p);if(w)return(0,S.join)(w,a[0])}else if(a.length>1){const w=a.indexOf(D);if(w>=0){const _=R(p);if(_)return(0,S.join)(_,a[w])}}}catch(o){}return null}e.realcaseSync=R;async function f(I){try{return await(0,b.promisify)(E.realpath)(I)}catch(p){const D=i(I);return await E.promises.access(D,E.constants.R_OK),D}}e.realpath=f;function m(I){try{return E.realpathSync(I)}catch(p){const D=i(I);return E.accessSync(D,E.constants.R_OK),D}}e.realpathSync=m;function i(I){return(0,C.rtrim)((0,S.normalize)(I),S.sep)}}),define(de[123],me([0,1,79]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function b(){const f=1025;return f+Math.floor((65535-f)*Math.random())}e.randomPort=b;function C(f,m,i){let I=!1;return new Promise(p=>{const D=setTimeout(()=>{if(!I)return I=!0,p(0)},i);S(f,m,o=>{if(!I)return I=!0,clearTimeout(D),p(o)})})}e.findFreePort=C;function S(f,m,i){if(m===0)return i(0);const I=new E.Socket;I.once("connect",()=>(R(I),S(f+1,m-1,i))),I.once("data",()=>{}),I.once("error",p=>(R(I),p.code!=="ECONNREFUSED"?S(f+1,m-1,i):i(f))),I.connect(f,"127.0.0.1")}function k(f,m,i){let I=!1,p,D=1;const o=E.createServer({pauseOnConnect:!0});function a(w,_){I||(I=!0,o.removeAllListeners(),o.close(),p&&clearTimeout(p),_(w))}return new Promise(w=>{p=setTimeout(()=>{a(0,w)},i),o.on("listening",()=>{a(f,w)}),o.on("error",_=>{_&&(_.code==="EADDRINUSE"||_.code==="EACCES")&&D<m?(f++,D++,o.listen(f,"127.0.0.1")):a(0,w)}),o.on("close",()=>{a(0,w)}),o.listen(f,"127.0.0.1")})}e.findFreePortFaster=k;function R(f){try{f.removeAllListeners("connect"),f.removeAllListeners("error"),f.end(),f.destroy(),f.unref()}catch(m){console.error(m)}}});var st=this&&this.__await||function(Y){return this instanceof st?(this.v=Y,this):new st(Y)},xt=this&&this.__asyncGenerator||function(Y,e,E){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var b=E.apply(Y,e||[]),C,S=[];return C={},k("next"),k("throw"),k("return"),C[Symbol.asyncIterator]=function(){return this},C;function k(p){b[p]&&(C[p]=function(D){return new Promise(function(o,a){S.push([p,D,o,a])>1||R(p,D)})})}function R(p,D){try{f(b[p](D))}catch(o){I(S[0][3],o)}}function f(p){p.value instanceof st?Promise.resolve(p.value.v).then(m,i):I(S[0][2],p)}function m(p){R("next",p)}function i(p){R("throw",p)}function I(p,D){p(D),S.shift(),S.length&&R(S[0][0],S[0][1])}},Kt=this&&this.__asyncValues||function(Y){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Y[Symbol.asyncIterator],E;return e?e.call(Y):(Y=typeof __values=="function"?__values(Y):Y[Symbol.iterator](),E={},b("next"),b("throw"),b("return"),E[Symbol.asyncIterator]=function(){return this},E);function b(S){E[S]=Y[S]&&function(k){return new Promise(function(R,f){k=Y[S](k),C(R,f,k.done,k.value)})}}function C(S,k,R,f){Promise.resolve(f).then(function(m){S({value:m,done:R})},k)}};define(de[124],me([0,1,21,25,4]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,k=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var f;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(f||(f={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(c,t,n){this.exePath=c,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:l=!1}={}){return l?m===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function D({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=p({useAlternateBitness:l});if(!t)return null;const n=C.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(n))return null;let r=-1,s=null;for(const y of await E.readdir(n)){let P=-1;if(c){const g=y.indexOf("-");if(g<0)continue;const F=y.substring(0,g);if(!S.test(F)||y.substring(g+1)!=="preview")continue;P=parseInt(F,10)}else{if(!S.test(y))continue;P=parseInt(y,10)}if(!(P<=r)){const v=C.join(n,y,"pwsh.exe");!await E.SymlinkSupport.existsFile(v)||(s=v,r=P)}}if(!s)return null;const u=t.includes("x86")?" (x86)":"",h=c?" Preview":"";return new I(s,`PowerShell${h}${u}`,!0)}async function o({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=l?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const r of await E.readdir(c))if(t.test(r)){const s=C.join(c,r,"pwsh.exe");return new I(s,n)}return null}function a(){const l=C.join(b.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function w(){const l=C.join(process.env.windir,m===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}function _(){return xt(this,arguments,function*(){let c=yield st(D());c&&(yield yield st(c)),c=yield st(D({useAlternateBitness:!0})),c&&(yield yield st(c)),c=yield st(o()),c&&(yield yield st(c)),c=a(),c&&(yield yield st(c)),c=yield st(D({findPreview:!0})),c&&(yield yield st(c)),c=yield st(o({findPreview:!0})),c&&(yield yield st(c)),c=yield st(D({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield st(c)),c=w(),c&&(yield yield st(c))})}function A(){return xt(this,arguments,function*(){var c,t;try{for(var n=Kt(_()),r;r=yield st(n.next()),!r.done;){const s=r.value;(yield st(s.exists()))&&(yield yield st(s))}}catch(s){c={error:s}}finally{try{r&&!r.done&&(t=n.return)&&(yield st(t.call(n)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=A;async function d(){var l,c;try{for(var t=Kt(A()),n;n=await t.next(),!n.done;)return n.value}catch(r){l={error:r}}finally{try{n&&!n.done&&(c=t.return)&&await c.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(de[80],me([0,1,37,8]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(k){return new Promise((R,f)=>{let m;const i=new Map;function I(o,a,w,_,A){const d=i.get(a);if(o===k||d){const l={name:p(w),cmd:w,pid:o,ppid:a,load:_,mem:A};i.set(o,l),o===k&&(m=l),d&&(d.children||(d.children=[]),d.children.push(l),d.children.length>1&&(d.children=d.children.sort((c,t)=>c.pid-t.pid)))}}function p(o){const a=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,_=/--crashes-directory/,A=/\\pipe\\winpty-control/,d=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(o))return"watcherService ";if(_.exec(o))return"electron-crash-reporter";if(A.exec(o))return"winpty-process";if(d.exec(o))return"console-window-host (Windows internal process)";let c=l.exec(o);if(c&&c.length===2)return c[1]==="renderer"?a.exec(o)?"shared-process":"window":c[1];const t=/[a-zA-Z-]+\.js/g;let n="";do c=t.exec(o),c&&(n+=c+" ");while(c);return n&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron_node ${n}`:o}if(process.platform==="win32"){const o=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substr(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substr(5):a;new Promise((a,w)=>{Y(["windows-process-tree"],a,w)}).then(a=>{a.getProcessList(k,w=>{a.getProcessCpuUsage(w,_=>{const A=new Map;_.forEach(d=>{const l=o(d.commandLine||"");A.set(d.pid,{name:p(l),cmd:l,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),m=A.get(k),m?(A.forEach(d=>{const l=A.get(d.ppid);l&&(l.children||(l.children=[]),l.children.push(d))}),A.forEach(d=>{d.children&&(d.children=d.children.sort((l,c)=>l.pid-c.pid))}),R(m)):f(new Error(`Root process ${k} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{function D(){let o=[m];const a=[];for(;o.length;){const _=o.shift();_&&(a.push(_.pid),_.children&&(o=o.concat(_.children)))}let w=JSON.stringify(b.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);w+=" "+a.join(" "),(0,E.exec)(w,{},(_,A,d)=>{if(_||d)f(_||new Error(d.toString()));else{const l=A.toString().split(`
`);for(let c=0;c<a.length;c++){const t=i.get(a[c]);t.load=parseFloat(l[c])}if(!m){f(new Error(`Root process ${k} not found`));return}R(m)}})}(0,E.exec)("which ps",{},(o,a,w)=>{if(o||w)if(process.platform!=="linux")f(o||new Error(w.toString()));else{const _=JSON.stringify(b.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,E.exec)(_,{},(A,d,l)=>{A||l?f(A||new Error(l.toString())):(S(d,I),D())})}else{const _=a.toString().trim(),A="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${_} ${A}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,l,c)=>{d||c&&!c.includes("screen size is bogus")?f(d||new Error(c.toString())):(S(l,I),process.platform==="linux"?D():m?R(m):f(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=C;function S(k,R){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=k.toString().split(`
`);for(const i of m){const I=f.exec(i.trim());I&&I.length===6&&R(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(de[125],me([0,1,4,15,5,74,2,21]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function f(I,p,D){return i({path:I,isDirectory:!1},p,D)}e.watchFile=f;function m(I,p,D){return i({path:I,isDirectory:!0},p,D)}e.watchFolder=m,e.CHANGE_BUFFER_DELAY=100;function i(I,p,D){const o=(0,E.basename)(I.path),a=new Map;let w=!1,_=[(0,k.toDisposable)(()=>{a.forEach(A=>(0,k.dispose)(A)),a.clear()})];try{const A=(0,b.watch)(I.path);_.push((0,k.toDisposable)(()=>{A.removeAllListeners(),A.close()}));const d=new Set;I.isDirectory&&(0,R.readdir)(I.path).then(l=>l.forEach(c=>d.add(c))),A.on("error",(l,c)=>{w||D(`Failed to watch ${I.path} for changes using fs.watch() (${l}, ${c})`)}),A.on("change",(l,c)=>{if(!w){let t="";if(c&&(t=c.toString(),C.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const n=I.isDirectory?(0,E.join)(I.path,t):I.path;if(I.isDirectory)if(l==="rename"){const r=a.get(n);r&&(0,k.dispose)(r);const s=setTimeout(async()=>{a.delete(n);const u=await(0,R.exists)(n);if(!w){let h;u?d.has(t)?h="changed":(h="added",d.add(t)):(d.delete(t),h="deleted"),p(h,n)}},e.CHANGE_BUFFER_DELAY);a.set(n,(0,k.toDisposable)(()=>clearTimeout(s)))}else{let r;d.has(t)?r="changed":(r="added",d.add(t)),p(r,n)}else if(l==="rename"||t!==o){const r=setTimeout(async()=>{const s=await(0,R.exists)(n);w||(s?(p("changed",n),_=[i(I,p,D)]):p("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(_),_=[(0,k.toDisposable)(()=>clearTimeout(r))]}else p("changed",n)}}})}catch(A){(0,R.exists)(I.path).then(d=>{d&&!w&&D(`Failed to watch ${I.path} for changes using fs.watch() (${A.toString()})`)})}return(0,k.toDisposable)(()=>{w=!0,_=(0,k.dispose)(_)})}}),define(de[35],me([0,1,6,2,14,28,12,18,19,11,45,13]),function(Y,e,E,b,C,S,k,R,f,m,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function D(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(o=e.ResponseType||(e.ResponseType={}));function a(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(w||(w={}));class _{constructor(T){this.buffer=T,this.pos=0}read(T){const L=this.buffer.slice(this.pos,this.pos+T);return this.pos+=L.byteLength,L}}class A{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var d;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(d||(d={}));function l(H){const T=R.VSBuffer.alloc(4);return T.writeUInt32BE(H,0),T}function c(H){return H.read(4).readUInt32BE(0)}function t(H){const T=R.VSBuffer.alloc(1);return T.writeUInt8(H,0),T}const n={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},r=typeof Buffer!="undefined";function s(H,T){if(typeof T=="undefined")H.write(n.Undefined);else if(typeof T=="string"){const L=R.VSBuffer.fromString(T);H.write(n.String),H.write(l(L.byteLength)),H.write(L)}else if(r&&Buffer.isBuffer(T)){const L=R.VSBuffer.wrap(T);H.write(n.Buffer),H.write(l(L.byteLength)),H.write(L)}else if(T instanceof R.VSBuffer)H.write(n.VSBuffer),H.write(l(T.byteLength)),H.write(T);else if(Array.isArray(T)){H.write(n.Array),H.write(l(T.length));for(const L of T)s(H,L)}else{const L=R.VSBuffer.fromString(JSON.stringify(T));H.write(n.Object),H.write(l(L.byteLength)),H.write(L)}}function u(H){switch(H.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return H.read(c(H)).toString();case d.Buffer:return H.read(c(H)).buffer;case d.VSBuffer:return H.read(c(H));case d.Array:{const L=c(H),B=[];for(let U=0;U<L;U++)B.push(u(H));return B}case d.Object:return JSON.parse(H.read(c(H)).toString())}}class h{constructor(T,L,B=null,U=1e3){this.protocol=T,this.ctx=L,this.logger=B,this.timeoutDelay=U,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(T,L){this.channels.set(T,L),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const L=this.send([T.type]);this.logger&&this.logger.logOutgoing(L,0,1,a(T.type));return}case 201:case 202:case 204:case 203:{const L=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(L,T.id,1,a(T.type),T.data);return}}}send(T,L=void 0){const B=new A;return s(B,T),s(B,L),this.sendBuffer(B.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(L){return 0}}onRawMessage(T){const L=new _(T),B=u(L),U=u(L),V=B[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,B[1],1,`${D(V)}: ${B[2]}.${B[3]}`,U),this.onPromise({type:V,id:B[1],channelName:B[2],name:B[3],arg:U});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,B[1],1,`${D(V)}: ${B[2]}.${B[3]}`,U),this.onEventListen({type:V,id:B[1],channelName:B[2],name:B[3],arg:U});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,B[1],1,`${D(V)}`),this.disposeActiveRequest({type:V,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,B[1],1,`${D(V)}`),this.disposeActiveRequest({type:V,id:B[1]})}}onPromise(T){const L=this.channels.get(T.channelName);if(!L){this.collectPendingRequest(T);return}const B=new S.CancellationTokenSource;let U;try{U=L.call(this.ctx,T.name,T.arg,B.token)}catch(le){U=Promise.reject(le)}const V=T.id;U.then(le=>{this.sendResponse({id:V,data:le,type:201}),this.activeRequests.delete(T.id)},le=>{le instanceof Error?this.sendResponse({id:V,data:{message:le.message,name:le.name,stack:le.stack?le.stack.split?le.stack.split(`
`):le.stack:void 0},type:202}):this.sendResponse({id:V,data:le,type:203}),this.activeRequests.delete(T.id)});const ie=(0,b.toDisposable)(()=>B.cancel());this.activeRequests.set(T.id,ie)}onEventListen(T){const L=this.channels.get(T.channelName);if(!L){this.collectPendingRequest(T);return}const B=T.id,V=L.listen(this.ctx,T.name,T.arg)(ie=>this.sendResponse({id:B,data:ie,type:204}));this.activeRequests.set(T.id,V)}disposeActiveRequest(T){const L=this.activeRequests.get(T.id);L&&(L.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let L=this.pendingRequests.get(T.channelName);L||(L=[],this.pendingRequests.set(T.channelName,L));const B=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);L.push({request:T,timeoutTimer:B})}flushPendingRequests(T){const L=this.pendingRequests.get(T);if(L){for(const B of L)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var y;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(T,L=null){this.protocol=T,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=L}getChannel(T){const L=this;return{call(B,U,V){return L.isDisposed?Promise.reject(k.canceled()):L.requestPromise(T,B,U,V)},listen(B,U){return L.isDisposed?Promise.reject(k.canceled()):L.requestEvent(T,B,U)}}}requestPromise(T,L,B,U=S.CancellationToken.None){const V=this.lastRequestId++,le={id:V,type:100,channelName:T,name:L,arg:B};if(U.isCancellationRequested)return Promise.reject(k.canceled());let ue;return new Promise((ke,Ae)=>{if(U.isCancellationRequested)return Ae(k.canceled());const Fe=()=>{const it=tt=>{switch(tt.type){case 201:this.handlers.delete(V),ke(tt.data);break;case 202:this.handlers.delete(V);const ye=new Error(tt.data.message);ye.stack=tt.data.stack,ye.name=tt.data.name,Ae(ye);break;case 203:this.handlers.delete(V),Ae(tt.data);break}};this.handlers.set(V,it),this.sendRequest(le)};let je=null;this.state===w.Idle?Fe():(je=(0,C.createCancelablePromise)(it=>this.whenInitialized()),je.then(()=>{je=null,Fe()}));const Qe=()=>{je?(je.cancel(),je=null):this.sendRequest({id:V,type:101}),Ae(k.canceled())},qe=U.onCancellationRequested(Qe);ue=(0,b.combinedDisposable)((0,b.toDisposable)(Qe),qe),this.activeRequests.add(ue)}).finally(()=>{this.activeRequests.delete(ue)})}requestEvent(T,L,B){const U=this.lastRequestId++,ie={id:U,type:102,channelName:T,name:L,arg:B};let le=null;const ue=new E.Emitter({onFirstListenerAdd:()=>{le=(0,C.createCancelablePromise)(ke=>this.whenInitialized()),le.then(()=>{le=null,this.activeRequests.add(ue),this.sendRequest(ie)})},onLastListenerRemove:()=>{le?(le.cancel(),le=null):(this.activeRequests.delete(ue),this.sendRequest({id:U,type:103}))}}),we=ke=>ue.fire(ke.data);return this.handlers.set(U,we),ue.event}sendRequest(T){switch(T.type){case 100:case 102:{const L=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(L,T.id,0,`${D(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const L=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(L,T.id,0,D(T.type));return}}}send(T,L=void 0){const B=new A;return s(B,T),s(B,L),this.sendBuffer(B.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(L){return 0}}onBuffer(T){const L=new _(T),B=u(L),U=u(L),V=B[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,a(V)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,B[1],0,a(V),U),this.onResponse({type:B[0],id:B[1],data:U})}}onResponse(T){if(T.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const L=this.handlers.get(T.id);L&&L(T)}whenInitialized(){return this.state===w.Idle?Promise.resolve():E.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelClient=P;class v{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:L,onDidClientDisconnect:B})=>{E.Event.once(L.onMessage)(V=>{const ie=new _(V),le=u(ie),ue=new h(L,le),we=new P(L);this.channels.forEach((Ae,Fe)=>ue.registerChannel(Fe,Ae));const ke={channelServer:ue,channelClient:we,ctx:le};this._connections.add(ke),this._onDidAddConnection.fire(ke),B(()=>{ue.dispose(),we.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const T=[];return this._connections.forEach(L=>T.push(L)),T}getChannel(T,L){const B=this;return{call(U,V,ie){let le;if((0,m.isFunction)(L)){let we=(0,f.getRandomElement)(B.connections.filter(L));le=we?Promise.resolve(we):E.Event.toPromise(E.Event.filter(B.onDidAddConnection,L))}else le=L.routeCall(B,U,V);const ue=le.then(we=>we.channelClient.getChannel(T));return F(ue).call(U,V,ie)},listen(U,V){if((0,m.isFunction)(L))return B.getMulticastEvent(T,L,U,V);const ie=L.routeEvent(B,U,V).then(le=>le.channelClient.getChannel(T));return F(ie).listen(U,V)}}}getMulticastEvent(T,L,B,U){const V=this;let ie=new b.DisposableStore;const le=new E.Emitter({onFirstListenerAdd:()=>{ie=new b.DisposableStore;const ue=new E.EventMultiplexer,we=new Map,ke=Fe=>{const Qe=Fe.channelClient.getChannel(T).listen(B,U),qe=ue.add(Qe);we.set(Fe,qe)},Ae=Fe=>{const je=we.get(Fe);!je||(je.dispose(),we.delete(Fe))};V.connections.filter(L).forEach(ke),E.Event.filter(V.onDidAddConnection,L)(ke,void 0,ie),V.onDidRemoveConnection(Ae,void 0,ie),ue.event(le.fire,le,ie),ie.add(ue)},onLastListenerRemove:()=>{ie.dispose()}});return le.event}registerChannel(T,L){this.channels.set(T,L),this._connections.forEach(B=>{B.channelServer.registerChannel(T,L)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class g{constructor(T,L,B=null){const U=new A;s(U,L),T.send(U.buffer),this.channelClient=new P(T,B),this.channelServer=new h(T,L,B)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,L){this.channelServer.registerChannel(T,L)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=g;function F(H){return{call(T,L,B){return H.then(U=>U.call(T,L,B))},listen(T,L){const B=new E.Relay;return H.then(U=>B.input=U.listen(T,L)),B.event}}}e.getDelayedChannel=F;function O(H){let T=!1;return{call(L,B,U){return T?H.call(L,B,U):(0,C.timeout)(0).then(()=>T=!0).then(()=>H.call(L,B,U))},listen(L,B){if(T)return H.listen(L,B);const U=new E.Relay;return(0,C.timeout)(0).then(()=>T=!0).then(()=>U.input=H.listen(L,B)),U.event}}}e.getNextTickChannel=O;class x{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const L of T.connections)if(await Promise.resolve(this.fn(L.ctx)))return Promise.resolve(L);return await E.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=x;var oe;(function(H){function T(U,V){const ie=U,le=V&&V.disableMarshalling,ue=new Map;for(const we in ie)B(we)&&ue.set(we,E.Event.buffer(ie[we],!0));return new class{listen(we,ke){const Ae=ue.get(ke);if(Ae)return Ae;throw new Error(`Event not found: ${ke}`)}call(we,ke,Ae){const Fe=ie[ke];if(typeof Fe=="function"){if(!le&&Array.isArray(Ae))for(let je=0;je<Ae.length;je++)Ae[je]=(0,i.revive)(Ae[je]);return Fe.apply(ie,Ae)}throw new Error(`Method not found: ${ke}`)}}}H.fromService=T;function L(U,V){const ie=V&&V.disableMarshalling;return new Proxy({},{get(le,ue){var we;if(typeof ue=="string")return((we=V==null?void 0:V.properties)===null||we===void 0?void 0:we.has(ue))?V.properties.get(ue):B(ue)?U.listen(ue):async function(...ke){let Ae;V&&!(0,m.isUndefinedOrNull)(V.context)?Ae=[V.context,...ke]:Ae=ke;const Fe=await U.call(ue,Ae);return ie?Fe:(0,i.revive)(Fe)};throw new Error(`Property not found: ${String(ue)}`)}})}H.toService=L;function B(U){return U[0]==="o"&&U[1]==="n"&&I.isUpperAsciiLetter(U.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let T=H.toString();if(T!=="[object Object]")return T}return H}function Q(H){return Array.isArray(H)?H.map(te):te(H)}function q(H,T,L,B,U,V,ie){ie=Q(ie);const le=W[U],ue=le[B%le.length];let we=[`%c[${H}]%c[${String(T).padStart(7," ")}]%c[len: ${String(L).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${ue}`];/\($/.test(V)?(we=we.concat(ie),we.push(")")):we.push(ie),console.log.apply(console,we)}e.logWithColors=q;class ee{constructor(T,L){this._outgoingPrefix=T,this._incomingPrefix=L,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,L,B,U,V){this._totalOutgoing+=T,q(this._outgoingPrefix,this._totalOutgoing,T,L,B,U,V)}logIncoming(T,L,B,U,V){this._totalIncoming+=T,q(this._incomingPrefix,this._totalIncoming,T,L,B,U,V)}}e.IPCLogger=ee}),define(de[81],me([0,1,6,35,2,18,5,24]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let f=null;function m(){return f||(f=S.VSBuffer.alloc(0)),f}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,s){if(r===0)return m();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const P=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=r),P}if(this._chunks[0].byteLength>r){const P=this._chunks[0].slice(0,r);return s&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),P}let u=S.VSBuffer.alloc(r),h=0,y=0;for(;r>0;){const P=this._chunks[y];if(P.byteLength>r){const v=P.slice(0,r);u.set(v,h),h+=r,s&&(this._chunks[y]=P.slice(r),this._totalLength-=r),r-=r}else u.set(P,h),h+=P.byteLength,s?(this._chunks.shift(),this._totalLength-=P.byteLength):y++,r-=P.byteLength}return u}}e.ChunkStream=i;var I;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var p;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class D{constructor(r,s,u,h){this.type=r,this.id=s,this.ack=u,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends C.Disposable{constructor(r){super();this._onMessage=this._register(new E.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const u=this._state.messageType,h=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new D(u,h,y,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class a{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(!this._isDisposed){r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=S.VSBuffer.alloc(13);s.writeUInt8(r.type,0),s.writeUInt32BE(r.id,1),s.writeUInt32BE(r.ack,5),s.writeUInt32BE(r.data.byteLength,9),this._writeSoon(s,r.data)}}_bufferAdd(r,s){const u=this._totalLength===0;return this._data.push(r,s),this._totalLength+=r.byteLength+s.byteLength,u}_bufferTake(){const r=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,s){this._bufferAdd(r,s)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends C.Disposable{constructor(r){super();this._onMessage=new E.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new a(this._socket)),this._socketReader=this._register(new o(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new D(1,0,0,r))}}e.Protocol=w;class _ extends b.IPCClient{constructor(r,s,u=null){super(r,s,u);this.protocol=r}static fromSocket(r,s){return new _(new w(r),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=_;class A{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new E.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=A;class d{constructor(r){this.data=r,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],s=0,u=this._first;for(;u;)r[s++]=u.data,u=u.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const s=new d(r);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class c{constructor(){this.lastRuns=[];const r=Date.now();for(let s=0;s<c._HISTORY_LENGTH;s++)this.lastRuns[s]=r-1e3*s;setInterval(()=>{for(let s=c._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const r=Date.now(),s=(1+c._HISTORY_LENGTH)*1e3;let u=0;for(let h=0;h<c._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=s&&u++;return 1-u/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(r,s=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new A,this.onControlMessage=this._onControlMessage.event,this._onMessage=new A,this.onMessage=this._onMessage.event,this._onDidDispose=new A,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new A,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new A,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new a(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new o(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new D(5,0,0,m());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const s=new D(4,0,0,m());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,s){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new a(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new o(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let s=0,u=r.length;s<u;s++)this._socketWriter.write(r[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new D(6,0,0,m())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const s=this._outgoingUnackMsg.toArray();for(let u=0,h=s.length;u<h;u++)this._socketWriter.write(s[u]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new D(1,s,this._incomingAckId,r);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(r){const s=new D(2,0,0,r);this._socketWriter.write(s)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const r=this._outgoingUnackMsg.peek(),s=Date.now()-r.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const r=new D(3,0,this._incomingAckId,m());this._socketWriter.write(r)}}}e.PersistentProtocol=t}),define(de[126],me([0,1,2,6,14,11]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var k;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));var R;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(R||(R={}));class f extends E.Disposable{constructor(I,p=Object.create(null)){super();this.database=I,this.options=p,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){var p,D;(p=I.changed)===null||p===void 0||p.forEach((o,a)=>this.accept(a,o)),(D=I.deleted)===null||D===void 0||D.forEach(o=>this.accept(o,void 0))}accept(I,p){if(this.state!==R.Closed){let D=!1;(0,S.isUndefinedOrNull)(p)?D=this.cache.delete(I):this.cache.get(I)!==p&&(this.cache.set(I,p),D=!0),D&&this._onDidChangeStorage.fire(I)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,p){const D=this.cache.get(I);return(0,S.isUndefinedOrNull)(D)?p:D}getBoolean(I,p){const D=this.get(I);return(0,S.isUndefinedOrNull)(D)?p:D==="true"}getNumber(I,p){const D=this.get(I);return(0,S.isUndefinedOrNull)(D)?p:parseInt(D,10)}async set(I,p){if(this.state!==R.Closed){if((0,S.isUndefinedOrNull)(p))return this.delete(I);const D=String(p);if(this.cache.get(I)!==D)return this.cache.set(I,D),this.pendingInserts.set(I,D),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(I){if(this.state!==R.Closed&&!!this.cache.delete(I))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{var p;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(p=this.whenFlushedCallbacks.pop())===null||p===void 0||p()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((p,D)=>this.items.set(D,p)),I.delete&&I.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=m}),define(de[82],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(C,S){this.lineNumber=C,this.column=S}with(C=this.lineNumber,S=this.column){return C===this.lineNumber&&S===this.column?this:new E(C,S)}delta(C=0,S=0){return this.with(this.lineNumber+C,this.column+S)}equals(C){return E.equals(this,C)}static equals(C,S){return!C&&!S?!0:!!C&&!!S&&C.lineNumber===S.lineNumber&&C.column===S.column}isBefore(C){return E.isBefore(this,C)}static isBefore(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<S.column}isBeforeOrEqual(C){return E.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<=S.column}static compare(C,S){let k=C.lineNumber|0,R=S.lineNumber|0;if(k===R){let f=C.column|0,m=S.column|0;return f-m}return k-R}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new E(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=E}),define(de[53],me([0,1,82]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class b{constructor(S,k,R,f){S>R||S===R&&k>f?(this.startLineNumber=R,this.startColumn=f,this.endLineNumber=S,this.endColumn=k):(this.startLineNumber=S,this.startColumn=k,this.endLineNumber=R,this.endColumn=f)}isEmpty(){return b.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return b.containsPosition(this,S)}static containsPosition(S,k){return!(k.lineNumber<S.startLineNumber||k.lineNumber>S.endLineNumber||k.lineNumber===S.startLineNumber&&k.column<S.startColumn||k.lineNumber===S.endLineNumber&&k.column>S.endColumn)}containsRange(S){return b.containsRange(this,S)}static containsRange(S,k){return!(k.startLineNumber<S.startLineNumber||k.endLineNumber<S.startLineNumber||k.startLineNumber>S.endLineNumber||k.endLineNumber>S.endLineNumber||k.startLineNumber===S.startLineNumber&&k.startColumn<S.startColumn||k.endLineNumber===S.endLineNumber&&k.endColumn>S.endColumn)}strictContainsRange(S){return b.strictContainsRange(this,S)}static strictContainsRange(S,k){return!(k.startLineNumber<S.startLineNumber||k.endLineNumber<S.startLineNumber||k.startLineNumber>S.endLineNumber||k.endLineNumber>S.endLineNumber||k.startLineNumber===S.startLineNumber&&k.startColumn<=S.startColumn||k.endLineNumber===S.endLineNumber&&k.endColumn>=S.endColumn)}plusRange(S){return b.plusRange(this,S)}static plusRange(S,k){let R,f,m,i;return k.startLineNumber<S.startLineNumber?(R=k.startLineNumber,f=k.startColumn):k.startLineNumber===S.startLineNumber?(R=k.startLineNumber,f=Math.min(k.startColumn,S.startColumn)):(R=S.startLineNumber,f=S.startColumn),k.endLineNumber>S.endLineNumber?(m=k.endLineNumber,i=k.endColumn):k.endLineNumber===S.endLineNumber?(m=k.endLineNumber,i=Math.max(k.endColumn,S.endColumn)):(m=S.endLineNumber,i=S.endColumn),new b(R,f,m,i)}intersectRanges(S){return b.intersectRanges(this,S)}static intersectRanges(S,k){let R=S.startLineNumber,f=S.startColumn,m=S.endLineNumber,i=S.endColumn,I=k.startLineNumber,p=k.startColumn,D=k.endLineNumber,o=k.endColumn;return R<I?(R=I,f=p):R===I&&(f=Math.max(f,p)),m>D?(m=D,i=o):m===D&&(i=Math.min(i,o)),R>m||R===m&&f>i?null:new b(R,f,m,i)}equalsRange(S){return b.equalsRange(this,S)}static equalsRange(S,k){return!!S&&!!k&&S.startLineNumber===k.startLineNumber&&S.startColumn===k.startColumn&&S.endLineNumber===k.endLineNumber&&S.endColumn===k.endColumn}getEndPosition(){return b.getEndPosition(this)}static getEndPosition(S){return new E.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return b.getStartPosition(this)}static getStartPosition(S){return new E.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,k){return new b(this.startLineNumber,this.startColumn,S,k)}setStartPosition(S,k){return new b(S,k,this.endLineNumber,this.endColumn)}collapseToStart(){return b.collapseToStart(this)}static collapseToStart(S){return new b(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,k=S){return new b(S.lineNumber,S.column,k.lineNumber,k.column)}static lift(S){return S?new b(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,k){return!(S.endLineNumber<k.startLineNumber||S.endLineNumber===k.startLineNumber&&S.endColumn<k.startColumn||k.endLineNumber<S.startLineNumber||k.endLineNumber===S.startLineNumber&&k.endColumn<S.startColumn)}static areIntersecting(S,k){return!(S.endLineNumber<k.startLineNumber||S.endLineNumber===k.startLineNumber&&S.endColumn<=k.startColumn||k.endLineNumber<S.startLineNumber||k.endLineNumber===S.startLineNumber&&k.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,k){if(S&&k){const m=S.startLineNumber|0,i=k.startLineNumber|0;if(m===i){const I=S.startColumn|0,p=k.startColumn|0;if(I===p){const D=S.endLineNumber|0,o=k.endLineNumber|0;if(D===o){const a=S.endColumn|0,w=k.endColumn|0;return a-w}return D-o}return I-p}return m-i}return(S?1:0)-(k?1:0)}static compareRangesUsingEnds(S,k){return S.endLineNumber===k.endLineNumber?S.endColumn===k.endColumn?S.startLineNumber===k.startLineNumber?S.startColumn-k.startColumn:S.startLineNumber-k.startLineNumber:S.endColumn-k.endColumn:S.endLineNumber-k.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=b}),define(de[127],me([0,1,46,4]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(S,k,R,f){if(Array.isArray(S)){let m=0;for(const i of S){const I=C(i,k,R,f);if(I===10)return I;I>m&&(m=I)}return m}else{if(typeof S=="string")return f?S==="*"?5:S===R?10:0:0;if(S){const{language:m,pattern:i,scheme:I,hasAccessToAllModels:p}=S;if(!f&&!p)return 0;let D=0;if(I)if(I===k.scheme)D=10;else if(I==="*")D=5;else return 0;if(m)if(m===R)D=10;else if(m==="*")D=Math.max(D,5);else return 0;if(i){let o;if(typeof i=="string"?o=i:o=Object.assign(Object.assign({},i),{base:(0,b.normalize)(i.base)}),o===k.fsPath||(0,E.match)(o,k.fsPath))D=10;else return 0}return D}else return 0}}e.score=C}),define(de[128],me([0,1,6,2]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,R){return this._map.set(k,R),this.fire([k]),(0,b.toDisposable)(()=>{this._map.get(k)===R&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,R){let f=null,m=!1;return this._promises.set(k,R.then(i=>{this._promises.delete(k),!(m||!i)&&(f=this.register(k,i))})),(0,b.toDisposable)(()=>{m=!0,f&&f.dispose()})}getPromise(k){const R=this.get(k);if(R)return Promise.resolve(R);const f=this._promises.get(k);return f?f.then(m=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(de[129],me([9,10]),function(Y,e){return Y.create("vs/base/common/actions",e)}),define(de[130],me([0,1,129,2,6]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class S extends b.Disposable{constructor(p,D="",o="",a=!0,w){super();this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=p,this._label=D,this._cssClass=o,this._enabled=a,this._actionCallback=w}get id(){return this._id}get label(){return this._label}set label(p){this._setLabel(p)}_setLabel(p){this._label!==p&&(this._label=p,this._onDidChange.fire({label:p}))}get tooltip(){return this._tooltip||""}set tooltip(p){this._setTooltip(p)}_setTooltip(p){this._tooltip!==p&&(this._tooltip=p,this._onDidChange.fire({tooltip:p}))}get class(){return this._cssClass}set class(p){this._setClass(p)}_setClass(p){this._cssClass!==p&&(this._cssClass=p,this._onDidChange.fire({class:p}))}get enabled(){return this._enabled}set enabled(p){this._setEnabled(p)}_setEnabled(p){this._enabled!==p&&(this._enabled=p,this._onDidChange.fire({enabled:p}))}get checked(){return this._checked}set checked(p){this._setChecked(p)}_setChecked(p){this._checked!==p&&(this._checked=p,this._onDidChange.fire({checked:p}))}async run(p,D){this._actionCallback&&await this._actionCallback(p)}}e.Action=S;class k extends b.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new C.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new C.Emitter),this.onDidRun=this._onDidRun.event}async run(p,D){if(!!p.enabled){this._onBeforeRun.fire({action:p});let o;try{await this.runAction(p,D)}catch(a){o=a}this._onDidRun.fire({action:p,error:o})}}async runAction(p,D){await p.run(D)}}e.ActionRunner=k;class R extends S{constructor(p){super(R.ID,p,p?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=R,R.ID="vs.actions.separator";class f{constructor(p,D,o,a){this.tooltip="",this.enabled=!0,this.checked=!1,this.id=p,this.label=D,this.class=a,this._actions=o}get actions(){return this._actions}dispose(){}async run(){}}e.SubmenuAction=f;class m extends S{constructor(){super(m.ID,E.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function i(I){var p,D;return{id:I.id,label:I.label,class:void 0,enabled:(p=I.enabled)!==null&&p!==void 0?p:!0,checked:(D=I.checked)!==null&&D!==void 0?D:!1,run:async()=>I.run(),tooltip:I.label,dispose:()=>{}}}e.toAction=i}),define(de[131],me([9,10]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(de[132],me([0,1,131]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const b=60,C=b*60,S=C*24,k=S*7,R=S*30,f=S*365;function m(I,p){typeof I!="number"&&(I=I.getTime());const D=Math.round((new Date().getTime()-I)/1e3);if(D<-30)return(0,E.localize)(0,null,m(new Date().getTime()+D*1e3,!1));if(D<30)return(0,E.localize)(1,null);let o;return D<b?(o=D,p?o===1?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):o===1?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o)):D<C?(o=Math.floor(D/b),p?o===1?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):o===1?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):D<S?(o=Math.floor(D/C),p?o===1?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):o===1?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o)):D<k?(o=Math.floor(D/S),p?o===1?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):o===1?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):D<R?(o=Math.floor(D/k),p?o===1?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):o===1?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o)):D<f?(o=Math.floor(D/R),p?o===1?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):o===1?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):(o=Math.floor(D/f),p?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o))}e.fromNow=m;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(de[133],me([9,10]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(de[42],me([0,1,133,11,19]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(m,i){return i&&(m.stack||m.stacktrace)?E.localize(0,null,R(m),k(m.stack)||k(m.stacktrace)):R(m)}function k(m){return Array.isArray(m)?m.join(`
`):m}function R(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?E.localize(1,null,m.message):m.message||E.localize(2,null)}function f(m=null,i=!1){if(!m)return E.localize(3,null);if(Array.isArray(m)){const I=C.coalesce(m),p=f(I[0],i);return I.length>1?E.localize(4,null,p,I.length):p}if(b.isString(m))return m;if(m.detail){const I=m.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return m.stack?S(m,i):m.message?m.message:E.localize(5,null)}e.toErrorMessage=f}),define(de[134],me([9,10]),function(Y,e){return Y.create("vs/base/common/jsonErrorMessages",e)}),define(de[135],me([0,1,134]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function b(C){switch(C){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=b}),define(de[136],me([9,10]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(de[83],me([0,1,4,15,21,37,136,24,11,20,29,5,75,8]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function o(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(c,t){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const r=S.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],n);return new Promise(s=>{r.once("error",u=>{s({success:!1,error:u})}),r.once("exit",(u,h)=>{s(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?o(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{S.execFile(n,[c.pid.toString()],{encoding:"utf8",shell:!0},(s,u,h)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function w(c=R.env){return c.comspec||"cmd.exe"}e.getWindowsShell=w;class _{constructor(t,n,r,s){if(n!==void 0&&r!==void 0&&s!==void 0)this.cmd=t,this.args=n,this.shell=r,this.options=s;else{const u=t;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(R.env).forEach(h=>{u[h]=R.env[h]}),Object.keys(this.options.env).forEach(h=>{u[h]=this.options.env[h]}),this.options.env=u}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(E.sep);return n!==-1&&(t=t.substring(n+1)),_.WellKnowCommands[t]?t:"other"}start(t){return I.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(R.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(n=>{let r,s;const u=new Promise((h,y)=>{r=h,s=y});if(n){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=S.exec(h,this.options,(y,P,v)=>{this.childProcess=null;const g=y;g&&g.killed?s({killed:this.terminateRequested,stdout:P.toString(),stderr:v.toString()}):this.handleExec(r,t,y,P,v)})}else{let h=null;const y=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,r,t,s);const v={terminated:this.terminateRequested};f.isNumber(P)&&(v.cmdCode=P),r(v)};if(this.shell&&I.isWindows){const P=m.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let v=!1,g=!1;const F=[];let O=this.ensureQuotes(this.cmd);F.push(O.value),v=O.quoted,this.args&&this.args.forEach(oe=>{O=this.ensureQuotes(oe),F.push(O.value),g=g&&O.quoted});const x=["/s","/c"];v?g?x.push('"'+F.join(" ")+'"'):F.length>1?x.push('"'+F[0]+'" '+F.slice(1).join(" ")):x.push('"'+F[0]+'"'):x.push(F.join(" ")),h=S.spawn(w(),x,P)}else this.cmd&&(h=S.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(f.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",P=>{this.childProcess=null,s({terminated:this.terminateRequested,error:P})}),h.pid&&(this.childProcess.on("close",y),this.handleSpawn(h,r,t,s,!0)))}return u})}handleClose(t,n,r,s){}ensureQuotes(t){return _.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,a(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!I.isWindows)return t(!1);const n=S.spawn(w(),["/s","/c"]);n.on("error",r=>t(!0)),n.on("exit",r=>t(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class A extends _{constructor(t,n,r,s){super(t,n,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,r,s,u){[s,u].forEach((h,y)=>{const P=new p.LineDecoder;P.write(h).forEach(F=>{n({line:F,source:y===0?0:1})});const g=P.end();g&&n({line:g,source:y===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,n,r,s,u){const h=new p.LineDecoder,y=new p.LineDecoder;t.stdout.on("data",P=>{h.write(P).forEach(g=>r({line:g,source:0}))}),t.stderr.on("data",P=>{y.write(P).forEach(g=>r({line:g,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=y}handleClose(t,n,r,s){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&r({line:u,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=A;function d(c){let t=[],n=!1;const r=function(s){if(n){t.push(s);return}(!c.send(s,h=>{if(h&&console.error(h),n=!1,t.length>0){const y=t.slice(0);t=[],y.forEach(P=>r(P))}})||I.isWindows)&&(n=!0)};return{send:r}}e.createQueuedSender=d;var l;(function(c){async function t(n,r,s){if(E.isAbsolute(n))return n;if(r===void 0&&(r=R.cwd()),E.dirname(n)!=="."||(s===void 0&&f.isString(R.env.PATH)&&(s=R.env.PATH.split(E.delimiter)),s===void 0||s.length===0))return E.join(r,n);async function h(y){return await C.exists(y)?!(await b.promises.stat(y)).isDirectory():!1}for(let y of s){let P;if(E.isAbsolute(y)?P=E.join(y,n):P=E.join(r,y,n),await h(P))return P;let v=P+".com";if(await h(v)||(v=P+".exe",await h(v)))return v}return E.join(r,n)}c.findExecutable=t})(l=e.win32||(e.win32={}))}),define(de[137],me([0,1,25,5,124,83]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(D,o){return D===1?b.isWindows?I():S.getWindowsShell(o):m(D,o)}e.getSystemShell=k;function R(D,o){return D===1?b.isWindows?p(o):S.getWindowsShell(o):m(D,o)}e.getSystemShellSync=R;let f=null;function m(D,o){if(b.isLinux&&D===2||b.isMacintosh&&D===3)return"/bin/bash";if(!f){let a;if(b.isWindows)a="/bin/bash";else{if(a=o.SHELL,!a)try{a=(0,E.userInfo)().shell}catch(w){}a||(a="sh"),a==="/bin/false"&&(a="/bin/bash")}f=a}return f}let i=null;async function I(){return i||(i=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),i}function p(D){if(i)return i;const o=b.isWindows&&parseFloat((0,E.release)())>=10,a=D.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${D.windir}\\${a?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return o?w:S.getWindowsShell(D)}}),define(de[54],me([0,1,37,2,14,20,6,83,35,116,28,12,18,5]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class o extends f.ChannelServer{constructor(_){super({send:A=>{try{process.send&&process.send(A.buffer.toString("base64"))}catch(d){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",A=>p.VSBuffer.wrap(Buffer.from(A,"base64")))},_);process.once("disconnect",()=>this.dispose())}}e.Server=o;class a{constructor(_,A){this.modulePath=_,this.options=A,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=A&&A.timeout?A.timeout:6e4;this.disposeDelayer=new C.Delayer(d),this.child=null,this._client=null}getChannel(_){const A=this;return{call(d,l,c){return A.requestPromise(_,d,l,c)},listen(d,l){return A.requestEvent(_,d,l)}}}requestPromise(_,A,d,l=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(_),t=(0,C.createCancelablePromise)(s=>c.call(A,d,s)),n=l.onCancellationRequested(()=>t.cancel()),r=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(_,A,d){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let l;const c=new k.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(_).listen(A,d)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const _=this.options&&this.options.args?this.options.args:[],A=Object.create(null);A.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(A.env=Object.assign(Object.assign({},A.env),this.options.env)),this.options&&this.options.freshExecArgv&&(A.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(A.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(A.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),A.execArgv===void 0&&(A.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),D.isMacintosh&&A.env&&delete A.env.DYLD_LIBRARY_PATH,this.child=(0,E.fork)(this.modulePath,_,A);const d=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,m.isRemoteConsoleLog)(u)){(0,m.log)(u,`IPC Library: ${this.options.serverName}`);return}d.fire(p.VSBuffer.wrap(Buffer.from(u,"base64")))});const c=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&c.send(u.buffer.toString("base64")),n=d.event,r={send:t,onMessage:n};this._client=new f.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,h)=>{process.removeListener("exit",s),this.activeRequests.forEach(y=>(0,b.dispose)(y)),this.activeRequests.clear(),u!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:h})})}return this._client}getCachedChannel(_){let A=this.channels.get(_);return A||(A=this.client.getChannel(_),this.channels.set(_,A)),A}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=a}),define(de[138],me([9,10]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(de[139],me([9,10]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(de[140],me([9,10]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(de[141],me([9,10]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(de[142],me([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(de[143],me([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(de[144],me([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(de[145],me([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(de[146],me([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(de[147],me([9,10]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(de[148],me([9,10]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(de[149],me([9,10]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(de[150],me([9,10]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(de[151],me([9,10]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(de[152],me([9,10]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(de[153],me([9,10]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(de[154],me([9,10]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(de[155],me([9,10]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(de[156],me([9,10]),function(Y,e){return Y.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(de[157],me([9,10]),function(Y,e){return Y.create("vs/server/serverEnvironmentService",e)}),define(de[158],me([9,10]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(de[159],me([9,10]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(de[160],me([9,10]),function(Y,e){return Y.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(de[161],me([0,1,6,2]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(R,f,m){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(R,f,m){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class S extends b.Disposable{constructor(R){super();this.channel=R}reload(R){this.channel.call("reload",[R])}get onReload(){return this.channel.listen("reload")}close(R){this.channel.call("close",[R])}get onClose(){return this.channel.listen("close")}attachSession(R,f,m){this.channel.call("attach",[R,f,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(R,f){this.channel.call("terminate",[R,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(R,f,m){return this.channel.call("openExtensionDevelopmentHostWindow",[R,f||{},m])}}e.ExtensionHostDebugChannelClient=S}),define(de[162],me([0,1,3]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class b{constructor(k){this.service=k}listen(k,R,f){throw new Error("Invalid listen")}call(k,R,f){switch(R){case"download":return this.service.download(E.URI.revive(f[0]),E.URI.revive(f[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=b;class C{constructor(k,R){this.channel=k,this.getUriTransformer=R}async download(k,R){const f=this.getUriTransformer();f&&(k=f.transformOutgoingURI(k),R=f.transformOutgoingURI(R)),await this.channel.call("download",[k,R])}}e.DownloadServiceChannelClient=C}),define(de[163],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(k){k[k.ACTIVATE=0]="ACTIVATE",k[k.RESTORE=1]="RESTORE",k[k.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var b;(function(k){k[k.PICK=1]="PICK",k[k.DISABLED=2]="DISABLED"})(b=e.EditorOverride||(e.EditorOverride={}));var C;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))});var Oe=this&&this.__decorate||function(Y,e,E,b){var C=arguments.length,S=C<3?e:b===null?b=Object.getOwnPropertyDescriptor(e,E):b,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(Y,e,E,b);else for(var R=Y.length-1;R>=0;R--)(k=Y[R])&&(S=(C<3?k(S):C>3?k(e,E,S):k(e,E))||S);return C>3&&S&&Object.defineProperty(e,E,S),S};define(de[164],me([0,1,4,17,109,132,8,3,24]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(o,a,w){this._args=o,this.paths=a,this.productService=w}get appRoot(){return(0,E.dirname)(k.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,E.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const o=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,E.join)(this.userDataPath,"logs",o)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,E.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(R.URI.file((0,E.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=f.env.VSCODE_PORTABLE;return o?R.URI.file((0,E.join)(o,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,E.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,E.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,E.resolve)(o):(0,E.normalize)((0,E.join)(k.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const o=this.args["extensions-download-dir"];return o?(0,E.resolve)(o):(0,E.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,E.resolve)(o);const a=f.env.VSCODE_EXTENSIONS;if(a)return a;const w=f.env.VSCODE_PORTABLE;return w?(0,E.join)(w,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(a=>/^[^:/?#]+?:\/\//.test(a)?R.URI.parse(a):R.URI.file((0,E.normalize)(a)))}get extensionDevelopmentKind(){var o;return(o=this.args.extensionDevelopmentKind)===null||o===void 0?void 0:o.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?R.URI.parse(o):R.URI.file((0,E.normalize)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,E.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}Oe([C.memoize],m.prototype,"appRoot",null),Oe([C.memoize],m.prototype,"userHome",null),Oe([C.memoize],m.prototype,"userDataPath",null),Oe([C.memoize],m.prototype,"appSettingsHome",null),Oe([C.memoize],m.prototype,"tmpDir",null),Oe([C.memoize],m.prototype,"userRoamingDataHome",null),Oe([C.memoize],m.prototype,"settingsResource",null),Oe([C.memoize],m.prototype,"userDataSyncHome",null),Oe([C.memoize],m.prototype,"userDataSyncLogResource",null),Oe([C.memoize],m.prototype,"sync",null),Oe([C.memoize],m.prototype,"machineSettingsResource",null),Oe([C.memoize],m.prototype,"globalStorageHome",null),Oe([C.memoize],m.prototype,"workspaceStorageHome",null),Oe([C.memoize],m.prototype,"keybindingsResource",null),Oe([C.memoize],m.prototype,"keyboardLayoutResource",null),Oe([C.memoize],m.prototype,"argvResource",null),Oe([C.memoize],m.prototype,"snippetsHome",null),Oe([C.memoize],m.prototype,"isExtensionDevelopment",null),Oe([C.memoize],m.prototype,"untitledWorkspacesHome",null),Oe([C.memoize],m.prototype,"installSourcePath",null),Oe([C.memoize],m.prototype,"builtinExtensionsPath",null),Oe([C.memoize],m.prototype,"extensionsPath",null),Oe([C.memoize],m.prototype,"extensionDevelopmentLocationURI",null),Oe([C.memoize],m.prototype,"extensionDevelopmentKind",null),Oe([C.memoize],m.prototype,"extensionTestsLocationURI",null),Oe([C.memoize],m.prototype,"debugExtensionHost",null),Oe([C.memoize],m.prototype,"serviceMachineIdResource",null),Oe([C.memoize],m.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=m;function i(D,o){return p(D["inspect-extensions"],D["inspect-brk-extensions"],5870,o,D.debugId)}e.parseExtensionHostPort=i;function I(D,o){return p(D["inspect-search"],D["inspect-brk-search"],5876,o)}e.parseSearchPort=I;function p(D,o,a,w,_){const d=Number(o||D)||(w?null:a),l=d?Boolean(!!o):!1;return{port:d,break:l,debugId:_}}}),define(de[55],me([0,1,234,140,5]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,b.localize)(0,null),e:(0,b.localize)(1,null),t:(0,b.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,b.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,b.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,b.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,b.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,b.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,b.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,b.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,b.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,b.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,b.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,b.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,b.localize)(14,null)},category:{type:"string",cat:"e",description:(0,b.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,b.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,b.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,b.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,b.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,b.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,b.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,b.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,b.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,b.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,b.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,b.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,b.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,b.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,b.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,b.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,b.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function R(o,a,w=k){const _={},A=[],d=[];for(let n in a){const r=a[n];r.alias&&(_[n]=r.alias),r.type==="string"||r.type==="string[]"?(A.push(n),r.deprecates&&A.push(r.deprecates)):r.type==="boolean"&&(d.push(n),r.deprecates&&d.push(r.deprecates))}const l=E(o,{string:A,boolean:d,alias:_}),c={},t=l;c._=l._.map(n=>String(n)).filter(n=>n.length>0),delete t._;for(let n in a){const r=a[n];r.alias&&delete t[r.alias];let s=t[n];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(s||(s=t[r.deprecates]),delete t[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),w.onMultipleValues(n,s)),c[n]=s),delete t[n]}for(let n in t)w.onUnknownOption(n);return c}e.parseArgs=R;function f(o,a){let w="";return a.args&&(Array.isArray(a.args)?w=` <${a.args.join("> <")}>`:w=` <${a.args}>`),a.alias?`-${a.alias} --${o}${w}`:`--${o}${w}`}function m(o,a){let w=0,_=[];for(const c in o){const t=o[c],n=f(c,t);w=Math.max(w,n.length),_.push([n,t.description])}let A=w+2+1;if(a-A<25)return _.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let d=a-A-1,l=[];for(const c of _){let t=c[0],n=I(c[1],d),r=i(A-t.length-2);l.push("  "+t+r+n[0]);for(let s=1;s<n.length;s++)l.push(i(A)+n[s])}return l}e.formatOptions=m;function i(o){return" ".repeat(o)}function I(o,a){let w=[];for(;o.length;){let _=o.length<a?o.length:o.lastIndexOf(" ",a),A=o.slice(0,_).trim();o=o.slice(_),w.push(A)}return w}function p(o,a,w,_,A=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${o} ${w}`];l.push(""),l.push(`${(0,b.localize)(32,null)}: ${a} [${(0,b.localize)(33,null)}][${(0,b.localize)(34,null)}...]`),l.push(""),A&&(C.isWindows?l.push((0,b.localize)(35,null,a)):l.push((0,b.localize)(36,null,a)),l.push(""));const c={};for(const t in _){const n=_[t];if(n.description&&n.cat){let r=c[n.cat];r||(c[n.cat]=r={}),r[t]=n}}for(let t in c){const n=t;let r=c[n];r&&(l.push(S[n]),l.push(...m(r,d)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=p;function D(o,a){return`${o||(0,b.localize)(37,null)}
${a||(0,b.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=D}),function(){"use strict";function Y(e,E,b,C){function S(R){const f=k(R),m=[f];return e.isAbsolute(f)||m.unshift(C),e.resolve(...m)}function k(R){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");const m=R["user-data-dir"];if(m)return m;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(I,"AppData","Roaming")}break;case"darwin":i=e.join(E.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,b)}return{getUserDataPath:S}}if(typeof define=="function")define(de[165],me([0,76,25,8,17,24]),function(e,E,b,C,S,k){const R=S.dirname(C.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(S.joinPath(R,"package.json").fsPath);return Y(E,b,f.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),E=require("path"),b=require("os");module.exports=Y(E,b,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(de[166],me([0,1,25,165,164]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends C.AbstractNativeEnvironmentService{constructor(R,f){super(R,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,b.getUserDataPath)(R)},f)}}e.NativeEnvironmentService=S}),define(de[167],me([0,1,6,3,52,20,2]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(o,a){return b.URI.revive(a?a.transformIncoming(o):o)}function f(o,a){return a?a.transformOutgoingURI(o):o}function m(o,a){a=a||C.DefaultURITransformer;const w=o.manifest,_=(0,C.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},o),{manifest:void 0}),a);return Object.assign(Object.assign({},_),{manifest:w})}function i(o,a){return a?(0,S.cloneAndChange)(o,w=>w instanceof b.URI?a.transformOutgoingURI(w):void 0):o}class I{constructor(a,w){this.service=a,this.getUriTransformer=w,this.onInstallExtension=E.Event.buffer(a.onInstallExtension,!0),this.onDidInstallExtension=E.Event.buffer(a.onDidInstallExtension,!0),this.onUninstallExtension=E.Event.buffer(a.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(a.onDidUninstallExtension,!0)}listen(a,w){const _=this.getUriTransformer(a);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return E.Event.map(this.onDidInstallExtension,A=>Object.assign(Object.assign({},A),{local:A.local?i(A.local,_):A.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(a,w,_){const A=this.getUriTransformer(a);switch(w){case"zip":return this.service.zip(m(_[0],A)).then(d=>f(d,A));case"unzip":return this.service.unzip(R(_[0],A));case"install":return this.service.install(R(_[0],A));case"getManifest":return this.service.getManifest(R(_[0],A));case"canInstall":return this.service.canInstall(_[0]);case"installFromGallery":return this.service.installFromGallery(_[0],_[1]);case"uninstall":return this.service.uninstall(m(_[0],A),_[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(m(_[0],A));case"getInstalled":return this.service.getInstalled(_[0]).then(d=>d.map(l=>i(l,A)));case"updateMetadata":return this.service.updateMetadata(m(_[0],A),_[1]).then(d=>i(d,A));case"updateExtensionScope":return this.service.updateExtensionScope(m(_[0],A),_[1]).then(d=>i(d,A));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=I;class p extends k.Disposable{constructor(a){super();this.channel=a,this._onInstallExtension=this._register(new E.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new E.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new E.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new E.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire(w))),this._register(this.channel.listen("onDidInstallExtension")(w=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},w),{local:w.local?m(w.local,null):w.local})))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}zip(a){return Promise.resolve(this.channel.call("zip",[a]).then(w=>b.URI.revive(w)))}unzip(a){return Promise.resolve(this.channel.call("unzip",[a]))}install(a){return Promise.resolve(this.channel.call("install",[a])).then(w=>m(w,null))}getManifest(a){return Promise.resolve(this.channel.call("getManifest",[a]))}async canInstall(a){return!0}installFromGallery(a,w){return Promise.resolve(this.channel.call("installFromGallery",[a,w])).then(_=>m(_,null))}uninstall(a,w){return Promise.resolve(this.channel.call("uninstall",[a,w]))}reinstallFromGallery(a){return Promise.resolve(this.channel.call("reinstallFromGallery",[a]))}getInstalled(a=null){return Promise.resolve(this.channel.call("getInstalled",[a])).then(w=>w.map(_=>m(_,null)))}updateMetadata(a,w){return Promise.resolve(this.channel.call("updateMetadata",[a,w])).then(_=>m(_,null))}updateExtensionScope(a,w){return Promise.resolve(this.channel.call("updateExtensionScope",[a,w])).then(_=>m(_,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=p;class D{constructor(a){this.service=a}listen(a,w){throw new Error("Invalid listen")}call(a,w,_){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(b.URI.revive(_[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=D}),define(de[168],me([0,1,20]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const b=/^%([\w\d.-]+)%$/i;function C(S,k){const R=f=>{if(typeof f=="string"){const m=b.exec(f);if(!!m)return k[m[1]]||f}};return(0,E.cloneAndChange)(S,R)}e.localizeManifest=C}),define(de[56],me([0,1,147]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function C(I){return I=I.trim(),I==="*"||b.test(I)}e.isValidVersionStr=C;function S(I){if(!C(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=I.match(b);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=S;function k(I){if(!I)return null;let p=I.majorBase,D=I.majorMustEqual,o=I.minorBase,a=I.minorMustEqual,w=I.patchBase,_=I.patchMustEqual;return I.hasCaret&&(p===0||(a=!1),_=!1),{majorBase:p,majorMustEqual:D,minorBase:o,minorMustEqual:a,patchBase:w,patchMustEqual:_,isMinimum:I.hasGreaterEquals}}e.normalizeVersion=k;function R(I,p){let D;typeof I=="string"?D=k(S(I)):D=I;let o;if(typeof p=="string"?o=k(S(p)):o=p,!D||!o)return!1;let a=D.majorBase,w=D.minorBase,_=D.patchBase,A=o.majorBase,d=o.minorBase,l=o.patchBase,c=o.majorMustEqual,t=o.minorMustEqual,n=o.patchMustEqual;return o.isMinimum?a>A?!0:a<A?!1:w>d?!0:w<d?!1:_>=l:(a===1&&A===0&&(!c||!t||!n)&&(A=1,d=0,l=0,c=!0,t=!1,n=!1),a<A?!1:a>A?!c:w<d?!1:w>d?!t:_<l?!1:_>l?!n:!0)}e.isValidVersion=R;function f(I,p,D){return p.isBuiltin||typeof p.main=="undefined"?!0:i(I,p.engines.vscode,D)}e.isValidExtensionVersion=f;function m(I,p){return I==="*"||i(p,I)}e.isEngineValid=m;function i(I,p,D=[]){let o=k(S(p));if(!o)return D.push(E.localize(0,null,p)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return D.push(E.localize(1,null,p)),!1}else if(!o.majorMustEqual)return D.push(E.localize(2,null,p)),!1;return R(I,o)?!0:(D.push(E.localize(3,null,I,p)),!1)}e.isVersionValid=i}),define(de[169],me([0,1,6,2,3,23,18,41,12,42]),function(Y,e,E,b,C,S,k,R,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class i extends b.Disposable{constructor(p){super();this.channel=p,this.session=(0,S.generateUuid)(),this._onDidChange=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new E.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new E.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._capabilities=2|4|16|8|8192,this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(p=>{if(Array.isArray(p)){const D=p;this._onDidChange.fire(D.map(o=>({resource:C.URI.revive(o.resource),type:o.type})))}else{const D=p;this._onDidWatchErrorOccur.fire(D)}}))}setCaseSensitive(p){p?this._capabilities|=1024:this._capabilities&=~1024,this._onDidChangeCapabilities.fire(void 0)}stat(p){return this.channel.call("stat",[p])}open(p,D){return this.channel.call("open",[p,D])}close(p){return this.channel.call("close",[p])}async read(p,D,o,a,w){const[_,A]=await this.channel.call("read",[p,D,w]);return o.set(_.buffer.slice(0,A),a),A}async readFile(p){return(await this.channel.call("readFile",[p])).buffer}readFileStream(p,D,o){const a=(0,R.newWriteableStream)(_=>k.VSBuffer.concat(_.map(A=>k.VSBuffer.wrap(A))).buffer),w=this.channel.listen("readFileStream",[p,D])(_=>{if(_ instanceof k.VSBuffer)a.write(_.buffer);else{if(_==="end")a.end();else{let A=_;A instanceof Error||(A=new Error((0,m.toErrorMessage)(A))),a.error(A),a.end()}w.dispose()}});return o.onCancellationRequested(()=>{a.error((0,f.canceled)()),a.end(),w.dispose()}),a}write(p,D,o,a,w){return this.channel.call("write",[p,D,k.VSBuffer.wrap(o),a,w])}writeFile(p,D,o){return this.channel.call("writeFile",[p,k.VSBuffer.wrap(D),o])}delete(p,D){return this.channel.call("delete",[p,D])}mkdir(p){return this.channel.call("mkdir",[p])}readdir(p){return this.channel.call("readdir",[p])}rename(p,D,o){return this.channel.call("rename",[p,D,o])}copy(p,D,o){return this.channel.call("copy",[p,D,o])}watch(p,D){const o=Math.random();return this.channel.call("watch",[this.session,o,p,D]),(0,b.toDisposable)(()=>this.channel.call("unwatch",[this.session,o]))}}e.IPCFileSystemProvider=i}),define(de[170],me([0,1,35,54,2,8]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends C.Disposable{constructor(f,m,i,I){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new b.Client(S.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService((0,E.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(de[171],me([0,1,35,54,2,8]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends C.Disposable{constructor(f,m,i,I,p={}){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new b.Client(S.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService((0,E.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(de[172],me([0,1,37,75,46,8]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(f,m,i,I,p){this.watchedFolder=f,this.eventCallback=i,this.logCallback=I,this.verboseLogging=p,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(D=>C.parse(D)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=E.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Y).fsPath,f);const m=new b.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];m.write(i).forEach(p=>{const D=p.split("|");if(D.length===2){const o=Number(D[0]),a=D[1];if(o>=0&&o<3){if(this.ignored&&this.ignored.some(w=>w(a))){this.verboseLogging&&this.log(a);return}I.push({type:k.changeTypeMap[o],path:a})}else this.log(D[1])}}),I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(f){this.error("process error: "+f.toString())}onExit(f,m){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${m})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(de[173],me([0,1,172,4,13]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(R,f,m,i){this.onDidFilesChange=f,this.onLogMessage=m,this.verboseLogging=i,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(b.posix.sep)&&(this.folder.path=(0,C.rtrim)(this.folder.path,b.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new E.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(de[57],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(S,k=[],R=!1){this.ctor=S,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=E;const b=(C,...S)=>new E(C,S);e.createSyncDescriptor=b}),define(de[174],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=E;class b{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let k of this._nodes.values())k.outgoing.size===0&&S.push(k);return S}insertEdge(S,k){const R=this.lookupOrInsertNode(S),f=this.lookupOrInsertNode(k);R.outgoing.set(this._hashFn(k),f),f.incoming.set(this._hashFn(S),R)}removeNode(S){const k=this._hashFn(S);this._nodes.delete(k);for(let R of this._nodes.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(S){const k=this._hashFn(S);let R=this._nodes.get(k);return R||(R=new E(S),this._nodes.set(k,R)),R}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[k,R]of this._nodes)S.push(`${k}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,k]of this._nodes){const R=new Set([S]),f=this._findCycle(k,R);if(f)return f}}_findCycle(S,k){for(let[R,f]of S.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const m=this._findCycle(f,k);if(m)return m;k.delete(R)}}}e.Graph=b}),define(de[7],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function f(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=f})(E=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function b(R,f,m,i){f[E.DI_TARGET]===f?f[E.DI_DEPENDENCIES].push({id:R,index:m,optional:i}):(f[E.DI_DEPENDENCIES]=[{id:R,index:m,optional:i}],f[E.DI_TARGET]=f)}function C(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const f=function(m,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");b(f,m,I,!1)};return f.toString=()=>R,E.serviceIds.set(R,f),f}e.createDecorator=C;function S(R){return R}e.refineServiceDecorator=S;function k(R){return function(f,m,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");b(R,f,i,!0)}}e.optional=k}),define(de[175],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function b(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(de[176],me([0,1,6,115,2,26,112,127,175]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function m(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(m):!!p.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(D,o){let a={selector:D,provider:o,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(a){let w=this._entries.indexOf(a);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const o=[];for(let a of this._entries)a._score>0&&o.push(a.provider);return o}ordered(D){const o=[];return this._orderedForEach(D,a=>o.push(a.provider)),o}orderedGroups(D){const o=[];let a,w;return this._orderedForEach(D,_=>{a&&w===_._score?a.push(_.provider):(w=_._score,a=[_.provider],o.push(a))}),o}_orderedForEach(D,o){if(!!D){this._updateScores(D);for(const a of this._entries)a._score>0&&o(a)}}_updateScores(D){let o={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===o.language&&this._lastCandidate.uri===o.uri)){this._lastCandidate=o;for(let a of this._entries)if(a._score=(0,R.score)(a.selector,D.uri,D.getLanguageIdentifier().language,(0,f.shouldSynchronizeModel)(D)),m(a.selector)&&a._score>0){for(let w of this._entries)w._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(D,o){return D._score<o._score?1:D._score>o._score?-1:D._time<o._time?1:D._time>o._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(D,o,a=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=o,this.max=a,this._cache=new S.LRUCache(50,.7)}_key(D){return D.id+(0,b.hash)(this._registry.all(D))}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const o=this._key(D),a=this._cache.get(o);return this._clamp(a==null?void 0:a.value)}update(D,o){const a=this._key(D);let w=this._cache.get(a);return w||(w=new k.MovingAverage,this._cache.set(a,w)),w.update(o),this.get(D)}}e.LanguageFeatureRequestDelays=I}),define(de[177],me([0,1,3,53,176,128,71]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var R;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(R=e.LanguageId||(e.LanguageId={}));class f{constructor(g,F){this.language=g,this.id=F}}e.LanguageIdentifier=f;var m;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(m=e.FontStyle||(e.FontStyle={}));var i;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var p;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(p=e.MetadataConsts||(e.MetadataConsts={}));class D{static getLanguageId(g){return(g&255)>>>0}static getTokenType(g){return(g&1792)>>>8}static getFontStyle(g){return(g&14336)>>>11}static getForeground(g){return(g&8372224)>>>14}static getBackground(g){return(g&4286578688)>>>23}static getClassNameFromMetadata(g){let F=this.getForeground(g),O="mtk"+F,x=this.getFontStyle(g);return x&1&&(O+=" mtki"),x&2&&(O+=" mtkb"),x&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(g,F){const O=this.getForeground(g),x=this.getFontStyle(g);let oe=`color: ${F[O]};`;return x&1&&(oe+="font-style: italic;"),x&2&&(oe+="font-weight: bold;"),x&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=D;var o;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(g){const F=v[g];let O=F&&k.iconRegistry.get(F);return O||(console.info("No codicon found for CompletionItemKind "+g),O=k.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(g,F){let O=v[g];return typeof O=="undefined"&&!F&&(O=9),O}}();var a;(function(v){v[v.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var A;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(A=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(v){return v&&E.URI.isUri(v.uri)&&b.Range.isIRange(v.range)&&(b.Range.isIRange(v.originSelectionRange)||b.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=c;var t;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(v){v[v.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var r;(function(v){const g=new Map;g.set("file",0),g.set("module",1),g.set("namespace",2),g.set("package",3),g.set("class",4),g.set("method",5),g.set("property",6),g.set("field",7),g.set("constructor",8),g.set("enum",9),g.set("interface",10),g.set("function",11),g.set("variable",12),g.set("constant",13),g.set("string",14),g.set("number",15),g.set("boolean",16),g.set("array",17),g.set("object",18),g.set("key",19),g.set("null",20),g.set("enum-member",21),g.set("struct",22),g.set("event",23),g.set("operator",24),g.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function O(W){return g.get(W)}v.fromString=O;function x(W){return F.get(W)}v.toString=x;function oe(W,te){const Q=F.get(W);let q=Q&&k.iconRegistry.get("symbol-"+Q);return q||(console.info("No codicon found for SymbolKind "+W),q=k.Codicon.symbolProperty),`${te?"inline":"block"} ${q.classNames}`}v.toCssClassName=oe})(r=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(g){this.value=g}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var y;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(y=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var P;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(de[58],me([0,1,13,7,5]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=C.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",C.isMacintosh),k.set("isLinux",C.isLinux),k.set("isWindows",C.isWindows),k.set("isWeb",C.isWeb),k.set("isMacNative",C.isMacintosh&&!C.isWeb),k.set("isEdge",S.indexOf("Edg/")>=0),k.set("isFirefox",S.indexOf("Firefox")>=0),k.set("isChrome",S.indexOf("Chrome")>=0),k.set("isSafari",S.indexOf("Safari")>=0),k.set("isIPad",S.indexOf("iPad")>=0);const R=Object.prototype.hasOwnProperty;var f;(function(v){v[v.False=0]="False",v[v.True=1]="True",v[v.Defined=2]="Defined",v[v.Not=3]="Not",v[v.Equals=4]="Equals",v[v.NotEquals=5]="NotEquals",v[v.And=6]="And",v[v.Regex=7]="Regex",v[v.NotRegex=8]="NotRegex",v[v.Or=9]="Or",v[v.In=10]="In",v[v.NotIn=11]="NotIn",v[v.Greater=12]="Greater",v[v.GreaterEquals=13]="GreaterEquals",v[v.Smaller=14]="Smaller",v[v.SmallerEquals=15]="SmallerEquals"})(f=e.ContextKeyExprType||(e.ContextKeyExprType={}));class m{static false(){return I.INSTANCE}static true(){return p.INSTANCE}static has(g){return D.create(g)}static equals(g,F){return o.create(g,F)}static notEquals(g,F){return _.create(g,F)}static regex(g,F){return n.create(g,F)}static in(g,F){return a.create(g,F)}static not(g){return A.create(g)}static and(...g){return s.create(g)}static or(...g){return u.create(g)}static greater(g,F){return d.create(g,F)}static less(g,F){return c.create(g,F)}static deserialize(g,F=!1){if(!!g)return this._deserializeOrExpression(g,F)}static _deserializeOrExpression(g,F){let O=g.split("||");return u.create(O.map(x=>this._deserializeAndExpression(x,F)))}static _deserializeAndExpression(g,F){let O=g.split("&&");return s.create(O.map(x=>this._deserializeOne(x,F)))}static _deserializeOne(g,F){if(g=g.trim(),g.indexOf("!=")>=0){let O=g.split("!=");return _.create(O[0].trim(),this._deserializeValue(O[1],F))}if(g.indexOf("==")>=0){let O=g.split("==");return o.create(O[0].trim(),this._deserializeValue(O[1],F))}if(g.indexOf("=~")>=0){let O=g.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(g.indexOf(" in ")>=0){let O=g.split(" in ");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const O=g.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const O=g.split(">");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const O=g.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const O=g.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(g)?A.create(g.substr(1).trim()):D.create(g)}static _deserializeValue(g,F){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let O=/^'([^']*)'$/.exec(g);return O?O[1].trim():g}static _deserializeRegexValue(g,F){if((0,E.isFalsyOrWhitespace)(g)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=g.indexOf("/"),x=g.lastIndexOf("/");if(O===x||O<0){if(F)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let oe=g.slice(O+1,x),W=g[x+1]==="i"?"i":"";try{return new RegExp(oe,W)}catch(te){if(F)throw new Error(`bad regexp-value '${g}', parse error: ${te}`);return console.warn(`bad regexp-value '${g}', parse error: ${te}`),null}}}e.ContextKeyExpr=m;function i(v,g){return v.cmp(g)}class I{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class p{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class D{constructor(g){this.key=g,this.type=2}static create(g){const F=k.get(g);return typeof F=="boolean"?F?p.INSTANCE:I.INSTANCE:new D(g)}cmp(g){return g.type!==this.type?this.type-g.type:y(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return A.create(this.key)}}e.ContextKeyDefinedExpr=D;class o{constructor(g,F){this.key=g,this.value=F,this.type=4}static create(g,F){if(typeof F=="boolean")return F?D.create(g):A.create(g);const O=k.get(g);return typeof O=="boolean"?F===(O?"true":"false")?p.INSTANCE:I.INSTANCE:new o(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return _.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class a{constructor(g,F){this.key=g,this.valueKey=F,this.type=10}static create(g,F){return new a(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const F=g.getValue(this.valueKey),O=g.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?R.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=a;class w{constructor(g){this._actual=g,this.type=11}static create(g){return new w(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new w(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class _{constructor(g,F){this.key=g,this.value=F,this.type=5}static create(g,F){if(typeof F=="boolean")return F?A.create(g):D.create(g);const O=k.get(g);return typeof O=="boolean"?F===(O?"true":"false")?I.INSTANCE:p.INSTANCE:new _(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=_;class A{constructor(g){this.key=g,this.type=3}static create(g){const F=k.get(g);return typeof F=="boolean"?F?I.INSTANCE:p.INSTANCE:new A(g)}cmp(g){return g.type!==this.type?this.type-g.type:y(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return D.create(this.key)}}e.ContextKeyNotExpr=A;class d{constructor(g,F){this.key=g,this.value=F,this.type=12}static create(g,F){return new d(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class l{constructor(g,F){this.key=g,this.value=F,this.type=13}static create(g,F){return new l(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class c{constructor(g,F){this.key=g,this.value=F,this.type=14}static create(g,F){return new c(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(g,F){this.key=g,this.value=F,this.type=15}static create(g,F){return new t(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:P(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(g,F){this.key=g,this.regexp=F,this.type=7}static create(g,F){return new n(g,F)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const F=this.regexp?this.regexp.source:"",O=g.regexp?g.regexp.source:"";return F<O?-1:F>O?1:0}equals(g){if(g.type===this.type){const F=this.regexp?this.regexp.source:"",O=g.regexp?g.regexp.source:"";return this.key===g.key&&F===O}return!1}evaluate(g){let F=g.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(g){this._actual=g,this.type=8}static create(g){return new r(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new r(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(g){this.expr=g,this.type=6}static create(g){return s._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const x=i(this.expr[F],g.expr[F]);if(x!==0)return x}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(g.expr[F]))return!1;return!0}return!1}evaluate(g){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(g))return!1;return!0}static _normalizeArr(g){const F=[];let O=!1;for(const x of g)if(!!x){if(x.type===1){O=!0;continue}if(x.type===0)return I.INSTANCE;if(x.type===6){F.push(...x.expr);continue}F.push(x)}if(F.length===0&&O)return p.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const x=F[F.length-1];if(x.type!==9)break;F.pop();const oe=F.pop(),W=u.create(x.expr.map(te=>s.create([te,oe])));W&&(F.push(W),F.sort(i))}return F.length===1?F[0]:new s(F)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let F of this.expr)g.push(...F.keys());return g}map(g){return new s(this.expr.map(F=>F.map(g)))}negate(){let g=[];for(let F of this.expr)g.push(F.negate());return u.create(g)}}e.ContextKeyAndExpr=s;class u{constructor(g){this.expr=g,this.type=9}static create(g){const F=u._normalizeArr(g);if(F.length!==0)return F.length===1?F[0]:new u(F)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const x=i(this.expr[F],g.expr[F]);if(x!==0)return x}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(g.expr[F]))return!1;return!0}return!1}evaluate(g){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(g))return!0;return!1}static _normalizeArr(g){let F=[],O=!1;if(g){for(let x=0,oe=g.length;x<oe;x++){const W=g[x];if(!!W){if(W.type===0){O=!0;continue}if(W.type===1)return[p.INSTANCE];if(W.type===9){F=F.concat(W.expr);continue}F.push(W)}}if(F.length===0&&O)return[I.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let F of this.expr)g.push(...F.keys());return g}map(g){return new u(this.expr.map(F=>F.map(g)))}negate(){let g=[];for(let O of this.expr)g.push(O.negate());const F=O=>O.type===9?O.expr:[O];for(;g.length>1;){const O=g.shift(),x=g.shift(),oe=[];for(const W of F(O))for(const te of F(x))oe.push(m.and(W,te));g.unshift(m.or(...oe))}return g[0]}}e.ContextKeyOrExpr=u;class h extends D{constructor(g,F,O){super(g);this._defaultValue=F,typeof O=="object"?h._info.push(Object.assign(Object.assign({},O),{key:g})):O!==!0&&h._info.push({key:g,description:O,type:F!=null?typeof F:void 0})}static all(){return h._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return m.not(this.key)}isEqualTo(g){return m.equals(this.key,g)}notEqualsTo(g){return m.notEquals(this.key,g)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(v,g){return v<g?-1:v>g?1:0}function P(v,g,F,O){return v<F?-1:v>F?1:g<O?-1:g>O?1:0}}),define(de[178],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function b(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=b}),define(de[84],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,E.createDecorator)("downloadService")}),define(de[27],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(de[32],me([0,1,142,7,8]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=S;var k;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var R;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var f;(function(I){I.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var m;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(p,D){super(p);this.code=D}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(de[43],me([0,1,13,7]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));class k{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let p=typeof i=="string"?i:i.value,D=typeof I=="string"?I:I.value;return E.equalsIgnoreCase(p,D)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=k;function R(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=f,e.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(de[33],me([0,1,13,43]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(D,o){return D.uuid&&o.uuid?D.uuid===o.uuid:D.id===o.id?!0:(0,E.compareIgnoreCase)(D.id,o.id)===0}e.areSameExtensions=C;class S{constructor(o,a){this.version=a,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof S?C(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=S;function k(D,o){return`${D}.${o}`}e.getExtensionId=k;function R(D){return D.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function f(D,o){return R(k(D,o))}e.getGalleryExtensionId=f;function m(D,o){const a=[],w=_=>{for(const A of a)if(A.some(d=>C(o(d),o(_))))return A;return null};for(const _ of D){const A=w(_);A?A.push(_):a.push([_])}return a}e.groupByExtension=m;function i(D){return{id:D.identifier.id,name:D.manifest.name,galleryId:null,publisherId:D.publisherId,publisherName:D.manifest.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:D.manifest.extensionDependencies&&D.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(D){return Object.assign({id:D.identifier.id,name:D.name,galleryId:D.identifier.uuid,publisherId:D.publisherId,publisherName:D.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:!!(D.properties.dependencies&&D.properties.dependencies.length>0)},D.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function p(D){const o=new Set;for(const a of D)a.malicious&&o.add(a.id.id);return o}e.getMaliciousExtensionsSet=p});var xe=this&&this.__param||function(Y,e){return function(E,b){e(E,b,Y)}};define(de[85],me([0,1,143,12,3,48,32,33,43,51,28,8]),function(Y,e,E,b,C,S,k,R,f,m,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const p=A=>(0,E.localize)(0,null,A),D=(0,E.localize)(1,null,"ms-dotnettools.csharp");function o(A,d){return d?`${A.publisher}.${A.name}@${A.version}`:`${A.publisher}.${A.name}`}const a=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(A){const d=a.exec(A);return d&&d[1]?[(0,R.adoptToGalleryExtensionId)(d[1]),d[2]]:[(0,R.adoptToGalleryExtensionId)(A),void 0]}e.getIdAndVersion=w;let _=class{constructor(d,l){this.extensionManagementService=d,this.extensionGalleryService=l}get location(){}async listExtensions(d,l,c=console){let t=await this.extensionManagementService.getInstalled(1);const n=f.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(l&&l!==""){if(n.indexOf(l.toLowerCase())<0){c.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(s=>s.manifest.categories?s.manifest.categories.map(h=>h.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){c.log("Possible Categories: "),n.forEach(s=>{c.log(s)});return}this.location&&c.log((0,E.localize)(2,null,this.location)),t=t.sort((s,u)=>s.identifier.id.localeCompare(u.identifier.id));let r;for(let s of t)r!==s.identifier.id&&(r=s.identifier.id,c.log(o(s.manifest,d)))}async installExtensions(d,l,c,t,n=console){const r=[],s=[];d.length&&n.log(this.location?(0,E.localize)(3,null,this.location):(0,E.localize)(4,null));const u=await this.extensionManagementService.getInstalled(1),h=(v,g)=>{const F=u.find(O=>(0,R.areSameExtensions)(O.identifier,{id:v}));if(F){if(!g&&!t)return n.log((0,E.localize)(5,null,v,F.manifest.version,v)),!1;if(g&&F.manifest.version===g)return n.log((0,E.localize)(6,null,`${v}@${g}`)),!1}return!0},y=[],P=[];for(const v of d)if(v instanceof C.URI)y.push(v);else{const[g,F]=w(v);h(g,F)&&P.push({id:g,version:F,installOptions:{isBuiltin:!1,isMachineScoped:c}})}for(const v of l){const[g,F]=w(v);h(g,F)&&P.push({id:g,version:F,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(y.length&&await Promise.all(y.map(async v=>{try{const g=await this.installVSIX(v,{isBuiltin:!1,isMachineScoped:c},t,n);g&&s.push(g)}catch(g){n.error(g.message||g.stack||g),r.push(v.toString())}})),P.length){const v=await this.getGalleryExtensions(P);await Promise.all(P.map(async g=>{const F=v.get(g.id.toLowerCase());if(F)try{const O=await this.installFromGallery(g,F,u,t,n);O&&s.push(O)}catch(O){n.error(O.message||O.stack||O),r.push(g.id)}else n.error(`${p(g.version?`${g.id}@${g.version}`:g.id)}
${D}`),r.push(g.id)}))}if(r.length)throw new Error((0,E.localize)(7,null,r.join(", ")))}async installVSIX(d,l,c,t){const n=await this.extensionManagementService.getManifest(d);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,c,t))try{return await this.extensionManagementService.install(d,l),t.log((0,E.localize)(8,null,(0,m.getBaseLabel)(d))),n}catch(s){if((0,b.isPromiseCanceledError)(s))return t.log((0,E.localize)(9,null,(0,m.getBaseLabel)(d))),null;throw s}return null}async getGalleryExtensions(d){const l=d.filter(({version:n})=>n===void 0).map(({id:n})=>n),c=d.filter(({version:n})=>n!==void 0),t=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(l,i.CancellationToken.None)).forEach(r=>t.set(r.identifier.id.toLowerCase(),r))})(),Promise.all(c.map(async({id:n,version:r})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:n},r);s&&t.set(s.identifier.id.toLowerCase(),s)}))]),t}async installFromGallery({id:d,version:l,installOptions:c},t,n,r,s){const u=await this.extensionGalleryService.getManifest(t,i.CancellationToken.None);if(u&&!this.validateExtensionKind(u,s))return null;const h=n.find(y=>(0,R.areSameExtensions)(y.identifier,t.identifier));if(h){if(t.version===h.manifest.version)return s.log((0,E.localize)(10,null,l?`${d}@${l}`:d)),null;s.log((0,E.localize)(11,null,d,t.version))}try{return c.isBuiltin?s.log((0,E.localize)(12,null,d,t.version)):s.log((0,E.localize)(13,null,d,t.version)),await this.extensionManagementService.installFromGallery(t,c),s.log((0,E.localize)(14,null,d,t.version)),u}catch(y){if((0,b.isPromiseCanceledError)(y))return s.log((0,E.localize)(15,null,d)),null;throw y}}validateExtensionKind(d,l){return!0}async validateVSIX(d,l,c){const t={id:(0,R.getGalleryExtensionId)(d.publisher,d.name)},r=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,R.areSameExtensions)(t,s.identifier)&&(0,S.gt)(s.manifest.version,d.version));return r&&!l?(c.log((0,E.localize)(16,null,r.identifier.id,r.manifest.version,d.version)),!1):this.validateExtensionKind(d,c)}async uninstallExtensions(d,l,c=console){const t=async r=>{if(r instanceof C.URI){const s=await this.extensionManagementService.getManifest(r);return o(s)}return r},n=[];for(const r of d){const s=await t(r),h=(await this.extensionManagementService.getInstalled()).filter(y=>(0,R.areSameExtensions)(y.identifier,{id:s}));if(!h.length)throw new Error(`${this.notInstalled(s)}
${D}`);if(h.some(y=>y.type===0)){c.log((0,E.localize)(17,null,s));return}if(!l&&h.some(y=>y.isBuiltin)){c.log((0,E.localize)(18,null,s));return}c.log((0,E.localize)(19,null,s));for(const y of h)await this.extensionManagementService.uninstall(y),n.push(y);this.location?c.log((0,E.localize)(20,null,s,this.location)):c.log((0,E.localize)(21,null,s))}}async locateExtension(d,l=console){const c=await this.extensionManagementService.getInstalled();d.forEach(t=>{c.forEach(n=>{if(n.identifier.id===t&&n.location.scheme===I.Schemas.file){l.log(n.location.fsPath);return}})})}notInstalled(d){return this.location?(0,E.localize)(22,null,d,this.location):(0,E.localize)(23,null,d)}};_=Oe([xe(0,k.IExtensionManagementService),xe(1,k.IExtensionGalleryService)],_),e.ExtensionManagementCLIService=_}),define(de[179],me([0,1,2,4,43,21]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends E.Disposable{constructor(f,m){super();this.environmentService=f,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtension(i=>this.onDidInstallExtension(i))),this._register(m.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){S.rimraf(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(de[22],me([0,1,149,4,3,7,13,11,26]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function m(W){return W.create===!0}e.isFileOpenForWriteOptions=m;var i;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=p;function D(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=D;function o(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function a(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=a;var w;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(te,Q){super(te);this.code=Q}}e.FileSystemProviderError=_;function A(W,te){const Q=new _(W.toString(),te);return l(Q,te),Q}e.createFileSystemProviderError=A;function d(W){return W||A((0,E.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=d;function l(W,te){return W.name=te?`${te} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=l;function c(W){if(!W)return w.Unknown;if(W instanceof _)return W.code;const te=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!te)return w.Unknown;switch(te[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=c;function t(W){if(W instanceof y)return W.fileOperationResult;switch(c(W)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(te,Q,q){this.resource=te,this.operation=Q,this.target=q}isOperation(te){return this.operation===te}}e.FileOperationEvent=r;var s;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class u{constructor(te,Q){this.ignorePathCasing=Q,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=te;for(const q of te)switch(q.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(q.resource,q);break}}contains(te,...Q){return this.doContains(te,{includeChildren:!1},...Q)}affects(te,...Q){return this.doContains(te,{includeChildren:!0},...Q)}doContains(te,Q,...q){var ee,H,T,L,B,U;if(!te)return!1;const V=q.length>0;return!!((!V||q.includes(1))&&(((ee=this.added)===null||ee===void 0?void 0:ee.get(te))||Q.includeChildren&&((H=this.added)===null||H===void 0?void 0:H.findSuperstr(te)))||(!V||q.includes(0))&&(((T=this.updated)===null||T===void 0?void 0:T.get(te))||Q.includeChildren&&((L=this.updated)===null||L===void 0?void 0:L.findSuperstr(te)))||(!V||q.includes(2))&&(((B=this.deleted)===null||B===void 0?void 0:B.findSubstr(te))||Q.includeChildren&&((U=this.deleted)===null||U===void 0?void 0:U.findSuperstr(te))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(te){const Q=[],q=te===1?this.added:te===0?this.updated:this.deleted;if(q)for(const[,ee]of q)Q.push(ee);return Q}filter(te){return new u(this.changes.filter(Q=>te(Q)),this.ignorePathCasing)}}e.FileChangesEvent=u;function h(W,te,Q){return!W||!te||W===te||te.length>W.length?!1:(te.charAt(te.length-1)!==b.sep&&(te+=b.sep),Q?(0,k.startsWithIgnoreCase)(W,te):W.indexOf(te)===0)}e.isParent=h;class y extends Error{constructor(te,Q,q){super(te);this.fileOperationResult=Q,this.options=q}static isFileOperationError(te){return te instanceof Error&&!(0,R.isUndefinedOrNull)(te.fileOperationResult)}}e.FileOperationError=y;var P;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function g(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=g;async function F(W,te){if(!te.canHandleResource(C.URI.from({scheme:W.scheme})))return new Promise(Q=>{const q=te.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===W.scheme&&ee.added&&(q.dispose(),Q())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(te){return(0,R.isNumber)(te)||(te=0),te<O.KB?(0,E.localize)(1,null,te.toFixed(0)):te<O.MB?(0,E.localize)(2,null,(te/O.KB).toFixed(2)):te<O.GB?(0,E.localize)(3,null,(te/O.MB).toFixed(2)):te<O.TB?(0,E.localize)(4,null,(te/O.GB).toFixed(2)):(0,E.localize)(5,null,(te/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var x;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function oe(W){return{maxFileSize:W===0?300*O.MB:16*O.GB,maxHeapSize:W===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=oe}),define(de[180],me([0,1,235,141,22,55]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(p,D){const o={onUnknownOption:w=>{console.warn((0,b.localize)(0,null,w))},onMultipleValues:(w,_)=>{console.warn((0,b.localize)(1,null,w,_))}},a=(0,S.parseArgs)(p,S.OPTIONS,D?o:void 0);return a.goto&&a._.forEach(w=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,b.localize)(2,null))),a["max-memory"]&&E(parseInt(a["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),a}function R(p){const D=p.findIndex(o=>!/^-/.test(o));if(D>-1)return[...p.slice(0,D),...p.slice(D+1)]}function f(p){let[,...D]=p;process.env.VSCODE_DEV&&(D=R(D)||[]);const o=!I(process.env);return k(D,o)}e.parseMainProcessArgv=f;function m(p){const[,,...D]=p;return k(D,!0)}e.parseCLIProcessArgv=m;function i(p,...D){const o=p.indexOf("--");return o===-1?p.push(...D):p.splice(o,0,...D),p}e.addArg=i;function I(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(de[86],me([0,1,76,37,23,5,180,42,137]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function m(p,D,o){return D["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(o)&&!D["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(o)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=I(p)),i)}e.resolveShellEnv=m;let i;async function I(p){const D=new Promise(async(o,a)=>{const w=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",w);const _=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",_);const A=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),d=new RegExp(A+"(.*)"+A),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});p.trace("getUnixShellEnvironment#env",l);const c=await(0,f.getSystemShell)(S.OS,l);p.trace("getUnixShellEnvironment#shell",c);const t=E.basename(c);let n,r;/^pwsh(-preview)?$/.test(t)?(n=`& '${process.execPath}' -p '''${A}'' + JSON.stringify(process.env) + ''${A}'''`,r=["-Login","-Command"]):(n=`'${process.execPath}' -p '"${A}" + JSON.stringify(process.env) + "${A}"'`,r=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(r),n);const s=(0,b.spawn)(c,[...r,n],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});s.on("error",y=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(y)),o({})});const u=[];s.stdout.on("data",y=>u.push(y));const h=[];s.stderr.on("data",y=>h.push(y)),s.on("close",(y,P)=>{const v=Buffer.concat(u).toString("utf8");p.trace("getUnixShellEnvironment#raw",v);const g=Buffer.concat(h).toString("utf8");if(g.trim()&&p.trace("getUnixShellEnvironment#stderr",g),y||P)return a(new Error(`Failed to get environment (code ${y}, signal ${P})`));const F=d.exec(v),O=F?F[1]:"{}";try{const x=JSON.parse(O);w?x.ELECTRON_RUN_AS_NODE=w:delete x.ELECTRON_RUN_AS_NODE,_?x.ELECTRON_NO_ATTACH_CONSOLE=_:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",x),o(x)}catch(x){p.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(x)),a(x)}})});try{return await D}catch(o){return p.error("getUnixShellEnvironment#error",(0,R.toErrorMessage)(o)),{}}}}),define(de[87],me([0,1,3,22,5]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(f){return f.map(m=>({type:m.type,resource:E.URI.file(m.path)}))}e.toFileChanges=S;function k(f){const m=new R;for(const i of f)m.processEvent(i);return m.normalize()}e.normalizeFileChanges=k;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const i=this.mapPathToChange.get(m.path);if(i){const I=i.type,p=m.type;I===1&&p===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&p===1?i.type=0:I===1&&p===0||(i.type=p)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],i=[];return this.normalized.filter(I=>I.type!==2?(m.push(I),!1):!0).sort((I,p)=>I.path.length-p.path.length).filter(I=>i.some(p=>(0,b.isParent)(I.path,p,!C.isLinux))?!1:(i.push(I.path),!0)).concat(m)}}}),define(de[181],me([0,1,87,2,21,122,125,14,4]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class m extends b.Disposable{constructor(I,p,D,o){super();this.path=I,this.onDidFilesChange=p,this.onLogMessage=D,this.verboseLogging=o,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:p}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let D=this.path;if(p)try{D=await(0,S.realpath)(D)}catch(o){if(this.onError(o),p.dangling)return}I.isDirectory()?this._register((0,k.watchFolder)(D,(o,a)=>{this.onFileChange({type:o==="changed"?0:o==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(a))})},o=>this.onError(o))):this._register((0,k.watchFile)(D,o=>{this.onFileChange({type:o==="changed"?0:2,path:this.path})},o=>this.onError(o)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const D=(0,E.normalizeFileChanges)(p);this.verboseLogging&&D.forEach(o=>{this.onVerbose(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`)}),D.length>0&&this.onDidFilesChange(D)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=m}),define(de[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...C){this._entries=new Map;for(let[S,k]of C)this.set(S,k)}set(C,S){const k=this._entries.get(C);return this._entries.set(C,S),k}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=E}),define(de[88],me([0,1,12,174,57,7,59,14]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class m extends Error{constructor(o){var a;super("cyclic dependency between services");this.message=(a=o.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class i{constructor(o=new k.ServiceCollection,a=!1,w){this._activeInstantiations=new Set,this._services=o,this._strict=a,this._parent=w,this._services.set(S.IInstantiationService,this)}createChild(o){return new i(o,this._strict,this)}invokeFunction(o,...a){let w=p.traceInvocation(o),_=!1;try{return o({get:(d,l)=>{if(_)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(d,w);if(!c&&l!==S.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return c}},...a)}finally{_=!0,w.stop()}}createInstance(o,...a){let w,_;return o instanceof C.SyncDescriptor?(w=p.traceCreation(o.ctor),_=this._createInstance(o.ctor,o.staticArguments.concat(a),w)):(w=p.traceCreation(o),_=this._createInstance(o,a,w)),w.stop(),_}_createInstance(o,a=[],w){let _=S._util.getServiceDependencies(o).sort((l,c)=>l.index-c.index),A=[];for(const l of _){let c=this._getOrCreateServiceInstance(l.id,w);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${l.id}.`);A.push(c)}let d=_.length>0?_[0].index:a.length;if(a.length!==d){console.warn(`[createInstance] First service dependency of ${o.name} at position ${d+1} conflicts with ${a.length} static arguments`);let l=d-a.length;l>0?a=a.concat(new Array(l)):a=a.slice(0,d)}return new o(...[...a,...A])}_setServiceInstance(o,a){if(this._services.get(o)instanceof C.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){let w=this._getServiceInstanceOrDescriptor(o);return w instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,w,a.branch(o,!0)):(a.branch(o,!1),w)}_safeCreateAndCacheServiceInstance(o,a,w){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,w)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,w){const _=new b.Graph(l=>l.id.toString());let A=0;const d=[{id:o,desc:a,_trace:w}];for(;d.length;){const l=d.pop();if(_.lookupOrInsertNode(l),A++>1e3)throw new m(_);for(let c of S._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${o} depends on ${c.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};_.insertEdge(l,n),d.push(n)}}}for(;;){const l=_.roots();if(l.length===0){if(!_.isEmpty())throw new m(_);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}_.removeNode(c)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,w=[],_,A){if(this._services.get(o)instanceof C.SyncDescriptor)return this._createServiceInstance(a,w,_,A);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,w,_,A);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a=[],w,_){if(w){const A=new R.IdleValue(()=>this._createInstance(o,a,_));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let c=A.value,t=c[l];return typeof t!="function"||(t=t.bind(c),d[l]=t),t},set(d,l,c){return A.value[l]=c,!0}})}else return this._createInstance(o,a,_)}}e.InstantiationService=i;var I;(function(D){D[D.Creation=0]="Creation",D[D.Invocation=1]="Invocation",D[D.Branch=2]="Branch"})(I||(I={}));class p{constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return f?new p(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(o){return f?new p(0,o.name):p._None}branch(o,a){let w=new p(2,o.toString());return this._dep.push([o,a,w]),w}stop(){let o=Date.now()-this._start;p._totals+=o;let a=!1;function w(A,d){let l=[],c=new Array(A+1).join("	");for(const[t,n,r]of d._dep)if(n&&r){a=!0,l.push(`${c}CREATES -> ${t}`);let s=w(A+1,r);s&&l.push(s)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let _=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(o>2||a)&&console.log(_.join(`
`))}}p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(de[182],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,E.createDecorator)("labelService")}),define(de[60],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,E.createDecorator)("localizationsService");function b(C){if(typeof C.languageId!="string"||!Array.isArray(C.translations)||C.translations.length===0)return!1;for(const S of C.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(C.languageName&&typeof C.languageName!="string"||C.localizedLanguageName&&typeof C.localizedLanguageName!="string")}e.isValidLocalization=b}),define(de[16],me([0,1,7,2,5,6,42]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function R(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class m extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class i extends m{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(f.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let r=0;r<t.length;r++){let s=t[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}n+=(r>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class I extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...n):console.log(`[main ${R()}]`,t,...n))}debug(t,...n){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...n):console.log(`[main ${R()}]`,t,...n))}info(t,...n){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...n):console.log(`[main ${R()}]`,t,...n))}warn(t,...n){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...n):console.warn(`[main ${R()}]`,t,...n))}error(t,...n){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...n):console.error(`[main ${R()}]`,t,...n))}critical(t,...n){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...n):console.error(`[main ${R()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class p extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=p;class D extends m{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,k.toErrorMessage)(t,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=D;class o extends m{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const r of this.logServices)r.trace(t,...n)}debug(t,...n){for(const r of this.logServices)r.debug(t,...n)}info(t,...n){for(const r of this.logServices)r.info(t,...n)}warn(t,...n){for(const r of this.logServices)r.warn(t,...n)}error(t,...n){for(const r of this.logServices)r.error(t,...n)}critical(t,...n){for(const r of this.logServices)r.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class a extends b.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class w extends b.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}createLogger(t,n){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,(n==null?void 0:n.always)?f.Trace:this.logLevel,n),this.loggers.set(t.toString(),r),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class _{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return f.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=_;function A(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const t=d(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=A;function d(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=d;function l(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=l}),define(de[183],me([0,1,15,2,22,32,27,3,17,33,16,23,48,5,14,12]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let _=class extends b.Disposable{constructor(d,l,c,t){super();this.fileService=l,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=R.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,l){await this.cleanUpPromise;const c=this.getName(d),t=(0,f.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const n=(0,f.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(d,n,l);try{await this.rename(n,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch(s){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,a.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,n.path),r}}return t}async delete(d){}async rename(d,l,c){try{await E.promises.rename(d.fsPath,l.fsPath)}catch(t){if(D.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${d} to ${l} with 'EPERM' error. Trying again...`),this.rename(d,l,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const l=[],c=[];for(const r of d.children){const s=this.parse(r.name);s&&c.push([s,r])}const t=(0,m.groupByExtension)(c,([r])=>r),n=[];for(const r of t)r.sort((s,u)=>p.rcompare(s[0].version,u[0].version)),l.push(...r.slice(1).map(s=>s[1].resource)),n.push(r[0][1]);n.sort((r,s)=>r.mtime-s.mtime),l.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(r=>r.resource)),await o.Promises.settled(l.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?new m.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase():(0,I.generateUuid)()}parse(d){const l=w.exec(d);return l&&l[1]&&l[2]?new m.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};_=Oe([xe(0,k.INativeEnvironmentService),xe(1,C.IFileService),xe(2,S.IExtensionGalleryService),xe(3,i.ILogService)],_),e.ExtensionsDownloader=_}),define(de[184],me([0,1,2,16,37,42,4,14,6,8,21,27]),function(Y,e,E,b,C,S,k,R,f,m,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends E.Disposable{constructor(o,a){super();this.environmentService=o,this.logService=a,this.processesLimiter=new R.Limiter(5)}async postUninstall(o){const a=this.parseScript(o,"uninstall");return a&&(this.logService.info(o.identifier.id,o.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(a.script,"uninstall",a.args,!0,o).then(()=>this.logService.info(o.identifier.id,o.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(o.identifier.id,o.manifest.version,`Failed to run post uninstall script: ${w}`)))),(0,i.rimraf)(this.getExtensionStoragePath(o)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(o,a){const w=`vscode:${a}`;if(o.location.scheme===m.Schemas.file&&o.manifest&&o.manifest.scripts&&typeof o.manifest.scripts[w]=="string"){const _=o.manifest.scripts[w].split(" ");return _.length<2||_[0]!=="node"||!_[1]?(this.logService.warn(o.identifier.id,o.manifest.version,`${w} should be a node script`),null):{script:(0,k.join)(o.location.fsPath,_[1]),args:_.slice(2)||[]}}return null}runLifecycleHook(o,a,w,_,A){return new Promise((d,l)=>{const c=this.start(o,a,w,A);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?l(r):d(void 0)};c.on("error",r=>{n((0,S.toErrorMessage)(r)||"Unknown")}),c.on("exit",(r,s)=>{n(r?`post-${a} process exited with code ${r}`:void 0)}),_&&(t=setTimeout(()=>{t=null,c.kill(),l("timed out")},5e3))})}start(o,a,w,_){const A={silent:!0,execArgv:void 0},d=(0,C.fork)(o,[`--type=extension-post-${a}`,...w],A);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const l=f.Event.fromNodeEventEmitter(d.stdout,"data"),c=f.Event.fromNodeEventEmitter(d.stderr,"data");l(r=>this.logService.info(_.identifier.id,_.manifest.version,`post-${a}`,r)),c(r=>this.logService.error(_.identifier.id,_.manifest.version,`post-${a}`,r));const t=f.Event.any(f.Event.map(l,r=>({data:`%c${r}`,format:[""]})),f.Event.map(c,r=>({data:`%c${r}`,format:["color: red"]})));return f.Event.debounce(t,(r,s)=>r?{data:r.data+s.data,format:[...r.format,...s.format]}:{data:s.data,format:s.format},100)(r=>{console.group(_.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),d}getExtensionStoragePath(o){return(0,k.join)(this.environmentService.globalStorageHome.fsPath,o.identifier.id.toLowerCase())}};p=Oe([xe(0,I.IEnvironmentService),xe(1,b.ILogService)],p),e.ExtensionsLifecycle=p}),define(de[185],me([0,1,2,27,6,22,3,33,17,16]),function(Y,e,E,b,C,S,k,R,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends E.Disposable{constructor(p,D,o,a){super();this.extensionsManagementService=p,this.logService=a,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(A=>{this.installedExtensions=A.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(A=>this.onInstallExtension(A))),this._register(p.onDidInstallExtension(A=>this.onDidInstallExtension(A))),this._register(p.onDidUninstallExtension(A=>this.onDidUninstallExtension(A)));const w=k.URI.file(o.extensionsPath),_=new f.ExtUri(A=>!D.hasCapability(A,1024));this._register(D.watch(w)),this._register(C.Event.filter(D.onDidFilesChange,A=>A.changes.some(d=>this.doesChangeAffects(d,w,_)))(()=>this.onDidChange()))}doesChangeAffects(p,D,o){return o.isEqual(o.dirname(p.resource),D)?o.isEqual(p.resource,o.joinPath(D,".obsolete"))?!0:!(p.type!==1&&p.type!==2||o.basename(p.resource).startsWith(".")):!1}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtension(p){this.removeInstallingExtension(p.identifier),p.error||this.addInstalledExtension(p.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(D=>!(0,R.areSameExtensions)(D,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(D=>!(0,R.areSameExtensions)(D,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(1),D=p.filter(a=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,R.areSameExtensions)(w,a.identifier))?!1:a.installedTimestamp&&a.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",a.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",a.identifier.id),!1)),o=this.installedExtensions.filter(a=>this.installingExtensions.some(w=>(0,R.areSameExtensions)(w,a))?!1:p.every(w=>!(0,R.areSameExtensions)(w.identifier,a))?(this.logService.info("Detected extension removed from another source",a.id),!0):!1);this.installedExtensions=p.map(a=>a.identifier),(D.length||o.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D,removed:o})}}};i=Oe([xe(1,S.IFileService),xe(2,b.INativeEnvironmentService),xe(3,m.ILogService)],i),e.ExtensionsWatcher=i}),define(de[89],me([0,1,21,15,61,32,2,27,14,33,16,60,19,6,8,4]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let w=class extends k.Disposable{constructor(d,l,c){super();this.extensionManagementService=d,this.logService=c,this._onDidLanguagesChange=this._register(new D.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new _(l,c)),this._register(d.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(d.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(d=>{const l=["en",...Object.keys(d)];return(0,p.distinct)(l)})}onDidInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",d.identifier.id),this.update().then(l=>{l&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(d){this.cache.getLanguagePacks().then(l=>{Object.keys(l).some(c=>l[c]&&l[c].extensions.some(t=>(0,m.areSameExtensions)(t.extensionIdentifier,d)))&&(this.logService.debug("Removing language packs from the extension",d.id),this.update().then(c=>{c&&this._onDidLanguagesChange.fire()}))})}async update(){const[d,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(l);return!(0,p.equals)(Object.keys(d),Object.keys(c))}};w=Oe([xe(0,S.IExtensionManagementService),xe(1,R.INativeEnvironmentService),xe(2,i.ILogService)],w),e.LocalizationsService=w;let _=class extends k.Disposable{constructor(d,l){super();this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,a.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(l=>{Object.keys(l).forEach(c=>delete l[c]),this.createLanguagePacksFromExtensions(l,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...l){for(const c of l)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,c);Object.keys(d).forEach(c=>this.updateHash(d[c]))}createLanguagePacksFromExtension(d,l){const c=l.identifier,t=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const n of t)if(l.location.scheme===o.Schemas.file&&(0,I.isValidLocalization)(n)){let r=d[n.languageId];r||(r={hash:"",extensions:[],translations:{}},d[n.languageId]=r);let s=r.extensions.filter(u=>(0,m.areSameExtensions)(u.extensionIdentifier,c))[0];s?s.version=l.manifest.version:r.extensions.push({extensionIdentifier:c,version:l.manifest.version});for(const u of n.translations)r.translations[u.id]=(0,a.join)(l.location.fsPath,u.path)}}updateHash(d){if(d){const l=(0,C.createHash)("md5");for(const c of d.extensions)l.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);d.hash=l.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return b.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch(t){return{}}}).then(c=>(l=d(c),c)).then(c=>{for(const n of Object.keys(c))c[n]||delete c[n];this.languagePacks=c,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,E.writeFile)(this.languagePacksFilePath,t)}).then(()=>l,c=>this.logService.error(c))})}};_=Oe([xe(0,R.INativeEnvironmentService),xe(1,i.ILogService)],_)}),define(de[90],me([0,1,16,6,3]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(p){this.service=p,this.onDidChangeLogLevel=b.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,D){switch(D){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${D}`)}async call(p,D,o){switch(D){case"setLevel":return this.service.setLevel(o)}throw new Error(`Call not found: ${D}`)}}e.LogLevelChannel=S;class k{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){k.setLevel(this.channel,p)}static setLevel(p,D){return p.call("setLevel",D)}}e.LogLevelChannelClient=k;class R{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,D){throw new Error(`Event not found: ${D}`)}async call(p,D,o){switch(D){case"createLogger":this.createLogger(C.URI.revive(o[0]),o[1]);return;case"log":return this.log(C.URI.revive(o[0]),o[1]);case"consoleLog":return this.consoleLog(o[0],o[1])}throw new Error(`Call not found: ${D}`)}createLogger(p,D){this.loggers.set(p.toString(),this.loggerService.createLogger(p,D))}consoleLog(p,D){let o=console.log;switch(p){case E.LogLevel.Error:o=console.error;break;case E.LogLevel.Warning:o=console.warn;break;case E.LogLevel.Info:o=console.info;break}o.call(console,...D)}log(p,D){const o=this.loggers.get(p.toString());if(!o)throw new Error("Create the logger before logging");for(const[a,w]of D)switch(a){case E.LogLevel.Trace:o.trace(w);break;case E.LogLevel.Debug:o.debug(w);break;case E.LogLevel.Info:o.info(w);break;case E.LogLevel.Warning:o.warn(w);break;case E.LogLevel.Error:o.error(w);break;case E.LogLevel.Critical:o.critical(w);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class f extends E.AbstractLoggerService{constructor(p,D,o){super(p,D);this.channel=o}createConsoleMainLogger(){return new E.AdapterLogger({log:(p,D)=>{this.channel.call("consoleLog",[p,D])}})}doCreateLogger(p,D,o){return new m(this.channel,p,D,o)}}e.LoggerChannelClient=f;class m extends E.AbstractMessageLogger{constructor(p,D,o,a){super(a==null?void 0:a.always);this.channel=p,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(o),this.channel.call("createLogger",[D,a]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,D){const o=[[p,D]];this.isLoggerCreated?this.doLog(o):this.buffer.push(...o)}doLog(p){this.channel.call("log",[this.file,p])}}class i extends E.LogService{constructor(p,D){super(D);this.parent=p,this._register(p.onDidChangeLogLevel(o=>D.setLevel(o)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=i}),define(de[91],me([0,1,16,22]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(f,m,i,I){try{const p=await new Promise((D,o)=>{Y(["spdlog"],D,o)});return p.setAsyncMode(8192,500),p.createRotatingLoggerAsync(f,m,i,I)}catch(p){console.error(p)}return null}function S(f,m,i,I){return Y.__$__nodeRequire("spdlog").createRotatingLogger(f,m,i,I)}e.createRotatingLogger=S;function k(f,m,i){switch(m){case E.LogLevel.Trace:f.trace(i);break;case E.LogLevel.Debug:f.debug(i);break;case E.LogLevel.Info:f.info(i);break;case E.LogLevel.Warning:f.warn(i);break;case E.LogLevel.Error:f.error(i);break;case E.LogLevel.Critical:f.critical(i);break;default:throw new Error("Invalid log level")}}class R extends E.AbstractMessageLogger{constructor(m,i,I,p){super();this.name=m,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(D=>{this._logger&&this._logger.setLevel(D)}))}_createSpdLogLogger(){const m=this.rotating?6:1,i=30/m*b.ByteSize.MB;return C(this.name,this.filepath,i,m).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:p,message:D}of this.buffer)k(this._logger,p,D);this.buffer=[]}})}log(m,i){this._logger?k(this._logger,m,i):this.getLevel()<=m&&this.buffer.push({level:m,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=R}),define(de[186],me([0,1,7,152,72]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var k;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(f){function m(o,a){return a-o}f.compare=m;const i=Object.create(null);i[f.Error]=(0,b.localize)(0,null),i[f.Warning]=(0,b.localize)(1,null),i[f.Info]=(0,b.localize)(2,null);function I(o){return i[o]||""}f.toString=I;function p(o){switch(o){case C.default.Error:return f.Error;case C.default.Warning:return f.Warning;case C.default.Info:return f.Info;case C.default.Ignore:return f.Hint}}f.fromSeverity=p;function D(o){switch(o){case f.Error:return C.default.Error;case f.Warning:return C.default.Warning;case f.Info:return C.default.Info;case f.Hint:return C.default.Ignore}}f.toSeverity=D}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(f){const m="";function i(p){return I(p,!0)}f.makeKey=i;function I(p,D){let o=[m];return p.source?o.push(p.source.replace("\xA6","\\\xA6")):o.push(m),p.code?typeof p.code=="string"?o.push(p.code.replace("\xA6","\\\xA6")):o.push(p.code.value.replace("\xA6","\\\xA6")):o.push(m),p.severity!==void 0&&p.severity!==null?o.push(k.toString(p.severity)):o.push(m),p.message&&D?o.push(p.message.replace("\xA6","\\\xA6")):o.push(m),p.startLineNumber!==void 0&&p.startLineNumber!==null?o.push(p.startLineNumber.toString()):o.push(m),p.startColumn!==void 0&&p.startColumn!==null?o.push(p.startColumn.toString()):o.push(m),p.endLineNumber!==void 0&&p.endLineNumber!==null?o.push(p.endLineNumber.toString()):o.push(m),p.endColumn!==void 0&&p.endColumn!==null?o.push(p.endColumn.toString()):o.push(m),o.push(m),o.join("\xA6")}f.makeKeyOptionalMessage=I})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(de[187],me([0,1,72,7,6]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,b.createDecorator)("notificationService");var S;(function(m){m[m.WORKSPACE=0]="WORKSPACE",m[m.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(m){m[m.OFF=0]="OFF",m[m.SILENT=1]="SILENT",m[m.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new f,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=R;class f{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=f}),define(de[30],me([0,1,8,5,24,17]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof b.globals.vscode!="undefined"){const R=b.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Y==null?void 0:Y.__$__nodeRequire)=="function"){const R=(0,S.dirname)(E.FileAccess.asFileUri("",Y));k=Y.__$__nodeRequire((0,S.joinPath)(R,"product.json").fsPath);const f=Y.__$__nodeRequire((0,S.joinPath)(R,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:f.version})}else k={webBuiltInExtensions:[{name:"ms-vscode.remotehub",version:"0.5.3",repo:"https://github.com/microsoft/vscode-remotehub",metadata:{id:"ed0ffe1d-36f0-49a0-bafe-da68355eb33a",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vscode.test-adapter-converter","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","dbaeumer.vscode-eslint","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"ms-python.python":{default:!1},"ms-vscode.cpptools":{default:!1},"dbaeumer.vscode-eslint":{default:!1},"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"eamodio.gitlens":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"vscjava.vscode-java-debug":{default:!1},"octref.vetur":{default:!1},"ms-azuretools.vscode-docker":{default:!1},"vscjava.vscode-maven":{default:!1},"vscjava.vscode-java-test":{default:!1},"vscjava.vscode-java-pack":{default:!1},"formulahendry.code-runner":{default:!1},"felixfbecker.php-intellisense":{default:!1},"vscjava.vscode-java-dependency":{default:!1},"redhat.vscode-yaml":{default:!1},"felixfbecker.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"ms-vscode.PowerShell":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"ms-vscode-remote.remote-wsl":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"DavidAnson.vscode-markdownlint":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"felixfbecker.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"msjsdiag.vscode-react-native":{default:!1},"Dart-Code.dart-code":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"batisteo.vscode-django":{default:!1},"alefragnani.project-manager":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"GrapeCity.gc-excelviewer":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.27",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.6",repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.80",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.13",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.56.2",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.9",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.56.1",commit:"e713fe9b05fc24facbec8f34fb1017133858842b",date:"2021-05-06T09:56:45.660Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.56.0-dev",nameShort:b.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:b.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=k}),define(de[92],me([0,1,150,18,22,12,30]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(I,p,D,o,a,w){let _;try{await f(I,p,D,o,a,w)}catch(A){_=A}finally{_&&a.errorTransformer&&(_=a.errorTransformer(_)),typeof _!="undefined"&&D.error(_),D.end()}}e.readFileIntoStream=R;async function f(I,p,D,o,a,w){m(w);const _=await I.open(p,{create:!1});try{m(w);let A=0,d=0,l=a&&typeof a.length=="number"?a.length:void 0,c=b.VSBuffer.alloc(Math.min(a.bufferSize,typeof l=="number"?l:a.bufferSize)),t=a&&typeof a.position=="number"?a.position:0,n=0;do d=await I.read(_,t,c.buffer,n,c.byteLength-n),t+=d,n+=d,A+=d,typeof l=="number"&&(l-=d),n===c.byteLength&&(await D.write(o(c)),c=b.VSBuffer.alloc(Math.min(a.bufferSize,typeof l=="number"?l:a.bufferSize)),n=0);while(d>0&&(typeof l!="number"||l>0)&&m(w)&&i(A,a));if(n>0){let r=n;typeof l=="number"&&(r=Math.min(n,l)),D.write(o(c.slice(0,r)))}}catch(A){throw(0,C.ensureFileSystemProviderError)(A)}finally{await I.close(_)}}function m(I){if(I.isCancellationRequested)throw(0,S.canceled)();return!0}function i(I,p){if(p==null?void 0:p.limits){if(typeof p.limits.memory=="number"&&I>p.limits.memory)throw(0,C.createFileSystemProviderError)((0,E.localize)(0,null,k.default.nameShort),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&I>p.limits.size)throw(0,C.createFileSystemProviderError)((0,E.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(de[93],me([0,1,148,47,2,22,6,17,26,19,16,18,41,14,28,8,92,50]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let A=class extends C.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const t=new C.DisposableStore;return t.add(c.onDidChangeFile(n=>this._onDidFilesChange.fire(new S.FileChangesEvent(n,!this.isPathCaseSensitive(c))))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,C.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){c.push(t)}}),!this.provider.has(l)&&await D.Promises.settled(c)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,c){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return _.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,R.isAbsolutePath)(l))throw new S.FileOperationError((0,E.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,E.localize)(1,null,l.toString()),t}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasReadWriteCapability)(c)||(0,S.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,E.localize)(2,null,this.resourceForError(l)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(l,c){const t=await this.withProvider(l),n=this.isPathCaseSensitive(t),r=c==null?void 0:c.resolveTo,s=c==null?void 0:c.resolveSingleChildDescendants,u=c==null?void 0:c.resolveMetadata,h=await t.stat(l);let y;return this.toFileStat(t,l,h,void 0,!!u,(P,v)=>(y||(y=f.TernarySearchTree.forUris(()=>!n),y.set(l,!0),(0,m.isNonEmptyArray)(r)&&r.forEach(g=>y.set(g,!0))),Boolean(y.findSuperstr(P.resource)||y.get(P.resource))?!0:P.isDirectory&&s?v===1:!1))}async toFileStat(l,c,t,n,r,s){const{providerExtUri:u}=this.getExtUri(l),h={resource:c,name:u.basename(c),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(h.isDirectory&&s(h,n)){try{const y=await l.readdir(c),P=await D.Promises.settled(y.map(async([v,g])=>{try{const F=u.joinPath(c,v),O=r?await l.stat(F):{type:g};return await this.toFileStat(l,F,O,y.length,r,s)}catch(F){return this.logService.trace(F),null}}));h.children=(0,m.coalesce)(P)}catch(y){this.logService.trace(y),h.children=[]}return h}return h}async resolveAll(l){return D.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(t){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(t){return t}return!0}async doValidateCreateFile(l,c){if(!(c==null?void 0:c.overwrite)&&await this.exists(l))throw new S.FileOperationError((0,E.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=I.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const n=await this.writeFile(l,c);return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,n)),n}async writeFile(l,c,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,l,t)||await this.mkdirp(n,r.dirname(l));let u;if((0,S.hasReadWriteCapability)(n)&&!(c instanceof I.VSBuffer))if((0,p.isReadableStream)(c)){const h=await(0,p.peekStream)(c,3);h.ended?u=I.VSBuffer.concat(h.buffer):u=h}else u=(0,p.peekReadable)(c,h=>I.VSBuffer.concat(h),3);else u=c;!(0,S.hasOpenReadWriteCloseCapability)(n)||(0,S.hasReadWriteCapability)(n)&&u instanceof I.VSBuffer?await this.doWriteUnbuffered(n,l,t,u):await this.doWriteBuffered(n,l,t,u instanceof I.VSBuffer?(0,I.bufferToReadable)(u):u)}catch(s){throw new S.FileOperationError((0,E.localize)(4,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(c)));let r;try{r=await l.stat(c)}catch(s){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,E.localize)(6,null,this.resourceForError(c)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:r.size}))throw new S.FileOperationError((0,E.localize)(7,null),3,t);return r}async readFile(l,c){const t=await this.withReadProvider(l);return(c==null?void 0:c.atomic)?this.doReadFileAtomic(t,l,c):this.doReadFile(t,l,c)}async doReadFileAtomic(l,c,t){return new Promise((n,r)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,c,t);n(s)}catch(s){r(s)}})})}async doReadFile(l,c,t){const n=await this.doReadFileStream(l,c,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,I.streamToBuffer)(n.value)})}async readFileStream(l,c){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,c)}async doReadFileStream(l,c,t){const n=new o.CancellationTokenSource,r=this.validateReadFile(c,t).then(u=>u,u=>{throw n.cancel(),u});let s;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasFileReadStreamCapability)(l))||(0,S.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?s=this.readFileUnbuffered(l,c,t):(0,S.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,c,n.token,t):s=this.readFileBuffered(l,c,n.token,t);const u=await r;return Object.assign(Object.assign({},u),{value:s})}catch(u){throw s&&await(0,p.consumeStream)(s),new S.FileOperationError((0,E.localize)(8,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),t)}}readFileStreamed(l,c,t,n=Object.create(null)){const r=l.readFileStream(c,n,t);return(0,p.transform)(r,{data:s=>s instanceof I.VSBuffer?s:I.VSBuffer.wrap(s),error:s=>new S.FileOperationError((0,E.localize)(9,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),n)},s=>I.VSBuffer.concat(s))}readFileBuffered(l,c,t,n=Object.create(null)){const r=(0,I.newWriteableBufferStream)();return(0,w.readFileIntoStream)(l,c,r,s=>s,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new S.FileOperationError((0,E.localize)(10,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),n)}),t),r}readFileUnbuffered(l,c,t){const n=(0,p.newWriteableStream)(r=>I.VSBuffer.concat(r));return(async()=>{try{let r=await l.readFile(c);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(c,r.byteLength,t),n.end(I.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(l,c){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,E.localize)(11,null,this.resourceForError(l)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==S.ETAG_DISABLED&&c.etag===t.etag)throw new S.FileOperationError((0,E.localize)(12,null),2,c);return this.validateReadFileLimits(l,t.size,c),t}validateReadFileLimits(l,c,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&c>t.limits.size&&(n=7),typeof n=="number")throw new S.FileOperationError((0,E.localize)(13,null,this.resourceForError(l)),n)}}async canMove(l,c,t){return this.doCanMoveCopy(l,c,"move",t)}async canCopy(l,c,t){return this.doCanMoveCopy(l,c,"copy",t)}async doCanMoveCopy(l,c,t,n){if(l.toString()!==c.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,l,s,c,t,n)}catch(r){return r}return!0}async move(l,c,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(n,l,r,c,"move",!!t),u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,s==="move"?2:3,u)),u}async copy(l,c,t){const n=await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(n,l,r,c,"copy",!!t),u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,s==="copy"?3:2,u)),u}async doMoveCopy(l,c,t,n,r,s){if(c.toString()===n.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(l,c,t,n,r,s);if(u&&!h&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),r==="copy"){if(l===t&&(0,S.hasFileFolderCopyCapability)(l))await l.copy(c,n,{overwrite:s});else{const y=await this.resolve(c);y.isDirectory?await this.doCopyFolder(l,y,t,n):await this.doCopyFile(l,c,t,n)}return r}else return l===t?(await l.rename(c,n,{overwrite:s}),r):(await this.doMoveCopy(l,c,t,n,"copy",s),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,t,n){if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,c,t,n);if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,c,t,n);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,c,t,n);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,c,t,n)}async doCopyFolder(l,c,t,n){await t.mkdir(n),Array.isArray(c.children)&&await D.Promises.settled(c.children.map(async r=>{const s=this.getExtUri(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(l,await this.resolve(r.resource),t,s):this.doCopyFile(l,r.resource,t,s)}))}async doValidateMoveCopy(l,c,t,n,r,s){let u=!1;if(l===t){const{providerExtUri:y,isPathCaseSensitive:P}=this.getExtUri(l);if(P||(u=y.isEqual(c,n)),u&&r==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(c),this.resourceForError(n)));if(!u&&y.isEqualOrParent(n,c))throw new Error((0,E.localize)(15,null,this.resourceForError(c),this.resourceForError(n)))}const h=await this.exists(n);if(h&&!u){if(!s)throw new S.FileOperationError((0,E.localize)(16,null,this.resourceForError(c),this.resourceForError(n)),4);if(l===t){const{providerExtUri:y}=this.getExtUri(l);if(y.isEqualOrParent(c,n))throw new Error((0,E.localize)(17,null,this.resourceForError(c),this.resourceForError(n)))}}return{exists:h,isSameResourceWithDifferentPathCase:u}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,t)),t}async mkdirp(l,c){const t=[],{providerExtUri:n}=this.getExtUri(l);for(;!n.isEqual(c,n.dirname(c));)try{if(((await l.stat(c)).type&S.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(c)),c=n.dirname(c)}for(let r=t.length-1;r>=0;r--){c=n.joinPath(c,t[r]);try{await l.mkdir(c)}catch(s){if((0,S.toFileSystemProviderErrorCode)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(t){return t}return!0}async doValidateDelete(l,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(c==null?void 0:c.useTrash)&&!(t.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(l)));const r=await this.exists(l);if(!r)throw new S.FileOperationError((0,E.localize)(20,null,this.resourceForError(l)),1);if(!!!(c==null?void 0:c.recursive)&&r){const u=await this.resolve(l);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(l)))}return t}async del(l,c){const t=await this.doValidateDelete(l,c),n=!!(c==null?void 0:c.useTrash),r=!!(c==null?void 0:c.recursive);await t.delete(l,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new S.FileOperationEvent(l,1))}watch(l,c={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(l,c).then(r=>{t?(0,C.dispose)(r):n=()=>(0,C.dispose)(r)},r=>this.logService.error(r)),(0,C.toDisposable)(()=>n())}async doWatch(l,c){const t=await this.withProvider(l),n=this.toWatchKey(t,l,c),r=this.activeWatchers.get(n)||{count:0,disposable:t.watch(l,c)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,C.toDisposable)(()=>{r.count--,r.count===0&&((0,C.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(l,c,t){const{providerExtUri:n}=this.getExtUri(l);return[n.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,C.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,c,t,n){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{var r;const s=await l.open(c,{create:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1});try{(0,p.isReadableStream)(n)||(0,p.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(l,s,n):await this.doWriteReadableBufferedQueued(l,s,n)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,c,t){let n=0,r;if((0,p.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=I.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,c,s,s.byteLength,n,0),n+=s.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(s,u)=>{(0,p.listenStream)(r,{onData:async h=>{r.pause();try{await this.doWriteBuffer(l,c,h,h.byteLength,n,0)}catch(y){return u(y)}n+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>u(h),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,c,t){let n=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(l,c,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(l,c,t,n,r,s){let u=0;for(;u<n;)u+=await l.write(c,r+u,t.buffer,s+u,n-u)}async doWriteUnbuffered(l,c,t,n){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,t,n))}async doWriteUnbufferedQueued(l,c,t,n){var r;let s;n instanceof I.VSBuffer?s=n:(0,p.isReadableStream)(n)?s=await(0,I.streamToBuffer)(n):(0,p.isReadableBufferedStream)(n)?s=await(0,I.bufferedStreamToBuffer)(n):s=(0,I.readableToBuffer)(n),await l.writeFile(c,s.buffer,{create:!0,overwrite:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(l,c,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,t,n))}async doPipeBufferedQueued(l,c,t,n){let r,s;try{r=await l.open(c,{create:!1}),s=await t.open(n,{create:!0,unlock:!1});const u=I.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,y=0,P=0;do P=await l.read(r,h,u.buffer,y,u.byteLength-y),await this.doWriteBuffer(t,s,u,P,h,y),h+=P,y+=P,y===u.byteLength&&(y=0);while(P>0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await D.Promises.settled([typeof r=="number"?l.close(r):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,c,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,t,n))}async doPipeUnbufferedQueued(l,c,t,n){return t.writeFile(n,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,t,n))}async doPipeUnbufferedToBufferedQueued(l,c,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const s=await l.readFile(c);await this.doWriteBuffer(t,r,I.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(l,c,t,n){const r=await(0,I.streamToBuffer)(this.readFileBuffered(l,c,o.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,r)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new S.FileOperationError((0,E.localize)(22,null,this.resourceForError(c)),6);return l}resourceForError(l){return l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}};A=Oe([xe(0,i.ILogService)],A),e.FileService=A}),define(de[62],me([0,1,15,78,2,22,6,5,21,4,17,29,14,16,151,87,171,173,170,181,41,92,19,18]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A,d,l,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends C.Disposable{constructor(u,h){var y;super();this.logService=u,this.options=h,this.BUFFER_SIZE=((y=this.options)===null||y===void 0?void 0:y.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new p.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:h,symbolicLink:y}=await f.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(h,y),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size}}catch(h){throw this.toFileSystemProviderError(h)}}async readdir(u){try{const h=await(0,f.readdir)(this.toFilePath(u),{withFileTypes:!0}),y=[];return await Promise.all(h.map(async P=>{try{let v;P.isSymbolicLink()?v=(await this.stat((0,i.joinPath)(u,P.name))).type:v=this.toType(P),y.push([P.name,v])}catch(v){this.logService.trace(v)}})),y}catch(h){throw this.toFileSystemProviderError(h)}}toType(u,h){let y;return(h==null?void 0:h.dangling)?y=S.FileType.Unknown:u.isFile()?y=S.FileType.File:u.isDirectory()?y=S.FileType.Directory:y=S.FileType.Unknown,h&&(y|=S.FileType.SymbolicLink),y}async readFile(u){try{const h=this.toFilePath(u);return await E.promises.readFile(h)}catch(h){throw this.toFileSystemProviderError(h)}}readFileStream(u,h,y){const P=(0,l.newWriteableStream)(v=>n.VSBuffer.concat(v.map(g=>n.VSBuffer.wrap(g))).buffer);return(0,c.readFileIntoStream)(this,u,P,v=>v.buffer,Object.assign(Object.assign({},h),{bufferSize:this.BUFFER_SIZE}),y),P}async writeFile(u,h,y){let P;try{const v=this.toFilePath(u);if(!y.create||!y.overwrite){if(await(0,f.exists)(v)){if(!y.overwrite)throw(0,S.createFileSystemProviderError)((0,o.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!y.create)throw(0,S.createFileSystemProviderError)((0,o.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}P=await this.open(u,{create:!0,unlock:y.unlock}),await this.write(P,0,h,0,h.byteLength)}catch(v){throw await this.toFileSystemProviderWriteError(u,v)}finally{typeof P=="number"&&await this.close(P)}}async open(u,h){try{const y=this.toFilePath(u);if((0,S.isFileOpenForWriteOptions)(h)&&h.unlock)try{const{stat:g}=await f.SymlinkSupport.stat(y);g.mode&128||await E.promises.chmod(y,g.mode|128)}catch(g){this.logService.trace(g)}let P;if((0,S.isFileOpenForWriteOptions)(h)){if(R.isWindows)try{await E.promises.truncate(y,0),P="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}P||(P="w")}else P="r";const v=await(0,b.promisify)(E.open)(y,P);return this.mapHandleToPos.set(v,0),(0,S.isFileOpenForWriteOptions)(h)&&this.writeHandles.set(v,u),v}catch(y){throw(0,S.isFileOpenForWriteOptions)(h)?await this.toFileSystemProviderWriteError(u,y):this.toFileSystemProviderError(y)}}async close(u){try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&this.canFlush)try{await(0,b.promisify)(E.fdatasync)(u)}catch(h){this.canFlush=!1,this.logService.error(h)}return await(0,b.promisify)(E.close)(u)}catch(h){throw this.toFileSystemProviderError(h)}}async read(u,h,y,P,v){const g=this.normalizePos(u,h);let F=null;try{const O=await(0,b.promisify)(E.read)(u,y,P,v,g);return typeof O=="number"?F=O:F=O.bytesRead,F}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(u,g,F)}}normalizePos(u,h){return h===this.mapHandleToPos.get(u)?null:h}updatePos(u,h,y){const P=this.mapHandleToPos.get(u);typeof P=="number"&&(typeof h=="number"||(typeof y=="number"?this.mapHandleToPos.set(u,P+y):this.mapHandleToPos.delete(u)))}async write(u,h,y,P,v){return(0,p.retry)(()=>this.doWrite(u,h,y,P,v),100,3)}async doWrite(u,h,y,P,v){const g=this.normalizePos(u,h);let F=null;try{const O=await(0,b.promisify)(E.write)(u,y,P,v,g);return typeof O=="number"?F=O:F=O.bytesWritten,F}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),O)}finally{this.updatePos(u,g,F)}}async mkdir(u){try{await E.promises.mkdir(this.toFilePath(u))}catch(h){throw this.toFileSystemProviderError(h)}}async delete(u,h){try{const y=this.toFilePath(u);await this.doDelete(y,h)}catch(y){throw this.toFileSystemProviderError(y)}}async doDelete(u,h){h.recursive?await(0,f.rimraf)(u,f.RimRafMode.MOVE):await E.promises.unlink(u)}async rename(u,h,y){const P=this.toFilePath(u),v=this.toFilePath(h);if(P!==v)try{await this.validateTargetDeleted(u,h,"move",y.overwrite),await(0,f.move)(P,v)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,o.localize)(2,null,(0,m.basename)(P),(0,m.basename)((0,m.dirname)(v)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(u,h,y){const P=this.toFilePath(u),v=this.toFilePath(h);if(P!==v)try{await this.validateTargetDeleted(u,h,"copy",y.overwrite),await(0,f.copy)(P,v,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,o.localize)(3,null,(0,m.basename)(P),(0,m.basename)((0,m.dirname)(v)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(u,h,y,P){const v=this.toFilePath(u),g=this.toFilePath(h);let F=!1;if(!!(this.capabilities&1024)||(F=(0,I.isEqual)(v,g,!0)),F&&y==="copy")throw(0,S.createFileSystemProviderError)((0,o.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!F&&await(0,f.exists)(g)){if(!P)throw(0,S.createFileSystemProviderError)((0,o.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(h,{recursive:!0,useTrash:!1})}}watch(u,h){return h.recursive?this.watchRecursive(u,h.excludes):this.watchNonRecursive(u)}watchRecursive(u,h){const y={path:this.toFilePath(u),excludes:h},P=(0,t.insert)(this.recursiveFoldersToWatch,y);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{P(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var u,h,y;if(this.recursiveWatcher instanceof A.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let P,v;((h=(u=this.options)===null||u===void 0?void 0:u.watcher)===null||h===void 0?void 0:h.usePolling)?(P=w.FileWatcher,v=(y=this.options)===null||y===void 0?void 0:y.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?P=_.FileWatcher:P=w.FileWatcher:P=A.FileWatcher,this.recursiveWatcher=new P(this.recursiveFoldersToWatch,g=>this._onDidChangeFile.fire((0,a.toFileChanges)(g)),g=>{g.type==="error"&&this._onDidWatchErrorOccur.fire(g.message),this.logService[g.type](g.message)},this.logService.getLevel()===D.LogLevel.Trace,v),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))}}watchNonRecursive(u){const h=new d.FileWatcher(this.toFilePath(u),P=>this._onDidChangeFile.fire((0,a.toFileChanges)(P)),P=>{P.type==="error"&&this._onDidWatchErrorOccur.fire(P.message),this.logService[P.type](P.message)},this.logService.getLevel()===D.LogLevel.Trace),y=this.logService.onDidChangeLogLevel(()=>{h.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)});return(0,C.combinedDisposable)(h,y)}toFilePath(u){return(0,m.normalize)(u.fsPath)}toFileSystemProviderError(u){if(u instanceof S.FileSystemProviderError)return u;let h;switch(u.code){case"ENOENT":h=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":h=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":h=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":h=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":h=S.FileSystemProviderErrorCode.NoPermissions;break;default:h=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(u,h)}async toFileSystemProviderWriteError(u,h){let y=this.toFileSystemProviderError(h);if(u&&y.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:P}=await f.SymlinkSupport.stat(this.toFilePath(u));P.mode&128||(y=(0,S.createFileSystemProviderError)(h,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(P){this.logService.trace(P)}return y}dispose(){super.dispose(),(0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,C.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(de[44],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService")}),define(de[31],me([0,1,11,108]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(k,R){b.ok(E.isString(k)),b.ok(E.isObject(R)),b.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,R)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new C}),define(de[188],me([0,1,31,6]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class S{constructor(){this._onDidChangeSchema=new b.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,m){this.schemasById[C(f)]=m,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new S;E.Registry.add(e.Extensions.JSONContribution,k)}),define(de[38],me([0,1,139,6,31,11,188]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=C.Registry.as(k.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(_,A=!0){this.registerConfigurations([_],A)}registerConfigurations(_,A=!0){const d=[];_.forEach(l=>{d.push(...this.validateAndRegisterProperties(l,A,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(_){const A=[],d=l=>{if(l.properties)for(const c in l.properties)A.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,l.properties[c]);l.allOf&&l.allOf.forEach(c=>d(c))};for(const l of _){d(l);const c=this.configurationContributors.indexOf(l);c!==-1&&this.configurationContributors.splice(c,1)}f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(A)}registerDefaultConfigurations(_){const A=[],d=[];for(const l of _)for(const c in l)if(A.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),l[c]);const t={type:"object",default:this.defaultValues[c],description:E.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};d.push(I(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=l[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(A)}deregisterDefaultConfigurations(_){const A=[];for(const d of _)for(const l in d)if(A.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const c=this.configurationProperties[l];c&&(this.updatePropertyDefaultValue(l,c),this.updateSchema(l,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(A)}notifyConfigurationSchemaUpdated(..._){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(_){for(const A of _)this.overrideIdentifiers.add(A);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(_,A=!0,d,l=3){var c;l=S.isUndefinedOrNull(_.scope)?l:_.scope;let t=[],n=_.properties;if(n)for(let s in n){if(A&&o(s)){delete n[s];continue}const u=n[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=S.isUndefinedOrNull(u.scope)?l:u.scope,u.restricted=S.isUndefinedOrNull(u.restricted)?!!((c=d==null?void 0:d.restrictedConfigurations)===null||c===void 0?void 0:c.includes(s)):u.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let r=_.allOf;if(r)for(let s of r)t.push(...this.validateAndRegisterProperties(s,A,d,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(_){const A=d=>{let l=d.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let c=d.allOf;c&&c.forEach(A)};A(_)}updateSchema(_,A){switch(e.allSettings.properties[_]=A,A.scope){case 1:e.applicationSettings.properties[_]=A;break;case 2:e.machineSettings.properties[_]=A;break;case 6:e.machineOverridableSettings.properties[_]=A;break;case 3:e.windowSettings.properties[_]=A;break;case 4:e.resourceSettings.properties[_]=A;break;case 5:e.resourceSettings.properties[_]=A,this.resourceLanguageSettingsSchema.properties[_]=A;break}}removeFromSchema(_,A){switch(delete e.allSettings.properties[_],A.scope){case 1:delete e.applicationSettings.properties[_];break;case 2:delete e.machineSettings.properties[_];break;case 6:delete e.machineOverridableSettings.properties[_];break;case 3:delete e.windowSettings.properties[_];break;case 4:case 5:delete e.resourceSettings.properties[_];break}}updateOverridePropertyPatternKey(){for(const _ of this.overrideIdentifiers.values()){const A=`[${_}]`,d={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(A,d),e.allSettings.properties[A]=d,e.applicationSettings.properties[A]=d,e.machineSettings.properties[A]=d,e.machineOverridableSettings.properties[A]=d,e.windowSettings.properties[A]=d,e.resourceSettings.properties[A]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(_,A){let d=this.defaultValues[_];S.isUndefined(d)&&(d=A.default),S.isUndefined(d)&&(d=p(A.type)),A.default=d}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=I;function p(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const D=new m;C.Registry.add(e.Extensions.Configuration,D);function o(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?E.localize(5,null,w):D.getConfigurationProperties()[w]!==void 0?E.localize(6,null,w):null:E.localize(4,null)}e.validateProperty=o;function a(){const w=[],_=D.getConfigurationProperties();for(const A of Object.keys(_))w.push([A,_[A].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=a}),define(de[34],me([0,1,20,11,3,31,7,38]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function f(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=f;var m;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(m=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,r){const s=r?n?r.keys.filter(F=>n.keys.indexOf(F)===-1):[...r.keys]:[],u=n?r?n.keys.filter(F=>r.keys.indexOf(F)===-1):[...n.keys]:[],h=[];if(r&&n){for(const F of n.keys)if(r.keys.indexOf(F)!==-1){const O=_(n.contents,F),x=_(r.contents,F);E.equals(O,x)||h.push(F)}}const y=[],P=F=>{const O={};for(const x of F)for(const oe of x.identifiers)O[c(oe)]=x;return O},v=r?P(r.overrides):{},g=n?P(n.overrides):{};if(Object.keys(v).length)for(const F of s){const O=v[F];O&&y.push([(0,R.overrideIdentifierFromKey)(F),O.keys])}if(Object.keys(g).length)for(const F of u){const O=g[F];O&&y.push([(0,R.overrideIdentifierFromKey)(F),O.keys])}if(Object.keys(v).length&&Object.keys(g).length)for(const F of h){const O=g[F],x=v[F];if(O&&x){const oe=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});y.push([(0,R.overrideIdentifierFromKey)(F),[...oe.added,...oe.removed,...oe.updated]])}}return{added:s,removed:u,updated:h,overrides:y}}e.compare=I;function p(n,r){const s=[];for(const u of Object.keys(n))if(R.OVERRIDE_PROPERTY_PATTERN.test(u)){const h={};for(const y in n[u])h[y]=n[u][y];s.push({identifiers:[(0,R.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(h),contents:D(h,r)})}return s}e.toOverrides=p;function D(n,r){const s=Object.create(null);for(let u in n)o(s,u,n[u],r);return s}e.toValuesTree=D;function o(n,r,s,u){const h=r.split("."),y=h.pop();let P=n;for(let v=0;v<h.length;v++){let g=h[v],F=P[g];switch(typeof F){case"undefined":F=P[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${h.slice(0,v+1).join(".")} is ${JSON.stringify(F)}`);return}P=F}if(typeof P=="object"&&P!==null)try{P[y]=s}catch(v){u(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(P)}`)}else u(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=o;function a(n,r){const s=r.split(".");w(n,s)}e.removeFromValueTree=a;function w(n,r){const s=r.shift();if(r.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const u=n[s];typeof u=="object"&&!Array.isArray(u)&&(w(u,r),Object.keys(u).length===0&&delete n[s])}}function _(n,r,s){function u(P,v){let g=P;for(const F of v){if(typeof g!="object"||g===null)return;g=g[F]}return g}const h=r.split("."),y=u(n,h);return typeof y=="undefined"?s:y}e.getConfigurationValue=_;function A(n,r,s){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in n?b.isObject(n[u])&&b.isObject(r[u])?A(n[u],r[u],s):s&&(n[u]=r[u]):n[u]=r[u])})}e.merge=A;function d(){const n=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=d;function l(){const n=Object.create(null),r=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in r){let u=r[s].default;o(n,s,u,h=>console.error(`Conflict in default settings: ${h}`))}return n}e.getDefaultValues=l;function c(n){return`[${n}]`}e.keyFromOverrideIdentifier=c;function t(n,r,s){const u=n.inspect(r),h=n.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:u.defaultValue}e.getMigratedSettingValue=t}),define(de[189],me([0,1,36,26,19,11,20,3,38,34,31,2,6]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class D{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,m.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,m.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const s of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[s],h=n[s];h&&(typeof u=="object"&&typeof h=="object"?(u=k.deepClone(u),this.mergeContents(u,h)):u=h),r[s]=u}return new D(r,this.keys,this.overrides)}merge(...t){const n=k.deepClone(this.contents),r=k.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const h of u.overrides){const[y]=r.filter(P=>C.equals(P.identifiers,h.identifiers));y?this.mergeContents(y.contents,h.contents):r.push(k.deepClone(h))}for(const h of u.keys)s.indexOf(h)===-1&&s.push(h)}return new D(n,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&S.isObject(t[r])&&S.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=k.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,m.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,m.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=D;class o extends D{constructor(){const t=(0,m.getDefaultValues)(),n=(0,m.getConfigurationKeys)(),r=[];for(const s of Object.keys(t))f.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,f.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,m.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,r)}}e.DefaultConfigurationModel=o;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:s,overrides:u,restricted:h}=this.doParseRaw(t,n);this._configurationModel=new D(r,s,u),this._restrictedConfigurations=h||[]}doParseContent(t){let n={},r=null,s=[],u=[],h=[];function y(v){Array.isArray(s)?s.push(v):r&&(s[r]=v)}let P={onObjectBegin:()=>{let v={};y(v),u.push(s),s=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let v=[];y(v),u.push(s),s=v,r=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:y,onError:(v,g,F)=>{h.push({error:v,offset:g,length:F})}};if(t)try{E.visit(t,P),n=s[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(t,n){const r=i.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,r,!0,n);t=s.raw;const u=(0,m.toValuesTree)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),h=Object.keys(t),y=(0,m.toOverrides)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:u,keys:h,overrides:y,restricted:s.restricted}}filter(t,n,r,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const u={},h=[];for(let y in t)if(f.OVERRIDE_PROPERTY_PATTERN.test(y)&&r){const P=this.filter(t[y],n,!1,s);u[y]=P.raw,h.push(...P.restricted)}else{const P=n[y],v=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&h.push(y),(v===void 0||s.scopes===void 0||s.scopes.includes(v))&&(s.skipRestricted&&(P==null?void 0:P.restricted)||(u[y]=t[y]))}return{raw:u,restricted:h}}}e.ConfigurationModelParser=a;class w extends I.Disposable{constructor(t,n,r,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(p.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new D}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class _{constructor(t,n,r=new D,s=new D,u=new b.ResourceMap,h=new D,y=new b.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=y,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new b.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new D,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const s=this.getConsolidateConfigurationModel(n,r),u=this.getFolderConfigurationModelForResource(n.resource,r),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,y=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,x=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(t):h.getValue(t),oe=s.getValue(t),W=C.distinct(C.flatten(s.overrides.map(te=>te.identifiers))).filter(te=>s.getOverrideValue(t,te)!==void 0);return{defaultValue:y,userValue:P,userLocalValue:v,userRemoteValue:g,workspaceValue:F,workspaceFolderValue:O,memoryValue:x,value:oe,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:h.getValue(t),override:n.overrideIdentifier?h.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(s=>f.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,f.overrideIdentifierFromKey)(s),h=this._defaultConfiguration.getKeysForOverrideIdentifier(u),y=t.getKeysForOverrideIdentifier(u),P=[...y.filter(v=>h.indexOf(v)===-1),...h.filter(v=>y.indexOf(v)===-1),...h.filter(v=>!k.equals(this._defaultConfiguration.override(u).getValue(v),t.override(u).getValue(v)))];return[u,P]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:s,overrides:u}=(0,m.compare)(this.localUserConfiguration,t),h=[...n,...r,...s];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:s,overrides:u}=(0,m.compare)(this.remoteUserConfiguration,t);let h=[...n,...r,...s];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:s,overrides:u}=(0,m.compare)(this.workspaceConfiguration,t);let h=[...n,...r,...s];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:s,updated:u,removed:h,overrides:y}=(0,m.compare)(r,n);let P=[...s,...u,...h];return(P.length||!r)&&this.updateFolderConfiguration(t,n),{keys:P,overrides:y}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:s,removed:u,overrides:h}=(0,m.compare)(n,void 0);return{keys:[...r,...s,...u],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const u=this._memoryConfigurationByResource.get(t);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=r.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:s,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((h,y)=>(h.set(R.URI.revive(y[0]),this.parseConfigurationModel(y[1])),h),new b.ResourceMap);return new _(n,r,new D,s,u,new D,new b.ResourceMap,!1)}static parseConfigurationModel(t){return new D(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=_;function A(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,n=new Map;for(const s of c)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,h])=>{const y=(0,b.getOrSet)(n,u,new Set);h.forEach(P=>y.add(P))});const r=[];return n.forEach((s,u)=>r.push([u,[...s.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=A;class d{constructor(t,n,r,s){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(y=>u.add(y)),t.overrides.forEach(([,y])=>y.forEach(P=>u.add(P))),this.affectedKeys=[...u.values()];const h=new D;this.affectedKeys.forEach(y=>h.setValue(y,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=_.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!k.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,m.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(t=t[s],!t)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=d;class l extends d{constructor(t,n,r,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=l}),define(de[94],me([0,1,31,38,2,34,189,6,14,17]),function(Y,e,E,b,C,S,k,R,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends C.Disposable{constructor(p,D){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,m.extUriBiasedIgnorePathCase,D)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(o=>this.onDidDefaultConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,D){const o=typeof p=="string"?p:void 0,a=(0,S.isConfigurationOverrides)(p)?p:(0,S.isConfigurationOverrides)(D)?D:{};return this.configuration.getValue(o,a,void 0)}updateValue(p,D,o,a){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const D=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(o,D,1)}onDidDefaultConfigurationChange(p){const D=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,p);this.trigger(o,D,6)}trigger(p,D,o){const a=new k.ConfigurationChangeEvent(p,{data:D},this.configuration);a.source=o,a.sourceConfig=this.getTargetConfiguration(o),this._onDidChangeConfiguration.fire(a)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(de[95],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var b;(function(k){k[k.Unknown=0]="Unknown",k[k.DisableTrust=1]="DisableTrust",k[k.MachineTrusted=2]="MachineTrusted"})(b=e.RemoteTrustOption||(e.RemoteTrustOption={}));var C;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(R,f=C.Unknown,m){super(R);this._message=R,this._code=f,this._detail=m,this.isHandled=f===C.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(R){return R instanceof S&&R._code===C.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof S&&R._code===C.NoResolverFound}static isHandled(R){return R instanceof S&&R.isHandled}}e.RemoteAuthorityResolverError=S}),define(de[190],me([0,1,8]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function b(f){return f.scheme===E.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=b;function C(f){if(!!f){const m=f.indexOf("+");return m<0?f:f.substr(0,m)}}e.getRemoteName=C;function S(f){return f.scheme!==E.Schemas.file&&f.scheme!==E.Schemas.vscodeRemote}function k(f){if(f.folders.length)return f.folders.every(m=>S(m.uri))?f.folders[0].uri:void 0;if(f.configuration&&S(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=k;function R(f){var m;return(m=k(f))===null||m===void 0?void 0:m.scheme}e.getVirtualWorkspaceScheme=R}),define(de[63],me([0,1,153,7,38,31,18]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,b.createDecorator)("requestService");function R(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}e.isSuccess=R;function f(o){return o.res.statusCode===204}async function m(o){if(!R(o))throw new Error("Server returned "+o.res.statusCode);return f(o)?null:(await(0,k.streamToBuffer)(o.stream)).toString()}e.asText=m;async function i(o){if(!R(o))throw new Error("Server returned "+o.res.statusCode);if(f(o))return null;const w=(await(0,k.streamToBuffer)(o.stream)).toString();try{return JSON.parse(w)}catch(_){throw _.message+=`:
`+w,_}}e.asJson=i;function I(o){D(o)}e.updateProxyConfigurationsScope=I;let p;function D(o){const a=S.Registry.as(C.Extensions.Configuration);p&&a.deregisterConfigurations([p]),p={id:"http",order:15,title:(0,E.localize)(0,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,E.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,E.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,E.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,E.localize)(4,null),(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],default:"override",description:(0,E.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,E.localize)(9,null),restricted:!0}}},a.registerConfiguration(p)}D(2)}),define(de[191],me([0,1,28,18]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class C{constructor(R){this.service=R}listen(R,f){throw new Error("Invalid listen")}call(R,f,m){switch(f){case"request":return this.service.request(m[0],E.CancellationToken.None).then(async({res:i,stream:I})=>{const p=await(0,b.streamToBuffer)(I);return[{statusCode:i.statusCode,headers:i.headers},p]})}throw new Error("Invalid call")}}e.RequestChannel=C;class S{constructor(R){this.channel=R}async request(R,f){return S.request(this.channel,R,f)}static async request(R,f,m){const[i,I]=await R.call("request",[f]);return{res:i,stream:(0,b.bufferToStream)(I)}}}e.RequestChannelClient=S}),define(de[192],me([0,1,64,11]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(k,R){return k.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:k.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function S(k,R,f={}){const m=(0,E.parse)(k),i=f.proxyUrl||C(m,R);if(!i)return null;const I=(0,E.parse)(i);if(!/^https?:$/.test(I.protocol||""))return null;const p={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,b.isBoolean)(f.strictSSL)?f.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((D,o)=>{Y(["http-proxy-agent"],D,o)}))(p):new(await new Promise((D,o)=>{Y(["https-proxy-agent"],D,o)}))(p)}e.getProxyAgent=S}),define(de[193],me([0,1,23,18]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(S,k,R){let f=R&&R.get("storage.serviceMachineId",0)||null;if(f)return f;try{const i=(await k.readFile(S.serviceMachineIdResource)).value.toString();f=(0,E.isUUID)(i)?i:null}catch(m){f=null}if(!f){f=(0,E.generateUuid)();try{await k.writeFile(S.serviceMachineIdResource,b.VSBuffer.fromString(f))}catch(m){}}return R&&R.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=C}),define(de[194],me([0,1,7,6,2,11,126,14]),function(Y,e,E,b,C,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var m;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(a){a[a.GLOBAL=0]="GLOBAL",a[a.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class p extends C.Disposable{constructor(w={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,_){_===f?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:_,target:this.getKeyTargets(w)[_]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,_,A){var d;return(d=this.getStorage(_))===null||d===void 0?void 0:d.get(w,A)}getBoolean(w,_,A){var d;return(d=this.getStorage(_))===null||d===void 0?void 0:d.getBoolean(w,A)}getNumber(w,_,A){var d;return(d=this.getStorage(_))===null||d===void 0?void 0:d.getNumber(w,A)}store(w,_,A,d){if((0,S.isUndefinedOrNull)(_)){this.remove(w,A);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(w,A,d),(l=this.getStorage(A))===null||l===void 0||l.set(w,_)})}remove(w,_){this.withPausedEmitters(()=>{var A;this.updateKeyTarget(w,_,void 0),(A=this.getStorage(_))===null||A===void 0||A.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,_){const A=[],d=this.getKeyTargets(w);for(const l of Object.keys(d))d[l]===_&&A.push(l);return A}updateKeyTarget(w,_,A){var d,l;const c=this.getKeyTargets(_);typeof A=="number"?c[w]!==A&&(c[w]=A,(d=this.getStorage(_))===null||d===void 0||d.set(f,JSON.stringify(c))):typeof c[w]=="number"&&(delete c[w],(l=this.getStorage(_))===null||l===void 0||l.set(f,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const _=this.get(f,w);if(_)try{return JSON.parse(_)}catch(A){}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(){var w,_,A,d;this._onWillSaveState.fire({reason:m.NONE}),await R.Promises.settled([(_=(w=this.getStorage(0))===null||w===void 0?void 0:w.whenFlushed())!==null&&_!==void 0?_:Promise.resolve(),(d=(A=this.getStorage(1))===null||A===void 0?void 0:A.whenFlushed())!==null&&d!==void 0?d:Promise.resolve()])}async logStorage(){var w,_,A,d,l,c;const t=(_=(w=this.getStorage(0))===null||w===void 0?void 0:w.items)!==null&&_!==void 0?_:new Map,n=(d=(A=this.getStorage(1))===null||A===void 0?void 0:A.items)!==null&&d!==void 0?d:new Map;return o(t,n,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(c=this.getLogDetails(1))!==null&&c!==void 0?c:"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class D extends p{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=D;async function o(a,w,_,A){const d=u=>{try{return JSON.parse(u)}catch(h){return u}},l=new Map,c=new Map;a.forEach((u,h)=>{l.set(h,u),c.set(h,d(u))});const t=new Map,n=new Map;w.forEach((u,h)=>{t.set(h,u),n.set(h,d(u))}),console.group(`Storage: Global (path: ${_})`);let r=[];l.forEach((u,h)=>{r.push({key:h,value:u})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${A})`);let s=[];t.forEach((u,h)=>{s.push({key:h,value:u})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=o}),define(de[195],me([0,1,5,24,23,3]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function k(m){if(E.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function R(m,i,I,p,D,o,a,w,_,A){const d=Object.create(null);d["common.machineId"]=a,d.sessionID=(0,C.generateUuid)()+Date.now(),d.commitHash=D,d.version=o,d["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,E.PlatformToString)(E.platform),d["common.nodePlatform"]=b.platform,d["common.nodeArch"]=p,d["common.product"]=A||"desktop";const l=f(w||[]);l&&(d["common.msftInternal"]=l);let c=0;const t=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),E.isLinuxSnap&&(d["common.snap"]="true");const n=k(I);n&&(d["common.platformDetail"]=n);try{const r=await m.readFile(S.URI.file(_));d["common.source"]=r.value.toString().slice(0,30)}catch(r){}return d}e.resolveCommonProperties=R;function f(m){const i=b.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return m.some(p=>I===p)}}),define(de[196],me([0,1,19,12,2,20]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(f){function m(i,I){return i.callstack<I.callstack?-1:i.callstack>I.callstack?1:0}f.compare=m})(k=e.ErrorEvent||(e.ErrorEvent={}));class R{constructor(m,i=R.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new C.DisposableStore,this._telemetryService=m,this._flushDelay=i;const I=b.errorHandler.addListener(p=>this._onErrorEvent(p));this._disposables.add((0,C.toDisposable)(I)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(m){if(!!m){m.detail&&m.detail.stack&&(m=m.detail);let i=Array.isArray(m.stack)?m.stack.join(`
`):m.stack,I=m.message?m.message:(0,S.safeStringify)(m);!i||this._enqueue({msg:I,callstack:i})}}_enqueue(m){const i=(0,E.binarySearch)(this._buffer,m,k.compare);i<0?(m.count=1,this._buffer.splice(~i,0,m)):(this._buffer[i].count||(this._buffer[i].count=0),this._buffer[i].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let m of this._buffer)this._telemetryService.publicLogError2("UnhandledError",m);this._buffer.length=0}}e.default=R,R.ERROR_FLUSH_TIMEOUT=5*1e3}),define(de[39],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(de[197],me([0,1,25,77,178,15,4,36,80,44,5,3,39,50,8,22,21]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function _(t,n){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,u=new Map,h=2e4;function y(g,F,O,x){const oe=F.substring(g.length+1);return new Promise(async W=>{var te,Q,q;let ee;try{ee=await(0,w.readdir)(F,{withFileTypes:!0})}catch(L){W();return}if(x.count>=h){x.count+=ee.length,x.maxReached=!0,W();return}let H=ee.length;if(H===0){W();return}let T=ee;x.count+ee.length>h&&(x.maxReached=!0,H=h-x.count,T=ee.slice(0,H)),x.count+=ee.length;for(const L of T)if(L.isDirectory()){if(O.includes(L.name)||await y(g,(0,k.join)(F,L.name),O,x),--H==0){W();return}}else{const B=L.name.lastIndexOf(".");if(B>=0){const U=L.name.substring(B+1);U&&s.set(U,((te=s.get(U))!==null&&te!==void 0?te:0)+1)}for(const U of r)((Q=U.relativePathPattern)===null||Q===void 0?void 0:Q.test(oe))!==!1&&U.filePattern.test(L.name)&&u.set(U.tag,((q=u.get(U.tag))!==null&&q!==void 0?q:0)+1);if(--H==0){W();return}}})}const P={count:0,maxReached:!1};await y(t,t,n,P);const v=await l(t);return{configFiles:A(u),fileTypes:A(s),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:v}}e.collectWorkspaceStats=_;function A(t){return[...D.Iterable.map(t.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function d(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/a.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/a.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},n=E.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=d;function l(t){let n=new Map,r=(0,k.join)(t,".vscode","launch.json");return new Promise((s,u)=>{(0,S.exists)(r,h=>{if(h)(0,S.readFile)(r,(y,P)=>{if(y)return s([]);const v=[],g=(0,R.parse)(P.toString(),v);if(v.length)return console.log(`Unable to parse ${r}`),s([]);if((0,R.getNodeType)(g)==="object"&&g.configurations)for(const F of g.configurations){const O=F.type;O&&(n.has(O)?n.set(O,n.get(O)+1):n.set(O,1))}return s(A(n))});else return s([])})})}e.collectLaunchConfigs=l;let c=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const s=E.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(E.totalmem()/a.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/a.ByteSize.GB).toFixed(2)}GB free)`),i.isWindows||r.push(`Load (avg):       ${E.loadavg().map(u=>Math.round(u)).join(", ")}`),r.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,f.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[u,h]=s,y=this.formatProcessList(n,u);return r.forEach(P=>{if((0,C.isRemoteDiagnosticError)(P))y+=`
${P.errorMessage}`,h+=`
${P.errorMessage}`;else if(y+=`

Remote: ${P.hostName}`,P.processes&&(y+=`
${this.formatProcessList(n,P.processes)}`),P.workspaceMetadata){h+=`
|  Remote: ${P.hostName}`;for(const v of Object.keys(P.workspaceMetadata)){const g=P.workspaceMetadata[v];let F=`${g.fileCount} files`;g.maxFilesReached&&(F=`more than ${F}`),h+=`|    Folder (${v}): ${F}`,h+=this.formatWorkspaceStats(g)}}}),{processInfo:y,workspaceInfo:h}})}async getSystemInfo(n,r){const{memory:s,vmHint:u,os:h,cpus:y}=d(),P={os:h,memory:s,cpus:y,vmHint:u,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return i.isWindows||(P.load=`${E.loadavg().map(v=>Math.round(v)).join(", ")}`),i.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(n,r){const s=[];return(0,f.listProcesses)(n.mainPID).then(async u=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,u)),n.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),r.forEach(h=>{if((0,C.isRemoteDiagnosticError)(h))s.push(`
${h.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${h.hostName}`),s.push(this.formatMachineInfo(h.machineInfo)),h.processes&&s.push(this.formatProcessList(n,h.processes)),h.workspaceMetadata)for(const y of Object.keys(h.workspaceMetadata)){const P=h.workspaceMetadata[y];let v=`${P.fileCount} files`;P.maxFilesReached&&(v=`more than ${v}`),s.push(`Folder (${y}): ${v}`),s.push(this.formatWorkspaceStats(P))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const r=[],s=60;let u=0;const h=(g,F)=>{const O=` ${g}(${F})`;u+O.length>s?(r.push(y),y="|                 ",u=y.length):u+=O.length,y+=O};let y="|      File types:";const P=10;let v=n.fileTypes.length>P?P:n.fileTypes.length;for(let g=0;g<v;g++){const F=n.fileTypes[g];h(F.name,F.count)}if(r.push(y),n.configFiles.length>=0&&(y="|      Conf files:",u=0,n.configFiles.forEach(g=>{h(g.name,g.count)}),r.push(y)),n.launchConfigFiles.length>0){let g="|      Launch Configs:";n.launchConfigFiles.forEach(F=>{g+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),r.push(g)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],s=[];return n.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(r.push(`|  Window (${u.title})`),u.folderURIs.forEach(h=>{const y=I.URI.revive(h);if(y.scheme===o.Schemas.file){const P=y.fsPath;s.push(_(P,["node_modules",".git"]).then(v=>{let g=`${v.fileCount} files`;v.maxFilesReached&&(g=`more than ${g}`),r.push(`|    Folder (${(0,k.basename)(P)}): ${g}`),r.push(this.formatWorkspaceStats(v))}).catch(v=>{r.push(`|      Error: Unable to collect workspace stats for folder ${P} (${v.toString()})`)}))}else r.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(u=>r.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(n,r){const s=new Map;n.windows.forEach(h=>s.set(h.pid,h.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,s,u,r,0),u.join(`
`)}formatProcessItem(n,r,s,u,h){const y=h===0;let P;y?P=u.pid===n?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(h)} ${u.name}`,u.name==="window"&&(P=`${P} (${r.get(u.pid)})`));const v=process.platform==="win32"?u.mem:E.totalmem()*(u.mem/100);s.push(`${u.load.toFixed(0).padStart(5," ")}	${(v/a.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(u.children)&&u.children.forEach(g=>this.formatProcessItem(n,r,s,g,h+1))}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const s=I.URI.revive(r);if(s.scheme===o.Schemas.file){const u=s.fsPath;try{const h=await _(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),h.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:y.name,count:y.count})}),h.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:y.name,count:y.count})}),h.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:y.name,count:y.count})})}catch(h){}}}}};c=Oe([xe(0,p.ITelemetryService),xe(1,m.IProductService)],c),e.DiagnosticsService=c}),define(de[96],me([0,1,12,32,33,20,39,63,56,27,28,16,22,3,44,194,193,7,17]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var d;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(d||(d={}));function l(...T){return String(T.reduce((L,B)=>L|B,0))}var c;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:d.None,criteria:[],assetTypes:[]};class u{constructor(L=s){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(L,B=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:L,pageSize:B}))}withFilter(L,...B){const U=[...this.state.criteria,...B.length?B.map(V=>({filterType:L,value:V})):[{filterType:L}]];return new u(Object.assign(Object.assign({},this.state),{criteria:U}))}withSortBy(L){return new u(Object.assign(Object.assign({},this.state),{sortBy:L}))}withSortOrder(L){return new u(Object.assign(Object.assign({},this.state),{sortOrder:L}))}withFlags(...L){return new u(Object.assign(Object.assign({},this.state),{flags:L.reduce((B,U)=>B|U,0)}))}withAssetTypes(...L){return new u(Object.assign(Object.assign({},this.state),{assetTypes:L}))}get raw(){const{criteria:L,pageNumber:B,pageSize:U,sortBy:V,sortOrder:ie,flags:le,assetTypes:ue}=this.state;return{filters:[{criteria:L,pageNumber:B,pageSize:U,sortBy:V,sortOrder:ie}],assetTypes:ue,flags:le}}get searchText(){const L=this.state.criteria.filter(B=>B.filterType===c.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function h(T,L){const B=(T||[]).filter(U=>U.statisticName===L)[0];return B?B.value:0}function y(T){const L="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(U=>U.assetType.indexOf(L)===0).reduce((U,V)=>{const ie=F(T,V.assetType);return ie&&U.push([V.assetType.substring(L.length),ie]),U},[])}function P(T){if(T.properties){const L=T.properties.filter(V=>V.key===t.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),U=L.filter(V=>B.test(V.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return F(T,t.Repository)}function v(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function g(T){const L=F(T,t.Icon);if(L)return L;const B=b.DefaultIconPath;return{uri:B,fallbackUri:B}}function F(T,L){return T.files.filter(U=>U.assetType===L)[0]?{uri:`${T.assetUri}/${L}`,fallbackUri:`${T.fallbackAssetUri}/${L}`}:null}function O(T,L){const B=T.properties?T.properties.filter(V=>V.key===L):[],U=B.length>0&&B[0].value;return U?U.split(",").map(V=>(0,C.adoptToGalleryExtensionId)(V)):[]}function x(T){const L=T.properties?T.properties.filter(B=>B.key===n.Engine):[];return L.length>0&&L[0].value||""}function oe(T){const L=T.properties?T.properties.filter(U=>U.key===n.LocalizedLanguages):[],B=L.length>0&&L[0].value||"";return B?B.split(","):[]}function W(T){return T.indexOf("preview")!==-1}function te(T){const L=T.properties?T.properties.find(B=>B.key===n.WebExtension):void 0;return!!L&&L.value==="true"}function Q(T){return T.files.some(L=>L.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,A.joinPath)(D.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function q(T,L,B,U,V){const ie={manifest:F(L,t.Manifest),readme:F(L,t.Details),changelog:F(L,t.Changelog),license:F(L,t.License),repository:P(L),download:v(L),icon:g(L),coreTranslations:y(L)};return{identifier:{id:(0,C.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:L.version,date:L.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:h(T.statistics,"install"),rating:h(T.statistics,"averagerating"),ratingCount:h(T.statistics,"ratingcount"),assetUri:D.URI.parse(L.assetUri),webResource:Q(L),assetTypes:L.files.map(({assetType:le})=>le),assets:ie,properties:{dependencies:O(L,n.Dependency),extensionPack:O(L,n.ExtensionPack),engine:x(L),localizedLanguages:oe(L),webExtension:te(L)},telemetryData:{index:(U.pageNumber-1)*U.pageSize+B,searchText:U.searchText,querySource:V},preview:W(T.flags)}}let ee=class{constructor(L,B,U,V,ie,le,ue){this.requestService=L,this.logService=B,this.environmentService=U,this.telemetryService=V,this.fileService=ie,this.productService=le;const we=le.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=H(le.version,this.environmentService,this.fileService,ue)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,B){const U=[];let{total:V,firstPage:ie,getPage:le}=await this.query({names:L,pageSize:L.length},B);U.push(...ie);for(let ue=1;U.length<V&&(ie=await le(ue,B),ie.length);ue++)U.push(...ie);return U}async getCompatibleExtension(L,B){const U=await this.getCompatibleExtensionByEngine(L,B);return(U==null?void 0:U.properties.webExtension)?U.webResource?U:null:U}async getCompatibleExtensionByEngine(L,B){const U=(0,b.isIExtensionIdentifier)(L)?null:L;if(U&&U.properties.engine&&(0,f.isEngineValid)(U.properties.engine,this.productService.version))return U;const{id:V,uuid:ie}=U?U.identifier:L;let le=new u().withFlags(d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");ie?le=le.withFilter(c.ExtensionId,ie):le=le.withFilter(c.ExtensionName,V);const{galleryExtensions:ue}=await this.queryGallery(le,i.CancellationToken.None),[we]=ue;if(!we||!we.versions.length)return null;if(B){const Ae=we.versions.filter(Fe=>Fe.version===B)[0];if(Ae){const Fe=q(we,Ae,0,le);if(Fe.properties.engine&&(0,f.isEngineValid)(Fe.properties.engine,this.productService.version))return Fe}return null}const ke=await this.getLastValidExtensionVersion(we,we.versions);return ke?q(we,ke,0,le):null}async query(L,B){const U=i.CancellationToken.isCancellationToken(L)?{}:L,V=i.CancellationToken.isCancellationToken(L)?L:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=U.text||"";const le=(0,S.getOrDefault)(U,je=>je.pageSize,50);let ue=new u().withFlags(d.IncludeLatestVersionOnly,d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,le).withFilter(c.Target,"Microsoft.VisualStudio.Code");ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(je,Qe,qe)=>(ue=ue.withFilter(c.Category,qe||Qe),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(je,Qe,qe)=>(ue=ue.withFilter(c.Tag,qe||Qe),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ue=ue.withFilter(c.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ue=ue.withFilter(c.SearchText,ie)),ue=ue.withSortBy(0)):U.ids?ue=ue.withFilter(c.ExtensionId,...U.ids):U.names?ue=ue.withFilter(c.ExtensionName,...U.names):ue=ue.withSortBy(4),typeof U.sortBy=="number"&&(ue=ue.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(ue=ue.withSortOrder(U.sortOrder));const{galleryExtensions:we,total:ke}=await this.queryGallery(ue,V),Ae=we.map((je,Qe)=>q(je,je.versions[0],Qe,ue,U.source)),Fe=async(je,Qe)=>{if(Qe.isCancellationRequested)throw(0,E.canceled)();const qe=ue.withPage(je+1),{galleryExtensions:it}=await this.queryGallery(qe,Qe);return it.map((tt,ye)=>q(tt,tt.versions[0],ye,qe,U.source))};return{firstPage:Ae,total:ke,pageSize:ue.pageSize,getPage:Fe}}async queryGallery(L,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,d.ExcludeNonValidated).withFilter(c.ExcludeWithFlags,l(d.Unpublished));const U=await this.commonHeadersPromise,V=JSON.stringify(L.raw),ie=Object.assign(Object.assign({},U),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)}),le=new Date().getTime();let ue,we,ke=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:V,headers:ie},B),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ke};const Ae=await(0,R.asJson)(ue);if(Ae){const Fe=Ae.results[0],je=Fe.extensions,Qe=Fe.resultMetadata&&Fe.resultMetadata.filter(qe=>qe.metadataType==="ResultCount")[0];return ke=Qe&&Qe.metadataItems.filter(qe=>qe.name==="TotalCount")[0].count||0,{galleryExtensions:je,total:ke}}return{galleryExtensions:[],total:ke}}catch(Ae){throw we=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},L.telemetryData),{requestBodySize:String(V.length),duration:new Date().getTime()-le,success:!!ue&&(0,R.isSuccess)(ue),responseBodySize:ue==null?void 0:ue.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:we?(0,E.isPromiseCanceledError)(we)?"canceled":(0,E.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ke)}))}}async reportStatistic(L,B,U,V){if(!!this.isEnabled()){const ie=await this.commonHeadersPromise,le=Object.assign(Object.assign({},ie),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${L}/extensions/${B}/${U}/stats?statType=${V}`),headers:le},i.CancellationToken.None)}catch(ue){}}}async download(L,B,U){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const V=(0,C.getGalleryExtensionTelemetryData)(L),ie=new Date().getTime(),le=Ae=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},V),{duration:Ae})),ue=U===1?"install":U===2?"update":"",we=ue?{uri:`${L.assets.download.uri}&${ue}=true`,fallbackUri:`${L.assets.download.fallbackUri}?${ue}=true`}:L.assets.download,ke=await this.getAsset(we);await this.fileService.writeFile(B,ke.stream),le(new Date().getTime()-ie)}async getReadme(L,B){if(L.assets.readme){const U=await this.getAsset(L.assets.readme,{},B);return await(0,R.asText)(U)||""}return""}async getManifest(L,B){if(L.assets.manifest){const U=await this.getAsset(L.assets.manifest,{},B),V=await(0,R.asText)(U);return V?JSON.parse(V):null}return null}async getCoreTranslation(L,B){const U=L.assets.coreTranslations.filter(V=>V[0]===B.toUpperCase())[0];if(U){const V=await this.getAsset(U[1]),ie=await(0,R.asText)(V);return ie?JSON.parse(ie):null}return null}async getChangelog(L,B){if(L.assets.changelog){const U=await this.getAsset(L.assets.changelog,{},B);return await(0,R.asText)(U)||""}return""}async getAllVersions(L,B){let U=new u().withFlags(d.IncludeVersions,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");L.identifier.uuid?U=U.withFilter(c.ExtensionId,L.identifier.uuid):U=U.withFilter(c.ExtensionName,L.identifier.id);const V=[],{galleryExtensions:ie}=await this.queryGallery(U,i.CancellationToken.None);return ie.length&&(B?await Promise.all(ie[0].versions.map(async le=>{let ue;try{ue=await this.getEngine(le)}catch(we){}ue&&(0,f.isEngineValid)(ue,this.productService.version)&&V.push({version:le.version,date:le.lastUpdated})})):V.push(...ie[0].versions.map(le=>({version:le.version,date:le.lastUpdated})))),V}async getAsset(L,B={},U=i.CancellationToken.None){const V=await this.commonHeadersPromise,ie={type:"GET"},le=Object.assign(Object.assign({},V),B.headers||{});B=Object.assign(Object.assign(Object.assign({},B),ie),{headers:le});const ue=L.uri,we=L.fallbackUri,ke=Object.assign(Object.assign({},B),{url:ue});try{const Ae=await this.requestService.request(ke,U);if(Ae.res.statusCode===200)return Ae;const Fe=await(0,R.asText)(Ae);throw new Error(`Expected 200, got back ${Ae.res.statusCode} instead.

${Fe}`)}catch(Ae){if((0,E.isPromiseCanceledError)(Ae))throw Ae;const Fe=(0,E.getErrorMessage)(Ae);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:Fe});const je=Object.assign(Object.assign({},B),{url:we});return this.requestService.request(je,U)}}async getLastValidExtensionVersion(L,B){const U=this.getLastValidExtensionVersionFromProperties(L,B);return U||this.getLastValidExtensionVersionRecursively(L,B)}getLastValidExtensionVersionFromProperties(L,B){for(const U of B){const V=x(U);if(!V)return null;if((0,f.isEngineValid)(V,this.productService.version))return U}return null}async getEngine(L){const B=x(L);if(B)return B;const U=F(L,t.Manifest);if(!U)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},ie=await this.getAsset(U,{headers:V}),le=await(0,R.asJson)(ie);if(le)return le.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(L,B){if(!B.length)return null;const U=B[0],V=await this.getEngine(U);return(0,f.isEngineValid)(V,this.productService.version)?(U.properties=U.properties||[],U.properties.push({key:n.Engine,value:V}),U):this.getLastValidExtensionVersionRecursively(L,B.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,R.asJson)(L),U=new Map;if(B)for(const V of B.malicious){const ie=U.get(V)||{id:{id:V},malicious:!0,slow:!1};ie.malicious=!0,U.set(V,ie)}return[...U.values()]}};ee=Oe([xe(0,R.IRequestService),xe(1,I.ILogService),xe(2,m.IEnvironmentService),xe(3,k.ITelemetryService),xe(4,p.IFileService),xe(5,o.IProductService),xe(6,(0,_.optional)(a.IStorageService))],ee),e.ExtensionGalleryService=ee;async function H(T,L,B,U){const V={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},ie=await(0,w.getServiceMachineId)(L,B,U);return V["X-Market-User-Id"]=ie,V}e.resolveMarketplaceHeaders=H}),define(de[198],me([0,1,30,154,13,7,34,38,2,20,31]),function(Y,e,E,b,C,S,k,R,f,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(o,a){this._configurationService=a,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=o.appender,this._commonProperties=o.commonProperties||Promise.resolve({}),this._piiPaths=o.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!o.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(w),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(w=>{const _=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!_})}))}setExperimentProperty(o,a){this._experimentProperties[o]=a}setEnabled(o){this._enabled=o}_updateUserOptIn(){var o;const a=(o=this._configurationService)===null||o===void 0?void 0:o.getValue(p);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const o=await this._commonProperties;let a=o.sessionID,w=o["common.instanceId"],_=o["common.machineId"],A=o["common.firstSessionDate"],d=o["common.msftInternal"];return{sessionId:a,instanceId:w,machineId:_,firstSessionDate:A,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(o,a,w){return this.isOptedIn?this._commonProperties.then(_=>{a=(0,m.mixin)(a,_),a=(0,m.mixin)(a,this._experimentProperties),a=(0,m.cloneAndChange)(a,A=>{if(typeof A=="string")return this._cleanupInfo(A,w)}),this._appender.log(o,a)},_=>{console.error(_)}):Promise.resolve(void 0)}publicLog2(o,a,w){return this.publicLog(o,a,w)}publicLogError(o,a){return this.sendErrorTelemetry?this.publicLog(o,a,!0):Promise.resolve(void 0)}publicLogError2(o,a){return this.publicLogError(o,a)}_cleanupInfo(o,a){let w=o;if(a){const _=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(o);if(!t)break;_.push([t.index,c.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(w="";;){const c=d.exec(o);if(!c)break;!A.test(c[0])&&_.every(([t,n])=>c.index<t||c.index>=n)&&(w+=o.substring(l,c.index)+"<REDACTED: user-file-path>",l=d.lastIndex)}l<o.length&&(w+=o.substr(l))}for(let _ of this._cleanupPatterns)w=w.replace(_,"");return w}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=Oe([xe(1,(0,S.optional)(k.IConfigurationService))],I),e.TelemetryService=I;const p="telemetry";i.Registry.as(R.Extensions.Configuration).registerConfiguration({id:p,order:110,type:"object",title:(0,b.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,b.localize)(2,null,E.default.privacyStatementUrl):(0,b.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(de[65],me([0,1,34,20,11,14]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(o,a){return Promise.resolve(void 0)}publicLog2(o,a){return this.publicLog(o,a)}publicLogError(o,a){return Promise.resolve(void 0)}publicLogError2(o,a){return this.publicLogError(o,a)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(a,w,_){}async publicLogError(a,w,_){}}e.NullEndpointTelemetryService=k;function R(...o){return{log:(a,w)=>o.forEach(_=>_.log(a,w)),flush:()=>S.Promises.settled(o.map(a=>a.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(o,a){return a.onDidChangeConfiguration(w=>{w.source!==6&&o.publicLog2("updateConfiguration",{configurationSource:(0,E.ConfigurationTargetToString)(w.source),configurationKeys:p(w.sourceConfig)})})}e.configurationTelemetry=f;function m(o){const a=Object.create(null),w=Object.create(null),_=Object.create(null);I(o,_);for(let A in _){A=A.length>150?A.substr(A.length-149):A;const d=_[A];typeof d=="number"?w[A]=d:typeof d=="boolean"?w[A]=d?1:0:typeof d=="string"?a[A]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(a[A]=d)}return{properties:a,measurements:w}}e.validateTelemetryData=m;function i(o){if(!o)return"none";let a="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(_=>{o.indexOf(`${_}+`)===0&&(a=_)}),a}e.cleanRemoteAuthority=i;function I(o,a,w=0,_){if(!!o)for(let A of Object.getOwnPropertyNames(o)){const d=o[A],l=_?_+A:A;Array.isArray(d)?a[l]=(0,b.safeStringify)(d):d instanceof Date?a[l]=d.toISOString():(0,C.isObject)(d)?w<2?I(d,a,w+1,l+"."):a[l]=(0,b.safeStringify)(d):a[l]=d}}function p(o){if(!o)return[];const a=[];return D(a,"",o),a}function D(o,a,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(_=>D(o,a?`${a}.${_}`:_,w[_])):o.push(a)}}),define(de[199],me([0,1,12,20,65]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function S(R){const f=await new Promise((i,I)=>{Y(["applicationinsights"],i,I)});let m;return f.defaultClient?(m=new f.TelemetryClient(R),m.channel.setUseDiskRetryCaching(!0)):(f.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),m=f.defaultClient),R.indexOf("AIF-")===0&&(m.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),m}class k{constructor(f,m,i){this._eventPrefix=f,this._defaultData=m,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=S(this._aiClient)),this._asyncAIClient.then(m=>{f(m)},m=>{(0,E.onUnexpectedError)(m),console.error(m)})}}log(f,m){!this._aiClient||(m=(0,b.mixin)(m,this._defaultData),m=(0,C.validateTelemetryData)(m),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+f,properties:m.properties,measurements:m.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(m=>{m.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(de[200],me([0,1,12,196]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class C extends b.default{installErrorListeners(){(0,E.setUnexpectedErrorHandler)(R=>console.error(R));const k=[];process.on("unhandledRejection",(R,f)=>{k.push(f),setTimeout(()=>{const m=k.indexOf(f);m>=0&&f.catch(i=>{k.splice(m,1),console.warn(`rejected promise not handled within 1 second: ${i}`),i.stack&&console.warn(`stack trace: ${i.stack}`),(0,E.onUnexpectedError)(R)})},1e3)}),process.on("rejectionHandled",R=>{const f=k.indexOf(R);f>=0&&k.splice(f,1)}),process.on("uncaughtException",R=>{(0,E.onUnexpectedError)(R)})}}e.default=C}),define(de[97],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var b;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(b=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,E.createDecorator)("localTerminalService"),e.IPtyService=(0,E.createDecorator)("ptyService");var S;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var k;(function(f){f[f.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(k=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var R;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(R=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(de[201],me([0,1,2,16,97,54,8,35,6,90,39]),function(Y,e,E,b,C,S,k,R,f,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var I;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(I||(I={}));let p=0,D=class extends E.Disposable{constructor(a,w){super();this._logService=a,this._telemetryService=w,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new f.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new f.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new f.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new f.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new f.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new f.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new f.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new f.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new f.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new f.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new f.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new f.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new f.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,E.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new S.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(a.getChannel(C.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=I.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const _=a.getChannel(C.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(_,this._logService.getLevel())}));const A=R.ProxyChannel.toService(a.getChannel(C.TerminalIpcChannels.PtyHost));return this._register(A.onProcessData(d=>this._onProcessData.fire(d))),this._register(A.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(A.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(A.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(A.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(A.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(A.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(A.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(A.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),[a,A]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,w,_,A,d,l,c,t,n,r){const s=setTimeout(()=>this._handleUnresponsiveCreateProcess(),C.HeartbeatConstants.CreateProcessTimeout),u=await this._proxy.createProcess(a,w,_,A,d,l,c,t,n,r);return clearTimeout(s),p=Math.max(p,u),u}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,w){return this._proxy.shutdown(a,w)}input(a,w){return this._proxy.input(a,w)}processBinary(a,w){return this._proxy.processBinary(a,w)}resize(a,w,_){return this._proxy.resize(a,w,_)}acknowledgeDataEvent(a,w){return this._proxy.acknowledgeDataEvent(a,w)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}getShellEnvironment(){return this._proxy.getShellEnvironment()}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier+C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${C.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};D=Oe([xe(0,b.ILogService),xe(1,i.ITelemetryService)],D),e.PtyHostService=D}),define(de[98],me([0,1,3,17,7,26]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var k;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function R(p){const D=p;return!!(D&&typeof D=="object"&&typeof D.id=="string"&&Array.isArray(D.folders))}e.isWorkspace=R;function f(p){const D=p;return!!(D&&typeof D=="object"&&E.URI.isUri(D.uri)&&typeof D.name=="string"&&typeof D.toResource=="function")}e.isWorkspaceFolder=f;class m{constructor(D,o,a,w){this._id=D,this._configuration=a,this._ignorePathCasing=w,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(D){this._id=D.id,this._configuration=D.configuration,this._ignorePathCasing=D._ignorePathCasing,this.folders=D.folders}get folders(){return this._folders}set folders(D){this._folders=D,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(D){this._configuration=D}getFolder(D){return D&&this._foldersMap.findSubstr(D.with({scheme:D.scheme,authority:D.authority,path:D.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const D of this.folders)this._foldersMap.set(D.uri,D)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=m;class i{constructor(D,o){this.raw=o,this.uri=D.uri,this.index=D.index,this.name=D.name}toResource(D){return(0,b.joinPath)(this.uri,D)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(p){return new i({uri:p,index:0,name:(0,b.basenameOrAuthority)(p)},{uri:p.toString()})}e.toWorkspaceFolder=I}),define(de[202],me([0,1,7,155,98,3,5,4,17,111,36,8,51,29,190]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(Q){return(typeof Q=="string"?(0,R.extname)(Q):(0,f.extname)(Q))===a}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function _(Q){return Q.hasOwnProperty("workspace")}e.isRecentWorkspace=_;function A(Q){return Q.hasOwnProperty("folderUri")}e.isRecentFolder=A;function d(Q){return Q.hasOwnProperty("fileUri")}e.isRecentFile=d;function l(Q){const q=Q;return typeof(q==null?void 0:q.id)=="string"&&S.URI.isUri(q.uri)}e.isSingleFolderWorkspaceIdentifier=l;function c(Q){if(Q.configuration)return{id:Q.id,configPath:Q.configuration};if(Q.folders.length===1)return{id:Q.id,uri:Q.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(Q){const q=Q;return typeof(q==null?void 0:q.id)=="string"&&S.URI.isUri(q.configPath)}e.isWorkspaceIdentifier=t;function n(Q){const q=Q;if(q==null?void 0:q.uri)return{id:q.id,uri:S.URI.revive(q.uri)};const ee=Q;if(ee==null?void 0:ee.configPath)return{id:ee.id,configPath:S.URI.revive(ee.configPath)};if(Q==null?void 0:Q.id)return{id:Q.id}}e.reviveIdentifier=n;function r(Q,q){return f.extUriBiasedIgnorePathCase.isEqualOrParent(Q,q.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(Q){return u(Q)||h(Q)}e.isStoredWorkspaceFolder=s;function u(Q){const q=Q;return typeof(q==null?void 0:q.path)=="string"&&(!q.name||typeof q.name=="string")}e.isRawFileWorkspaceFolder=u;function h(Q){const q=Q;return typeof(q==null?void 0:q.uri)=="string"&&(!q.name||typeof q.name=="string")}e.isRawUriWorkspaceFolder=h;function y(Q,q,ee,H,T=!k.isWindows,L){if(Q.scheme!==H.scheme)return{name:ee,uri:Q.toString(!0)};let B=q?void 0:L.relativePath(H,Q);if(B!==void 0)B.length===0?B=".":k.isWindows&&Q.scheme===I.Schemas.file&&!T&&(B=B.replace(/\//g,"\\"));else if(Q.scheme===I.Schemas.file)B=Q.fsPath,k.isWindows&&(B=(0,p.normalizeDriveLetter)(B),T&&(B=(0,D.toSlashes)(B)));else{if(!L.isEqualAuthority(Q.authority,H.authority))return{name:ee,uri:Q.toString(!0)};B=Q.path}return{name:ee,path:B}}e.getStoredWorkspaceFolder=y;function P(Q,q,ee){let H=[],T=new Set;const L=ee.dirname(q);for(let B of Q){let U=null;if(u(B))B.path&&(U=ee.resolvePath(L,B.path));else if(h(B))try{U=S.URI.parse(B.uri),U.path[0]!=="/"&&(U=U.with({path:"/"+U.path}))}catch(V){console.warn(V)}if(U){let V=ee.getComparisonKey(U);if(!T.has(V)){T.add(V);const ie=B.name||ee.basenameOrAuthority(U);H.push(new C.WorkspaceFolder({uri:U,name:ie,index:H.length},B))}}}return H}e.toWorkspaceFolders=P;function v(Q,q,ee,H,T){let L=g(q,Q);const B=T.dirname(q),U=T.dirname(H),V=[],ie=F(L.folders);for(const ke of L.folders){const Ae=u(ke)?T.resolvePath(B,ke.path):S.URI.parse(ke.uri);let Fe;ee?Fe=!1:Fe=!u(ke)||(0,R.isAbsolute)(ke.path),V.push(y(Ae,Fe,ke.name,U,ie,T))}const le={insertSpaces:!1,tabSize:4,eol:k.isLinux||k.isMacintosh?`
`:`\r
`},ue=m.setProperty(Q,["folders"],V,le);let we=m.applyEdits(Q,ue);return L.remoteAuthority===(0,o.getRemoteAuthority)(H)&&(we=m.applyEdits(we,m.removeProperty(we,["remoteAuthority"],le))),we}e.rewriteWorkspaceFileForNewLocation=v;function g(Q,q){let ee=i.parse(q);if(ee&&Array.isArray(ee.folders))ee.folders=ee.folders.filter(H=>s(H));else throw new Error(`${Q} looks like an invalid workspace file.`);return ee}function F(Q){return k.isWindows?Q.some(q=>u(q)&&q.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function O(Q){return Q.workspace&&typeof Q.workspace=="object"&&typeof Q.workspace.id=="string"&&typeof Q.workspace.configPath=="string"}function x(Q){return typeof Q.folderUri=="string"}function oe(Q){return typeof Q.fileUri=="string"}function W(Q,q){const ee={workspaces:[],files:[]};if(Q){const H=function(L,B){for(let U=0;U<L.length;U++)try{B(L[U],U)}catch(V){q.warn(`Error restoring recent entry ${JSON.stringify(L[U])}: ${V.toString()}. Skip entry.`)}},T=Q;if(Array.isArray(T.entries))H(T.entries,L=>{const B=L.label,U=L.remoteAuthority;O(L)?ee.workspaces.push({label:B,remoteAuthority:U,workspace:{id:L.workspace.id,configPath:S.URI.parse(L.workspace.configPath)}}):x(L)?ee.workspaces.push({label:B,remoteAuthority:U,folderUri:S.URI.parse(L.folderUri)}):oe(L)&&ee.files.push({label:B,remoteAuthority:U,fileUri:S.URI.parse(L.fileUri)})});else{const L=Q;Array.isArray(L.workspaces3)&&H(L.workspaces3,(B,U)=>{const V=Array.isArray(L.workspaceLabels)&&L.workspaceLabels[U]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?ee.workspaces.push({label:V,workspace:{id:B.id,configPath:S.URI.parse(B.configURIPath)}}):typeof B=="string"&&ee.workspaces.push({label:V,folderUri:S.URI.parse(B)})}),Array.isArray(L.files2)&&H(L.files2,(B,U)=>{const V=Array.isArray(L.fileLabels)&&L.fileLabels[U]||void 0;typeof B=="string"&&ee.files.push({label:V,fileUri:S.URI.parse(B)})})}}return ee}e.restoreRecentlyOpened=W;function te(Q){const q={entries:[]};for(const ee of Q.workspaces)A(ee)?q.entries.push({folderUri:ee.folderUri.toString(),label:ee.label,remoteAuthority:ee.remoteAuthority}):q.entries.push({workspace:{id:ee.workspace.id,configPath:ee.workspace.configPath.toString()},label:ee.label,remoteAuthority:ee.remoteAuthority});for(const ee of Q.files)q.entries.push({fileUri:ee.fileUri.toString(),label:ee.label,remoteAuthority:ee.remoteAuthority});return q}e.toStoreData=te}),define(de[203],me([0,1,6,14]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function C(k){let R=0,f=0,m=0;k>=1e3&&(m=Math.floor(k/1e3),k-=m*1e3),m>=60&&(f=Math.floor(m/60),m-=f*60),f>=60&&(R=Math.floor(f/60),f-=R*60);const i=R?`${R}h`:"",I=f?`${f}m`:"",p=m?`${m}s`:"",D=k?`${k}ms`:"";return`${i}${I}${p}${D}`}e.printTime=C;class S{constructor(R,f,m,i){this._logService=R,this._reconnectionToken=f,this._onClose=new E.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=m,this.protocol=i,this._disposed=!1,this._disconnectRunner1=new b.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${C(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new b.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${C(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${C(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(R){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${R}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${C(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(!this._disposed){this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const R=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),R.end(),this._onClose.fire(void 0)}}acceptReconnection(R,f,m){this._remoteAddress=R,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(f,m),this.protocol.endAcceptReconnection()}}e.ManagementConnection=S}),define(de[99],me([0,1,15,8,4,120,30]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const R=C.join(b.FileAccess.asFileUri("",Y).fsPath,"nls.metadata.json"),f=new Map;function m(p){return new Promise(D=>E.exists(p,D))}function i(p,D){return m(R).then(o=>{if(!o||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let a=`${p}||${D}`,w=f.get(a);return w||(w=S.getNLSConfiguration(k.default.commit,D,R,p).then(_=>(I.is(_)&&(_._languagePackSupport=!0),_)),f.set(a,w)),w})}e.getNLSConfiguration=i;var I;(function(p){function D(o){let a=o;return a&&typeof a._languagePackId=="string"}p.is=D})(I=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(de[40],me([0,1,52,8]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=b.FileAccess.asFileUri("vs/server/uriTransformer.js",Y).fsPath;function C(S){const R=Y.__$__nodeRequire(e.uriTransformerPath)(S);return new E.URITransformer(R)}e.createRemoteURITransformer=C}),define(de[204],me([0,1,6,2,3,40,62,18,4,41,28]),function(Y,e,E,b,C,S,k,R,f,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class I extends b.Disposable{constructor(o,a,w,_){super();this.logService=o,this.environmentService=a,this.uriTransformer=w,this.watcherRequests=new Map,this.fileWatcher=this._register(new k.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(_)}registerListeners(o){const a=this._register(new E.Emitter);this._register(a.event(w=>{o.fire(w.map(_=>({resource:this.uriTransformer.transformOutgoingURI(_.resource),type:_.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>a.fire(w))),this._register(this.fileWatcher.onDidErrorOccur(w=>o.fire(w)))}getWatcherOptions(){const o=this.environmentService.args.fileWatcherPolling;if(o){const a=o.split(f.delimiter),w=Number(a[0]);if(w>0)return{usePolling:a.length>1?a.slice(1):!0,pollingInterval:w}}}watch(o,a,w){const _=C.URI.revive(this.uriTransformer.transformIncoming(a));return this.environmentService.extensionsPath&&(w.excludes=[...w.excludes||[],f.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(o,this.fileWatcher.watch(_,w)),(0,b.toDisposable)(()=>{(0,b.dispose)(this.watcherRequests.get(o)),this.watcherRequests.delete(o)})}dispose(){super.dispose(),this.watcherRequests.forEach(o=>(0,b.dispose)(o)),this.watcherRequests.clear()}}class p extends b.Disposable{constructor(o,a){super();this.logService=o,this.environmentService=a,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new k.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(o,a,w){const _=this.getUriTransformer(o.remoteAuthority);switch(a){case"stat":return this.stat(_,w[0]);case"readdir":return this.readdir(_,w[0]);case"open":return this.open(_,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(_,w[0]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(_,w[0],w[1],w[2]);case"rename":return this.rename(_,w[0],w[1],w[2]);case"copy":return this.copy(_,w[0],w[1],w[2]);case"mkdir":return this.mkdir(_,w[0]);case"delete":return this.delete(_,w[0],w[1]);case"watch":return Promise.resolve(this.watch(w[0],w[1],w[2],w[3]));case"unwatch":return Promise.resolve(this.unwatch(w[0],w[1]))}throw new Error(`IPC Command ${a} not found`)}listen(o,a,w){const _=this.getUriTransformer(o.remoteAuthority);switch(a){case"filechange":return this.onFileChange(_,w[0]);case"readFileStream":return this.onReadFileStream(_,w[0],w[1])}throw new Error(`Unknown event ${a}`)}onFileChange(o,a){const w=new E.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(a,new I(this.logService,this.environmentService,o,w))},onLastListenerRemove:()=>{(0,b.dispose)(this.fileWatchers.get(a)),this.fileWatchers.delete(a)}});return w.event}onReadFileStream(o,a,w){const _=this.transformIncoming(o,a,!0),A=new i.CancellationTokenSource,d=new E.Emitter({onLastListenerRemove:()=>{A.cancel()}}),l=this.fsProvider.readFileStream(_,w,A.token);return(0,m.listenStream)(l,{onData:c=>d.fire(R.VSBuffer.wrap(c)),onError:c=>d.fire(c),onEnd:()=>{d.fire("end"),d.dispose(),A.dispose()}}),d.event}getUriTransformer(o){let a=this.uriTransformerCache.get(o);return a||(a=(0,S.createRemoteURITransformer)(o),this.uriTransformerCache.set(o,a)),a}stat(o,a){const w=this.transformIncoming(o,a,!0);return this.fsProvider.stat(w)}readdir(o,a){const w=this.transformIncoming(o,a);return this.fsProvider.readdir(w)}open(o,a,w){const _=this.transformIncoming(o,a,!0);return this.fsProvider.open(_,w)}close(o){return this.fsProvider.close(o)}async read(o,a,w){const _=R.VSBuffer.alloc(w),A=0,d=await this.fsProvider.read(o,a,_.buffer,A,w);return[_,d]}async readFile(o,a){const w=this.transformIncoming(o,a,!0),_=await this.fsProvider.readFile(w);return R.VSBuffer.wrap(_)}write(o,a,w,_,A){return this.fsProvider.write(o,a,w.buffer,_,A)}writeFile(o,a,w,_){const A=this.transformIncoming(o,a);return this.fsProvider.writeFile(A,w.buffer,_)}rename(o,a,w,_){const A=C.URI.revive(o.transformIncoming(a)),d=C.URI.revive(o.transformIncoming(w));return this.fsProvider.rename(A,d,_)}copy(o,a,w,_){const A=this.transformIncoming(o,a),d=this.transformIncoming(o,w);return this.fsProvider.copy(A,d,_)}mkdir(o,a){const w=this.transformIncoming(o,a);return this.fsProvider.mkdir(w)}delete(o,a,w){const _=this.transformIncoming(o,a);return this.fsProvider.delete(_,w)}transformIncoming(o,a,w=!1){if(w&&a.path==="/vscode-resource"&&a.query){const _=JSON.parse(a.query).requestResourcePath;return C.URI.from({scheme:"file",path:_})}return C.URI.revive(o.transformIncoming(a))}watch(o,a,w,_){const A=o+a,d=this.fileWatchers.get(o);if(d){const l=d.watch(a,w,_);this.watchRequests.set(A,l)}}unwatch(o,a){const w=o+a,_=this.watchRequests.get(w);_&&((0,b.dispose)(_),this.watchRequests.delete(w))}dispose(){super.dispose(),this.watchRequests.forEach(o=>(0,b.dispose)(o)),this.watchRequests.clear(),this.fileWatchers.forEach(o=>(0,b.dispose)(o)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=p}),define(de[66],me([0,1,157,166,55,7,27]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:E.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":C.OPTIONS["disable-telemetry"],"extensions-dir":C.OPTIONS["extensions-dir"],"extensions-download-dir":C.OPTIONS["extensions-download-dir"],"install-extension":C.OPTIONS["install-extension"],"install-builtin-extension":C.OPTIONS["install-builtin-extension"],"uninstall-extension":C.OPTIONS["uninstall-extension"],"locate-extension":C.OPTIONS["locate-extension"],"list-extensions":C.OPTIONS["list-extensions"],force:C.OPTIONS.force,"show-versions":C.OPTIONS["show-versions"],category:C.OPTIONS.category,"do-not-sync":C.OPTIONS["do-not-sync"],"force-disable-user-env":C.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},log:{type:"string"},_:C.OPTIONS._},e.IServerEnvironmentService=(0,S.refineServiceDecorator)(k.IEnvironmentService);class R extends b.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=R}),define(de[205],me([0,1,15,64,78,236,61,29,119,5,3,40,30,4,8,23,24]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const _={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function A(t,n,r,s){n.writeHead(r,{"Content-Type":"text/plain"}),n.end(s)}e.serveError=A;async function d(t,n,r,s,u=Object.create(null)){try{const h=await C.promisify(E.stat)(s),y=`W/"${[h.ino,h.size,h.mtime.getTime()].join("-")}"`;if(n.headers["if-none-match"]===y)return r.writeHead(304),r.end();u["Content-Type"]=_[(0,D.extname)(s)]||(0,f.getMediaMime)(s)||"text/plain",u.Etag=y,r.writeHead(200,u),E.createReadStream(s).pipe(r)}catch(h){return h.code!=="ENOENT"&&(t.error(h),console.error(h.toString())),r.writeHead(404,{"Content-Type":"text/plain"}),r.end("Not found")}}e.serveFile=d;const l=(0,D.dirname)(o.FileAccess.asFileUri("",Y).fsPath);class c{constructor(n,r,s){this._connectionToken=n,this._environmentService=r,this._logService=s,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(n,r,s){try{const u=s.pathname;return u==="/favicon.ico"||u==="/manifest.json"||u==="/code-192.png"||u==="/code-512.png"?d(this._logService,n,r,(0,D.join)(l,"resources","server",u.substr(1))):/^\/static\//.test(u)?this._handleStatic(n,r,s):u==="/"?this._handleRoot(n,r,s):u==="/callback"?this._handleCallback(n,r,s):u==="/fetch-callback"?this._handleFetchCallback(n,r,s):A(n,r,404,"Not found.")}catch(u){return this._logService.error(u),console.error(u.toString()),A(n,r,500,"Internal Server Error.")}}_hasCorrectTokenCookie(n){return S.parse(n.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(n,r,s){const u=Object.create(null),h=decodeURIComponent(s.pathname),y=(0,D.normalize)(h.substr("/static/".length)),P=(0,D.join)(l,y);return(0,R.isEqualOrParent)(P,l,!m.isLinux)?d(this._logService,n,r,P,u):A(n,r,400,"Bad request.")}async _handleRoot(n,r,s){if(!n.headers.host)return A(n,r,400,"Bad request.");const u=s.query.tkn;if(typeof u=="string"){const te=Object.create(null);te["Set-Cookie"]=S.serialize("vscode-tkn",u,{sameSite:"strict",maxAge:60*60*24*7});const Q=Object.create(null);for(let ee in s.query)ee!=="tkn"&&(Q[ee]=s.query[ee]);const q=b.format({pathname:"/",query:Q});return te.Location=q,r.writeHead(302,te),r.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(n))return A(n,r,403,"Forbidden.");const h=n.headers.host,y=(0,I.createRemoteURITransformer)(h),{workspacePath:P,isFolder:v}=await this._getWorkspaceFromCLI();function g(te){return te.replace(/"/g,"&quot;")}let F;this._environmentService.driverHandle&&(F=!1);const O=o.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",Y).fsPath,x=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,a.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,oe=(await C.promisify(E.readFile)(O)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",g(JSON.stringify({folderUri:P&&v?y.transformOutgoing(i.URI.file(P)):void 0,workspaceUri:P&&!v?y.transformOutgoing(i.URI.file(P)):void 0,remoteAuthority:h,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:F,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>x?g(JSON.stringify(x)):""),W=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(oe).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${h};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return r.writeHead(200,{"Content-Type":"text/html","Set-Cookie":S.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":W}),r.end(oe)}_getScriptCspHashes(n){const r=/<script>([\s\S]+?)<\/script>/img,s=[];let u;for(;u=r.exec(n);){const h=k.createHash("sha256"),y=u[1].replace(/\r\n/g,`
`),P=h.update(Buffer.from(y)).digest().toString("base64");s.push(`'sha256-${P}'`)}return s}async _getWorkspaceFromCLI(){const n=this._environmentService.args.workspace;if(n&&n.length>0){const s=(0,R.sanitizeFilePath)(n,(0,w.cwd)());if(await C.promisify(E.exists)(s))return{workspacePath:s}}const r=this._environmentService.args.folder;if(r&&r.length>0){const s=(0,R.sanitizeFilePath)(r,(0,w.cwd)());if(await C.promisify(E.exists)(s))return{workspacePath:s,isFolder:!0}}return{}}_getFirstQueryValue(n,r){const s=n.query[r];return Array.isArray(s)?s[0]:s}_getFirstQueryValues(n,r){const s=new Map;for(const u in n.query)if(!(r&&r.indexOf(u)>=0)){const h=this._getFirstQueryValue(n,u);typeof h=="string"&&s.set(u,h)}return s}async _handleCallback(n,r,s){const u=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[h,y,P,v,g,F]=u.map(oe=>{const W=this._getFirstQueryValue(s,oe);return W&&decodeURIComponent(W)});if(!h)return r.writeHead(400,{"Content-Type":"text/plain"}),r.end("Bad request.");let O=g,x=0;return this._getFirstQueryValues(s,u).forEach((oe,W)=>{O||(O=""),O+=`${x++==0?"":"&"}${W}=${oe}`}),this._mapCallbackUriToRequestId.set(h,i.URI.from({scheme:y||p.default.urlProtocol,authority:P,path:v,query:O,fragment:F}).toJSON()),d(this._logService,n,r,o.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",Y).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(n,r,s){const u=this._getFirstQueryValue(s,"vscode-requestId");if(!u)return r.writeHead(400,{"Content-Type":"text/plain"}),r.end("Bad request.");const h=this._mapCallbackUriToRequestId.get(u);return h&&this._mapCallbackUriToRequestId.delete(u),r.writeHead(200,{"Content-Type":"text/json"}),r.end(JSON.stringify(h))}}e.WebClientServer=c}),define(de[206],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class b{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=b}),define(de[207],me([0,1,6]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var b;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(b=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,S=k=>{let R=C.get(k);return R||(R={children:new Map,bus:new E.Emitter},C.set(k,R)),R};e.getPrivateApiFor=S});var yt=this&&this.__classPrivateFieldSet||function(Y,e,E,b,C){if(b==="m")throw new TypeError("Private method is not writable");if(b==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return b==="a"?C.call(Y,E):C?C.value=E:e.set(Y,E),E},ot=this&&this.__classPrivateFieldGet||function(Y,e,E,b){if(E==="a"&&!b)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?b:E==="a"?b.call(Y):b?b.value:e.get(Y)},Xt=this&&this.__rest||function(Y,e){var E={};for(var b in Y)Object.prototype.hasOwnProperty.call(Y,b)&&e.indexOf(b)<0&&(E[b]=Y[b]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,b=Object.getOwnPropertySymbols(Y);C<b.length;C++)e.indexOf(b[C])<0&&Object.prototype.propertyIsEnumerable.call(Y,b[C])&&(E[b[C]]=Y[b[C]]);return E};define(de[100],me([0,1,19,12,73,26,13,11,3,23,22,95,207]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p){"use strict";var D,o,a,w,_,A,d,l,c,t,n,r,s,u,h,y;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(M){function N(){return Reflect.construct(M,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(M,"name")),Object.setPrototypeOf(N,M),Object.setPrototypeOf(N.prototype,M.prototype),N}let v=a=class{constructor(N){D.set(this,void 0),yt(this,D,N,"f")}static from(...N){let X=N;return new a(function(){if(X){for(const pe of X)pe&&typeof pe.dispose=="function"&&pe.dispose();X=void 0}})}dispose(){typeof ot(this,D,"f")=="function"&&(ot(this,D,"f").call(this),yt(this,D,void 0,"f"))}};D=new WeakMap,v=a=Oe([P],v),e.Disposable=v;let g=w=class{constructor(N,X){if(N<0)throw(0,b.illegalArgument)("line must be non-negative");if(X<0)throw(0,b.illegalArgument)("character must be non-negative");this._line=N,this._character=X}static Min(...N){if(N.length===0)throw new TypeError;let X=N[0];for(let pe=1;pe<N.length;pe++){const Be=N[pe];Be.isBefore(X)&&(X=Be)}return X}static Max(...N){if(N.length===0)throw new TypeError;let X=N[0];for(let pe=1;pe<N.length;pe++){const Be=N[pe];Be.isAfter(X)&&(X=Be)}return X}static isPosition(N){if(!N)return!1;if(N instanceof w)return!0;let{line:X,character:pe}=N;return typeof X=="number"&&typeof pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,X=0){if(N===null||X===null)throw(0,b.illegalArgument)();let pe;return typeof N=="undefined"?pe=0:typeof N=="number"?pe=N:(pe=typeof N.lineDelta=="number"?N.lineDelta:0,X=typeof N.characterDelta=="number"?N.characterDelta:0),pe===0&&X===0?this:new w(this.line+pe,this.character+X)}with(N,X=this.character){if(N===null||X===null)throw(0,b.illegalArgument)();let pe;return typeof N=="undefined"?pe=this.line:typeof N=="number"?pe=N:(pe=typeof N.line=="number"?N.line:this.line,X=typeof N.character=="number"?N.character:this.character),pe===this.line&&X===this.character?this:new w(pe,X)}toJSON(){return{line:this.line,character:this.character}}};g=w=Oe([P],g),e.Position=g;let F=_=class{constructor(N,X,pe,Be){let Ge,Ze;if(typeof N=="number"&&typeof X=="number"&&typeof pe=="number"&&typeof Be=="number"?(Ge=new g(N,X),Ze=new g(pe,Be)):N instanceof g&&X instanceof g&&(Ge=N,Ze=X),!Ge||!Ze)throw new Error("Invalid arguments");Ge.isBefore(Ze)?(this._start=Ge,this._end=Ze):(this._start=Ze,this._end=Ge)}static isRange(N){return N instanceof _?!0:N?g.isPosition(N.start)&&g.isPosition(N.end):!1}get start(){return this._start}get end(){return this._end}contains(N){return N instanceof _?this.contains(N._start)&&this.contains(N._end):N instanceof g?!(N.isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const X=g.Max(N.start,this._start),pe=g.Min(N.end,this._end);if(!X.isAfter(pe))return new _(X,pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const X=g.Min(N.start,this._start),pe=g.Max(N.end,this.end);return new _(X,pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,X=this.end){if(N===null||X===null)throw(0,b.illegalArgument)();let pe;return N?g.isPosition(N)?pe=N:(pe=N.start||this.start,X=N.end||this.end):pe=this.start,pe.isEqual(this._start)&&X.isEqual(this.end)?this:new _(pe,X)}toJSON(){return[this.start,this.end]}};F=_=Oe([P],F),e.Range=F;let O=A=class extends F{constructor(N,X,pe,Be){let Ge,Ze;if(typeof N=="number"&&typeof X=="number"&&typeof pe=="number"&&typeof Be=="number"?(Ge=new g(N,X),Ze=new g(pe,Be)):N instanceof g&&X instanceof g&&(Ge=N,Ze=X),!Ge||!Ze)throw new Error("Invalid arguments");super(Ge,Ze);this._anchor=Ge,this._active=Ze}static isSelection(N){return N instanceof A?!0:N?F.isRange(N)&&g.isPosition(N.anchor)&&g.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=A=Oe([P],O),e.Selection=O;class x{constructor(N,X,pe){if(typeof N!="string"||N.length===0)throw(0,b.illegalArgument)("host");if(typeof X!="number"||X===0||Math.round(X)!==X)throw(0,b.illegalArgument)("port");if(typeof pe!="undefined"&&(typeof pe!="string"||pe.length===0||!/^[0-9A-Za-z\-]+$/.test(pe)))throw(0,b.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(X),this.connectionToken=pe}}e.ResolvedAuthority=x;class oe extends Error{constructor(N,X=I.RemoteAuthorityResolverErrorCode.Unknown,pe){super(N);this._message=N,this._code=X,this._detail=pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,oe.prototype)}static NotAvailable(N,X){return new oe(N,I.RemoteAuthorityResolverErrorCode.NotAvailable,X)}static TemporarilyNotAvailable(N){return new oe(N,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=oe;var W;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var te;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(te=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=d=class{constructor(N,X){this._range=N,this._newText=X}static isTextEdit(N){return N instanceof d?!0:N?F.isRange(N)&&typeof N.newText=="string":!1}static replace(N,X){return new d(N,X)}static insert(N,X){return d.replace(new F(N,N),X)}static delete(N){return d.replace(N,"")}static setEndOfLine(N){const X=new d(new F(new g(0,0),new g(0,0)),"");return X.newEol=N,X}get range(){return this._range}set range(N){if(N&&!F.isRange(N))throw(0,b.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,b.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,b.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=d=Oe([P],Q),e.TextEdit=Q;var q;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellOutput=4]="CellOutput",M[M.CellReplace=5]="CellReplace",M[M.CellOutputItem=6]="CellOutputItem"})(q=e.FileEditType||(e.FileEditType={}));let ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,X,pe,Be){this._edits.push({_type:1,from:N,to:X,options:pe,metadata:Be})}createFile(N,X,pe){this._edits.push({_type:1,from:void 0,to:N,options:X,metadata:pe})}deleteFile(N,X,pe){this._edits.push({_type:1,from:N,to:void 0,options:X,metadata:pe})}replaceNotebookMetadata(N,X,pe){this._edits.push({_type:3,metadata:pe,uri:N,edit:{editType:5,metadata:X},notebookMetadata:X})}replaceNotebookCells(N,X,pe,Be,Ge){let Ze,nt,at=[],ct;if(wt.isNotebookRange(X)&&vt.isNotebookCellDataArray(pe)&&!vt.isNotebookCellDataArray(Be)?(Ze=X.start,nt=X.end,at=pe,ct=Be):typeof X=="number"&&typeof pe=="number"&&vt.isNotebookCellDataArray(Be)&&(Ze=X,nt=pe,at=Be,ct=Ge),Ze===void 0||nt===void 0)throw new Error("Invalid arguments");(Ze!==nt||at.length>0)&&this._edits.push({_type:5,uri:N,index:Ze,count:nt-Ze,cells:at,metadata:ct})}replaceNotebookCellMetadata(N,X,pe,Be){this._edits.push({_type:3,metadata:Be,uri:N,edit:{editType:8,index:X,metadata:pe}})}replace(N,X,pe,Be){this._edits.push({_type:2,uri:N,edit:new Q(X,pe),metadata:Be})}insert(N,X,pe,Be){this.replace(N,new F(X,X),pe,Be)}delete(N,X,pe){this.replace(N,X,"",pe)}has(N){return this._edits.some(X=>X._type===2&&X.uri.toString()===N.toString())}set(N,X){if(X)for(const pe of X)pe&&this._edits.push({_type:2,uri:N,edit:pe});else{for(let pe=0;pe<this._edits.length;pe++){const Be=this._edits[pe];Be._type===2&&Be.uri.toString()===N.toString()&&(this._edits[pe]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(N){const X=[];for(let pe of this._edits)pe._type===2&&pe.uri.toString()===N.toString()&&X.push(pe.edit);return X}entries(){const N=new S.ResourceMap;for(let X of this._edits)if(X._type===2){let pe=N.get(X.uri);pe||(pe=[X.uri,[]],N.set(X.uri,pe)),pe[1].push(X.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ee=Oe([P],ee),e.WorkspaceEdit=ee;let H=l=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=l._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,X=this._tabstop++){if(typeof N=="function"){const pe=new l;pe._tabstop=this._tabstop,N(pe),this._tabstop=pe._tabstop,N=pe.value}else N=l._escape(N);return this.value+="${",this.value+=X,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,X=this._tabstop++){const pe=N.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=X,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(N,X){if(typeof X=="function"){const pe=new l;pe._tabstop=this._tabstop,X(pe),this._tabstop=pe._tabstop,X=pe.value}else typeof X=="string"&&(X=X.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,X&&(this.value+=":",this.value+=X),this.value+="}",this}};H=l=Oe([P],H),e.SnippetString=H;var T;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(T=e.DiagnosticTag||(e.DiagnosticTag={}));var L;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let B=c=class{constructor(N,X){if(this.uri=N,X)if(X instanceof F)this.range=X;else if(X instanceof g)this.range=new F(X,X);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof c?!0:N?F.isRange(N.range)&&f.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};B=c=Oe([P],B),e.Location=B;let U=class{constructor(N,X){this.location=N,this.message=X}static is(N){return N?typeof N.message=="string"&&N.location&&F.isRange(N.location.range)&&f.URI.isUri(N.location.uri):!1}static isEqual(N,X){return N===X?!0:!N||!X?!1:N.message===X.message&&N.location.range.isEqual(X.location.range)&&N.location.uri.toString()===X.location.uri.toString()}};U=Oe([P],U),e.DiagnosticRelatedInformation=U;let V=class{constructor(N,X,pe=L.Error){if(!F.isRange(N))throw new TypeError("range must be set");if(!X)throw new TypeError("message must be set");this.range=N,this.message=X,this.severity=pe}toJSON(){return{severity:L[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,X){return N===X?!0:!N||!X?!1:N.message===X.message&&N.severity===X.severity&&N.code===X.code&&N.severity===X.severity&&N.source===X.source&&N.range.isEqual(X.range)&&(0,E.equals)(N.tags,X.tags)&&(0,E.equals)(N.relatedInformation,X.relatedInformation,U.isEqual)}};V=Oe([P],V),e.Diagnostic=V;let ie=class{constructor(N,X){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:(0,C.isMarkdownString)(N)?this.contents=[N]:this.contents=[N],this.range=X}};ie=Oe([P],ie),e.Hover=ie;var le;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ue=class{constructor(N,X=le.Text){this.range=N,this.kind=X}toJSON(){return{range:this.range,kind:le[this.kind]}}};ue=Oe([P],ue),e.DocumentHighlight=ue;var we;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(we=e.SymbolKind||(e.SymbolKind={}));var ke;(function(M){M[M.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Ae=t=class{constructor(N,X,pe,Be,Ge){this.name=N,this.kind=X,this.containerName=Ge,typeof pe=="string"&&(this.containerName=pe),Be instanceof B?this.location=Be:pe instanceof F&&(this.location=new B(Be,pe)),t.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:we[this.kind],location:this.location,containerName:this.containerName}}};Ae=t=Oe([P],Ae),e.SymbolInformation=Ae;let Fe=n=class{constructor(N,X,pe,Be,Ge){this.name=N,this.detail=X,this.kind=pe,this.range=Be,this.selectionRange=Ge,this.children=[],n.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(n.validate)}};Fe=n=Oe([P],Fe),e.DocumentSymbol=Fe;var je;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Qe=class{constructor(N,X){this.title=N,this.kind=X}};Qe=Oe([P],Qe),e.CodeAction=Qe;let qe=r=class{constructor(N){this.value=N}append(N){return new r(this.value?this.value+r.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+r.sep)}};qe.sep=".",qe=r=Oe([P],qe),e.CodeActionKind=qe,qe.Empty=new qe(""),qe.QuickFix=qe.Empty.append("quickfix"),qe.Refactor=qe.Empty.append("refactor"),qe.RefactorExtract=qe.Refactor.append("extract"),qe.RefactorInline=qe.Refactor.append("inline"),qe.RefactorRewrite=qe.Refactor.append("rewrite"),qe.Source=qe.Empty.append("source"),qe.SourceOrganizeImports=qe.Source.append("organizeImports"),qe.SourceFixAll=qe.Source.append("fixAll");let it=class{constructor(N,X){if(this.range=N,this.parent=X,X&&!X.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};it=Oe([P],it),e.SelectionRange=it;class tt{constructor(N,X,pe,Be,Ge,Ze){this.kind=N,this.name=X,this.detail=pe,this.uri=Be,this.range=Ge,this.selectionRange=Ze}}e.CallHierarchyItem=tt;class ye{constructor(N,X){this.fromRanges=X,this.from=N}}e.CallHierarchyIncomingCall=ye;class be{constructor(N,X){this.fromRanges=X,this.to=N}}e.CallHierarchyOutgoingCall=be;let _e=class{constructor(N,X){this.range=N,this.command=X}get isResolved(){return!!this.command}};_e=Oe([P],_e),e.CodeLens=_e;let Ie=s=class{constructor(N,X=!1){o.set(this,void 0),yt(this,o,new C.MarkdownString(N,{supportThemeIcons:X}),"f")}static isMarkdownString(N){return N instanceof s?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return ot(this,o,"f").value}set value(N){ot(this,o,"f").value=N}get isTrusted(){return ot(this,o,"f").isTrusted}set isTrusted(N){ot(this,o,"f").isTrusted=N}get supportThemeIcons(){return ot(this,o,"f").supportThemeIcons}appendText(N){return ot(this,o,"f").appendText(N),this}appendMarkdown(N){return ot(this,o,"f").appendMarkdown(N),this}appendCodeblock(N,X){return ot(this,o,"f").appendCodeblock(X!=null?X:"",N),this}};o=new WeakMap,Ie=s=Oe([P],Ie),e.MarkdownString=Ie;let Le=class{constructor(N,X){this.label=N,this.documentation=X}};Le=Oe([P],Le),e.ParameterInformation=Le;let ze=class{constructor(N,X){this.label=N,this.documentation=X,this.parameters=[]}};ze=Oe([P],ze),e.SignatureInformation=ze;let We=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};We=Oe([P],We),e.SignatureHelp=We;var Ke;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(Ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(M){M[M.Other=0]="Other",M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(et=e.InlineHintKind||(e.InlineHintKind={}));let se=class{constructor(N,X,pe){this.text=N,this.range=X,this.kind=pe}};se=Oe([P],se),e.InlineHint=se;var ve;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ge;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(ge=e.CompletionItemKind||(e.CompletionItemKind={}));var Ne;(function(M){M[M.Deprecated=1]="Deprecated"})(Ne=e.CompletionItemTag||(e.CompletionItemTag={}));let j=class{constructor(N,X){this.label=N,this.kind=X}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};j=Oe([P],j),e.CompletionItem=j;let K=class{constructor(N=[],X=!1){this.items=N,this.isIncomplete=X}};K=Oe([P],K),e.CompletionList=K;var ne;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(ne=e.ViewColumn||(e.ViewColumn={}));var z;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(z=e.StatusBarAlignment||(e.StatusBarAlignment={}));var G;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var re;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(re=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Re;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Re=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function N(X){switch(X){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=N}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ce=class{constructor(N,X){if(X&&!f.URI.isUri(X))throw(0,b.illegalArgument)("target");if(!F.isRange(N)||N.isEmpty)throw(0,b.illegalArgument)("range");this.range=N,this.target=X}};Ce=Oe([P],Ce),e.DocumentLink=Ce;let Pe=class{constructor(N,X,pe,Be){this.red=N,this.green=X,this.blue=pe,this.alpha=Be}};Pe=Oe([P],Pe),e.Color=Pe;let fe=class{constructor(N,X){if(X&&!(X instanceof Pe))throw(0,b.illegalArgument)("color");if(!F.isRange(N)||N.isEmpty)throw(0,b.illegalArgument)("range");this.range=N,this.color=X}};fe=Oe([P],fe),e.ColorInformation=fe;let Se=class{constructor(N){if(!N||typeof N!="string")throw(0,b.illegalArgument)("label");this.label=N}};Se=Oe([P],Se),e.ColorPresentation=Se;var Te;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Te=e.ColorFormat||(e.ColorFormat={}));var Me;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Me=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ue;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Xe;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Xe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ye=u=class{constructor(N,X){if(typeof N!="string"||typeof X!="string")throw(0,b.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};Ye.Clean=new u("clean","Clean"),Ye.Build=new u("build","Build"),Ye.Rebuild=new u("rebuild","Rebuild"),Ye.Test=new u("test","Test"),Ye=u=Oe([P],Ye),e.TaskGroup=Ye;function ae(M){let N="";for(let X=0;X<M.length;X++)N+=M[X].replace(/,/g,",,")+",";return N}let he=class{constructor(N,X,pe){if(typeof N!="string")throw(0,b.illegalArgument)("process");this._args=[],this._process=N,X!==void 0&&(Array.isArray(X)?(this._args=X,this._options=pe):this._options=X)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,b.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let X of this._args)N.push(X);return ae(N)}};he=Oe([P],he),e.ProcessExecution=he;let J=class{constructor(N,X,pe){if(this._args=[],Array.isArray(X)){if(!N)throw(0,b.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,b.illegalArgument)("command");this._command=N,this._args=X,this._options=pe}else{if(typeof N!="string")throw(0,b.illegalArgument)("commandLine");this._commandLine=N,this._options=X}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,b.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,b.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let X of this._args)N.push(typeof X=="string"?X:X.value);return ae(N)}};J=Oe([P],J),e.ShellExecution=J;var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($=e.ShellQuoting||(e.ShellQuoting={}));var De;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(De=e.TaskScope||(e.TaskScope={}));class Ee{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,m.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=Ee;let $e=h=class{constructor(N,X,pe,Be,Ge,Ze){this.__deprecated=!1,this._definition=this.definition=N;let nt;typeof X=="string"?(this._name=this.name=X,this._source=this.source=pe,this.execution=Be,nt=Ge,this.__deprecated=!0):X===De.Global||X===De.Workspace?(this.target=X,this._name=this.name=pe,this._source=this.source=Be,this.execution=Ge,nt=Ze):(this.target=X,this._name=this.name=pe,this._source=this.source=Be,this.execution=Ge,nt=Ze),typeof nt=="string"?(this._problemMatchers=[nt],this._hasDefinedMatchers=!0):Array.isArray(nt)?(this._problemMatchers=nt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof he?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof J?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Ee?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,m.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,b.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,b.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const X=this._definition.type;(h.EmptyType===X||h.ProcessType===X||h.ShellType===X||h.ExtensionCallbackType===X)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,b.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};$e.ExtensionCallbackType="customExecution",$e.ProcessType="process",$e.ShellType="shell",$e.EmptyType="$empty",$e=h=Oe([P],$e),e.Task=$e;var He;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(He=e.ProgressLocation||(e.ProgressLocation={}));let Je=class{constructor(N,X=rt.None){this.collapsibleState=X,f.URI.isUri(N)?this.resourceUri=N:this.label=N}};Je=Oe([P],Je),e.TreeItem=Je;var rt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ve=class{constructor(N,X){this.id=N,this.color=X}};Ve=Oe([P],Ve),e.ThemeIcon=Ve,Ve.File=new Ve("file"),Ve.Folder=new Ve("folder");let lt=class{constructor(N){this.id=N}};lt=Oe([P],lt),e.ThemeColor=lt;var ut;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ft=class{constructor(N,X){if(typeof N!="string"&&(!N||!f.URI.isUri(N)&&!f.URI.isUri(N.uri)))throw(0,b.illegalArgument)("base");if(typeof X!="string")throw(0,b.illegalArgument)("pattern");typeof N=="string"?(this.baseFolder=f.URI.file(N),this.base=N):f.URI.isUri(N)?(this.baseFolder=N,this.base=N.fsPath):(this.baseFolder=N.uri,this.base=N.uri.fsPath),this.pattern=X}};ft=Oe([P],ft),e.RelativePattern=ft;let gt=class{constructor(N,X,pe,Be){this.enabled=typeof N=="boolean"?N:!0,typeof X=="string"&&(this.condition=X),typeof pe=="string"&&(this.hitCondition=pe),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=(0,m.generateUuid)()),this._id}};gt=Oe([P],gt),e.Breakpoint=gt;let Ct=class extends gt{constructor(N,X,pe,Be,Ge){super(X,pe,Be,Ge);if(N===null)throw(0,b.illegalArgument)("location");this.location=N}};Ct=Oe([P],Ct),e.SourceBreakpoint=Ct;let It=class extends gt{constructor(N,X,pe,Be,Ge){super(X,pe,Be,Ge);this.functionName=N}};It=Oe([P],It),e.FunctionBreakpoint=It;let Pt=class extends gt{constructor(N,X,pe,Be,Ge,Ze,nt){super(Be,Ge,Ze,nt);if(!X)throw(0,b.illegalArgument)("dataId");this.label=N,this.dataId=X,this.canPersist=pe}};Pt=Oe([P],Pt),e.DataBreakpoint=Pt;let kt=class{constructor(N,X,pe){this.command=N,this.args=X||[],this.options=pe}};kt=Oe([P],kt),e.DebugAdapterExecutable=kt;let At=class{constructor(N,X){this.port=N,this.host=X}};At=Oe([P],At),e.DebugAdapterServer=At;let Rt=class{constructor(N){this.path=N}};Rt=Oe([P],Rt),e.DebugAdapterNamedPipeServer=Rt;let Tt=class{constructor(N){this.implementation=N}};Tt=Oe([P],Tt),e.DebugAdapterInlineImplementation=Tt;let Lt=class{constructor(N,X){this.range=N,this.expression=X}};Lt=Oe([P],Lt),e.EvaluatableExpression=Lt;let Ft=class{constructor(N,X){this.range=N,this.text=X}};Ft=Oe([P],Ft),e.InlineValueText=Ft;let Ot=class{constructor(N,X,pe=!0){this.range=N,this.variableName=X,this.caseSensitiveLookup=pe}};Ot=Oe([P],Ot),e.InlineValueVariableLookup=Ot;let Nt=class{constructor(N,X){this.range=N,this.expression=X}};Nt=Oe([P],Nt),e.InlineValueEvaluatableExpression=Nt;let Mt=class{constructor(N,X){this.frameId=N,this.stoppedLocation=X}};Mt=Oe([P],Mt),e.InlineValueContext=Mt;var Zt;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Zt=e.FileChangeType||(e.FileChangeType={}));let Ut=y=class extends Error{constructor(N,X=i.FileSystemProviderErrorCode.Unknown,pe){var Be;super(f.URI.isUri(N)?N.toString(!0):N);this.code=(Be=pe==null?void 0:pe.name)!==null&&Be!==void 0?Be:"Unknown",(0,i.markAsFileSystemProviderError)(this,X),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}static FileExists(N){return new y(N,i.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(N){return new y(N,i.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(N){return new y(N,i.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(N){return new y(N,i.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(N){return new y(N,i.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(N){return new y(N,i.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};Ut=y=Oe([P],Ut),e.FileSystemError=Ut;let Bt=class{constructor(N,X,pe){this.start=N,this.end=X,this.kind=pe}};Bt=Oe([P],Bt),e.FoldingRange=Bt;var en;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var tn;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(tn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var nn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(nn=e.CommentMode||(e.CommentMode={}));class rn{constructor(N,X=[]){this.tokenTypes=N,this.tokenModifiers=X}}e.SemanticTokensLegend=rn;function sn(M){return typeof M=="undefined"||(0,R.isStringArray)(M)}class jt{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let X=0,pe=N.tokenTypes.length;X<pe;X++)this._tokenTypeStrToInt.set(N.tokenTypes[X],X);for(let X=0,pe=N.tokenModifiers.length;X<pe;X++)this._tokenModifierStrToInt.set(N.tokenModifiers[X],X)}}push(N,X,pe,Be,Ge){if(typeof N=="number"&&typeof X=="number"&&typeof pe=="number"&&typeof Be=="number"&&(typeof Ge=="number"||typeof Ge=="undefined"))return typeof Ge=="undefined"&&(Ge=0),this._pushEncoded(N,X,pe,Be,Ge);if(F.isRange(N)&&typeof X=="string"&&sn(pe))return this._push(N,X,pe);throw(0,b.illegalArgument)()}_push(N,X,pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(X))throw new Error("`tokenType` is not in the provided legend");const Be=N.start.line,Ge=N.start.character,Ze=N.end.character-N.start.character,nt=this._tokenTypeStrToInt.get(X);let at=0;if(pe)for(const ct of pe){if(!this._tokenModifierStrToInt.has(ct))throw new Error("`tokenModifier` is not in the provided legend");const ht=this._tokenModifierStrToInt.get(ct);at|=1<<ht>>>0}this._pushEncoded(Be,Ge,Ze,nt,at)}_pushEncoded(N,X,pe,Be,Ge){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&X<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const at=this._data.length/5|0;let ct=0,ht=0;for(let dt=0;dt<at;dt++){let mt=this._data[5*dt],bt=this._data[5*dt+1];mt===0?(mt=ct,bt+=ht):mt+=ct,this._data[5*dt]=mt,this._data[5*dt+1]=bt,ct=mt,ht=bt}}let Ze=N,nt=X;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(nt-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=nt,this._data[this._dataLen++]=pe,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=Ge,this._prevLine=N,this._prevChar=X}static _sortAndDeltaEncode(N){let X=[];const pe=N.length/5|0;for(let nt=0;nt<pe;nt++)X[nt]=nt;X.sort((nt,at)=>{const ct=N[5*nt],ht=N[5*at];if(ct===ht){const dt=N[5*nt+1],mt=N[5*at+1];return dt-mt}return ct-ht});const Be=new Uint32Array(N.length);let Ge=0,Ze=0;for(let nt=0;nt<pe;nt++){const at=5*X[nt],ct=N[at+0],ht=N[at+1],dt=N[at+2],mt=N[at+3],bt=N[at+4],Qt=ct-Ge,Rn=Qt===0?ht-Ze:ht,St=5*nt;Be[St+0]=Qt,Be[St+1]=Rn,Be[St+2]=dt,Be[St+3]=mt,Be[St+4]=bt,Ge=ct,Ze=ht}return Be}build(N){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),N):new zt(jt._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=jt;class zt{constructor(N,X){this.resultId=X,this.data=N}}e.SemanticTokens=zt;class on{constructor(N,X,pe){this.start=N,this.deleteCount=X,this.data=pe}}e.SemanticTokensEdit=on;class an{constructor(N,X){this.resultId=X,this.edits=N}}e.SemanticTokensEdits=an;var ln;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(ln=e.DebugConsoleMode||(e.DebugConsoleMode={}));var cn;(function(M){M[M.Initial=1]="Initial",M[M.Dynamic=2]="Dynamic"})(cn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Dt=class{constructor(){}};Dt.Back={iconPath:new Ve("arrow-left")},Dt=Oe([P],Dt),e.QuickInputButtons=Dt;var un;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(un=e.ExtensionKind||(e.ExtensionKind={}));class fn{constructor(N,X,pe){this.badge=N,this.tooltip=X,this.color=pe}static validate(N){if(N.badge&&N.badge.length!==1&&N.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=fn;let $t=class{constructor(N){this.kind=N}};$t=Oe([P],$t),e.ColorTheme=$t;var hn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast"})(hn=e.ColorThemeKind||(e.ColorThemeKind={}));class wt{constructor(N,X){if(N<0)throw(0,b.illegalArgument)("start must be positive");if(X<0)throw(0,b.illegalArgument)("end must be positive");N<=X?(this._start=N,this._end=X):(this._start=X,this._end=N)}static isNotebookRange(N){return N instanceof wt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let X=this._start,pe=this._end;return N.start!==void 0&&(X=N.start),N.end!==void 0&&(pe=N.end),X===this._start&&pe===this._end?this:new wt(X,pe)}}e.NotebookRange=wt;class Wt{constructor(N,X){typeof N=="object"?Object.assign(this,N):(this.inputCollapsed=N,this.outputCollapsed=X)}with(N){let{inputCollapsed:X,outputCollapsed:pe}=N,Be=Xt(N,["inputCollapsed","outputCollapsed"]);return X===void 0?X=this.inputCollapsed:X===null&&(X=void 0),pe===void 0?pe=this.outputCollapsed:pe===null&&(pe=void 0),X===this.inputCollapsed&&pe===this.outputCollapsed&&Object.keys(Be).length===0?this:new Wt(Object.assign({inputCollapsed:X,outputCollapsed:pe},Be))}}e.NotebookCellMetadata=Wt;class _t{constructor(N=!0){var X;typeof N=="object"?(Object.assign(this,N),this.trusted=(X=N.trusted)!==null&&X!==void 0?X:!0):this.trusted=N}with(N){let{trusted:X}=N,pe=Xt(N,["trusted"]);return X===void 0?X=this.trusted:X===null&&(X=void 0),X===this.trusted&&Object.keys(pe).length===0?this:new _t(Object.assign({trusted:X},pe))}}e.NotebookDocumentMetadata=_t;class vt{constructor(N,X,pe,Be,Ge,Ze){this.kind=N,this.source=X,this.language=pe,this.outputs=Be!=null?Be:[],this.metadata=Ge,this.latestExecutionSummary=Ze}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(X=>vt.isNotebookCellData(X))}static isNotebookCellData(N){return!0}}e.NotebookCellData=vt;class dn{constructor(N,X){this.cells=N,this.metadata=X!=null?X:new _t}}e.NotebookData=dn;class Ht{constructor(N,X,pe){if(this.mime=N,this.value=X,this.metadata=pe,(0,k.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(N){return N instanceof Ht}}e.NotebookCellOutputItem=Ht;class mn{constructor(N,X,pe){this.outputs=N,typeof X=="string"?(this.id=X,this.metadata=pe):(this.id=(0,m.generateUuid)(),this.metadata=X!=null?X:pe)}}e.NotebookCellOutput=mn;var gn;(function(M){M[M.Markdown=1]="Markdown",M[M.Code=2]="Code"})(gn=e.NotebookCellKind||(e.NotebookCellKind={}));var vn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(vn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(pn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var yn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(yn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class wn{constructor(N,X,pe,Be,Ge,Ze){this.text=N,this.alignment=X,this.command=pe,this.tooltip=Be,this.priority=Ge,this.accessibilityInformation=Ze}}e.NotebookCellStatusBarItem=wn;var En;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(En=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));let qt=class{constructor(N,X){this.label=N,this.timestamp=X}};qt=Oe([P],qt),e.TimelineItem=qt;var bn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(bn=e.ExtensionMode||(e.ExtensionMode={}));var Sn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Dn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=4]="RegEx"})(Dn=e.StandardTokenType||(e.StandardTokenType={}));class _n{constructor(N,X){this.ranges=N,this.wordPattern=X}}e.LinkedEditingRanges=_n;var Cn;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(Cn=e.TestResultState||(e.TestResultState={}));var Yt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information",M[M.Hint=3]="Hint"})(Yt=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Jt;(function(M){M[M.Pending=0]="Pending",M[M.Resolved=1]="Resolved"})(Jt=e.TestItemStatus||(e.TestItemStatus={}));const pt=(M,N,X,pe)=>{let Be=X;return{enumerable:!0,configurable:!1,get(){return Be},set(Ge){pe(Be,Ge)||(Be=Ge,M.bus.fire([3,N,Ge]))}}},Et=(M,N)=>M===N,In=(M,N)=>M===N?!0:!M||!N?!1:M.isEqual(N);class Vt{constructor(N,X,pe,Be){this.label=X,this.data=Be;const Ge=(0,p.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:N,enumerable:!0,writable:!1},uri:{value:pe,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Ge.parent},children:{value:new S.ReadonlyMapView(Ge.children),enumerable:!0,writable:!1},range:pt(Ge,"range",void 0,In),description:pt(Ge,"description",void 0,Et),runnable:pt(Ge,"runnable",!0,Et),debuggable:pt(Ge,"debuggable",!0,Et),status:pt(Ge,"status",Jt.Resolved,Et),error:pt(Ge,"error",void 0,Et)})}invalidate(){(0,p.getPrivateApiFor)(this).bus.fire([2])}dispose(){const N=(0,p.getPrivateApiFor)(this);N.parent&&(0,p.getPrivateApiFor)(N.parent).children.delete(this.id),N.bus.fire([1])}addChild(N){if(!(N instanceof Vt))throw new Error("Test child must be created through vscode.test.createTestItem()");const X=(0,p.getPrivateApiFor)(this);if(X.children.has(N.id))throw new Error(`Attempted to insert a duplicate test item ID ${N.id}`);X.children.set(N.id,N),X.bus.fire([0,N])}}e.TestItemImpl=Vt;class Gt{constructor(N){this.message=N,this.severity=Yt.Error}static diff(N,X,pe){const Be=new Gt(N);return Be.expectedOutput=X,Be.actualOutput=pe,Be}}e.TestMessage=Gt;var Pn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(Pn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var kn;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(kn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var An;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore"})(An=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(de[208],me([0,1,46,8,4,5,58]),function(Y,e,E,b,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var R;(function(P){P[P.Markdown=1]="Markdown",P[P.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var f;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(f=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var m;(function(P){P[P.Idle=1]="Idle",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(P){P[P.WithHardKernelDependency=0]="WithHardKernelDependency",P[P.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",P[P.Pure=2]="Pure",P[P.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.CellClearOutput=3]="CellClearOutput",P[P.CellsClearOutput=4]="CellsClearOutput",P[P.ChangeLanguage=5]="ChangeLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var D;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.Move=6]="Move",P[P.OutputItems=7]="OutputItems",P[P.PartialMetadata=8]="PartialMetadata"})(D=e.CellEditType||(e.CellEditType={}));function o(P){const v=a.parse(P);return v?v.notebook.toString():P.toString()}e.getCellUndoRedoComparisonKey=o;var a;(function(P){P.scheme=b.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function g(oe,W){return oe.with({scheme:P.scheme,fragment:`ch${W.toString().padStart(7,"0")}${oe.scheme!==b.Schemas.file?oe.scheme:""}`})}P.generate=g;function F(oe){if(oe.scheme===P.scheme){const W=v.exec(oe.fragment);if(!!W)return{handle:Number(W[1]),notebook:oe.with({scheme:oe.fragment.substr(W[0].length)||b.Schemas.file,fragment:null})}}}P.parse=F;function O(oe,W){return oe.with({scheme:b.Schemas.vscodeNotebookCellMetadata,fragment:`ch${W.toString().padStart(7,"0")}${oe.scheme!==b.Schemas.file?oe.scheme:""}`})}P.generateCellMetadataUri=O;function x(oe){if(oe.scheme===b.Schemas.vscodeNotebookCellMetadata){const W=v.exec(oe.fragment);if(!!W)return{handle:Number(W[1]),notebook:oe.with({scheme:oe.fragment.substr(W[0].length)||b.Schemas.file,fragment:null})}}}P.parseCellMetadataUri=x})(a=e.CellUri||(e.CellUri={}));const w=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(P){var v,g;return(g=(v=w.get(P))===null||v===void 0?void 0:v.alwaysSecure)!==null&&g!==void 0?g:!1}e.mimeTypeIsAlwaysSecure=_;function A(P){var v,g;return(g=(v=w.get(P))===null||v===void 0?void 0:v.supportedByCore)!==null&&g!==void 0?g:!1}e.mimeTypeSupportedByCore=A;function d(P){var v,g;return(g=(v=w.get(P))===null||v===void 0?void 0:v.mergeable)!==null&&g!==void 0?g:!1}e.mimeTypeIsMergeable=d;function l(P,v){return S.isWindows&&(P=P.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),E.match(P,v)}function c(P,v,g){let F=0;for(let O=0;O<v.length;O++){if(l(v[O],P))return F;F++}for(let O=0;O<g.length;O++){if(l(g[O],P))return F;F++}return F}function t(P,v,g){return P.sort((F,O)=>c(F,v,g)-c(O,v,g))}e.sortMimeTypes=t;function n(P,v,g,F=(O,x)=>O===x){const O=[];function x(te,Q,q){if(!(Q===0&&q.length===0)){const ee=O[O.length-1];ee&&ee.start+ee.deleteCount===te?(ee.deleteCount+=Q,ee.toInsert.push(...q)):O.push({start:te,deleteCount:Q,toInsert:q})}}let oe=0,W=0;for(;;){if(oe===P.length){x(oe,0,v.slice(W));break}if(W===v.length){x(oe,P.length-oe,[]);break}const te=P[oe],Q=v[W];if(F(te,Q)){oe+=1,W+=1;continue}g(Q)?(x(oe,1,[]),oe+=1):(x(oe,0,[Q]),W+=1)}return O}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(P){P.default="default",P.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(P){const v=P;return!!((typeof v.include=="string"||E.isRelativePattern(v.include))&&(typeof v.exclude=="string"||E.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=s;function u(P,v,g){if(Array.isArray(P.viewType)&&P.viewType.indexOf(v)>=0||P.viewType===v)return!0;if(P.filenamePattern){let F=s(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,O=s(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(E.match(F,(0,C.basename)(g.fsPath).toLowerCase()))return!(O&&E.match(O,(0,C.basename)(g.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class h{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let g=0;g<this.textModel.cells.length;g++)v[g]=this.textModel.cells[g].getHashValue();return v}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var y;(function(P){P[P.Left=1]="Left",P[P.Right=2]="Right"})(y=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={})),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX="notebook/"}),define(de[101],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,E.createDecorator)("environmentVariableService");var b;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(b=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(de[209],me([0,1,5,101]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class C{constructor(f){this.map=new Map,f.forEach((m,i)=>{const I=m.map.entries();let p=I.next();for(;!p.done;){const D=p.value[0];let o=this.map.get(D);if(o||(o=[],this.map.set(D,o)),o.length>0&&o[0].type===b.EnvironmentVariableMutatorType.Replace){p=I.next();continue}const a=p.value[1];o.unshift({extensionIdentifier:i,value:a.value,type:a.type}),p=I.next()}})}applyToProcessEnvironment(f,m){let i;E.isWindows&&(i={},Object.keys(f).forEach(I=>i[I.toLowerCase()]=I)),this.map.forEach((I,p)=>{const D=E.isWindows&&i[p.toLowerCase()]||p;I.forEach(o=>{const a=m?m(o.value):o.value;switch(o.type){case b.EnvironmentVariableMutatorType.Append:f[D]=(f[D]||"")+a;break;case b.EnvironmentVariableMutatorType.Prepend:f[D]=a+(f[D]||"");break;case b.EnvironmentVariableMutatorType.Replace:f[D]=a;break}})})}diff(f){const m=new Map,i=new Map,I=new Map;if(f.map.forEach((p,D)=>{const o=this.map.get(D),a=S(p,o);a&&m.set(D,a)}),this.map.forEach((p,D)=>{const o=f.map.get(D),a=S(p,o);a&&I.set(D,a)}),this.map.forEach((p,D)=>{const o=f.map.get(D),a=k(p,o);a&&i.set(D,a)}),!(m.size===0&&i.size===0&&I.size===0))return{added:m,changed:i,removed:I}}}e.MergedEnvironmentVariableCollection=C;function S(R,f){if(!f)return R;const m=new Set;f.forEach(I=>m.add(I.extensionIdentifier));const i=[];return R.forEach(I=>{m.has(I.extensionIdentifier)||i.push(I)}),i.length===0?void 0:i}function k(R,f){if(!!f){const m=new Map;f.forEach(I=>m.set(I.extensionIdentifier,I));const i=[];return R.forEach(I=>{const p=m.get(I.extensionIdentifier);p&&(I.type!==p.type||I.value!==p.value)&&i.push(p)}),i.length===0?void 0:i}}}),define(de[102],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=E;function b(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=b}),define(de[210],me([0,1,4,113,5]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function S(c,t){if(!!t)if(C.isWindows)for(const n in t){let r=n;for(const u in c)if(n.toLowerCase()===u.toLowerCase()){r=u;break}const s=t[n];s!==void 0&&k(c,r,s)}else Object.keys(t).forEach(n=>{const r=t[n];r!==void 0&&k(c,n,r)})}e.mergeEnvironments=S;function k(c,t,n){typeof n=="string"?c[t]=n:delete c[t]}function R(c,t,n,r){c.TERM_PROGRAM="vscode",t&&(c.TERM_PROGRAM_VERSION=t),i(c,r)&&(c.LANG=I(n)),c.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=R;function f(c,t){if(!!t)for(const n of Object.keys(t)){const r=t[n];r&&(c[n]=r)}}function m(c,t){return Object.keys(t).forEach(n=>{const r=t[n];if(typeof r=="string")try{t[n]=c(r)}catch(s){t[n]=r}}),t}function i(c,t){if(t==="on")return!0;if(t==="auto"){const n=c.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=i;function I(c){const t=c?c.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in r&&t.push(r[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=I;function p(c,t,n,r,s,u){if(c.cwd){const y=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,P=D(y,n);return o(P||y)}let h;return!c.ignoreConfigurationCwd&&s&&(n&&(s=D(s,n,u)),s&&(E.isAbsolute(s)?h=s:r&&(h=E.join(r.fsPath,s)))),h||(h=r?r.fsPath:t||""),o(h)}e.getCwd=p;function D(c,t,n){if(t)try{return t(c)}catch(r){n==null||n.error("Could not resolve terminal cwd",r);return}return c}function o(c){return C.OS===1&&c&&c[1]===":"?c[0].toUpperCase()+c.substr(1):c}function a(c){let t=c;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=a;function w(c,t,n){if(!!n)return r=>n.resolveWithEnvironment(t,c,r)}e.createVariableResolver=w;function _(c,t,n,r,s,u,h,y=C.platform){let P;h&&(P=d(c,"automationShell",y)),P||(P=d(c,"shell",y));let v=P||t;if(y===3&&!n&&r){const g=E.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();v&&v.toLowerCase().indexOf(g)===0&&(v=E.join(r,"System32",v.substr(g.length+1)))}if(v&&y===3&&(v=v.replace(/\//g,"\\")),s)try{v=s(v)}catch(g){u.error("Could not resolve shell",g)}return v}e.getDefaultShell=_;function A(c,t,n,r,s=C.platform){if(t&&d(c,"automationShell",s))return[];const u=s===3?"windows":s===1?"osx":"linux";let h=c(`terminal.integrated.shellArgs.${u}`);if(!h)return[];if(typeof h=="string"&&s===3)return n?n(h):h;if(n){const y=[];for(const P of h)try{y.push(n(P))}catch(v){r.error(`Could not resolve terminal.integrated.shellArgs.${u}`,v),y.push(P)}h=y}return h}e.getDefaultShellArgs=A;function d(c,t,n=C.platform){return c(`terminal.integrated.${t}.${n===3?"windows":n===1?"osx":"linux"}`)}function l(c,t,n,r,s,u){let h={};if(c.strictEnv)f(h,c.env);else{f(h,u);const y=Object.assign({},t);n&&(y&&m(n,y),c.env&&m(n,c.env)),(0,b.sanitizeProcessEnvironment)(h,"VSCODE_IPC_HOOK_CLI"),S(h,y),S(h,c.env),R(h,r,C.locale,s)}return h}e.createTerminalEnvironment=l}),define(de[211],me([0,1,15,4,5]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMainProcessParentEnv=void 0;let S;async function k(R){if(S)return S;if(C.isLinux){const f=process.ppid,m=b.basename(process.argv[0]);let i=0,I=f,p=m;do i=I,(await E.promises.readFile(`/proc/${i}/status`,"utf8")).split(`
`).forEach(_=>{_.indexOf("Name:")===0&&(p=_.replace(/^Name:\s+/,"")),_.indexOf("PPid:")===0&&(I=parseInt(_.replace(/^PPid:\s+/,"")))});while(p===m);const D=await E.promises.readFile(`/proc/${i}/environ`,"utf8"),o={};D.split("\0").forEach(a=>{const w=a.indexOf("=");o[a.substr(0,w)]=a.substr(w+1)}),S=o}return C.isMacintosh&&(S={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(m=>{R[m]&&(S[m]=R[m])})),C.isWindows&&(S=R),S}e.getMainProcessParentEnv=k}),define(de[212],me([0,1,38,34,7,31]),function(Y,e,E,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.filterSettingsRequireWorkspaceTrust=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`;function k(R){const f=S.Registry.as(E.Extensions.Configuration);return R.filter(m=>{const i=f.getConfigurationProperties()[m];return i.restricted&&i.scope!==1&&i.scope!==2})}e.filterSettingsRequireWorkspaceTrust=k,e.IWorkbenchConfigurationService=(0,C.refineServiceDecorator)(b.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(de[213],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,E.createDecorator)("configurationResolverService")}),define(de[214],me([0,1,4,24,11,20,5,51,159]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class m{constructor(I,p,D){this._contributedVariables=new Map,this._context=I,this._labelService=p,D&&(this._envVariablesPromise=D.then(o=>this.prepareEnv(o)))}prepareEnv(I){if(k.isWindows){const p=Object.create(null);return Object.keys(I).forEach(D=>{p[D.toLowerCase()]=I[D]}),p}return I}resolveWithEnvironment(I,p,D){return this.recursiveResolve(this.prepareEnv(I),p?p.uri:void 0,D)}async resolveAsync(I,p){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,p)}async resolveAnyBase(I,p,D,o){const a=S.deepClone(p);return k.isWindows&&a.windows?Object.keys(a.windows).forEach(w=>a[w]=a.windows[w]):k.isMacintosh&&a.osx?Object.keys(a.osx).forEach(w=>a[w]=a.osx[w]):k.isLinux&&a.linux&&Object.keys(a.linux).forEach(w=>a[w]=a.linux[w]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a,D,o)}async resolveAnyAsync(I,p,D){return this.resolveAnyBase(I,p,D)}async resolveAnyMap(I,p,D){const o=new Map;return{newConfig:await this.resolveAnyBase(I,p,D,o),resolvedVariables:o}}resolveWithInteractionReplace(I,p,D,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,p,D,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,p){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,p)}recursiveResolve(I,p,D,o,a){if(C.isString(D))return this.resolveString(I,p,D,o,a);if(C.isArray(D))return D.map(w=>this.recursiveResolve(I,p,w,o,a));if(C.isObject(D)){let w=Object.create(null);return Object.keys(D).forEach(_=>{const A=this.resolveString(I,p,_,o,a);w[A]=this.recursiveResolve(I,p,D[_],o,a)}),w}return D}resolveString(I,p,D,o,a){return D.replace(m.VARIABLE_REGEXP,(_,A)=>{if(A.includes(m.VARIABLE_LHS))return _;let d=this.evaluateSingleVariable(I,_,A,p,o);return a&&a.set(A,d),d})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,p,D,o,a){let w;const _=D.split(":");_.length>1&&(D=_[0],w=_[1]);const A=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,f.localize)(0,null,p))},d=()=>{const c=A();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,f.localize)(1,null,p,E.basename(c)))},l=()=>{if(w){const c=this._context.getFolderUri(w);if(c)return c;throw new Error((0,f.localize)(2,null,p,w))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,f.localize)(3,null,p)):new Error((0,f.localize)(4,null,p))};switch(D){case"env":if(w){if(I){const c=I[k.isWindows?w.toLowerCase():w];if(C.isString(c))return c}return""}throw new Error((0,f.localize)(5,null,p));case"config":if(w){const c=this._context.getConfigurationValue(o,w);if(C.isUndefinedOrNull(c))throw new Error((0,f.localize)(6,null,p,w));if(C.isObject(c))throw new Error((0,f.localize)(7,null,p,w));return c}throw new Error((0,f.localize)(8,null,p));case"command":return this.resolveFromMap(p,w,a,"command");case"input":return this.resolveFromMap(p,w,a,"input");default:switch(D){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return o||w?(0,R.normalizeDriveLetter)(this.fsPath(l())):b.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(l()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,f.localize)(9,null,p));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,f.localize)(10,null,p));case"file":return A();case"fileWorkspaceFolder":return d();case"relativeFile":return o||w?E.relative(this.fsPath(l()),A()):A();case"relativeFileDirname":const n=E.dirname(A());if(o||w){const h=E.relative(this.fsPath(l()),n);return h.length===0?".":h}return n;case"fileDirname":return E.dirname(A());case"fileExtname":return E.extname(A());case"fileBasename":return E.basename(A());case"fileBasenameNoExtension":const r=E.basename(A());return r.slice(0,r.length-E.extname(r).length);case"fileDirnameBasename":return E.basename(E.dirname(A()));case"execPath":const s=this._context.getExecPath();return s||p;case"execInstallFolder":const u=this._context.getAppRoot();return u||p;case"pathSeparator":return E.sep;default:try{const h=w?`${D}:${w}`:D;return this.resolveFromMap(p,h,a,void 0)}catch(h){return p}}}}resolveFromMap(I,p,D,o){if(p&&D){const a=o===void 0?D[p]:D[o+":"+p];if(typeof a=="string")return a;throw new Error((0,f.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=m,m.VARIABLE_LHS="${",m.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(de[67],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(de[215],me([0,1,19,73,237,45,20,11,3,53,177,163,186,208,67,100]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(ae){function he($){const{selectionStartLineNumber:De,selectionStartColumn:Ee,positionLineNumber:$e,positionColumn:He}=$,Je=new a.Position(De-1,Ee-1),rt=new a.Position($e-1,He-1);return new a.Selection(Je,rt)}ae.to=he;function J($){const{anchor:De,active:Ee}=$;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Ee.line+1,positionColumn:Ee.character+1}}ae.from=J})(w=e.Selection||(e.Selection={}));var _;(function(ae){function he($){if(!!$){const{start:De,end:Ee}=$;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Ee.line+1,endColumn:Ee.character+1}}}ae.from=he;function J($){if(!!$){const{startLineNumber:De,startColumn:Ee,endLineNumber:$e,endColumn:He}=$;return new a.Range(De-1,Ee-1,$e-1,He-1)}}ae.to=J})(_=e.Range||(e.Range={}));var A;(function(ae){function he(J){switch(J){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}ae.to=he})(A=e.TokenType||(e.TokenType={}));var d;(function(ae){function he($){return new a.Position($.lineNumber-1,$.column-1)}ae.to=he;function J($){return{lineNumber:$.line+1,column:$.character+1}}ae.from=J})(d=e.Position||(e.Position={}));var l;(function(ae){function he($){switch($){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}ae.from=he;function J($){switch($){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}ae.to=J})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(ae){function he($){let De;return $.code&&((0,R.isString)($.code)||(0,R.isNumber)($.code)?De=String($.code):De={value:String($.code.value),target:$.code.target}),Object.assign(Object.assign({},_.from($.range)),{message:$.message,source:$.source,code:De,severity:n.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(t.from),tags:Array.isArray($.tags)?(0,E.coalesce)($.tags.map(l.from)):void 0})}ae.from=he;function J($){var De;const Ee=new a.Diagnostic(_.to($),$.message,n.to($.severity));return Ee.source=$.source,Ee.code=(0,R.isString)($.code)?$.code:(De=$.code)===null||De===void 0?void 0:De.value,Ee.relatedInformation=$.relatedInformation&&$.relatedInformation.map(t.to),Ee.tags=$.tags&&(0,E.coalesce)($.tags.map(l.to)),Ee}ae.to=J})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(ae){function he($){return Object.assign(Object.assign({},_.from($.location.range)),{message:$.message,resource:$.location.uri})}ae.from=he;function J($){return new a.DiagnosticRelatedInformation(new a.Location($.resource,_.to($)),$.message)}ae.to=J})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ae){function he($){switch($){case a.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ae.from=he;function J($){switch($){case p.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}ae.to=J})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(ae){function he($){return typeof $=="number"&&$>=a.ViewColumn.One?$-1:$===a.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}ae.from=he;function J($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=J})(r=e.ViewColumn||(e.ViewColumn={}));function s(ae){return typeof ae.range!="undefined"}function u(ae){return ae.length===0?!0:!!s(ae[0])}e.isDecorationOptionsArr=u;var h;(function(ae){function he(He){return He.map(ae.from)}ae.fromMany=he;function J(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function $(He){let Je;if(J(He)){const{language:ut,value:ft}=He;Je={value:"```"+ut+`
`+ft+"\n```\n"}}else a.MarkdownString.isMarkdownString(He)?Je={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons}:typeof He=="string"?Je={value:He}:Je={value:""};const rt=Object.create(null);Je.uris=rt;const Ve=ut=>{try{let ft=f.URI.parse(ut,!0);ft=ft.with({query:De(ft.query,rt)}),rt[ut]=ft}catch(ft){}return""},lt=new C.Renderer;return lt.link=Ve,lt.image=ut=>Ve(b.parseHrefAndDimensions(ut).href),C(Je.value,{renderer:lt}),Je}ae.from=$;function De(He,Je){if(!He)return He;let rt;try{rt=(0,S.parse)(He)}catch(lt){}if(!rt)return He;let Ve=!1;return rt=(0,k.cloneAndChange)(rt,lt=>{if(f.URI.isUri(lt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[ut]=lt,Ve=!0,ut}else return}),Ve?JSON.stringify(rt):He}function Ee(He){const Je=new a.MarkdownString(He.value,He.supportThemeIcons);return Je.isTrusted=He.isTrusted,Je}ae.to=Ee;function $e(He){if(!!He)return typeof He=="string"?He:ae.from(He)}ae.fromStrict=$e})(h=e.MarkdownString||(e.MarkdownString={}));function y(ae){return u(ae)?ae.map(he=>({range:_.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?h.fromMany(he.hoverMessage):he.hoverMessage?h.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):ae.map(he=>({range:_.from(he)}))}e.fromRangeOrRangeWithMessage=y;function P(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?f.URI.file(ae):ae}e.pathOrURIToURI=P;var v;(function(ae){function he(J){return typeof J=="undefined"?J:{contentText:J.contentText,contentIconPath:J.contentIconPath?P(J.contentIconPath):void 0,border:J.border,borderColor:J.borderColor,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,color:J.color,backgroundColor:J.backgroundColor,margin:J.margin,width:J.width,height:J.height}}ae.from=he})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var g;(function(ae){function he(J){return typeof J=="undefined"?J:{backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?P(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?v.from(J.before):void 0,after:J.after?v.from(J.after):void 0}}ae.from=he})(g=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ae){function he(J){if(typeof J=="undefined")return J;switch(J){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=he})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(ae){function he(J){return{isWholeLine:J.isWholeLine,rangeBehavior:J.rangeBehavior?F.from(J.rangeBehavior):void 0,overviewRulerLane:J.overviewRulerLane,light:J.light?g.from(J.light):void 0,dark:J.dark?g.from(J.dark):void 0,backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?P(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?v.from(J.before):void 0,after:J.after?v.from(J.after):void 0}}ae.from=he})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(ae){function he($){return{text:$.newText,eol:$.newEol&&Ke.from($.newEol),range:_.from($.range)}}ae.from=he;function J($){const De=new a.TextEdit(_.to($.range),$.text);return De.newEol=typeof $.eol=="undefined"?void 0:Ke.to($.eol),De}ae.to=J})(x=e.TextEdit||(e.TextEdit={}));var oe;(function(ae){function he($,De,Ee){var $e,He,Je;const rt={edits:[]};if($ instanceof a.WorkspaceEdit)for(let Ve of $._allEntries())if(Ve._type===1)rt.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata});else if(Ve._type===2){const lt=De==null?void 0:De.getDocument(Ve.uri);rt.edits.push({_type:2,resource:Ve.uri,edit:x.from(Ve.edit),modelVersionId:lt==null?void 0:lt.version,metadata:Ve.metadata})}else Ve._type===3?rt.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:($e=Ee==null?void 0:Ee.lookupNotebookDocument(Ve.uri))===null||$e===void 0?void 0:$e.apiNotebook.version}):Ve._type===4?(Ve.newOutputs&&rt.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:{editType:2,index:Ve.index,append:Ve.append,outputs:Ve.newOutputs.map(Re.from)}}),Ve.newMetadata&&rt.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:{editType:8,index:Ve.index,metadata:Ve.newMetadata}})):Ve._type===5?rt.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:(He=Ee==null?void 0:Ee.lookupNotebookDocument(Ve.uri))===null||He===void 0?void 0:He.apiNotebook.version,edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(re.from)}}):Ve._type===6&&rt.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:{editType:7,outputId:Ve.outputId,items:((Je=Ve.newOutputItems)===null||Je===void 0?void 0:Je.map(ce.from))||[],append:Ve.append}});return rt}ae.from=he;function J($){const De=new a.WorkspaceEdit;for(const Ee of $.edits)Ee.edit?De.replace(f.URI.revive(Ee.resource),_.to(Ee.edit.range),Ee.edit.text):De.renameFile(f.URI.revive(Ee.oldUri),f.URI.revive(Ee.newUri),Ee.options);return De}ae.to=J})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ae){const he=Object.create(null);he[a.SymbolKind.File]=0,he[a.SymbolKind.Module]=1,he[a.SymbolKind.Namespace]=2,he[a.SymbolKind.Package]=3,he[a.SymbolKind.Class]=4,he[a.SymbolKind.Method]=5,he[a.SymbolKind.Property]=6,he[a.SymbolKind.Field]=7,he[a.SymbolKind.Constructor]=8,he[a.SymbolKind.Enum]=9,he[a.SymbolKind.Interface]=10,he[a.SymbolKind.Function]=11,he[a.SymbolKind.Variable]=12,he[a.SymbolKind.Constant]=13,he[a.SymbolKind.String]=14,he[a.SymbolKind.Number]=15,he[a.SymbolKind.Boolean]=16,he[a.SymbolKind.Array]=17,he[a.SymbolKind.Object]=18,he[a.SymbolKind.Key]=19,he[a.SymbolKind.Null]=20,he[a.SymbolKind.EnumMember]=21,he[a.SymbolKind.Struct]=22,he[a.SymbolKind.Event]=23,he[a.SymbolKind.Operator]=24,he[a.SymbolKind.TypeParameter]=25;function J(De){return typeof he[De]=="number"?he[De]:6}ae.from=J;function $(De){for(const Ee in he)if(he[Ee]===De)return Number(Ee);return a.SymbolKind.Property}ae.to=$})(W=e.SymbolKind||(e.SymbolKind={}));var te;(function(ae){function he($){switch($){case a.SymbolTag.Deprecated:return 1}}ae.from=he;function J($){switch($){case 1:return a.SymbolTag.Deprecated}}ae.to=J})(te=e.SymbolTag||(e.SymbolTag={}));var Q;(function(ae){function he($){return{name:$.name,kind:W.from($.kind),tags:$.tags&&$.tags.map(te.from),containerName:$.containerName,location:L.from($.location)}}ae.from=he;function J($){const De=new a.SymbolInformation($.name,W.to($.kind),$.containerName,L.to($.location));return De.tags=$.tags&&$.tags.map(te.to),De}ae.to=J})(Q=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(ae){function he($){var De,Ee;const $e={name:$.name||"!!MISSING: name!!",detail:$.detail,range:_.from($.range),selectionRange:_.from($.selectionRange),kind:W.from($.kind),tags:(Ee=(De=$.tags)===null||De===void 0?void 0:De.map(te.from))!==null&&Ee!==void 0?Ee:[]};return $.children&&($e.children=$.children.map(he)),$e}ae.from=he;function J($){const De=new a.DocumentSymbol($.name,$.detail,W.to($.kind),_.to($.range),_.to($.selectionRange));return(0,E.isNonEmptyArray)($.tags)&&(De.tags=$.tags.map(te.to)),$.children&&(De.children=$.children.map(J)),De}ae.to=J})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(ae){function he(J){const $=new a.CallHierarchyItem(W.to(J.kind),J.name,J.detail||"",f.URI.revive(J.uri),_.to(J.range),_.to(J.selectionRange));return $._sessionId=J._sessionId,$._itemId=J._itemId,$}ae.to=he})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(ae){function he(J){return new a.CallHierarchyIncomingCall(ee.to(J.from),J.fromRanges.map($=>_.to($)))}ae.to=he})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var T;(function(ae){function he(J){return new a.CallHierarchyOutgoingCall(ee.to(J.to),J.fromRanges.map($=>_.to($)))}ae.to=he})(T=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var L;(function(ae){function he($){return{range:$.range&&_.from($.range),uri:$.uri}}ae.from=he;function J($){return new a.Location(f.URI.revive($.uri),_.to($.range))}ae.to=J})(L=e.location||(e.location={}));var B;(function(ae){function he($){const De=$,Ee=$;return{originSelectionRange:De.originSelectionRange?_.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Ee.uri,range:_.from(De.targetRange?De.targetRange:Ee.range),targetSelectionRange:De.targetSelectionRange?_.from(De.targetSelectionRange):void 0}}ae.from=he;function J($){return{targetUri:f.URI.revive($.uri),targetRange:_.to($.range),targetSelectionRange:$.targetSelectionRange?_.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?_.to($.originSelectionRange):void 0}}ae.to=J})(B=e.DefinitionLink||(e.DefinitionLink={}));var U;(function(ae){function he($){return{range:_.from($.range),contents:h.fromMany($.contents)}}ae.from=he;function J($){return new a.Hover($.contents.map(h.to),_.to($.range))}ae.to=J})(U=e.Hover||(e.Hover={}));var V;(function(ae){function he($){return{range:_.from($.range),expression:$.expression}}ae.from=he;function J($){return new a.EvaluatableExpression(_.to($.range),$.expression)}ae.to=J})(V=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ie;(function(ae){function he($){if($ instanceof a.InlineValueText)return{type:"text",range:_.from($.range),text:$.text};if($ instanceof a.InlineValueVariableLookup)return{type:"variable",range:_.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:_.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=he;function J($){switch($.type){case"text":return{range:_.to($.range),text:$.text};case"variable":return{range:_.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:_.to($.range),expression:$.expression}}}ae.to=J})(ie=e.InlineValue||(e.InlineValue={}));var le;(function(ae){function he($){return{frameId:$.frameId,stoppedLocation:_.from($.stoppedLocation)}}ae.from=he;function J($){return new a.InlineValueContext($.frameId,_.to($.stoppedLocation))}ae.to=J})(le=e.InlineValueContext||(e.InlineValueContext={}));var ue;(function(ae){function he($){return{range:_.from($.range),kind:$.kind}}ae.from=he;function J($){return new a.DocumentHighlight(_.to($.range),$.kind)}ae.to=J})(ue=e.DocumentHighlight||(e.DocumentHighlight={}));var we;(function(ae){function he(J){switch(J){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}ae.to=he})(we=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ke;(function(ae){function he(J){return{triggerKind:we.to(J.triggerKind),triggerCharacter:J.triggerCharacter}}ae.to=he})(ke=e.CompletionContext||(e.CompletionContext={}));var Ae;(function(ae){function he($){switch($){case a.CompletionItemTag.Deprecated:return 1}}ae.from=he;function J($){switch($){case 1:return a.CompletionItemTag.Deprecated}}ae.to=J})(Ae=e.CompletionItemTag||(e.CompletionItemTag={}));var Fe;(function(ae){const he=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function J(Ee){var $e;return($e=he.get(Ee))!==null&&$e!==void 0?$e:9}ae.from=J;const $=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function De(Ee){var $e;return($e=$.get(Ee))!==null&&$e!==void 0?$e:a.CompletionItemKind.Property}ae.to=De})(Fe=e.CompletionItemKind||(e.CompletionItemKind={}));var je;(function(ae){function he(J,$){var De;const Ee=new a.CompletionItem(typeof J.label=="string"?J.label:J.label.name);return typeof J.label!="string"&&(Ee.label2=J.label),Ee.insertText=J.insertText,Ee.kind=Fe.to(J.kind),Ee.tags=(De=J.tags)===null||De===void 0?void 0:De.map(Ae.to),Ee.detail=J.detail,Ee.documentation=b.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation,Ee.sortText=J.sortText,Ee.filterText=J.filterText,Ee.preselect=J.preselect,Ee.commitCharacters=J.commitCharacters,m.Range.isIRange(J.range)?Ee.range=_.to(J.range):typeof J.range=="object"&&(Ee.range={inserting:_.to(J.range.insert),replacing:_.to(J.range.replace)}),Ee.keepWhitespace=typeof J.insertTextRules=="undefined"?!1:Boolean(J.insertTextRules&1),typeof J.insertTextRules!="undefined"&&J.insertTextRules&4?Ee.insertText=new a.SnippetString(J.insertText):(Ee.insertText=J.insertText,Ee.textEdit=Ee.range instanceof a.Range?new a.TextEdit(Ee.range,Ee.insertText):void 0),J.additionalTextEdits&&J.additionalTextEdits.length>0&&(Ee.additionalTextEdits=J.additionalTextEdits.map($e=>x.to($e))),Ee.command=$&&J.command?$.fromInternal(J.command):void 0,Ee}ae.to=he})(je=e.CompletionItem||(e.CompletionItem={}));var Qe;(function(ae){function he($){return{label:$.label,documentation:$.documentation?h.fromStrict($.documentation):void 0}}ae.from=he;function J($){return{label:$.label,documentation:b.isMarkdownString($.documentation)?h.to($.documentation):$.documentation}}ae.to=J})(Qe=e.ParameterInformation||(e.ParameterInformation={}));var qe;(function(ae){function he($){return{label:$.label,documentation:$.documentation?h.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(Qe.from):[],activeParameter:$.activeParameter}}ae.from=he;function J($){return{label:$.label,documentation:b.isMarkdownString($.documentation)?h.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(Qe.to):[],activeParameter:$.activeParameter}}ae.to=J})(qe=e.SignatureInformation||(e.SignatureInformation={}));var it;(function(ae){function he($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(qe.from):[]}}ae.from=he;function J($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(qe.to):[]}}ae.to=J})(it=e.SignatureHelp||(e.SignatureHelp={}));var tt;(function(ae){function he($){var De;return{text:$.text,range:_.from($.range),kind:ye.from((De=$.kind)!==null&&De!==void 0?De:a.InlineHintKind.Other),description:$.description&&h.fromStrict($.description),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}ae.from=he;function J($){const De=new a.InlineHint($.text,_.to($.range),ye.to($.kind));return De.whitespaceAfter=$.whitespaceAfter,De.whitespaceBefore=$.whitespaceBefore,De.description=b.isMarkdownString($.description)?h.to($.description):$.description,De}ae.to=J})(tt=e.InlineHint||(e.InlineHint={}));var ye;(function(ae){function he($){return $}ae.from=he;function J($){return $}ae.to=J})(ye=e.InlineHintKind||(e.InlineHintKind={}));var be;(function(ae){function he($){return{range:_.from($.range),url:$.target,tooltip:$.tooltip}}ae.from=he;function J($){let De;if($.url)try{De=typeof $.url=="string"?f.URI.parse($.url,!0):f.URI.revive($.url)}catch(Ee){}return new a.DocumentLink(_.to($.range),De)}ae.to=J})(be=e.DocumentLink||(e.DocumentLink={}));var _e;(function(ae){function he($){const De=new a.ColorPresentation($.label);return $.textEdit&&(De.textEdit=x.to($.textEdit)),$.additionalTextEdits&&(De.additionalTextEdits=$.additionalTextEdits.map(Ee=>x.to(Ee))),De}ae.to=he;function J($){return{label:$.label,textEdit:$.textEdit?x.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(De=>x.from(De)):void 0}}ae.from=J})(_e=e.ColorPresentation||(e.ColorPresentation={}));var Ie;(function(ae){function he($){return new a.Color($[0],$[1],$[2],$[3])}ae.to=he;function J($){return[$.red,$.green,$.blue,$.alpha]}ae.from=J})(Ie=e.Color||(e.Color={}));var Le;(function(ae){function he($){return{range:_.from($.range)}}ae.from=he;function J($){return new a.SelectionRange(_.to($.range))}ae.to=J})(Le=e.SelectionRange||(e.SelectionRange={}));var ze;(function(ae){function he(J){switch(J){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}ae.to=he})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var We;(function(ae){function he($){switch($){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=he;function J($){switch($){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}ae.to=J})(We=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ke;(function(ae){function he($){if($===a.EndOfLine.CRLF)return 1;if($===a.EndOfLine.LF)return 0}ae.from=he;function J($){if($===1)return a.EndOfLine.CRLF;if($===0)return a.EndOfLine.LF}ae.to=J})(Ke=e.EndOfLine||(e.EndOfLine={}));var et;(function(ae){function he(J){if(typeof J=="object")return J.viewId;switch(J){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=he})(et=e.ProgressLocation||(e.ProgressLocation={}));var se;(function(ae){function he(J){const $={start:J.start+1,end:J.end+1};return J.kind&&($.kind=ve.from(J.kind)),$}ae.from=he})(se=e.FoldingRange||(e.FoldingRange={}));var ve;(function(ae){function he(J){if(J)switch(J){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ae.from=he})(ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ge;(function(ae){function he(J){if(J)return{pinned:typeof J.preview=="boolean"?!J.preview:void 0,inactive:J.background,preserveFocus:J.preserveFocus,selection:typeof J.selection=="object"?_.from(J.selection):void 0,override:typeof J.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ae.from=he})(ge=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ne;(function(ae){function he($){return $ instanceof a.RelativePattern||typeof $=="string"?$:J($)?new a.RelativePattern($.base,$.pattern):$}ae.from=he;function J($){const De=$;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(Ne=e.GlobPattern||(e.GlobPattern={}));var j;(function(ae){function he(J){if(J){if(Array.isArray(J))return J.map(he);if(typeof J=="string")return J;{const $=J;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:Ne.from($.pattern),exclusive:$.exclusive}}}else return}ae.from=he})(j=e.LanguageSelector||(e.LanguageSelector={}));var K;(function(ae){function he($){return{start:$.start,end:$.end}}ae.from=he;function J($){return new a.NotebookRange($.start,$.end)}ae.to=J})(K=e.NotebookRange||(e.NotebookRange={}));var ne;(function(ae){function he(J){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},J),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ae.to=he})(ne=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var z;(function(ae){function he($){return $}ae.from=he;function J($){return new a.NotebookDocumentMetadata().with($)}ae.to=J})(z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var G;(function(ae){function he($){return{startTime:$.runStartTime,endTime:$.runEndTime,executionOrder:$.executionOrder,success:$.lastRunSuccess}}ae.to=he;function J($){return{lastRunSuccess:$.success,runStartTime:$.startTime,runEndTime:$.endTime,executionOrder:$.executionOrder}}ae.from=J})(G=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var Z;(function(ae){function he($){switch($){case a.NotebookCellKind.Markdown:return D.CellKind.Markdown;case a.NotebookCellKind.Code:default:return D.CellKind.Code}}ae.from=he;function J($){switch($){case D.CellKind.Markdown:return a.NotebookCellKind.Markdown;case D.CellKind.Code:default:return a.NotebookCellKind.Code}}ae.to=J})(Z=e.NotebookCellKind||(e.NotebookCellKind={}));var re;(function(ae){function he($){var De;return{cellKind:Z.from($.kind),language:$.language,source:$.source,metadata:Object.assign(Object.assign({},$.metadata),G.from((De=$.latestExecutionSummary)!==null&&De!==void 0?De:{})),outputs:$.outputs?$.outputs.map(Re.from):[]}}ae.from=he;function J($){return new a.NotebookCellData(Z.to($.cellKind),$.source,$.language,$.outputs?$.outputs.map(Re.to):void 0,$.metadata?ne.to($.metadata):void 0)}ae.to=J})(re=e.NotebookCellData||(e.NotebookCellData={}));var ce;(function(ae){function he($){return{mime:$.mime,value:$.value,metadata:$.metadata}}ae.from=he;function J($){return new a.NotebookCellOutputItem($.mime,$.value,$.metadata)}ae.to=J})(ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ae){function he($){return{outputId:$.id,outputs:$.outputs.map(ce.from),metadata:$.metadata}}ae.from=he;function J($){const De=$.outputs.map(ce.to);return new a.NotebookCellOutput(De,$.outputId,$.metadata)}ae.to=J})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(ae){function he(Ee){if(Ee!=null){if(Ee instanceof a.RelativePattern||typeof Ee=="string")return Ee;if(De(Ee))return new a.RelativePattern(Ee.base,Ee.pattern);if($(Ee))return{include:Ne.from(Ee.include)||void 0,exclude:Ne.from(Ee.exclude)||void 0}}}ae.from=he;function J(Ee){return typeof Ee=="string"?Ee:De(Ee)?{base:Ee.base,pattern:Ee.pattern}:{include:Ee.include,exclude:Ee.exclude}}ae.to=J;function $(Ee){const $e=Ee,He=Ne.from($e.include);if(!(He&&He instanceof a.RelativePattern||typeof He=="string"))return!1;const Je=Ne.from($e.exclude);return!!(Je&&Je instanceof a.RelativePattern||typeof Je=="string")}function De(Ee){const $e=Ee;return $e&&typeof $e.base=="string"&&typeof $e.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(ae){function he(J){return{backgroundColor:J.backgroundColor,borderColor:J.borderColor,top:J.top?v.from(J.top):void 0}}ae.from=he})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var fe;(function(ae){function he(J,$,De){const Ee=typeof J.command=="string"?{title:"",command:J.command}:J.command;return{alignment:J.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(Ee,De),text:J.text,tooltip:J.tooltip,accessibilityInformation:J.accessibilityInformation,priority:J.priority}}ae.from=he})(fe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Se;(function(ae){function he(J){var $,De;return{transientOutputs:($=J==null?void 0:J.transientOutputs)!==null&&$!==void 0?$:!1,transientCellMetadata:Object.assign(Object.assign({},J==null?void 0:J.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(De=J==null?void 0:J.transientDocumentMetadata)!==null&&De!==void 0?De:{}}}ae.from=he})(Se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Te;(function(ae){function he($){var De;return{uri:$.uri,provides:typeof $.provides=="string"?[$.provides]:(De=$.provides)!==null&&De!==void 0?De:[]}}ae.from=he;function J($){return{uri:f.URI.revive($.uri),provides:$.provides}}ae.to=J})(Te=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Me;(function(ae){function he($){return{message:h.fromStrict($.message)||"",severity:$.severity,expectedOutput:$.expectedOutput,actualOutput:$.actualOutput,location:$.location?L.from($.location):void 0}}ae.from=he;function J($){const De=new a.TestMessage(typeof $.message=="string"?$.message:h.to($.message));return De.severity=$.severity,De.actualOutput=$.actualOutput,De.expectedOutput=$.expectedOutput,De}ae.to=J})(Me=e.TestMessage||(e.TestMessage={}));var Ue;(function(ae){function he(Ee){var $e,He;return{extId:Ee.id,label:Ee.label,uri:Ee.uri,range:_.from(Ee.range)||null,debuggable:($e=Ee.debuggable)!==null&&$e!==void 0?$e:!1,description:Ee.description||null,runnable:(He=Ee.runnable)!==null&&He!==void 0?He:!0,error:Ee.error&&h.fromStrict(Ee.error)||null}}ae.from=he;function J(Ee){return{extId:Ee.id,label:Ee.label,uri:Ee.uri,range:_.from(Ee.range)||null,debuggable:!1,description:Ee.description||null,error:null,runnable:!0}}ae.fromResultSnapshot=J;function $(Ee){return{id:Ee.extId,label:Ee.label,uri:f.URI.revive(Ee.uri),range:_.to(Ee.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Ee.debuggable,description:Ee.description||void 0,runnable:Ee.runnable}}ae.toPlain=$;function De(Ee){const $e=new a.TestItemImpl(Ee.extId,Ee.label,f.URI.revive(Ee.uri),void 0);return $e.range=_.to(Ee.range||void 0),$e.debuggable=Ee.debuggable,$e.description=Ee.description||void 0,$e.runnable=Ee.runnable,$e}ae.to=De})(Ue=e.TestItem||(e.TestItem={}));var Xe;(function(ae){const he=($,De)=>Object.assign(Object.assign({},Ue.toPlain($.item)),{taskStates:$.tasks.map(Ee=>({state:Ee.state,duration:Ee.duration,messages:Ee.messages.map(Me.to)})),children:$.children.map(Ee=>De.get(Ee)).filter(R.isDefined).map(Ee=>he(Ee,De))});function J($){const De=[],Ee=new Map;for(const $e of $.items)Ee.set($e.item.extId,$e),$e.direct&&De.push($e);return{completedAt:$.completedAt,results:De.map($e=>he($e,Ee))}}ae.to=J})(Xe=e.TestResults||(e.TestResults={}));var Ye;(function(ae){function he(J){switch(J){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}ae.to=he})(Ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(de[216],me([0,1,158,6,11,3,2,7,58,31,130,19,67]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCommandsContextActionRunner=e.TextEditorOptions=e.EditorOptions=e.isEditorInputWithOptions=e.EditorModel=e.SideBySideEditorInput=e.isEditorInputWithPreferredResource=e.EditorInput=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.EditorExtensions=void 0,e.EditorExtensions={Editors:"workbench.contributions.editors",Associations:"workbench.editors.associations",EditorInputFactories:"workbench.contributions.editor.inputFactories"},e.ActiveEditorDirtyContext=new f.RawContextKey("activeEditorIsDirty",!1,(0,E.localize)(0,null)),e.ActiveEditorPinnedContext=new f.RawContextKey("activeEditorIsNotPreview",!1,(0,E.localize)(1,null)),e.ActiveEditorStickyContext=new f.RawContextKey("activeEditorIsPinned",!1,(0,E.localize)(2,null)),e.ActiveEditorReadonlyContext=new f.RawContextKey("activeEditorIsReadonly",!1,(0,E.localize)(3,null)),e.ActiveEditorContext=new f.RawContextKey("activeEditor",null,{type:"string",description:(0,E.localize)(4,null)}),e.ActiveEditorAvailableEditorIdsContext=new f.RawContextKey("activeEditorAvailableEditorIds","",(0,E.localize)(5,null)),e.TextCompareEditorVisibleContext=new f.RawContextKey("textCompareEditorVisible",!1,(0,E.localize)(6,null)),e.TextCompareEditorActiveContext=new f.RawContextKey("textCompareEditorActive",!1,(0,E.localize)(7,null)),e.EditorGroupEditorsCountContext=new f.RawContextKey("groupEditorsCount",0,(0,E.localize)(8,null)),e.ActiveEditorGroupEmptyContext=new f.RawContextKey("activeEditorGroupEmpty",!1,(0,E.localize)(9,null)),e.ActiveEditorGroupIndexContext=new f.RawContextKey("activeEditorGroupIndex",0,(0,E.localize)(10,null)),e.ActiveEditorGroupLastContext=new f.RawContextKey("activeEditorGroupLast",!1,(0,E.localize)(11,null)),e.MultipleEditorGroupsContext=new f.RawContextKey("multipleEditorGroups",!1,(0,E.localize)(12,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new f.RawContextKey("editorIsOpen",!1,(0,E.localize)(13,null)),e.InEditorZenModeContext=new f.RawContextKey("inZenMode",!1,(0,E.localize)(14,null)),e.IsCenteredLayoutContext=new f.RawContextKey("isCenteredLayout",!1,(0,E.localize)(15,null)),e.SplitEditorsVertically=new f.RawContextKey("splitEditorsVertically",!1,(0,E.localize)(16,null)),e.EditorAreaVisibleContext=new f.RawContextKey("editorAreaVisible",!0,(0,E.localize)(17,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function D(F){const O=F;return typeof(O==null?void 0:O.getViewState)=="function"}e.isTextEditorPane=D;var o;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var a;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class w extends k.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new b.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new b.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onWillDispose=this._register(new b.Emitter),this.onWillDispose=this._onWillDispose.event,this.disposed=!1}getName(){return`Editor ${this.typeId}`}getDescription(O){}getTitle(O){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(O){return(0,I.firstOrDefault)(O)}getTelemetryDescriptor(){return{typeId:this.typeId}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(O,x){return this}async saveAs(O,x){return this}async revert(O,x){}rename(O,x){}canSplit(){return!0}matches(O){return this===O}copy(){return this}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onWillDispose.fire()),super.dispose()}}e.EditorInput=w;function _(F){const O=F;return O&&!!O.preferredResource}e.isEditorInputWithPreferredResource=_;class A extends w{constructor(O,x,oe,W){super();this.name=O,this.description=x,this._secondary=oe,this._primary=W,this.registerListeners()}get typeId(){return A.ID}registerListeners(){const O=b.Event.once(this.secondary.onWillDispose);this._register(O(()=>{this.isDisposed()||this.dispose()}));const x=b.Event.once(this.primary.onWillDispose);this._register(x(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getName(){return this.name?this.name:(0,E.localize)(18,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(O,x){return this.primary.save(O,x)}saveAs(O,x){return this.primary.saveAs(O,x)}revert(O,x){return this.primary.revert(O,x)}getTelemetryDescriptor(){const O=this.primary.getTelemetryDescriptor();return Object.assign(O,super.getTelemetryDescriptor())}matches(O){return O===this?!0:O instanceof A?this.primary.matches(O.primary)&&this.secondary.matches(O.secondary):!1}}e.SideBySideEditorInput=A,A.ID="workbench.editorinputs.sidebysideEditorInput";class d extends k.Disposable{constructor(){super(...arguments);this._onWillDispose=this._register(new b.Emitter),this.onWillDispose=this._onWillDispose.event,this.disposed=!1,this.resolved=!1}async resolve(){this.resolved=!0}isResolved(){return this.resolved}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onWillDispose.fire(),super.dispose()}}e.EditorModel=d;function l(F){const O=F;return!!O&&!!O.editor}e.isEditorInputWithOptions=l;class c{static create(O){const x=new c;return x.overwrite(O),x}overwrite(O){return typeof O.forceReload=="boolean"&&(this.forceReload=O.forceReload),typeof O.revealIfVisible=="boolean"&&(this.revealIfVisible=O.revealIfVisible),typeof O.revealIfOpened=="boolean"&&(this.revealIfOpened=O.revealIfOpened),typeof O.preserveFocus=="boolean"&&(this.preserveFocus=O.preserveFocus),typeof O.activation=="number"&&(this.activation=O.activation),typeof O.pinned=="boolean"&&(this.pinned=O.pinned),typeof O.sticky=="boolean"&&(this.sticky=O.sticky),typeof O.inactive=="boolean"&&(this.inactive=O.inactive),typeof O.ignoreError=="boolean"&&(this.ignoreError=O.ignoreError),typeof O.index=="number"&&(this.index=O.index),O.override!==void 0&&(this.override=O.override),typeof O.context=="number"&&(this.context=O.context),this}}e.EditorOptions=c;class t extends c{static from(O){if(!!(O==null?void 0:O.options))return t.create(O.options)}static create(O=Object.create(null)){const x=new t;return x.overwrite(O),x}overwrite(O){var x,oe;return super.overwrite(O),O.selection&&(this.selection={startLineNumber:O.selection.startLineNumber,startColumn:O.selection.startColumn,endLineNumber:(x=O.selection.endLineNumber)!==null&&x!==void 0?x:O.selection.startLineNumber,endColumn:(oe=O.selection.endColumn)!==null&&oe!==void 0?oe:O.selection.startColumn}),O.viewState&&(this.editorViewState=O.viewState),typeof O.selectionRevealType!="undefined"&&(this.selectionRevealType=O.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(O,x){const oe=t.create(x);return oe.editorViewState=(0,C.withNullAsUndefined)(O.saveViewState()),oe}apply(O,x){var oe,W;let te=!1;if(this.editorViewState)O.restoreViewState(this.editorViewState),te=!0;else if(this.selection){const Q={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:(oe=this.selection.endLineNumber)!==null&&oe!==void 0?oe:this.selection.startLineNumber,endColumn:(W=this.selection.endColumn)!==null&&W!==void 0?W:this.selection.startColumn};O.setSelection(Q),this.selectionRevealType===2?O.revealRangeNearTop(Q,x):this.selectionRevealType===3?O.revealRangeNearTopIfOutsideViewport(Q,x):this.selectionRevealType===1?O.revealRangeInCenterIfOutsideViewport(Q,x):O.revealRangeInCenter(Q,x),te=!0}return te}}e.TextEditorOptions=t;class n extends i.ActionRunner{constructor(O){super();this.context=O}run(O){return super.run(O,this.context)}}e.EditorCommandsContextActionRunner=n;var r;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH"})(r=e.SideBySideEditor||(e.SideBySideEditor={}));class s{getOriginalUri(O,x){if(!!O){if((x==null?void 0:x.supportSideBySide)&&O instanceof A){if((x==null?void 0:x.supportSideBySide)===r.BOTH)return{primary:this.getOriginalUri(O.primary,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(O.secondary,{filterByScheme:x.filterByScheme})};O=x.supportSideBySide===r.PRIMARY?O.primary:O.secondary}const oe=_(O)?O.preferredResource:O.resource;return!oe||!x||!x.filterByScheme?oe:this.filterUri(oe,x.filterByScheme)}}getCanonicalUri(O,x){if(!!O){if((x==null?void 0:x.supportSideBySide)&&O instanceof A){if((x==null?void 0:x.supportSideBySide)===r.BOTH)return{primary:this.getCanonicalUri(O.primary,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(O.secondary,{filterByScheme:x.filterByScheme})};O=x.supportSideBySide===r.PRIMARY?O.primary:O.secondary}const oe=O.resource;return!oe||!x||!x.filterByScheme?oe:this.filterUri(oe,x.filterByScheme)}}filterUri(O,x){if(Array.isArray(x)){if(x.some(oe=>O.scheme===oe))return O}else if(x===O.scheme)return O}}e.EditorResourceAccessor=new s;var u;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(u=e.CloseDirection||(e.CloseDirection={}));class h{constructor(){this.customEditorInputFactoryInstances=new Map,this.editorInputSerializerConstructors=new Map,this.editorInputSerializerInstances=new Map}start(O){const x=this.instantiationService=O.get(R.IInstantiationService);for(const[oe,W]of this.editorInputSerializerConstructors)this.createEditorInputSerializer(oe,W,x);this.editorInputSerializerConstructors.clear()}createEditorInputSerializer(O,x,oe){const W=oe.createInstance(x);this.editorInputSerializerInstances.set(O,W)}registerFileEditorInputFactory(O){if(this.fileEditorInputFactory)throw new Error("Can only register one file editor input factory.");this.fileEditorInputFactory=O}getFileEditorInputFactory(){return(0,C.assertIsDefined)(this.fileEditorInputFactory)}registerEditorInputSerializer(O,x){if(this.editorInputSerializerConstructors.has(O)||this.editorInputSerializerInstances.has(O))throw new Error(`A editor input serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorInputSerializer(O,x,this.instantiationService):this.editorInputSerializerConstructors.set(O,x),(0,k.toDisposable)(()=>{this.editorInputSerializerConstructors.delete(O),this.editorInputSerializerInstances.delete(O)})}getEditorInputSerializer(O){return this.editorInputSerializerInstances.get(typeof O=="string"?O:O.typeId)}registerCustomEditorInputFactory(O,x){this.customEditorInputFactoryInstances.set(O,x)}getCustomEditorInputFactory(O){return this.customEditorInputFactoryInstances.get(O)}}m.Registry.add(e.EditorExtensions.EditorInputFactories,new h);async function y(F,O){if(!F||!F.length)return[];const x=await Promise.all(F.map(async oe=>{const W=S.URI.revive(oe.fileUri);if(!(!W||!O.canHandleResource(W))){const te=typeof oe.exists=="boolean"?oe.exists:await O.exists(W);if(!(!te&&oe.openOnlyIfExists)){const Q=te&&typeof oe.lineNumber=="number"?{selection:{startLineNumber:oe.lineNumber,startColumn:oe.columnNumber||1},pinned:!0,override:oe.editorOverrideId}:{pinned:!0,override:oe.editorOverrideId};let q;return te?q={resource:W,options:Q,forceFile:!0}:q={resource:W,options:Q,forceUntitled:!0},q}}}));return(0,I.coalesce)(x)}e.pathsToEditors=y;var P;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(P=e.EditorsOrder||(e.EditorsOrder={}));function v(F,O){if(typeof O!="number"||O===p.ACTIVE_GROUP)return p.ACTIVE_GROUP;const x=F.getGroups(2);let oe=x[O];if(oe)return oe.id;let W=x[0];return x.length===1&&W.count===0?W.id:p.SIDE_GROUP}e.viewColumnToEditorGroup=v;function g(F,O){let x=typeof O=="number"?F.getGroup(O):O;return x=x!=null?x:F.activeGroup,F.getGroups(2).indexOf(x)}e.editorGroupToViewColumn=g}),define(de[217],me([0,1,11,212,16,95,98,102,213,216,67,8,182,101]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let o=class{constructor(w,_,A,d,l,c,t,n,r,s){this._remoteAuthority=w,this._channel=_,this._configurationService=A,this._workspaceContextService=d,this._resolverService=l,this._environmentVariableService=c,this._remoteAuthorityResolverService=t,this._logService=n,this._editorService=r,this._labelService=s}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessTitleChanged(){return this._channel.listen("$onProcessTitleChangedEvent")}get onProcessShellTypeChanged(){return this._channel.listen("$onProcessShellTypeChangedEvent")}get onProcessOverrideDimensions(){return this._channel.listen("$onProcessOverrideDimensionsEvent")}get onProcessResolvedShellLaunchConfig(){return this._channel.listen("$onProcessResolvedShellLaunchConfigEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(w,_,A,d,l,c){await this._configurationService.whenRemoteConfigurationLoaded();const t=Object.create(null),n=A?(0,E.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(A)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(n,{shellLaunchConfig:w,configuration:_})).resolvedVariables}catch(O){this._logService.error(O)}if(r)for(const[O,x]of r.entries())(/^config:/.test(O)||O==="selectedText"||O==="lineNumber")&&(t[O]=x);const s=[];for(const[O,x]of this._environmentVariableService.collections.entries())s.push([O,(0,R.serializeEnvironmentVariableCollection)(x.map)]);const u=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),h=u.options&&u.options.extensionHostEnv,y=this._workspaceContextService.getWorkspace(),P=y.folders,v=A?this._workspaceContextService.getWorkspaceFolder(A):null,g=m.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:m.SideBySideEditor.PRIMARY,filterByScheme:[I.Schemas.file,I.Schemas.userData,I.Schemas.vscodeRemote]}),F={configuration:_,resolvedVariables:t,envVariableCollections:s,shellLaunchConfig:w,workspaceId:y.id,workspaceName:this._labelService.getWorkspaceLabel(y),workspaceFolders:P,activeWorkspaceFolder:v,activeFileResource:g,shouldPersistTerminal:d,cols:l,rows:c,resolverEnv:h};return await this._channel.call("$createProcess",F)}attachToProcess(w){return this._channel.call("$attachToProcess",[w])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(w,_){return this._channel.call("$processBinary",[w,_])}start(w){return this._channel.call("$start",[w])}input(w,_){return this._channel.call("$input",[w,_])}acknowledgeDataEvent(w,_){return this._channel.call("$acknowledgeDataEvent",[w,_])}shutdown(w,_){return this._channel.call("$shutdown",[w,_])}resize(w,_,A){return this._channel.call("$resize",[w,_,A])}getInitialCwd(w){return this._channel.call("$getInitialCwd",[w])}getCwd(w){return this._channel.call("$getCwd",[w])}orphanQuestionReply(w){return this._channel.call("$orphanQuestionReply",[w])}sendCommandResult(w,_,A){return this._channel.call("$sendCommandResult",[w,_,A])}getDefaultSystemShell(w){return this._channel.call("$getDefaultSystemShell",[w])}getShellEnvironment(){return this._channel.call("$getShellEnvironment")}setTerminalLayoutInfo(w){const A={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:w.tabs};return this._channel.call("$setTerminalLayoutInfo",A)}getTerminalLayoutInfo(){const _={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",_)}};o=Oe([xe(2,b.IWorkbenchConfigurationService),xe(3,k.IWorkspaceContextService),xe(4,f.IConfigurationResolverService),xe(5,D.IEnvironmentVariableService),xe(6,S.IRemoteAuthorityResolverService),xe(7,C.ILogService),xe(8,i.IEditorService),xe(9,p.ILabelService)],o),e.RemoteTerminalChannelClient=o}),define(de[218],me([0,1,187]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var b;(function(S){function k(R,f){if(R===f)return!0;let m=Object.keys(R),i=new Set;for(let I of Object.keys(f))i.add(I);if(m.length!==i.size)return!1;for(let I of m){if(R[I]!==f[I])return!1;i.delete(I)}return i.size===0}S.equals=k})(b=e.Translations||(e.Translations={}));class C{constructor(k){this._messageHandler=k}error(k,R){this._messageHandler(E.Severity.Error,k,R)}warn(k,R){this._messageHandler(E.Severity.Warning,k,R)}info(k,R){this._messageHandler(E.Severity.Info,k,R)}}e.Logger=C}),define(de[219],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(f,m){this.isMain=f,this.sid=m,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const b=[];function C(R){const f=new E(!0,R);return b[f.nid]=f,f}e.createMainContextProxyIdentifier=C;function S(R){const f=new E(!1,R);return b[f.nid]=f,f}e.createExtHostContextProxyIdentifier=S;function k(R){return b[R].sid}e.getStringIdentifierForProxy=k}),define(de[220],me([0,1,3,219,45]),function(Y,e,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var f;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(f=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var m;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(m=e.CellKind||(e.CellKind={}));var i;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var p;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(p=e.CandidatePortSource||(e.CandidatePortSource={}));var D;(function(l){l.name="$ident";function c(n,r){return Object.defineProperty(n,l.name,{value:r,enumerable:!0}),n}l.mixin=c;function t(n){return n[l.name]}l.of=t})(D=e.ObjectIdentifier||(e.ObjectIdentifier={}));class o{static mixin(c){return c._id=o._n++,c}}e.IdObject=o,o._n=0;var a;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(l){if(l&&l.edits)for(const c of l.edits)typeof c.resource=="object"?c.resource=E.URI.revive(c.resource):(c.newUri=E.URI.revive(c.newUri),c.oldUri=E.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,C.revive)(c.metadata));return l}e.reviveWorkspaceEditDto=A;var d;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,b.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(de[221],me([0,1,11,100,215,20,220,19,16,45,53,82,3,2,7,206]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=n,this.converter=new _(this,r=>{const s=this._apiCommands.get(r);return(s==null?void 0:s.result)===d.Void?s:void 0},n),this._argumentProcessors=[{processArgument(r){return(0,m.revive)(r)}},{processArgument(r){return(0,S.cloneAndChange)(r,function(s){if(i.Range.isIRange(s))return C.Range.to(s);if(I.Position.isIPosition(s))return C.Position.to(s);if(i.Range.isIRange(s.range)&&p.URI.isUri(s.uri))return C.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...r)=>{const s=t.args.map((h,y)=>{if(!h.validate(r[y]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${r[y]}`);return h.convert(r[y])}),u=await this.executeCommand(t.internalId,...s);return t.result.convert(u,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new b.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,r,s,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:r,thisArg:s,description:u}),t&&this._proxy.$registerCommand(n),new b.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,r){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=(0,S.cloneAndChange)(n,function(u){if(u instanceof b.Position)return C.Position.from(u);if(u instanceof b.Range)return C.Range.from(u);if(u instanceof b.Location)return C.location.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,s,r);return(0,m.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:s,thisArg:u,description:h}=r;if(h)for(let y=0;y<h.args.length;y++)try{(0,E.validateConstraint)(n[y],h.args[y].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[y].name}' - ${h.args[y].description}`)}try{return await s.apply(u,n)}catch(y){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...n);P&&(t=P.command)}throw this._logService.error(y,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(r=>this._argumentProcessors.reduce((s,u)=>u.processArgument(s),r)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(r=>r[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,r]of this._commands){let{description:s}=r;s&&(t[n]=s)}return Promise.resolve(t)}};w=Oe([xe(0,a.IExtHostRpcService),xe(1,f.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class _{constructor(t,n,r){this._commands=t,this._lookupApiCommand=n,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const s=this._lookupApiCommand(t.command);if(s)r.id=s.internalId,r.arguments=s.args.map((u,h)=>u.convert(t.arguments&&t.arguments[h]));else if((0,R.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add((0,D.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),r.$ident=u,r.id=this.delegatingCommandId,r.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return r}}fromInternal(t){const n=k.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class A{constructor(t,n,r,s){this.name=t,this.description=n,this.validate=r,this.convert=s}optional(){return new A(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new A(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=A,A.Uri=new A("uri","Uri of a text document",c=>p.URI.isUri(c),c=>c),A.Position=new A("position","A position in a text document",c=>b.Position.isPosition(c),C.Position.from),A.Range=new A("range","A range in a text document",c=>b.Range.isRange(c),C.Range.from),A.Selection=new A("selection","A selection in a text document",c=>b.Selection.isSelection(c),C.Selection.from),A.Number=new A("number","",c=>typeof c=="number",c=>c),A.String=new A("string","",c=>typeof c=="string",c=>c),A.CallHierarchyItem=new A("item","A call hierarchy item",c=>c instanceof b.CallHierarchyItem,C.CallHierarchyItem.to);class d{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=d,d.Void=new d("no result",c=>c);class l{constructor(t,n,r,s,u){this.id=t,this.internalId=n,this.description=r,this.args=s,this.result=u}}e.ApiCommand=l}),define(de[222],me([0,1,15,160,4,48,36,19,135,11,3,21,33,56,43,218]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const w="package.json";class _{constructor(s,u,h,y,P){this._ourVersion=s,this._log=u,this._absoluteFolderPath=h,this._isBuiltin=y,this._isUnderDevelopment=P,this._absoluteManifestPath=C.join(h,w)}}class A extends _{static _fastParseJSON(s,u){try{return JSON.parse(s)}catch(h){return k.parse(s,u)}}parse(){return E.promises.readFile(this._absoluteManifestPath).then(s=>{var u;const h=[],y=A._fastParseJSON(s.toString(),h);if(k.getNodeType(y)!=="object")this._log.error(this._absoluteFolderPath,b.localize(0,null,this._absoluteManifestPath));else{if(h.length===0)return y.__metadata&&(y.uuid=y.__metadata.id),y.isUserBuiltin=!!((u=y.__metadata)===null||u===void 0?void 0:u.isBuiltin),delete y.__metadata,y;h.forEach(P=>{this._log.error(this._absoluteFolderPath,b.localize(1,null,this._absoluteManifestPath,P.offset,P.length,(0,f.getParseErrorMessage)(P.error)))})}return null},s=>(s.code==="ENOENT"||this._log.error(this._absoluteFolderPath,b.localize(2,null,this._absoluteManifestPath,s.message)),null))}}class d extends _{constructor(s,u,h,y,P,v){super(s,u,h,y,P);this._nlsConfig=v}replaceNLS(s){const u=(O,x)=>{x.forEach(oe=>{this._log.error(this._absoluteFolderPath,b.localize(3,null,O,(0,f.getParseErrorMessage)(oe.error)))})},h=O=>{this._log.error(this._absoluteFolderPath,b.localize(4,null,O))};let y=C.extname(this._absoluteManifestPath),P=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-y.length);const v=`${s.publisher}.${s.name}`;let g=this._nlsConfig.translations[v],F;return g?F=E.promises.readFile(g,"utf8").then(O=>{let x=[],oe=k.parse(O,x);return x.length>0?(u(g,x),{values:void 0,default:`${P}.nls.json`}):k.getNodeType(oe)!=="object"?(h(g),{values:void 0,default:`${P}.nls.json`}):{values:oe.contents?oe.contents.package:void 0,default:`${P}.nls.json`}},O=>({values:void 0,default:`${P}.nls.json`})):F=I.SymlinkSupport.existsFile(P+".nls"+y).then(O=>{if(!!O)return d.findMessageBundles(this._nlsConfig,P).then(x=>x.localized?E.promises.readFile(x.localized,"utf8").then(oe=>{let W=[],te=k.parse(oe,W);return W.length>0?(u(x.localized,W),{values:void 0,default:x.original}):k.getNodeType(te)!=="object"?(h(x.localized),{values:void 0,default:x.original}):{values:te,default:x.original}},oe=>({values:void 0,default:x.original})):{values:void 0,default:x.original},x=>{})}),F.then(O=>{if(O===void 0)return s;let x=[];return d.resolveOriginalMessageBundle(O.default,x).then(oe=>{if(x.length>0)return u(O.default,x),s;if(k.getNodeType(O)!=="object")return h(O.default),s;const W=O.values||Object.create(null);return d._replaceNLStrings(this._nlsConfig,s,W,oe,this._log,this._absoluteFolderPath),s})},O=>s)}static resolveOriginalMessageBundle(s,u){return new Promise((h,y)=>{s?E.promises.readFile(s).then(P=>{h(k.parse(P.toString(),u))},P=>{h(null)}):h(null)})}static findMessageBundles(s,u){return new Promise((h,y)=>{function P(v,g){let F=`${v}.nls.${g}.json`;I.SymlinkSupport.existsFile(F).then(O=>{O&&h({localized:F,original:`${v}.nls.json`});let x=g.lastIndexOf("-");x===-1?h({localized:`${v}.nls.json`,original:null}):(g=g.substring(0,x),P(v,g))})}if(s.devMode||s.pseudo||!s.locale)return h({localized:u+".nls.json",original:null});P(u,s.locale)})}static _replaceNLStrings(s,u,h,y,P,v){function g(F,O,x){let oe=F[O];if(m.isString(oe)){let W=oe,te=W.length;if(te>1&&W[0]==="%"&&W[te-1]==="%"){let Q=W.substr(1,te-2),q=h[Q];q===void 0&&y&&(q=y[Q]),q?(s.pseudo&&(q="\uFF3B"+q.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F[O]=x&&(O==="title"||O==="category")&&y?{value:q,original:y[Q]}:q):P.warn(v,b.localize(5,null,Q))}}else if(m.isObject(oe))for(let W in oe)oe.hasOwnProperty(W)&&(W==="commands"?g(oe,W,!0):g(oe,W,x));else if(m.isArray(oe))for(let W=0;W<oe.length;W++)g(oe,W,x)}for(let F in u)u.hasOwnProperty(F)&&g(u,F)}}class l extends _{validate(s){let u=s;u.isBuiltin=this._isBuiltin,u.isUserBuiltin=!this._isBuiltin&&!!u.isUserBuiltin,u.isUnderDevelopment=this._isUnderDevelopment;let h=[];return l.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,u,h)?(h.forEach(y=>{this._log.warn(this._absoluteFolderPath,y)}),u.publisher||(u.publisher="undefined_publisher"),u.id=(0,p.getExtensionId)(u.publisher,u.name),u.identifier=new o.ExtensionIdentifier(u.id),u.extensionLocation=i.URI.file(this._absoluteFolderPath),u):(h.forEach(y=>{this._log.error(this._absoluteFolderPath,y)}),null)}static isValidExtensionDescription(s,u,h,y){return l.baseIsValidExtensionDescription(u,h,y)?S.valid(h.version)?(0,D.isValidExtensionVersion)(s,h,y):(y.push(b.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(s,u,h){if(!u)return h.push(b.localize(7,null)),!1;if(typeof u.publisher!="undefined"&&typeof u.publisher!="string")return h.push(b.localize(8,null)),!1;if(typeof u.name!="string")return h.push(b.localize(9,null,"name")),!1;if(typeof u.version!="string")return h.push(b.localize(10,null,"version")),!1;if(!u.engines)return h.push(b.localize(11,null,"engines")),!1;if(typeof u.engines.vscode!="string")return h.push(b.localize(12,null,"engines.vscode")),!1;if(typeof u.extensionDependencies!="undefined"&&!l._isStringArray(u.extensionDependencies))return h.push(b.localize(13,null,"extensionDependencies")),!1;if(typeof u.activationEvents!="undefined"){if(!l._isStringArray(u.activationEvents))return h.push(b.localize(14,null,"activationEvents")),!1;if(typeof u.main=="undefined"&&typeof u.browser=="undefined")return h.push(b.localize(15,null,"activationEvents","main")),!1}if(typeof u.main!="undefined"){if(typeof u.main!="string")return h.push(b.localize(16,null,"main")),!1;{const y=C.join(s,u.main);y.startsWith(s)||h.push(b.localize(17,null,y,s))}if(typeof u.activationEvents=="undefined")return h.push(b.localize(18,null,"activationEvents","main")),!1}if(typeof u.browser!="undefined"){if(typeof u.browser!="string")return h.push(b.localize(19,null,"browser")),!1;{const y=C.join(s,u.browser);y.startsWith(s)||h.push(b.localize(20,null,y,s))}if(typeof u.activationEvents=="undefined")return h.push(b.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(s){if(!Array.isArray(s))return!1;for(let u=0,h=s.length;u<h;u++)if(typeof s[u]!="string")return!1;return!0}}class c{constructor(s,u,h,y,P,v,g,F){this.ourVersion=s,this.commit=u,this.locale=h,this.devMode=y,this.absoluteFolderPath=P,this.isBuiltin=v,this.isUnderDevelopment=g,this.translations=F}static createNLSConfig(s){return{devMode:s.devMode,locale:s.locale,pseudo:s.locale==="pseudo",translations:s.translations}}static equals(s,u){return s.ourVersion===u.ourVersion&&s.commit===u.commit&&s.locale===u.locale&&s.devMode===u.devMode&&s.absoluteFolderPath===u.absoluteFolderPath&&s.isBuiltin===u.isBuiltin&&s.isUnderDevelopment===u.isUnderDevelopment&&s.mtime===u.mtime&&a.Translations.equals(s.translations,u.translations)}}e.ExtensionScannerInput=c;class t{constructor(s){this.root=s}resolveExtensions(){return I.readDirsInDir(this.root).then(s=>s.map(u=>({name:u,path:C.join(this.root,u)})))}}class n{static scanExtension(s,u,h,y,P,v){return h=C.normalize(h),new A(s,u,h,y,P).parse().then(F=>F===null?null:new d(s,u,h,y,P,v).replaceNLS(F)).then(F=>F===null?null:new l(s,u,h,y,P).validate(F))}static async scanExtensions(s,u,h=null){const y=s.absoluteFolderPath,P=s.isBuiltin,v=s.isUnderDevelopment;h||(h=new t(y));try{let g={};if(!P)try{const W=await E.promises.readFile(C.join(y,".obsolete"),"utf8");g=JSON.parse(W)}catch(W){}let F=await h.resolveExtensions();F.sort((W,te)=>W.name<te.name?-1:1),P||(F=F.filter(W=>W.name.indexOf(".")!==0));const O=c.createNLSConfig(s);let x=await Promise.all(F.map(W=>this.scanExtension(s.ourVersion,u,W.path,P,v,O))),oe=R.coalesce(x);return oe=oe.filter(W=>W!==null&&!g[new p.ExtensionIdentifierWithVersion({id:(0,p.getGalleryExtensionId)(W.publisher,W.name)},W.version).key()]),P||(oe=(0,p.groupByExtension)(oe,te=>({id:te.identifier.value,uuid:te.uuid})).map(te=>te.sort((Q,q)=>S.rcompare(Q.version,q.version))[0])),oe.sort((W,te)=>W.extensionLocation.fsPath<te.extensionLocation.fsPath?-1:1),oe}catch(g){return u.error(y,g),[]}}static scanOneOrMultipleExtensions(s,u){const h=s.absoluteFolderPath,y=s.isBuiltin,P=s.isUnderDevelopment;return I.SymlinkSupport.existsFile(C.join(h,w)).then(v=>{if(v){const g=c.createNLSConfig(s);return this.scanExtension(s.ourVersion,u,h,y,P,g).then(F=>F===null?[]:[F])}return this.scanExtensions(s,u)},v=>(u.error(h,v),[]))}static scanSingleExtension(s,u){const h=s.absoluteFolderPath,y=s.isBuiltin,P=s.isUnderDevelopment,v=c.createNLSConfig(s);return this.scanExtension(s.ourVersion,u,h,y,P,v)}static mergeBuiltinExtensions(s,u){return Promise.all([s,u]).then(([h,y])=>{let P=Object.create(null);for(let g=0,F=h.length;g<F;g++)P[o.ExtensionIdentifier.toKey(h[g].identifier)]=h[g];for(let g=0,F=y.length;g<F;g++)P[o.ExtensionIdentifier.toKey(y[g].identifier)]=y[g];let v=Object.keys(P).map(g=>P[g]);return v.sort((g,F)=>{const O=C.basename(g.extensionLocation.fsPath),x=C.basename(F.extensionLocation.fsPath);return O<x?-1:O>x?1:0}),v})}}e.ExtensionScanner=n}),define(de[223],me([0,1,5,47,3,40,156,15,8,30,222,43,52,99,58,80,197,4,24]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let d=null;function l(){return d||(d=(0,_.normalize)((0,_.join)(f.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))),d}let c=null;function t(){return c||(c=(0,_.normalize)((0,_.join)(f.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),c}class n{constructor(s,u,h,y,P,v){this._connectionToken=s,this.environmentService=u,this.logService=y,this.telemetryService=P,this.telemetryAppender=v,this._logger=new class{error(F,O){y.error(F,O)}warn(F,O){y.warn(F,O)}info(F,O){y.info(F,O)}},u.args["install-builtin-extension"]?this.whenExtensionsReady=h.installExtensions([],u.args["install-builtin-extension"],!!u.args["do-not-sync"],!!u.args.force).then(null,F=>{y.error(F)}):this.whenExtensionsReady=Promise.resolve();const g=u.args["install-extension"];if(g){const F=g.map(O=>/\.vsix$/i.test(O)?C.URI.file((0,_.isAbsolute)(O)?O:(0,_.join)((0,A.cwd)(),O)):O);this.whenExtensionsReady.then(()=>h.installExtensions(F,[],!!u.args["do-not-sync"],!!u.args.force)).then(null,O=>{y.error(O)})}}async call(s,u,h){switch(u){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const y=h,P=(0,S.createRemoteURITransformer)(y.remoteAuthority);let v=await this._getEnvironmentData();return v=(0,p.transformOutgoingURIs)(v,P),v}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const y=h,P=y.language;this.logService.trace(`Scanning extensions using UI language: ${P}`);const v=(0,S.createRemoteURITransformer)(y.remoteAuthority),g=y.extensionDevelopmentPath&&y.extensionDevelopmentPath.map(x=>C.URI.revive(v.transformIncoming(x))),F=g?g.filter(x=>x.scheme===f.Schemas.file).map(x=>x.fsPath):void 0;let O=await this._scanExtensions(P,F);return O=(0,p.transformOutgoingURIs)(O,v),this.logService.trace("Scanned Extensions",O),n._massageWhenConditions(O),O}case"scanSingleExtension":{await this.whenExtensionsReady;const y=h,P=y.language,v=y.isBuiltin,g=(0,S.createRemoteURITransformer)(y.remoteAuthority),F=C.URI.revive(g.transformIncoming(y.extensionLocation)),O=F.scheme===f.Schemas.file?F.fsPath:null;if(!O)return null;const x=await this._getTranslations(P);let oe=await this._scanSingleExtension(O,v,P,x);return oe?(oe=(0,p.transformOutgoingURIs)(oe,g),n._massageWhenConditions([oe]),oe):null}case"getDiagnosticInfo":{const y=h,P={machineInfo:(0,w.getMachineInfo)()},v=y.includeProcesses?(0,a.listProcesses)(process.pid):Promise.resolve();let g=[];const F={};if(y.folders){const O=(0,S.createRemoteURITransformer)("");g=y.folders.map(oe=>C.URI.revive(O.transformIncoming(oe))).filter(oe=>oe.scheme==="file").map(oe=>(0,w.collectWorkspaceStats)(oe.fsPath,["node_modules",".git"]).then(W=>{F[(0,_.basename)(oe.fsPath)]=W}))}return Promise.all([v,...g]).then(([O,x])=>(P.processes=O||void 0,P.workspaceMetadata=y.folders?F:void 0,P))}case"logTelemetry":{const{eventName:y,data:P}=h;return this.telemetryAppender?this.telemetryAppender.log(y,P):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${u} not found`)}listen(s,u,h){throw new Error("Not supported")}static _massageWhenConditions(s){const u=(F,O)=>F.replace(/file/g,"vscode-remote"),h=F=>{let O="";return O+=F.global?"g":"",O+=F.ignoreCase?"i":"",O+=F.multiline?"m":"",new RegExp(u(F.source,!0),O)},y=new class{mapDefined(F){return o.ContextKeyDefinedExpr.create(F)}mapNot(F){return o.ContextKeyNotExpr.create(F)}mapEquals(F,O){return F==="resourceScheme"&&typeof O=="string"?o.ContextKeyEqualsExpr.create(F,u(O,!1)):o.ContextKeyEqualsExpr.create(F,O)}mapNotEquals(F,O){return F==="resourceScheme"&&typeof O=="string"?o.ContextKeyNotEqualsExpr.create(F,u(O,!1)):o.ContextKeyNotEqualsExpr.create(F,O)}mapGreater(F,O){return o.ContextKeyGreaterExpr.create(F,O)}mapGreaterEquals(F,O){return o.ContextKeyGreaterEqualsExpr.create(F,O)}mapSmaller(F,O){return o.ContextKeySmallerExpr.create(F,O)}mapSmallerEquals(F,O){return o.ContextKeySmallerEqualsExpr.create(F,O)}mapRegex(F,O){return F==="resourceScheme"&&O?o.ContextKeyRegexExpr.create(F,h(O)):o.ContextKeyRegexExpr.create(F,O)}mapIn(F,O){return o.ContextKeyInExpr.create(F,O)}},P=F=>{if(!(!F||!F.when||!/resourceScheme/.test(F.when))){const O=o.ContextKeyExpr.deserialize(F.when);if(!!O){const x=O.map(y);F.when=x.serialize()}}},v=F=>{if(Array.isArray(F))for(let O of F)P(O);else P(F)},g=F=>{for(let O in F)v(F[O])};s.forEach(F=>{F.contributes&&(F.contributes.menus&&g(F.contributes.menus),F.contributes.keybindings&&v(F.contributes.keybindings),F.contributes.views&&g(F.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:C.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:C.URI.file(this.environmentService.logsPath),extensionsPath:C.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:C.URI.file((0,_.join)(this.environmentService.logsPath,`exthost${n._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:E.OS,marks:b.getMarks(),useHostProxy:this.environmentService.args["use-host-proxy"]!==void 0}}async _getTranslations(s){const u=await(0,D.getNLSConfiguration)(s,this.environmentService.userDataPath);if(D.InternalNLSConfiguration.is(u))try{const h=await R.promises.readFile(u._translationsConfigFile,"utf8");return JSON.parse(h)}catch(h){return Object.create(null)}else return Object.create(null)}async _scanExtensions(s,u){const h=await this._getTranslations(s),[y,P,v]=await Promise.all([this._scanBuiltinExtensions(s,h),this._scanInstalledExtensions(s,h),this._scanDevelopedExtensions(s,h,u)]);let g=new Map;y.forEach(O=>{!O||g.set(I.ExtensionIdentifier.toKey(O.identifier),O)}),P.forEach(O=>{!O||(g.has(I.ExtensionIdentifier.toKey(O.identifier))&&console.warn(k.localize(0,null,g.get(I.ExtensionIdentifier.toKey(O.identifier)).extensionLocation.fsPath,O.extensionLocation.fsPath)),g.set(I.ExtensionIdentifier.toKey(O.identifier),O))}),v.forEach(O=>{!O||g.set(I.ExtensionIdentifier.toKey(O.identifier),O)});const F=[];return g.forEach(O=>F.push(O)),F}_scanDevelopedExtensions(s,u,h){if(h){const y=h.map(P=>i.ExtensionScanner.scanOneOrMultipleExtensions(new i.ExtensionScannerInput(m.default.version,m.default.commit,s,!0,P,!1,!0,u),this._logger));return Promise.all(y).then(P=>{let v=[];for(let g of P)v=v.concat(g);return v})}return Promise.resolve([])}_scanBuiltinExtensions(s,u){const h=m.default.version,y=m.default.commit,P=!!process.env.VSCODE_DEV,v=new i.ExtensionScannerInput(h,y,s,P,l(),!0,!1,u),g=i.ExtensionScanner.scanExtensions(v,this._logger);let F=g;if(P){class O{constructor(Q){this.builtInExtensions=Q}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(Q=>({name:Q.name,path:(0,_.join)(t(),Q.name)})))}}const x=Promise.resolve(m.default.builtInExtensions||[]),oe=new i.ExtensionScannerInput(h,y,s,P,t(),!0,!1,{}),W=x.then(te=>new O(te)).then(te=>i.ExtensionScanner.scanExtensions(oe,this._logger,te));F=i.ExtensionScanner.mergeBuiltinExtensions(g,W)}return F}_scanInstalledExtensions(s,u){const h=!!process.env.VSCODE_DEV,y=new i.ExtensionScannerInput(m.default.version,m.default.commit,s,h,this.environmentService.extensionsPath,!1,!1,u);return i.ExtensionScanner.scanExtensions(y,this._logger)}_scanSingleExtension(s,u,h,y){const P=!!process.env.VSCODE_DEV,v=new i.ExtensionScannerInput(m.default.version,m.default.commit,h,P,s,u,!1,y);return i.ExtensionScanner.scanSingleExtension(v,this._logger)}}e.RemoteAgentEnvironmentChannel=n,n._namePool=1}),define(de[224],me([0,1,169]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class b extends E.IPCFileSystemProvider{constructor(S){super(S.getConnection().getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME));this.setCaseSensitive(!0),(async()=>{const k=await S.getEnvironment();this.setCaseSensitive((k==null?void 0:k.os)===3)})()}}e.RemoteFileSystemProvider=b}),define(de[103],me([0,1,7]),function(Y,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(de[68],me([0,1,138,4,15,14,21,238,239,11]),function(Y,e,E,b,C,S,k,R,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,n){let r=n.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=n}}e.ExtractError=i;function I(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,r)=>n+r,t&61440)}function p(c){if(c instanceof i)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new i(t,c)}function D(c,t,n,r,s,u){const h=b.dirname(t),y=b.join(r,h);if(!y.startsWith(r))return Promise.reject(new Error(E.localize(0,null,t)));const P=b.join(r,t);let v;return u.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(C.promises.mkdir(y,{recursive:!0})).then(()=>new Promise((g,F)=>{if(!u.isCancellationRequested)try{v=(0,C.createWriteStream)(P,{mode:n}),v.once("close",()=>g()),v.once("error",F),c.once("error",F),c.pipe(v)}catch(O){F(O)}}))}function o(c,t,n,r){let s=(0,S.createCancelablePromise)(()=>Promise.resolve()),u=0;return r.onCancellationRequested(()=>{s.cancel(),c.close()}),new Promise((h,y)=>{const P=new S.Sequencer,v=g=>{g.isCancellationRequested||(u++,c.readEntry())};c.once("error",y),c.once("close",()=>s.then(()=>{r.isCancellationRequested||c.entryCount===u?h():y(new i("Incomplete",new Error(E.localize(1,null,u,c.entryCount))))},y)),c.readEntry(),c.on("entry",g=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(g.fileName)){v(r);return}const F=g.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const oe=b.join(t,F);s=(0,S.createCancelablePromise)(W=>C.promises.mkdir(oe,{recursive:!0}).then(()=>v(W)).then(void 0,y));return}const O=w(c,g),x=I(g);s=(0,S.createCancelablePromise)(oe=>P.queue(()=>O.then(W=>D(W,F,x,t,n,oe).then(()=>v(oe)))).then(null,y))}})})}function a(c,t=!1){return new Promise((n,r)=>{(0,R.open)(c,t?{lazyEntries:!0}:void 0,(s,u)=>{s?r(p(s)):n((0,m.assertIsDefined)(u))})})}function w(c,t){return new Promise((n,r)=>{c.openReadStream(t,(s,u)=>{s?r(p(s)):n((0,m.assertIsDefined)(u))})})}function _(c,t){return new Promise((n,r)=>{const s=new f.ZipFile;t.forEach(h=>{h.contents?s.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&s.addFile(h.localPath,h.path)}),s.end();const u=(0,C.createWriteStream)(c);s.outputStream.pipe(u),s.outputStream.once("error",r),u.once("error",r),u.once("finish",()=>n(c))})}e.zip=_;function A(c,t,n={},r){const s=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let u=a(c,!0);return n.overwrite&&(u=u.then(h=>(0,k.rimraf)(t).then(()=>h))),u.then(h=>o(h,t,{sourcePathRegex:s},r))}e.extract=A;function d(c,t){return a(c).then(n=>new Promise((r,s)=>{n.on("entry",u=>{u.fileName===t&&w(n,u).then(h=>r(h),h=>s(h))}),n.once("close",()=>s(new Error(E.localize(2,null,t))))}))}function l(c,t){return d(c,t).then(n=>new Promise((r,s)=>{const u=[];n.once("error",s),n.on("data",h=>u.push(h)),n.on("end",()=>r(Buffer.concat(u)))}))}e.buffer=l}),define(de[225],me([0,1,68,145]),function(Y,e,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function C(S){return(0,E.buffer)(S,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(R){throw new Error((0,b.localize)(0,null))}})}e.getManifest=C}),define(de[226],me([0,1,15,48,2,21,4,16,32,33,14,3,27,168,146,44,68,5,19,8,22,17,23,12]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A,d,l,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",s="scanningUser",u="extracting",h="deleting",y="renaming";let P=class extends C.Disposable{constructor(g,F,O,x,oe){super();this.beforeRemovingExtension=g,this.fileService=F,this.logService=O,this.environmentService=x,this.productService=oe,this._devSystemExtensionsPath=null,this.systemExtensionsPath=x.builtinExtensionsPath,this.extensionsPath=x.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new i.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(g){const F=[];(g===null||g===0)&&F.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(O).message,r)))),(g===null||g===1)&&F.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(O).message,s))));try{const O=await Promise.all(F);return(0,A.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(g){this.logService.trace("Started scanning user extensions");let[F,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(x=>!F[new m.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version).key()]),g&&(O=(0,m.groupByExtension)(O,oe=>oe.identifier).map(oe=>oe.sort((W,te)=>b.rcompare(W.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(g,F,O){const x=g.key(),oe=k.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),W=k.join(this.extensionsPath,x);try{await S.rimraf(W)}catch(Q){try{await S.rimraf(W)}catch(q){}throw new f.ExtensionManagementError((0,o.localize)(0,null,W,g.id),h)}await this.extractAtLocation(g,F,oe,O);let te=await this.scanExtension(I.URI.file(oe),1);if(!te)throw new Error((0,o.localize)(1,null,oe));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(g,oe,W,Date.now()+2*60*1e3),this.logService.info("Renamed to",W)}catch(Q){try{await S.rimraf(oe)}catch(q){}if(Q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",g.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(Q)}. Deleted from extracted location`,oe),Q}try{te=await this.scanExtension(I.URI.file(W),1)}catch(Q){}if(te)return te;throw new Error((0,o.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(g,F){return this.setMetadata(g,F),await this.storeMetadata(g,Object.assign(Object.assign({},F),{installedTimestamp:g.installedTimestamp})),g}async storeMetadata(g,F){F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0;const O=k.join(g.location.fsPath,"package.json"),x=await E.promises.readFile(O,"utf8"),{manifest:oe}=await this.parseManifest(x);return oe.__metadata=F,await S.writeFile(O,JSON.stringify(oe,null,"	")),g}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...g){const F=g.map(O=>new m.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{F.forEach(x=>O[x.key()]=!0)})}async setInstalled(g){await this.withUninstalledExtensions(x=>delete x[g.key()]);const O=(await this.scanExtensions(1)).find(x=>new m.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version).equals(g))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(g){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=await E.promises.readFile(this.uninstalledPath,"utf8")}catch(x){if(x.code!=="ENOENT")throw x}let O={};if(F)try{O=JSON.parse(F)}catch(x){}return g&&(g(O),Object.keys(O).length?await S.writeFile(this.uninstalledPath,JSON.stringify(O)):await S.rimraf(this.uninstalledPath)),O})}async removeExtension(g,F){this.logService.trace(`Deleting ${F} extension from disk`,g.identifier.id,g.location.fsPath),await S.rimraf(g.location.fsPath),this.logService.info("Deleted from disk",g.identifier.id,g.location.fsPath)}async removeUninstalledExtension(g){await this.removeExtension(g,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[new m.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version).key()])}async extractAtLocation(g,F,O,x){this.logService.trace(`Started extracting the extension from ${F} to ${O}`);try{await S.rimraf(O)}catch(oe){throw new f.ExtensionManagementError(this.joinErrors(oe).message,h)}try{await(0,w.extract)(F,O,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${O}:`,g.id)}catch(oe){try{await S.rimraf(O)}catch(W){}throw new f.ExtensionManagementError(oe.message,oe instanceof w.ExtractError&&oe.type?oe.type:u)}}async rename(g,F,O,x){try{await E.promises.rename(F,O)}catch(oe){if(_.isWindows&&oe&&oe.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${F} to ${O} with 'EPERM' error. Trying again...`,g.id),this.rename(g,F,O,x);throw new f.ExtensionManagementError(oe.message||(0,o.localize)(3,null,F,O),oe.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const g=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return g;const F=this.scanDevSystemExtensions(),[O,x]=await Promise.all([g,F]);return[...O,...x]}async scanExtensionsInDir(g,F){const O=new i.Limiter(10),x=await this.fileService.resolve(I.URI.file(g));return x.children?(await Promise.all(x.children.filter(W=>W.isDirectory).map(W=>O.queue(async()=>F===1&&(0,c.basename)(W.resource).indexOf(".")===0?null:this.scanExtension(W.resource,F))))).filter(W=>W&&W.identifier):[]}async scanExtension(g,F){var O,x;try{const oe=await this.fileService.resolve(g);if(oe.children){const{manifest:W,metadata:te}=await this.readManifest(g.fsPath),Q=(O=oe.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T)))===null||O===void 0?void 0:O.resource,q=(x=oe.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T)))===null||x===void 0?void 0:x.resource,ee={id:(0,m.getGalleryExtensionId)(W.publisher,W.name)},H={type:F,identifier:ee,manifest:W,location:g,readmeUrl:Q,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:F===0};return te&&(this.setMetadata(H,te),H.installedTimestamp=te.installedTimestamp),H}}catch(oe){F!==0&&this.logService.trace(oe)}return null}async scanDefaultSystemExtensions(){const g=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",g.length),g}async scanDevSystemExtensions(){const g=this.getDevSystemExtensionsList();if(g.length){const F=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",F.length),F.filter(O=>g.some(x=>(0,m.areSameExtensions)(O.identifier,{id:x})))}else return[]}setMetadata(g,F){g.publisherDisplayName=F.publisherDisplayName||null,g.publisherId=F.publisherId||null,g.identifier.uuid=F.id,g.isMachineScoped=!!F.isMachineScoped,g.isBuiltin=g.type===0||!!F.isBuiltin}async removeUninstalledExtensions(){const g=await this.getUninstalledExtensions(),F=await this.scanAllUserExtensions(),O=new Set;for(const W of F)g[new m.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]||O.add(W.identifier.id.toLowerCase());const x=(0,m.groupByExtension)(F,W=>W.identifier);await i.Promises.settled(x.map(async W=>{const te=W.sort((Q,q)=>b.rcompare(Q.manifest.version,q.manifest.version))[0];O.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const oe=F.filter(W=>g[new m.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]);await i.Promises.settled(oe.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const g=await this.scanAllUserExtensions(),F=[],O=(0,m.groupByExtension)(g,x=>x.identifier);F.push(...(0,A.flatten)(O.map(x=>x.sort((oe,W)=>b.rcompare(oe.manifest.version,W.manifest.version)).slice(1)))),await i.Promises.settled(F.map(x=>this.removeExtension(x,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(g=>g.name)}joinErrors(g){const F=Array.isArray(g)?g:[g];return F.length===1?F[0]instanceof Error?F[0]:new Error(F[0]):F.reduce((O,x)=>new Error(`${O.message}${O.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(d.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(g){const F=[E.promises.readFile(k.join(g,"package.json"),"utf8").then(W=>this.parseManifest(W)),E.promises.readFile(k.join(g,"package.nls.json"),"utf8").then(void 0,W=>W.code!=="ENOENT"?Promise.reject(W):"{}").then(W=>JSON.parse(W))],[{manifest:O,metadata:x},oe]=await Promise.all(F);return{manifest:(0,D.localizeManifest)(O,oe),metadata:x}}parseManifest(g){return new Promise((F,O)=>{try{const x=JSON.parse(g),oe=x.__metadata||null;F({manifest:x,metadata:oe})}catch(x){O(new Error((0,o.localize)(4,null)))}})}};P=Oe([xe(1,l.IFileService),xe(2,R.ILogService),xe(3,p.INativeEnvironmentService),xe(4,a.IProductService)],P),e.ExtensionsScanner=P}),define(de[104],me([0,1,15,144,4,21,2,19,68,32,33,27,14,6,48,3,30,5,16,179,42,39,56,17,23,84,7,8,28,225,183,226,184,185,22]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A,d,l,c,t,n,r,s,u,h,y,P,v,g,F,O,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const oe="unsetUninstalled",W="downloading",te="validating",Q="local",q="unknown";let ee=class extends k.Disposable{constructor(T,L,B,U,V,ie,le){super();this.environmentService=T,this.galleryService=L,this.logService=B,this.downloadService=U,this.telemetryService=V,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new D.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const ue=this._register(ie.createInstance(F.ExtensionsLifecycle));this.extensionsScanner=this._register(ie.createInstance(g.ExtensionsScanner,ke=>ue.postUninstall(ke))),this.manifestCache=this._register(new d.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(ie.createInstance(v.ExtensionsDownloader));const we=this._register(new O.ExtensionsWatcher(this,le,T,B));this._register(we.onDidChangeExtensionsByAnotherSource(({added:ke,removed:Ae})=>{ke.forEach(Fe=>this._onDidInstallExtension.fire({identifier:Fe.identifier,operation:0,local:Fe})),Ae.forEach(Fe=>this._onDidUninstallExtension.fire({identifier:Fe}))})),this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(ke=>ke.cancel()),this.uninstallingExtensions.forEach(ke=>ke.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const L=await this.collectFiles(T),B=await(0,f.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,L);return a.URI.file(B)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const L=await this.downloadVsix(T),B=C.resolve(L.fsPath);return(0,P.getManifest)(B)}async collectFiles(T){const L=async U=>{let V=await S.readdir(U);V=V.map(ue=>C.join(U,ue));const ie=await Promise.all(V.map(ue=>E.promises.stat(ue)));let le=Promise.resolve([]);return ie.forEach((ue,we)=>{const ke=V[we];ue.isFile()&&(le=le.then(Ae=>[...Ae,ke])),ue.isDirectory()&&(le=le.then(Ae=>L(ke).then(Fe=>[...Ae,...Fe])))}),le};return(await L(T.location.fsPath)).map(U=>({path:`extension/${C.relative(T.location.fsPath,U)}`,localPath:U}))}async install(T,L={}){return this.logService.trace("ExtensionManagementService#install",T.toString()),(0,p.createCancelablePromise)(async B=>{const U=await this.downloadVsix(T),V=C.resolve(U.fsPath),ie=await(0,P.getManifest)(V),le={id:(0,i.getGalleryExtensionId)(ie.publisher,ie.name)};let ue=1;if(ie.engines&&ie.engines.vscode&&!(0,t.isEngineValid)(ie.engines.vscode,w.default.version))throw new Error(b.localize(0,null,le.id,w.default.version));const we=new i.ExtensionIdentifierWithVersion(le,ie.version),Ae=(await this.getInstalled(1)).find(je=>(0,i.areSameExtensions)(le,je.identifier));if(Ae)if(L.isMachineScoped=L.isMachineScoped||Ae.isMachineScoped,L.isBuiltin=L.isBuiltin||Ae.isBuiltin,ue=2,we.equals(new i.ExtensionIdentifierWithVersion(Ae.identifier,Ae.manifest.version)))try{await this.extensionsScanner.removeExtension(Ae,"existing")}catch(je){throw new Error(b.localize(1,null,ie.displayName||ie.name))}else o.gt(Ae.manifest.version,ie.version)&&await this.uninstallExtension(Ae);else{const je=await this.unsetUninstalledAndGetLocal(we);if(je)try{await this.extensionsScanner.removeExtension(je,"existing")}catch(Qe){throw new Error(b.localize(2,null,ie.displayName||ie.name))}}this.logService.info("Installing the extension:",le.id),this._onInstallExtension.fire({identifier:le,zipPath:V});let Fe;try{Fe=await this.getGalleryMetadata((0,i.getGalleryExtensionId)(ie.publisher,ie.name))}catch(je){}try{const je=await this.installFromZipPath(we,V,Object.assign(Object.assign({},Fe||{}),L),L,ue,B);return this.logService.info("Successfully installed the extension:",le.id),je}catch(je){throw this.logService.error("Failed to install the extension:",le.id,je.message),je}})}async downloadVsix(T){if(T.scheme===h.Schemas.file)return T;if(!this.downloadService)throw new Error("Download service is not available");const L=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(T,L),L}async installFromZipPath(T,L,B,U,V,ie){try{const le=await this.installExtension({zipPath:L,identifierWithVersion:T,metadata:B},ie);try{await this.installDependenciesAndPackExtensions(le,void 0,U)}catch(ue){(0,R.isNonEmptyArray)(le.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",le.identifier.id,ue.message),(0,R.isNonEmptyArray)(le.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",le.identifier.id,ue.message)}return this._onDidInstallExtension.fire({identifier:T,zipPath:L,local:le,operation:V}),le}catch(le){throw this._onDidInstallExtension.fire({identifier:T,zipPath:L,operation:V,error:le}),le}}async canInstall(T){return!0}async installFromGallery(T,L={}){if(!this.galleryService.isEnabled())throw new Error(b.localize(3,null));try{T=await this.checkAndGetCompatibleVersion(T)}catch(V){const ie=V&&V.code?V.code:q;throw this.logService.error("Failed to install extension:",T.identifier.id,V?V.message:ie),this.reportTelemetry(this.getTelemetryEvent(1),(0,i.getGalleryExtensionTelemetryData)(T),void 0,V),V instanceof Error&&(V.name=ie),V}const B=new i.ExtensionIdentifierWithVersion(T.identifier,T.version).key();let U=this.installingExtensions.get(B);return U||(U=(0,p.createCancelablePromise)(V=>this.doInstallFromGallery(T,L,V)),this.installingExtensions.set(B,U),U.finally(()=>this.installingExtensions.delete(B))),U}async doInstallFromGallery(T,L,B){const U=new Date().getTime();let V=1;this.logService.info("Installing extension:",T.identifier.id),this._onInstallExtension.fire({identifier:T.identifier,gallery:T});try{const le=(await this.getInstalled(1)).find(ke=>(0,i.areSameExtensions)(ke.identifier,T.identifier));le&&(V=2);const ue=await this.downloadInstallableExtension(T,V);ue.metadata.isMachineScoped=L.isMachineScoped||(le==null?void 0:le.isMachineScoped),ue.metadata.isBuiltin=L.isBuiltin||(le==null?void 0:le.isBuiltin);const we=await this.installExtension(ue,B);try{await this.extensionsDownloader.delete(a.URI.file(ue.zipPath))}catch(ke){}if(!L.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(we,le,L)}catch(ke){try{await this.uninstall(we)}catch(Ae){}throw ke}return le&&o.neq(le.manifest.version,T.version)&&await this.extensionsScanner.setUninstalled(le),this.logService.info("Extensions installed successfully:",T.identifier.id),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,local:we,operation:V}),this.reportTelemetry(this.getTelemetryEvent(V),(0,i.getGalleryExtensionTelemetryData)(T),new Date().getTime()-U,void 0),we}catch(ie){const le=ie&&ie.code?ie.code:q;throw this.logService.error("Failed to install extension:",T.identifier.id,ie?ie.message:le),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,operation:V,error:le}),this.reportTelemetry(this.getTelemetryEvent(V),(0,i.getGalleryExtensionTelemetryData)(T),new Date().getTime()-U,ie),ie instanceof Error&&(ie.name=le),ie}}async checkAndGetCompatibleVersion(T){if(await this.isMalicious(T))throw new m.ExtensionManagementError(b.localize(4,null),m.INSTALL_ERROR_MALICIOUS);const L=await this.galleryService.getCompatibleExtension(T);if(!L)throw new m.ExtensionManagementError(b.localize(5,null,T.identifier.id,w.default.version),m.INSTALL_ERROR_INCOMPATIBLE);return L}async reinstallFromGallery(T){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(6,null));const L=await this.findGalleryExtension(T);if(!L)throw new Error(b.localize(7,null));await this.extensionsScanner.setUninstalled(T);try{await this.extensionsScanner.removeUninstalledExtension(T)}catch(B){throw new Error(b.localize(8,null,(0,l.toErrorMessage)(B)))}await this.installFromGallery(L)}getTelemetryEvent(T){return T===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(T){const L=await this.getExtensionsReport();return(0,i.getMaliciousExtensionsSet)(L).has(T.identifier.id)}async downloadInstallableExtension(T,L){const B={id:T.identifier.uuid,publisherId:T.publisherId,publisherDisplayName:T.publisherDisplayName};let U;try{this.logService.trace("Started downloading extension:",T.identifier.id),U=(await this.extensionsDownloader.downloadExtension(T,L)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,U)}catch(V){throw new m.ExtensionManagementError(this.joinErrors(V).message,W)}try{const V=await(0,P.getManifest)(U);return{zipPath:U,identifierWithVersion:new i.ExtensionIdentifierWithVersion(T.identifier,V.version),metadata:B}}catch(V){throw new m.ExtensionManagementError(this.joinErrors(V).message,te)}}async installExtension(T,L){try{const B=await this.unsetUninstalledAndGetLocal(T.identifierWithVersion);if(B)return T.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,T.metadata):B}catch(B){throw _.isMacintosh?new m.ExtensionManagementError(b.localize(9,null),oe):new m.ExtensionManagementError(b.localize(10,null),oe)}return this.extractAndInstall(T,L)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const B=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),B}async extractAndInstall({zipPath:T,identifierWithVersion:L,metadata:B},U){let V=await this.extensionsScanner.extractUserExtension(L,T,U);return this.logService.info("Installation completed.",L.id),B&&(V=await this.extensionsScanner.saveMetadataForLocalExtension(V,B)),V}async installDependenciesAndPackExtensions(T,L,B){if(!!this.galleryService.isEnabled()){const U=T.manifest.extensionDependencies||[];if(T.manifest.extensionPack)for(const V of T.manifest.extensionPack)L&&L.manifest.extensionPack&&L.manifest.extensionPack.some(ie=>(0,i.areSameExtensions)({id:ie},{id:V}))||U.every(ie=>!(0,i.areSameExtensions)({id:ie},{id:V}))&&U.push(V);if(U.length){const V=await this.getInstalled(),ie=U.filter(le=>V.every(({identifier:ue})=>!(0,i.areSameExtensions)(ue,{id:le})));if(ie.length){const ue=(await this.galleryService.query({names:ie,pageSize:U.length},y.CancellationToken.None)).firstPage;try{await p.Promises.settled(ue.map(we=>this.installFromGallery(we,B)))}catch(we){try{await this.rollback(ue)}catch(ke){}throw we}}}}}async rollback(T){const B=(await this.getInstalled(1)).filter(U=>T.some(V=>new i.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(new i.ExtensionIdentifierWithVersion(V.identifier,V.version))));await p.Promises.settled(B.map(U=>this.uninstall(U)))}async uninstall(T,L={}){this.logService.trace("ExtensionManagementService#uninstall",T.identifier.id);const B=await this.getInstalled(1),U=B.find(V=>(0,i.areSameExtensions)(V.identifier,T.identifier));if(!U)throw new Error(b.localize(11,null,T.manifest.displayName||T.manifest.name));try{await this.checkForDependenciesAndUninstall(U,B,L)}catch(V){throw this.joinErrors(V)}}async updateMetadata(T,L){return this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),L)),this.manifestCache.invalidate(),T}async updateExtensionScope(T,L){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),{isMachineScoped:L})),this.manifestCache.invalidate(),T}async getGalleryMetadata(T){const L=await this.findGalleryExtensionByName(T);return L?{id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId}:void 0}async findGalleryExtension(T){if(T.identifier.uuid){const L=await this.findGalleryExtensionById(T.identifier.uuid);return L||this.findGalleryExtensionByName(T.identifier.id)}return this.findGalleryExtensionByName(T.identifier.id)}async findGalleryExtensionById(T){return(await this.galleryService.query({ids:[T],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(T){return(await this.galleryService.query({names:[T],pageSize:1},y.CancellationToken.None)).firstPage[0]}joinErrors(T){const L=Array.isArray(T)?T:[T];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((B,U)=>new Error(`${B.message}${B.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}async checkForDependenciesAndUninstall(T,L,B){try{await this.preUninstallExtension(T);const U=B.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(T,L);await this.uninstallExtensions(T,U,L,B)}catch(U){throw await this.postUninstallExtension(T,new m.ExtensionManagementError(U instanceof Error?U.message:U,Q)),U}await this.postUninstallExtension(T)}async uninstallExtensions(T,L,B,U){const V=[T,...L];if(!U.donotCheckDependents)for(const ie of V)this.checkForDependents(ie,V,B,T);await p.Promises.settled([this.uninstallExtension(T),...L.map(ie=>this.doUninstall(ie))])}checkForDependents(T,L,B,U){const V=this.getDependents(T,B);if(V.length){const ie=V.filter(le=>L.indexOf(le)===-1);if(ie.length)throw new Error(this.getDependentsErrorMessage(T,ie,U))}}getDependentsErrorMessage(T,L,B){return B===T?L.length===1?b.localize(12,null,B.manifest.displayName||B.manifest.name,L[0].manifest.displayName||L[0].manifest.name):L.length===2?b.localize(13,null,B.manifest.displayName||B.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):b.localize(14,null,B.manifest.displayName||B.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):L.length===1?b.localize(15,null,B.manifest.displayName||B.manifest.name,T.manifest.displayName||T.manifest.name,L[0].manifest.displayName||L[0].manifest.name):L.length===2?b.localize(16,null,B.manifest.displayName||B.manifest.name,T.manifest.displayName||T.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):b.localize(17,null,B.manifest.displayName||B.manifest.name,T.manifest.displayName||T.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name)}getAllPackExtensionsToUninstall(T,L,B=[]){if(B.indexOf(T)!==-1)return[];B.push(T);const U=T.manifest.extensionPack?T.manifest.extensionPack:[];if(U.length){const V=L.filter(le=>!le.isBuiltin&&U.some(ue=>(0,i.areSameExtensions)({id:ue},le.identifier))),ie=[];for(const le of V)ie.push(...this.getAllPackExtensionsToUninstall(le,L,B));return[...V,...ie]}return[]}getDependents(T,L){return L.filter(B=>B.manifest.extensionDependencies&&B.manifest.extensionDependencies.some(U=>(0,i.areSameExtensions)({id:U},T.identifier)))}async doUninstall(T){try{await this.preUninstallExtension(T),await this.uninstallExtension(T)}catch(L){throw await this.postUninstallExtension(T,new m.ExtensionManagementError(L instanceof Error?L.message:L,Q)),L}await this.postUninstallExtension(T)}async preUninstallExtension(T){if(!await S.exists(T.location.fsPath))throw new Error(b.localize(18,null));this.logService.info("Uninstalling extension:",T.identifier.id),this._onUninstallExtension.fire(T.identifier)}async uninstallExtension(T){let L=this.uninstallingExtensions.get(T.identifier.id);return L||(L=(0,p.createCancelablePromise)(async()=>{const B=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...B.filter(U=>(0,i.areSameExtensions)(U.identifier,T.identifier)))}),this.uninstallingExtensions.set(T.identifier.id,L),L.finally(()=>this.uninstallingExtensions.delete(T.identifier.id))),L}async postUninstallExtension(T,L){if(L)this.logService.error("Failed to uninstall extension:",T.identifier.id,L.message);else if(this.logService.info("Successfully uninstalled extension:",T.identifier.id),T.identifier.uuid)try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"uninstall")}catch(U){}this.reportTelemetry("extensionGallery:uninstall",(0,i.getLocalExtensionTelemetryData)(T),void 0,L);const B=L?L instanceof m.ExtensionManagementError?L.code:q:void 0;this._onDidUninstallExtension.fire({identifier:T.identifier,error:B})}getInstalled(T=null){return this.extensionsScanner.scanExtensions(T)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(T){return(await this.filterUninstalled(T)).length===1}async filterUninstalled(...T){const L=[],B=await this.extensionsScanner.getUninstalledExtensions();for(const U of T)B[U.key()]&&L.push(U.key());return L}getExtensionsReport(){const T=new Date().getTime();return(!this.reportedExtensions||T-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=T),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const T=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${T.length} reported extensions from service`),T}catch(T){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(T,L,B,U){const V=U?U instanceof m.ExtensionManagementError?U.code:q:void 0;this.telemetryService.publicLogError(T,Object.assign(Object.assign({},L),{success:!U,duration:B,errorcode:V}))}};ee=Oe([xe(0,I.INativeEnvironmentService),xe(1,m.IExtensionGalleryService),xe(2,A.ILogService),xe(3,(0,u.optional)(s.IDownloadService)),xe(4,c.ITelemetryService),xe(5,u.IInstantiationService),xe(6,x.IFileService)],ee),e.ExtensionManagementService=ee}),define(de[49],me([0,1,61,79,227,6,35,4,25,23,2,18,81,12,5]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class a{constructor(y){this.socket=y,this._errorListener=P=>{if(P){if(P.code==="EPIPE")return;(0,D.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const P=v=>y(I.VSBuffer.wrap(v));return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(y){return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(y){return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(y){if(!this.socket.destroyed)try{this.socket.write(y.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,D.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,D.onUnexpectedError)(P)}}end(){this.socket.end()}drain(){return new Promise((y,P)=>{if(this.socket.bufferSize===0){y();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),y()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=a;var w;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var _;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(_||(_={}));class A extends i.Disposable{constructor(y,P,v,g){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=y,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=P,this._recordInflateBytes=g,P?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",F=>{console.error(F),(0,D.onUnexpectedError)(F),this._onClose.fire()}),this._zlibInflate.on("data",F=>{this._pendingInflateData.push(F)}),v&&(this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{console.error(F),(0,D.onUnexpectedError)(F),this._onClose.fire()}),this._zlibDeflate.on("data",F=>{this._pendingDeflateData.push(F)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._totalOutgoingDataBytes+=y.byteLength,this._zlibDeflate?(this._zlibDeflate.write(y.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let P=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.length-4),this._isEnded||this._write(I.VSBuffer.wrap(P),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(y,!1)}_write(y,P){let v=2;y.byteLength<126?v+=0:y.byteLength<2**16?v+=2:v+=8;const g=I.VSBuffer.alloc(v);if(P?g.writeUInt8(194,0):g.writeUInt8(130,0),y.byteLength<126)g.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){g.writeUInt8(126,1);let F=1;g.writeUInt8(y.byteLength>>>8&255,++F),g.writeUInt8(y.byteLength>>>0&255,++F)}else{g.writeUInt8(127,1);let F=1;g.writeUInt8(0,++F),g.writeUInt8(0,++F),g.writeUInt8(0,++F),g.writeUInt8(0,++F),g.writeUInt8(y.byteLength>>>24&255,++F),g.writeUInt8(y.byteLength>>>16&255,++F),g.writeUInt8(y.byteLength>>>8&255,++F),g.writeUInt8(y.byteLength>>>0&255,++F)}this._totalOutgoingWireBytes+=g.byteLength+y.byteLength,this.socket.write(I.VSBuffer.concat([g,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._totalIncomingWireBytes+=y.byteLength,this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),g=(P.readUInt8(0)&128)>>>7,F=P.readUInt8(1),O=(F&128)>>>7,x=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=g,this._state.mask=0}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),v=P.readUInt8(1),g=(v&128)>>>7;let F=v&127,O=1;F===126?F=P.readUInt8(++O)*2**8+P.readUInt8(++O):F===127&&(F=P.readUInt8(++O)*0+P.readUInt8(++O)*0+P.readUInt8(++O)*0+P.readUInt8(++O)*0+P.readUInt8(++O)*2**24+P.readUInt8(++O)*2**16+P.readUInt8(++O)*2**8+P.readUInt8(++O));let x=0;g&&(x=P.readUInt8(++O)*2**24+P.readUInt8(++O)*2**16+P.readUInt8(++O)*2**8+P.readUInt8(++O)),this._state.state=3,this._state.readLen=F,this._state.mask=x}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);d(P,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(P.buffer)),this._zlibInflate.write(P.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const v=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=v.length,this._onData.fire(I.VSBuffer.wrap(v))})):(this._totalIncomingDataBytes+=P.byteLength,this._onData.fire(P))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=A;function d(h,y){if(y!==0){let P=h.byteLength>>>2;for(let oe=0;oe<P;oe++){const W=h.readUInt32BE(oe*4);h.writeUInt32BE(W^y,oe*4)}let v=P*4,g=h.byteLength-v;const F=y>>>24&255,O=y>>>16&255,x=y>>>8&255;g>=1&&h.writeUInt8(h.readUInt8(v)^F,v),g>=2&&h.writeUInt8(h.readUInt8(v+1)^O,v+1),g>=3&&h.writeUInt8(h.readUInt8(v+2)^x,v+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const h=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):y=(0,R.join)((0,f.tmpdir)(),`vscode-ipc-${h}.sock`),n(y),y}e.createRandomIPCHandle=c;function t(h,y,P){const v=(0,E.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${P}-${y}-sock`;let g;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?g=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${P}-${y}.sock`):g=(0,R.join)(h,`${P}-${y}.sock`),n(g),g}e.createStaticIPCHandle=t;function n(h){const y=l[o.platform];typeof y=="number"&&h.length>=y&&console.warn(`WARNING: IPC handle "${h}" is longer than ${y} chars, try a shorter --user-data-dir`)}class r extends k.IPCServer{constructor(y){super(r.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const P=S.Event.fromNodeEventEmitter(y,"connection");return S.Event.map(P,v=>({protocol:new p.Protocol(new a(v)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(h){return new Promise((y,P)=>{const v=(0,b.createServer)();v.on("error",P),v.listen(h,()=>{v.removeListener("error",P),y(new r(v))})})}e.serve=s;function u(h,y){return new Promise((P,v)=>{const g=(0,b.createConnection)(h,()=>{g.removeListener("error",v),P(p.Client.fromSocket(new a(g),y))});g.once("error",v)})}e.connect=u}),define(de[105],me([0,1,227,64,2,11,12,192,34,16,18,27,86]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let D=class extends C.Disposable{constructor(a,w,_){super();this.environmentService=w,this.logService=_,this.configure(a.getValue()),this._register(a.onDidChangeConfiguration(()=>this.configure(a.getValue()),this))}configure(a){this.proxyUrl=a.http&&a.http.proxy,this.strictSSL=!!(a.http&&a.http.proxyStrictSSL),this.authorization=a.http&&a.http.proxyAuthorization}async request(a,w){this.logService.trace("RequestService#request",a.url);const{proxyUrl:_,strictSSL:A}=this,d=Object.assign(Object.assign({},process.env),await(0,p.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),l=a.agent?a.agent:await(0,R.getProxyAgent)(a.url||"",d,{proxyUrl:_,strictSSL:A});return a.agent=l,a.strictSSL=A,this.authorization&&(a.headers=Object.assign(Object.assign({},a.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(a,w)}async getNodeRequest(a){return((0,b.parse)(a.url).protocol==="https:"?await new Promise((A,d)=>{Y(["https"],A,d)}):await new Promise((A,d)=>{Y(["http"],A,d)})).request}_request(a,w){return new Promise(async(_,A)=>{let d;const l=(0,b.parse)(a.url),c=a.getRawRequest?a.getRawRequest(a):await this.getNodeRequest(a),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,S.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(t.auth=a.user+":"+a.password),d=c(t,n=>{const r=(0,S.isNumber)(a.followRedirects)?a.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request(Object.assign(Object.assign({},a),{url:n.headers.location,followRedirects:r-1}),w).then(_,A);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,E.createGunzip)())),_({res:n,stream:(0,i.streamToBufferReadableStream)(s)})}}),d.on("error",A),a.timeout&&d.setTimeout(a.timeout),a.data&&typeof a.data=="string"&&d.write(a.data),d.end(),w.onCancellationRequested(()=>{d.abort(),A((0,k.canceled)())})})}async resolveProxy(a){}};D=Oe([xe(0,f.IConfigurationService),xe(1,I.INativeEnvironmentService),xe(2,m.ILogService)],D),e.RequestService=D}),define(de[106],me([0,1,37,99,40,8,4,18,6,49,86,5]),function(Y,e,E,b,C,S,k,R,f,m,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function p(_={},A,d,l,c){const t=await(0,b.getNLSConfiguration)(A,l.userDataPath),n=await(0,i.resolveShellEnv)(c,l.args,process.env),r=l.isBuilt?(0,k.join)(l.appRoot,"bin"):(0,k.join)(l.appRoot,"resources","server","bin-dev"),s=process.env;let u=_.PATH||n.PATH||s.PATH;u?u=r+k.delimiter+u:u=r;const h=Object.assign(Object.assign(Object.assign(Object.assign({},s),n),{VSCODE_LOG_NATIVE:String(d),VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(t,void 0,0)}),_);return l.args["without-browser-env-var"]||(h.BROWSER=(0,k.join)(r,"helpers",I.isWindows?"browser.cmd":"browser.sh")),a(h,"PATH",u),w(h),h}e.buildUserEnvironment=p;class D{constructor(A,d,l,c,t,n){this.socket=A,this.socketDrain=d,this.initialDataChunk=l,this.skipWebSocketFrames=c,this.permessageDeflate=t,this.inflateBytes=n}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class o{constructor(A,d,l,c,t,n){this._environmentService=A,this._logService=d,this._reconnectionToken=l,this._onClose=new f.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=c,this._extensionHostProcess=null,this._connectionData=o._toConnectionData(t,n),this._connectionData.socket.pause(),this._log("New connection established.")}_log(A){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${A}`)}_logError(A){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${A}`)}static _toConnectionData(A,d){return A instanceof m.NodeSocket?new D(A.socket,A.drain(),d,!0,!1,R.VSBuffer.alloc(0)):new D(A.socket.socket,A.drain(),d,!1,A.permessageDeflate,A.recordedInflateBytes)}async _sendSocketToExtensionHost(A,d){await d.socketDrain;const l=d.toIExtHostSocketMessage();A.send(l,d.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!!this._extensionHostProcess){const A={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(A)}}acceptReconnection(A,d,l){this._remoteAddress=A,this._log("The client has reconnected.");const c=o._toConnectionData(d,l);if(c.socket.pause(),!this._extensionHostProcess){this._connectionData=c;return}this._sendSocketToExtensionHost(this._extensionHostProcess,c)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(A){try{let d=[];A.port&&!process.pkg&&(d=[`--inspect${A.break?"-brk":""}=0.0.0.0:${A.port}`]);const c={env:await p(A.env,A.language,!!A.debugId,this._environmentService,this._logService),execArgv:d,silent:!0},t=["--type=extensionHost",`--uriTransformerPath=${C.uriTransformerPath}`],n=this._environmentService.args["use-host-proxy"];n!==void 0&&t.push(`--useHostProxy=${n}`),this._extensionHostProcess=E.fork(S.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,t,c);const r=this._extensionHostProcess.pid;this._log(`<${r}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const s=f.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),u=f.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");s(y=>console.log("EXTHOST-STDOUT::::::::"+y)),u(y=>console.log("EXTHOST-STDERR::::::::"+y)),this._extensionHostProcess.on("message",y=>{y&&y.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(y.arguments))}),this._extensionHostProcess.on("error",y=>{this._logError(`<${r}> Extension Host Process had an error`),this._logService.error(y),this._cleanResources()}),this._extensionHostProcess.on("exit",(y,P)=>{this._log(`<${r}> Extension Host Process exited with code: ${y}, signal: ${P}.`),this._cleanResources()});const h=y=>{y.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",h),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",h)}catch(d){console.error("ExtensionHostConnection errored"),d&&console.error(d)}}}e.ExtensionHostConnection=o;function a(_,A,d){const l=Object.keys(_).filter(t=>t.toLowerCase()===A.toLowerCase()),c=l.length>0?l[0]:A;_[c]=d}function w(_){for(let A of Object.keys(_))_[A]===null&&delete _[A]}}),define(de[228],me([0,1,59,16,57,94,34,63,105,65,39,32,96,104,88,30,2,93,62,8,22,44,91,103,66,85,60,89,12,3,4,24]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A,d,l,c,t,n,r,s,u,h,y,P,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class F extends w.Disposable{constructor(W,te){super();this.args=W,this.remoteDataFolder=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async te=>{const Q=te.get(b.ILogService),q=te.get(I.IExtensionManagementCLIService);try{await this.doRun(q)}catch(ee){throw Q.error(ee),console.error((0,y.getErrorMessage)(ee)),ee}})}async initServices(){const W=new E.ServiceCollection,te=Object.assign({_serviceBrand:void 0},a.default);W.set(c.IProductService,te);const Q=new r.ServerEnvironmentService(this.args,te);W.set(r.IServerEnvironmentService,Q);const q=new b.LogService(new t.SpdLogLogger(n.RemoteExtensionLogFileName,(0,v.join)(Q.logsPath,`${n.RemoteExtensionLogFileName}.log`),!0,(0,b.getLogLevel)(Q)));W.set(b.ILogService,q),q.trace(`Remote configuration data at ${this.remoteDataFolder}`),q.trace("process arguments:",this.args);const ee=this._register(new _.FileService(q));W.set(l.IFileService,ee),ee.registerProvider(d.Schemas.file,this._register(new A.DiskFileSystemProvider(q)));const H=this._register(new S.ConfigurationService(Q.settingsResource,ee));return await H.initialize(),W.set(k.IConfigurationService,H),W.set(R.IRequestService,new C.SyncDescriptor(f.RequestService)),W.set(i.ITelemetryService,m.NullTelemetryService),W.set(I.IExtensionGalleryService,new C.SyncDescriptor(p.ExtensionGalleryService)),W.set(I.IExtensionManagementService,new C.SyncDescriptor(D.ExtensionManagementService)),W.set(I.IExtensionManagementCLIService,new C.SyncDescriptor(s.ExtensionManagementCLIService)),W.set(u.ILocalizationsService,new C.SyncDescriptor(h.LocalizationsService)),new o.InstantiationService(W)}async doRun(W){if(this.args["list-extensions"])return W.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return W.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return W.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return W.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(W){return W.map(te=>/\.vsix$/i.test(te)?P.URI.file((0,v.isAbsolute)(te)?te:(0,v.join)((0,g.cwd)(),te)):te)}}function O(oe){setTimeout(()=>process.exit(oe),0)}async function x(oe,W){const te=new F(oe,W);try{await te.run(),O(0)}catch(Q){O(1)}finally{te.dispose()}}e.run=x}),define(de[229],me([0,1,49,240,15,221,3,202,16]),function(Y,e,E,b,C,S,k,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class m{constructor(p,D,o){this._commands=p,this.logService=D,this._ipcHandlePath=o,this._server=b.createServer((a,w)=>this.onRequest(a,w)),this.setup().catch(a=>(D.error(a),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch(p){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,D){const o=[];p.setEncoding("utf8"),p.on("data",a=>o.push(a)),p.on("end",()=>{const a=JSON.parse(o.join(""));switch(a.type){case"open":this.open(a,D);break;case"openExternal":this.openExternal(a,D);break;case"status":this.getStatus(a,D);break;case"extensionManagement":this.manageExtensions(a,D).catch(this.logService.error);break;default:D.writeHead(404),D.write(`Unknown message type: ${a.type}`,w=>{w&&this.logService.error(w)}),D.end();break}})}open(p,D){let{fileURIs:o,folderURIs:a,forceNewWindow:w,diffMode:_,addMode:A,forceReuseWindow:d,gotoLineMode:l,waitMarkerFilePath:c}=p;const t=[];if(Array.isArray(a))for(const n of a)try{t.push({folderUri:k.URI.parse(n)})}catch(r){}if(Array.isArray(o))for(const n of o)try{(0,R.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:k.URI.parse(n)}):t.push({fileUri:k.URI.parse(n)})}catch(r){}if(t.length){const n=c?k.URI.file(c):void 0,s={forceNewWindow:w,diffMode:_,addMode:A,gotoLineMode:l,forceReuseWindow:d,preferNewWindow:!d&&!n&&!A,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,s)}D.writeHead(200),D.end()}async openExternal(p,D){for(const o of p.uris){const a=k.URI.parse(o),w=a.scheme==="file"?a:o;await this._commands.executeCommand("_remoteCLI.openExternal",w)}D.writeHead(200),D.end()}async manageExtensions(p,D){try{const o=_=>_==null?void 0:_.map(A=>/\.vsix$/i.test(A)?k.URI.parse(A):A),a={list:p.list,install:o(p.install),uninstall:o(p.uninstall),force:p.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",a);D.writeHead(200),D.write(w)}catch(o){D.writeHead(500),D.write(String(o),a=>{a&&this.logService.error(a)})}D.end()}async getStatus(p,D){try{const o=await this._commands.executeCommand("_remoteCLI.getSystemStatus");D.writeHead(200),D.write(o),D.end()}catch(o){D.writeHead(500),D.write(String(o),a=>{a&&this.logService.error(a)}),D.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=m;let i=class extends m{constructor(p,D){super(p,D,(0,E.createRandomIPCHandle)())}};i=Oe([xe(0,S.IExtHostCommands),xe(1,f.ILogService)],i),e.CLIServer=i}),define(de[230],me([0,1,25,6,20,2,4,5,3,49,30,106,40,229,209,102,210,211,214]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends A.AbstractVariableResolverService{constructor(t,n,r,s){super({getFolderUri:u=>{const h=n.filter(y=>y.name===u);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>n.length,getConfigurationValue:(u,h)=>s[`config:${h}`],getExecPath:()=>t.VSCODE_EXEC_PATH,getAppRoot:()=>t.VSCODE_CWD,getFilePath:()=>{if(r)return k.normalize(r.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber},void 0,Promise.resolve(t))}}class l extends S.Disposable{constructor(t,n,r){super();this._logService=t,this._environmentService=n,this._ptyService=r,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new b.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(t,n,r){var s;switch(n){case"$restartPtyHost":return(s=this._ptyService.restartPtyHost)===null||s===void 0?void 0:s.apply(this._ptyService,r);case"$createProcess":{const u=(0,p.createRemoteURITransformer)(t.remoteAuthority);return this._createProcess(u,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getShellEnvironment":return this._getShellEnvironment();case"$getTerminalLayoutInfo":return this._getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._setTerminalLayoutInfo(r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime()}throw new Error(`IPC Command ${n} not found`)}listen(t,n,r){switch(n){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||b.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||b.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||b.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||b.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessTitleChangedEvent":return this._ptyService.onProcessTitleChanged;case"$onProcessShellTypeChangedEvent":return this._ptyService.onProcessShellTypeChanged;case"$onProcessOverrideDimensionsEvent":return this._ptyService.onProcessOverrideDimensions;case"$onProcessResolvedShellLaunchConfigEvent":return this._ptyService.onProcessResolvedShellLaunchConfig;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;default:break}throw new Error("Not supported")}async _createProcess(t,n){const r={name:n.shellLaunchConfig.name,executable:n.shellLaunchConfig.executable,args:n.shellLaunchConfig.args,cwd:typeof n.shellLaunchConfig.cwd=="string"||typeof n.shellLaunchConfig.cwd=="undefined"?n.shellLaunchConfig.cwd:f.URI.revive(t.transformIncoming(n.shellLaunchConfig.cwd)),env:n.shellLaunchConfig.env},s=await(0,I.buildUserEnvironment)(n.resolverEnv,R.language,!1,this._environmentService,this._logService),u=H=>({uri:f.URI.revive(t.transformIncoming(H.uri)),name:H.name,index:H.index,toResource:()=>{throw new Error("Not implemented")}}),h=n.workspaceFolders.map(u),y=n.activeWorkspaceFolder?u(n.activeWorkspaceFolder):void 0,P=n.activeFileResource?f.URI.revive(t.transformIncoming(n.activeFileResource)):void 0,v=new d(s,h,P,n.resolvedVariables),g=w.createVariableResolver(y,process.env,v),F=w.getCwd(r,E.homedir(),g,y==null?void 0:y.uri,n.configuration["terminal.integrated.cwd"],this._logService);r.cwd=F;const O=R.isWindows?"terminal.integrated.env.windows":R.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",x=n.configuration[O],oe=n.configuration["terminal.integrated.inheritEnv"]?s:await this._getNonInheritedEnv(s),W=w.createTerminalEnvironment(r,x,g,i.default.version,n.configuration["terminal.integrated.detectLocale"],oe);if(!r.strictEnv){const H=[];for(const[B,U]of n.envVariableCollections)H.push([B,{map:(0,a.deserializeEnvironmentVariableCollection)(U)}]);const T=new Map(H);new o.MergedEnvironmentVariableCollection(T).applyToProcessEnvironment(W)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:F,cols:n.cols,rows:n.rows,env:W});const te=(0,m.createRandomIPCHandle)();W.VSCODE_IPC_HOOK_CLI=te;const Q={executeCommand:(H,...T)=>this._executeCommand(H,T,t)},q=new D.CLIServerBase(Q,this._logService,te),ee=await this._ptyService.createProcess(r,F,n.cols,n.rows,W,s,!1,n.shouldPersistTerminal,n.workspaceId,n.workspaceName);return this._ptyService.onProcessExit(H=>H.id===ee&&q.dispose()),{persistentTerminalId:ee,resolvedShellLaunchConfig:r}}_executeCommand(t,n,r){let s,u;const h=new Promise((v,g)=>{s=v,u=g}),y=++this._lastReqId;this._pendingCommands.set(y,{resolve:s,reject:u,uriTransformer:r});const P=(0,C.cloneAndChange)(n,v=>{if(v&&v.$mid===1)return r.transformOutgoing(v);if(v&&v instanceof f.URI)return r.transformOutgoingURI(v)});return this._onExecuteCommand.fire({reqId:y,commandId:t,commandArgs:P}),h}_getNonInheritedEnv(t){return(0,_.getMainProcessParentEnv)(t)}_sendCommandResult(t,n,r){const s=this._pendingCommands.get(t);if(!!s){this._pendingCommands.delete(t);const u=(0,C.cloneAndChange)(r,h=>{if(h&&h.$mid===1)return s.uriTransformer.transformIncoming(h)});n?s.reject(u):s.resolve(u)}}_getDefaultSystemShell(t){return this._ptyService.getDefaultSystemShell(t)}_getShellEnvironment(){return Object.assign({},process.env)}_setTerminalLayoutInfo(t){this._ptyService.setTerminalLayoutInfo(t)}async _getTerminalLayoutInfo(t){return this._ptyService.getTerminalLayoutInfo(t)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=l}),define(de[231],me([0,1,61,15,79,64,25,47,232,18,2,23,21,123,5,81,49,106,203,40,16,8,30,27,59,57,94,34,63,105,65,39,32,96,104,88,84,162,60,89,199,198,195,77,93,62,22,44,35,6,223,204,224,191,167,200,161,90,205,3,29,66,4,217,230,107,103,85,91,97,201]),function(Y,e,E,b,C,S,k,R,f,m,i,I,p,D,o,a,w,_,A,d,l,c,t,n,r,s,u,h,y,P,v,g,F,O,x,oe,W,te,Q,q,ee,H,T,L,B,U,V,ie,le,ue,we,ke,Ae,Fe,je,Qe,qe,it,tt,ye,be,_e,Ie,Le,ze,We,Ke,et,se,ve,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Ne=5*60*1e3,j=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,K="monacoworkbench";class ne extends le.IPCServer{constructor(){const fe=new ue.Emitter;super(fe.event);this._onDidConnectEmitter=fe}acceptConnection(fe,Se){this._onDidConnectEmitter.fire({protocol:fe,onDidClientDisconnect:Se})}}function z(Pe){return Pe<10?`0${Pe}`:String(Pe)}function G(){const Pe=new Date;return`${z(Pe.getHours())}:${z(Pe.getMinutes())}:${z(Pe.getSeconds())}`}class Z extends l.AbstractLogger{constructor(fe=l.DEFAULT_LOG_LEVEL){super();this.setLevel(fe),this.useColors=Boolean(process.stdout.isTTY)}trace(fe,...Se){this.getLevel()<=l.LogLevel.Trace&&(this.useColors?console.log(`[90m[${G()}][0m`,fe,...Se):console.log(`[${G()}]`,fe,...Se))}debug(fe,...Se){this.getLevel()<=l.LogLevel.Debug&&(this.useColors?console.log(`[90m[${G()}][0m`,fe,...Se):console.log(`[${G()}]`,fe,...Se))}info(fe,...Se){this.getLevel()<=l.LogLevel.Info&&(this.useColors?console.log(`[90m[${G()}][0m`,fe,...Se):console.log(`[${G()}]`,fe,...Se))}warn(fe,...Se){this.getLevel()<=l.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${G()}][0m`,fe,...Se):console.warn(`[${G()}]`,fe,...Se))}error(fe,...Se){this.getLevel()<=l.LogLevel.Error&&(this.useColors?console.error(`[91m[${G()}][0m`,fe,...Se):console.error(`[${G()}]`,fe,...Se))}critical(fe,...Se){this.getLevel()<=l.LogLevel.Critical&&(this.useColors?console.error(`[90m[${G()}][0m`,fe,...Se):console.error(`[${G()}]`,fe,...Se))}dispose(){}flush(){}}class re extends i.Disposable{constructor(fe,Se,Te,Me,Ue,Xe){super();this._environmentService=fe,this._productService=Se,this._connectionToken=Te,this._connectionTokenIsMandatory=Me;const Ye=Ce(this._environmentService);Ye.trace(`Remote configuration data at ${Xe}`),Ye.trace("process arguments:",this._environmentService.args),Ye.info(j),this._logService=new l.MultiplexLogService([new Z((0,l.getLogLevel)(this._environmentService)),Ye]),this._socketServer=new ne,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),Ue?this._webClientServer=new tt.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const fe=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,Se=>this._logService.error(Se)),1e4),fe}async _createServices(){const fe=new r.ServiceCollection;this._socketServer.registerChannel(qe.ExtensionHostDebugBroadcastChannel.ChannelName,new qe.ExtensionHostDebugBroadcastChannel);const Se=new le.StaticRouter(he=>he.clientId==="renderer");this._socketServer.registerChannel("logger",new it.LogLevelChannel(this._logService)),fe.set(n.IEnvironmentService,this._environmentService),fe.set(n.INativeEnvironmentService,this._environmentService),fe.set(l.ILogService,this._logService),fe.set(ie.IProductService,this._productService);const Te=this._register(new B.FileService(this._logService));fe.set(V.IFileService,Te),Te.registerProvider(c.Schemas.file,this._register(new U.DiskFileSystemProvider(this._logService))),fe.set(h.IConfigurationService,new s.SyncDescriptor(u.ConfigurationService,[this._environmentService.machineSettingsResource,Te])),fe.set(y.IRequestService,new s.SyncDescriptor(P.RequestService));let Me=v.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&t.default.enableTelemetry){t.default.aiConfig&&t.default.aiConfig.asimovKey&&(Me=new ee.AppInsightsAppender(K,null,t.default.aiConfig.asimovKey),this._register((0,i.toDisposable)(()=>Me.flush())));const he=await(0,L.getMachineId)(),J={appender:Me,commonProperties:(0,T.resolveCommonProperties)(Te,(0,k.release)(),(0,k.hostname)(),process.arch,t.default.commit,t.default.version+"-remote",he,t.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};fe.set(g.ITelemetryService,new s.SyncDescriptor(H.TelemetryService,[J]))}else fe.set(g.ITelemetryService,v.NullTelemetryService);fe.set(F.IExtensionGalleryService,new s.SyncDescriptor(O.ExtensionGalleryService));const Ue=this._socketServer.getChannel("download",Se);fe.set(W.IDownloadService,new te.DownloadServiceChannelClient(Ue,()=>this._getUriTransformer("renderer"))),fe.set(F.IExtensionManagementService,new s.SyncDescriptor(x.ExtensionManagementService));const Xe=new oe.InstantiationService(fe);fe.set(Q.ILocalizationsService,Xe.createInstance(q.LocalizationsService));const Ye=Xe.createInstance(et.ExtensionManagementCLIService);fe.set(F.IExtensionManagementCLIService,Ye);const ae=Xe.createInstance(ge.PtyHostService);return fe.set(ve.IPtyService,ae),Xe.invokeFunction(he=>{const J=new we.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,Ye,this._logService,he.get(g.ITelemetryService),Me);this._socketServer.registerChannel("remoteextensionsenvironment",J),this._socketServer.registerChannel(Le.REMOTE_TERMINAL_CHANNEL_NAME,new ze.RemoteTerminalChannel(this._logService,this._environmentService,ae));const $=new ke.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Ae.REMOTE_FILE_SYSTEM_CHANNEL_NAME,$),this._socketServer.registerChannel("request",new Fe.RequestChannel(he.get(y.IRequestService)));const De=he.get(F.IExtensionManagementService),Ee=new je.ExtensionManagementChannel(De,$e=>this._getUriTransformer($e.remoteAuthority));return this._socketServer.registerChannel("extensions",Ee),De.removeDeprecatedExtensions(),this._register(new Qe.default(he.get(g.ITelemetryService))),{telemetryService:he.get(g.ITelemetryService)}})}_getUriTransformer(fe){return this._uriTransformerCache[fe]||(this._uriTransformerCache[fe]=(0,d.createRemoteURITransformer)(fe)),this._uriTransformerCache[fe]}async handleRequest(fe,Se){if(fe.method!=="GET")return(0,tt.serveError)(fe,Se,405,`Unsupported method ${fe.method}`);if(!fe.url)return(0,tt.serveError)(fe,Se,400,"Bad request.");const Te=S.parse(fe.url,!0),Me=Te.pathname;if(!Me)return(0,tt.serveError)(fe,Se,400,"Bad request.");if(Me==="/version")return Se.writeHead(200,{"Content-Type":"text/plain"}),Se.end(t.default.commit||"");if(Me==="/delay-shutdown")return this._delayShutdown(),Se.writeHead(200),Se.end("OK");if(Me==="/vscode-remote-resource"){if(Te.query.tkn!==this._connectionToken)return(0,tt.serveError)(fe,Se,403,"Forbidden.");const Ue=Te.query.path;if(typeof Ue!="string")return(0,tt.serveError)(fe,Se,400,"Bad request.");let Xe;try{Xe=ye.URI.from({scheme:c.Schemas.file,path:Ue}).fsPath}catch(ae){return(0,tt.serveError)(fe,Se,400,"Bad request.")}const Ye=Object.create(null);return this._environmentService.isBuilt&&((0,be.isEqualOrParent)(Xe,this._environmentService.builtinExtensionsPath,!o.isLinux)||(0,be.isEqualOrParent)(Xe,this._environmentService.extensionsPath,!o.isLinux))&&(Ye["Cache-Control"]="public, max-age=31536000"),(0,tt.serveFile)(this._logService,fe,Se,Xe,Ye)}if(this._webClientServer){this._webClientServer.handle(fe,Se,Te);return}return Se.writeHead(404,{"Content-Type":"text/plain"}),Se.end("Not found")}handleUpgrade(fe,Se){let Te=(0,I.generateUuid)(),Me=!1,Ue=!1;if(fe.url){const $=S.parse(fe.url,!0).query;typeof $.reconnectionToken=="string"&&(Te=$.reconnectionToken),$.reconnection==="true"&&(Me=!0),$.skipWebSocketFrames==="true"&&(Ue=!0)}if(fe.headers.upgrade!=="websocket"){Se.end("HTTP/1.1 400 Bad Request");return}const Xe=fe.headers["sec-websocket-key"],Ye=E.createHash("sha1");Ye.update(Xe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ae=Ye.digest("base64"),he=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ae}`];let J=!1;if(!Ue&&fe.headers["sec-websocket-extensions"]){const $=Array.isArray(fe.headers["sec-websocket-extensions"])?fe.headers["sec-websocket-extensions"]:[fe.headers["sec-websocket-extensions"]];for(const De of $)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(De)){if(/\b(permessage-deflate)\b/.test(De)){J=!0,he.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(De)){J=!0,he.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}Se.write(he.join(`\r
`)+`\r
\r
`),Se.setTimeout(0),Ue?this._handleWebSocketConnection(new w.NodeSocket(Se),Me,Te):this._handleWebSocketConnection(new w.WebSocketNodeSocket(new w.NodeSocket(Se),J,null,!0),Me,Te)}handleServerError(fe){this._logService.error("Error occurred in server"),this._logService.error(fe)}async _cleanupOlderLogs(fe){const Se=(0,Ie.basename)(fe),Te=(0,Ie.dirname)(fe),Xe=(await(0,p.readdir)(Te)).filter(ae=>/^\d{8}T\d{6}$/.test(ae)).sort().filter(ae=>ae!==Se),Ye=Xe.slice(0,Math.max(0,Xe.length-9));await Promise.all(Ye.map(ae=>(0,p.rimraf)((0,Ie.join)(Te,ae))))}_getRemoteAddress(fe){let Se;return fe instanceof w.NodeSocket?Se=fe.socket:Se=fe.socket.socket,Se.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(fe,Se,Te){const Me=Se.getSocket();this._logService.error(`${fe} ${Te}.`);const Ue={type:"error",reason:Te};Se.sendControl(m.VSBuffer.fromString(JSON.stringify(Ue))),Se.dispose(),await Me.drain(),Me.dispose()}_handleWebSocketConnection(fe,Se,Te){const Me=this._getRemoteAddress(fe),Ue=`[${Me}][${Te.substr(0,8)}]`,Xe=new a.PersistentProtocol(fe);let Ye;try{const De=Y.__$__nodeRequire("vsda");Ye=new De.validator}catch(De){}let ae;(function(De){De[De.WaitingForAuth=0]="WaitingForAuth",De[De.WaitingForConnectionType=1]="WaitingForConnectionType",De[De.Done=2]="Done",De[De.Error=3]="Error"})(ae||(ae={}));let he=0;const J=De=>{he=3,$.dispose(),this._rejectWebSocketConnection(Ue,Xe,De)},$=Xe.onControlMessage(De=>{if(he===0){let Ee;try{Ee=JSON.parse(De.toString())}catch(Je){return J("Malformed first message")}if(Ee.type!=="auth")return J("Invalid first message");if(this._connectionTokenIsMandatory&&Ee.auth!==this._connectionToken)return J("Unauthorized client refused: auth mismatch");let $e="VS Code Headless is cool";if(Ye)try{$e=Ye.createNewMessage($e)}catch(Je){}const He={type:"sign",data:$e};Xe.sendControl(m.VSBuffer.fromString(JSON.stringify(He))),he=1}else if(he===1){let Ee;try{Ee=JSON.parse(De.toString())}catch(rt){return J("Malformed second message")}if(Ee.type!=="connectionType")return J("Invalid second message");if(typeof Ee.signedData!="string")return J("Invalid second message field type");const $e=Ee.commit,He=t.default.commit;if($e&&He&&$e!==He)return J("Client refused: version mismatch");let Je=!1;if(Ee.signedData===this._connectionToken)Je=!0;else if(Ye)try{Je=Ye.validate(Ee.signedData)==="ok"}catch(rt){}if(!Je){if(this._environmentService.isBuilt)return J("Unauthorized client refused");this._logService.error(`${Ue} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let rt in this._managementConnections)this._managementConnections[rt].shortenReconnectionGraceTimeIfNecessary();for(let rt in this._extHostConnections)this._extHostConnections[rt].shortenReconnectionGraceTimeIfNecessary();he=2,$.dispose(),this._handleConnectionType(Me,Ue,Xe,fe,Se,Te,Ee)}})}async _handleConnectionType(fe,Se,Te,Me,Ue,Xe,Ye){const ae=Ye.desiredConnectionType===1?`${Se}[ManagementConnection]`:Ye.desiredConnectionType===2?`${Se}[ExtensionHostConnection]`:Se;if(Ye.desiredConnectionType===1)if(Ue){if(!this._managementConnections[Xe])return this._rejectWebSocketConnection(ae,Te,"Unknown reconnection token");Te.sendControl(m.VSBuffer.fromString(JSON.stringify({type:"ok"})));const he=Te.readEntireBuffer();Te.dispose(),this._managementConnections[Xe].acceptReconnection(fe,Me,he)}else{if(this._managementConnections[Xe])return this._rejectWebSocketConnection(ae,Te,"Duplicate reconnection token");Te.sendControl(m.VSBuffer.fromString(JSON.stringify({type:"ok"})));const he=new A.ManagementConnection(this._logService,Xe,fe,Te);this._socketServer.acceptConnection(he.protocol,he.onClose),this._managementConnections[Xe]=he,he.onClose(()=>{delete this._managementConnections[Xe]})}else if(Ye.desiredConnectionType===2){const he=Ye.args||{language:"en"},J=await this._updateWithFreeDebugPort(he);if(J.port&&this._logService.trace(`${ae} - startParams debug port ${J.port}`),this._logService.trace(`${ae} - startParams language: ${J.language}`),this._logService.trace(`${ae} - startParams env: ${JSON.stringify(J.env)}`),Ue){if(!this._extHostConnections[Xe])return this._rejectWebSocketConnection(ae,Te,"Unknown reconnection token");Te.sendControl(m.VSBuffer.fromString(JSON.stringify(J.port?{debugPort:J.port}:{})));const $=Te.readEntireBuffer();Te.dispose(),this._extHostConnections[Xe].acceptReconnection(fe,Me,$)}else{if(this._extHostConnections[Xe])return this._rejectWebSocketConnection(ae,Te,"Duplicate reconnection token");Te.sendControl(m.VSBuffer.fromString(JSON.stringify(J.port?{debugPort:J.port}:{})));const $=Te.readEntireBuffer();Te.dispose();const De=new _.ExtensionHostConnection(this._environmentService,this._logService,Xe,fe,Me,$);this._extHostConnections[Xe]=De,De.onClose(()=>{delete this._extHostConnections[Xe],this._onDidCloseExtHostConnection()}),De.start(J)}}else if(Ye.desiredConnectionType===3){const he=Ye.args;this._createTunnel(Te,he)}else return this._rejectWebSocketConnection(ae,Te,"Unknown initial data received")}async _createTunnel(fe,Se){const Te=fe.getSocket().socket,Me=fe.readEntireBuffer();fe.dispose(),Te.pause();const Ue=await this._connectTunnelSocket(Se.port);Me.byteLength>0&&Ue.write(Me.buffer),Ue.on("end",()=>Te.end()),Ue.on("close",()=>Te.end()),Ue.on("error",()=>Te.destroy()),Te.on("end",()=>Ue.end()),Te.on("close",()=>Ue.end()),Te.on("error",()=>Ue.destroy()),Ue.pipe(Te),Te.pipe(Ue)}_connectTunnelSocket(fe){return new Promise((Se,Te)=>{const Me=C.createConnection({port:fe},()=>{Me.removeListener("error",Te),Me.pause(),Se(Me)});Me.once("error",Te)})}_updateWithFreeDebugPort(fe){return typeof fe.port=="number"?(0,D.findFreePort)(fe.port,10,5e3).then(Se=>(fe.port=Se,fe)):(fe.debugId=void 0,fe.port=void 0,fe.break=void 0,Promise.resolve(fe))}async _onDidCloseExtHostConnection(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown()))}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Ne))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=re;function ce(Pe){if(Pe["connection-secret"]){Pe.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let fe=b.readFileSync(Pe["connection-secret"]).toString();return fe=fe.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(fe)||(console.warn(`The secret defined in ${Pe["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:fe,connectionTokenIsMandatory:!0}}else return{connectionToken:Pe.connectionToken||(0,I.generateUuid)(),connectionTokenIsMandatory:!1}}async function Re(Pe,fe,Se){const Te=Object.assign({_serviceBrand:void 0},t.default),Me=new _e.ServerEnvironmentService(fe,Te);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const He=(0,Ie.join)(process.env.HOMEDRIVE,"node_modules"),Je=(0,Ie.dirname)((0,Ie.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),rt=(0,Ie.join)(Je,"node_modules");if(b.existsSync(He)||b.existsSync(rt)){const Ve=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${He}
* ${rt}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Ce(Me).warn(Ve),console.warn(Ve),process.exit(0)}}const{connectionToken:Ue,connectionTokenIsMandatory:Xe}=ce(fe),Ye=b.existsSync(c.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",Y).fsPath);Ye&&Pe&&typeof Pe!="string"&&console.log(`Web UI available at http://localhost${Pe.port===80?"":`:${Pe.port}`}/?tkn=${Ue}`);const ae=new re(Me,Te,Ue,Xe,Ye,Se),he=await ae.initialize(),{telemetryService:J}=he;R.mark("code/server/ready");const $=f.performance.now(),De=global.vscodeServerStartTime,Ee=global.vscodeServerListenTime,$e=global.vscodeServerCodeLoadedTime;if(J.publicLog2("serverStart",{startTime:De,startedTime:Ee,codeLoadedTime:$e,readyTime:$}),fe["print-startup-performance"]){const He=We.LoaderStats.get();let Je="";Je+=`

### Load AMD-module
`,Je+=We.LoaderStats.toMarkdownTable(["Module","Duration"],He.amdLoad),Je+=`

### Load commonjs-module
`,Je+=We.LoaderStats.toMarkdownTable(["Module","Duration"],He.nodeRequire),Je+=`

### Invoke AMD-module factory
`,Je+=We.LoaderStats.toMarkdownTable(["Module","Duration"],He.amdInvoke),Je+=`

### Invoke commonjs-module
`,Je+=We.LoaderStats.toMarkdownTable(["Module","Duration"],He.nodeEval),Je+=`Start-up time: ${Ee-De}
`,Je+=`Code loading time: ${$e-De}
`,Je+=`Initialized time: ${$-De}
`,Je+=`
`,console.log(Je)}return ae}e.createServer=Re;const Ce=function(){let Pe;return function(Se){return Pe||(Pe=new l.LogService(new se.SpdLogLogger(Ke.RemoteExtensionLogFileName,(0,Ie.join)(Se.logsPath,`${Ke.RemoteExtensionLogFileName}.log`),!0,(0,l.getLogLevel)(Se)))),Pe}}()}),define(de[241],me([0,1,25,15,8,228,231,55,4,232,66,47]),function(Y,e,E,b,C,S,k,R,f,m,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,I.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=m.performance.now();const p={onMultipleValues:(n,r)=>{console.error(`Option ${n} can only be defined once. Using value ${r}.`)},onUnknownOption:n=>{console.error(`Ignoring option ${n}: not supported for server.`)}},D=(0,R.parseArgs)(process.argv.slice(2),i.serverOptions,p),o=process.env.VSCODE_AGENT_FOLDER||(0,f.join)(E.homedir(),".vscode-remote"),a=(0,f.join)(o,"data"),w=(0,f.join)(a,"User"),_=(0,f.join)(w,"globalStorage"),A=(0,f.join)(a,"Machine");D["user-data-dir"]=a;const d=(0,f.dirname)(C.FileAccess.asFileUri("",Y).fsPath),l=(0,f.join)(d,"extensions");D["builtin-extensions-dir"]=l,D["extensions-dir"]=D["extensions-dir"]||(0,f.join)(o,"extensions"),[o,D["extensions-dir"],a,w,A,_].forEach(n=>{try{b.existsSync(n)||b.mkdirSync(n)}catch(r){console.error(r)}});function c(){(0,S.run)(D,o)}e.spawnCli=c;function t(n){return(0,k.createServer)(n,D,o)}e.createServer=t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e713fe9b05fc24facbec8f34fb1017133858842b/core/vs/server/remoteExtensionHostAgent.js.map
